﻿Namespace Testing
	Public Class LoadedModelTestSuite
		Inherits TestSuite
		Private __model As LoadedModel
		Private __testSuite As LoadedModel.TestSuite
		Public Sub New(model As LoadedModel, testSuiteName As String)
			__model = model
			For Each testSuite In __model.GetTestSuites()
				If testSuite.GetDescription().Equals(testSuiteName) Then
					__testSuite = testSuite
					Exit For
				End If
			Next
			If __testSuite Is Nothing Then
				Throw New Exception("Could not find test suite by description (" + testSuiteName + ")!")
			End If
		End Sub
		'Define all tests:
		Public Overrides Function GetTests() As Test()
			Dim sourceTests As List(Of LoadedModel.Trace) = __testSuite.GetTests()
			Console.WriteLine("#tests = " + sourceTests.Count.ToString)
			Dim result(sourceTests.Count - 1) As Test
			For i As Integer = 0 To result.Length - 1
				result(i) = New LoadedModelTest(i.ToString("D5"), __model, sourceTests(i))
			Next
			Return result
		End Function
		'Define one test:
		'Public Overrides Function GetTests() As Test()
		'	Dim tests(0) As Test
		'	Dim i As Integer = 178
		'	tests(0) = New LoadedModelTest(i.ToString("D5"), __model, __model.GetTests()(i))
		'	Return tests
		'End Function
	End Class
End Namespace
