Option Explicit On
Imports SySimFWK, PredefinedControls
Imports SimSupport.SimPrimitives, SimSupport.SimPrimitives.NotifyEnum, SimSupport

Namespace SIMULATOR.Logical_Components
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class F_EST_EfeS_SR : Implements SMSupport.SMQueued 
    Protected Class F_EST_EfeS_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As F_EST_EfeS_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsF_EST_EfeS_SR_States
      RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE
      RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED
      RtsF_EST_EfeS_SR_States_NotIn_F_EST_EfeS_SR
    End Enum
    Public Enum RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States
      RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING
      RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING
      RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL
      RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE
      RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_NotIn_OPERATING_VOLTAGE_SUPPLIED
    End Enum
    ' \ART_SMG :: Created for state : F_EST_EfeS_SR
    Private RtsCurrent_F_EST_EfeS_SR As F_EST_EfeS_SR.RtsF_EST_EfeS_SR_States
    ' \ART_SMG :: Created for state : OPERATING_VOLTAGE_SUPPLIED
    Private RtsCurrent_OPERATING_VOLTAGE_SUPPLIED As F_EST_EfeS_SR.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States
    ' \ART_SMG :: Created for state : BOOTING
    Private RtsAttBOOTING_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast16 As Boolean
    Private ChgFlg16 As Boolean
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast13 As Boolean
    Private ChgFlg13 As Boolean
    Private ChgFlgLast10 As Boolean
    Private ChgFlg10 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast11 As Boolean
    Private ChgFlg11 As Boolean
    Private ChgFlgLast15 As Boolean
    Private ChgFlg15 As Boolean
    Private ChgFlgLast12 As Boolean
    Private ChgFlg12 As Boolean
    Private ChgFlgLast14 As Boolean
    Private ChgFlg14 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As F_EST_EfeS_SRSMQueue = New F_EST_EfeS_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    ' The FlowPort T1_Power_On_Detected indicates that the voltage reaches the permitted range for operation.
    Protected T1_Power_On_Detected As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T2_Power_Off_Detected indicates that voltage leaves the permitted range for operation.
    Protected T2_Power_Off_Detected As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T3_Reset indicates that a reset command is received.
    Protected T3_Reset As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T4_Booted indicates that the booting process was completed successfully.
    ' 
    ' T4_Booted shall be trigged under the following conditions:
    ' - all conditions for the required Safety Integrity Level are fulfilled
    ' - the basic data is valid and complete
    ' - the safe communication protocol connection is disconnected
    ' - the time synchronisation was initiated according to the specification in [Eu.Doc.76] if the subsystem MDM and the SMI functionality is used
    Protected T4_Booted As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T5_SIL_Not_Fulfilled indicates that at least one condition for the needed Safety Integrity Level is not fulfilled.
    Protected T5_SIL_Not_Fulfilled As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T7_Invalid_Or_Missing_Basic_Data indicates a failed validity check of Basic Data on the system data interface to Basic Data identifier.
    Protected T7_Invalid_Or_Missing_Basic_Data As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T16_Data_Installation_Complete indicates that the installation of new Engineering Data and Configuration Data is completed.
    Protected T16_Data_Installation_Complete As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T9_PDI_Connection_Established As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T18_Not_Ready_For_PDI_Connection As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T10_PDI_Connection_Terminated As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort D51_EST_EfeS_State indicates the current essential state of the EULYNX field element Subsystem.
    Protected D51_EST_EfeS_State As OOutputPort(Of String)
    Protected T13_Data_Update_After_Booting As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T14_Data_Update_After_Operational As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T15_Data_Update_In_Initialising As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort D20_Con_MDM_Used provides configuration values whether the MDM is used during initialisation.
    ' 
    ' The following values are permitted:
    ' - True: MDM is used
    ' - False: MDM is not used
    Protected D20_Con_MDM_Used As OInputPort(Of Boolean)
    Protected T21_Ready_For_PDI_Connection As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T17_Data_Update_Finished As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T22_Data_Update_Stop As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort D44_Con_tmax_Booting represents the time constraint Con_tmax_Booting.
    Protected D44_Con_tmax_Booting As OInputPort(Of Integer)
    ' The operation cOp1_init initialises all output ports and block properties.
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' T18_Not_Ready_For_PDI_Connection := FALSE;
    ' T13_Data_Update_After_Booting := FALSE;
    ' T14_Data_Update_After_Operational := FALSE;
    ' T15_Data_Update_In_Initialising := FALSE;
    ' D51_EST_EfeS_State := "";
    ' T21_Ready_For_PDI_Connection := FALSE;
    ' T22_Data_Update_Stop := FALSE;
    Public Sub cOp1_init()
      T18_Not_Ready_For_PDI_Connection.SetValue(False)
      T13_Data_Update_After_Booting.SetValue(False)
      T14_Data_Update_After_Operational.SetValue(False)
      T15_Data_Update_In_Initialising.SetValue(False)
      D51_EST_EfeS_State.SetValue("")
      T21_Ready_For_PDI_Connection.SetValue(False)
      T22_Data_Update_Stop.SetValue(False)
    End Sub
    
    ' \ART_SMG :: Created for state : BOOTING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' pInstance.RtsBOOTING_Timer1();
    Private Shared Sub RtsBOOTING_Timer1_CallBack(ByRef pInstance As F_EST_EfeS_SR)
      pInstance.RtsBOOTING_Timer1()
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' assume RtsCurrent_F_EST_EfeS_SR: on object;
    ' assume RtsCurrent_OPERATING_VOLTAGE_SUPPLIED: on object;
    ' assume RtsAttBOOTING_Timer1: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2002# *//*##STRT fa348070-5123-49aa-849e-2d25665113de */ ( D20_Con_MDM_Used )/*##END fa348070-5123-49aa-849e-2d25665113de */  and /* #REF2003# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"fc8af9bc-75cd-4d88-9fe2-6369b6c7c511",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT fc8af9bc-75cd-4d88-9fe2-6369b6c7c511 */  T21_Ready_For_PDI_Connection := TRUE; nullstat;/*##END fc8af9bc-75cd-4d88-9fe2-6369b6c7c511 */ /* #REF1546# */
    ' 		ChgFlg8 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2002# *//*##STRT e0e42e78-ba0b-4284-9ba6-3a494d3ae771 */ ( D20_Con_MDM_Used )/*##END e0e42e78-ba0b-4284-9ba6-3a494d3ae771 */  and /* #REF2003# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8b985e31-e34e-4285-af38-059b531fca84",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8b985e31-e34e-4285-af38-059b531fca84 */  T15_Data_Update_In_Initialising := TRUE; nullstat;/*##END 8b985e31-e34e-4285-af38-059b531fca84 */ /* #REF1546# */
    ' 		ChgFlg7 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2002# *//*##STRT 7b7a8e3d-72d2-46a1-8fee-c7947e68b565 */ (NOT D20_Con_MDM_Used )/*##END 7b7a8e3d-72d2-46a1-8fee-c7947e68b565 */  and /* #REF2003# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ab90d899-4003-433f-ab83-771c71bcac95",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ab90d899-4003-433f-ab83-771c71bcac95 */  T21_Ready_For_PDI_Connection := TRUE; nullstat;/*##END ab90d899-4003-433f-ab83-771c71bcac95 */ /* #REF1546# */
    ' 		ChgFlg6 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then
    ' /* #REF123# */
    ' 	/* 584378e8-56e4-4e55-95b6-e6ab3b8cb2d9 BOOTING */
    '   ThisState := "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 92bfe9ad-8f20-4a7b-bc63-570d58d329b8 */ (NOT D20_Con_MDM_Used )/*##END 92bfe9ad-8f20-4a7b-bc63-570d58d329b8 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5180c282-17be-4c00-8f87-88345df90804",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7660d238-1b79-4c1a-8cc3-0f6384838195",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 4fb47724-f471-46ee-a8b3-31fab2e02957 */  nullstat;/*##END 4fb47724-f471-46ee-a8b3-31fab2e02957 */ /* #REF1544# */
    ' 	/*##STRT 9e7107b0-623b-4ba4-b7f6-40f8dcd30ae7 */ 
    '  T21_Ready_For_PDI_Connection := TRUE; nullstat;/*##END 9e7107b0-623b-4ba4-b7f6-40f8dcd30ae7 */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then
    ' /* #REF123# */
    ' 	/* 584378e8-56e4-4e55-95b6-e6ab3b8cb2d9 BOOTING */
    '   ThisState := "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT f25fceeb-8178-4ade-9253-4055bdb6fea3 */ ( D20_Con_MDM_Used )/*##END f25fceeb-8178-4ade-9253-4055bdb6fea3 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5180c282-17be-4c00-8f87-88345df90804",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c7094d38-759f-436b-a3b8-f768c9d79e17",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 4fb47724-f471-46ee-a8b3-31fab2e02957 */  nullstat;/*##END 4fb47724-f471-46ee-a8b3-31fab2e02957 */ /* #REF1544# */
    ' 	/*##STRT 779111ac-4743-40e8-9fd3-fbed24761bb4 */ 
    '  T13_Data_Update_After_Booting := TRUE; nullstat;/*##END 779111ac-4743-40e8-9fd3-fbed24761bb4 */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then
    ' /* #REF123# */
    ' 	/* 584378e8-56e4-4e55-95b6-e6ab3b8cb2d9 BOOTING */
    '   ThisState := "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"25a8d0fb-7a48-4d93-8165-36208b292bb6",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 47f7e709-225c-43b0-8c82-5c620c6e7a7f */  nullstat;/*##END 47f7e709-225c-43b0-8c82-5c620c6e7a7f */ /* #REF1546# */
    ' 		This.RtsEnter_FALLBACK_MODE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then
    ' /* #REF123# */
    ' 	/* 584378e8-56e4-4e55-95b6-e6ab3b8cb2d9 BOOTING */
    '   ThisState := "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"d9ef2cde-a46b-4c43-9030-d3c86c4ba0c9",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 1f8794ec-5d4f-48c5-b562-4941646124ff */  nullstat;/*##END 1f8794ec-5d4f-48c5-b562-4941646124ff */ /* #REF1546# */
    ' 		This.RtsEnter_FALLBACK_MODE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2000# *//*##STRT bf501a6b-2cd8-4a4f-ae5e-d6107550fa52 */ ( D20_Con_MDM_Used )/*##END bf501a6b-2cd8-4a4f-ae5e-d6107550fa52 */  and /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"9d12b216-4515-4bb5-9e04-f04cc9f81fd8",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 0c85e34f-8a6f-4c70-93c1-5589a4159eb1 */  nullstat;/*##END 0c85e34f-8a6f-4c70-93c1-5589a4159eb1 */ /* #REF1546# */
    ' 		This.RtsEnter_BOOTING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a72da017-7802-4fae-b997-e619c6efa5f2",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT a8325fd0-c430-4a9c-89de-3260e739a736 */ 
    '  T18_Not_Ready_For_PDI_Connection := TRUE;
    '  T22_Data_Update_Stop := TRUE; nullstat;/*##END a8325fd0-c430-4a9c-89de-3260e739a736 */ /* #REF1546# */
    ' 		This.RtsEnter_BOOTING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c75dc6af-e202-447c-97b5-ba2c42aad68e",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ca70d3b5-ba0e-49b7-a102-c38332020cba */ 
    '  T18_Not_Ready_For_PDI_Connection := TRUE;
    '  T22_Data_Update_Stop := TRUE; nullstat;/*##END ca70d3b5-ba0e-49b7-a102-c38332020cba */ /* #REF1546# */
    ' 		This.RtsEnter_FALLBACK_MODE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then
    ' /* #REF123# */
    ' 	/* 8029dc51-ea65-45ea-84a9-d2e30f071170 INITIALISING */
    '   ThisState := "8029dc51-ea65-45ea-84a9-d2e30f071170";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"af8b8404-ed40-45bc-9476-b2deb6477512",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT de5706e7-87bb-4ebc-92bb-c98af4e77329 */  nullstat;/*##END de5706e7-87bb-4ebc-92bb-c98af4e77329 */ /* #REF1546# */
    ' 		This.RtsEnter_OPERATIONAL();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL then
    ' /* #REF123# */
    ' 	/* a4636040-14bc-476e-ad26-646acfd7b1e2 OPERATIONAL */
    '   ThisState := "a4636040-14bc-476e-ad26-646acfd7b1e2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 6648780a-fabc-42ea-aa76-dc3551d7b52f */ ( D20_Con_MDM_Used )/*##END 6648780a-fabc-42ea-aa76-dc3551d7b52f */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_OPERATIONAL */
    ' 		/* standard */
    ' 		This.RtsExit_OPERATIONAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"234cc6ff-d067-4139-a4b7-18e4f7b18f93",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"473a171b-c9aa-4c91-a99a-887b1b93c31b",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 96eb4212-7698-4c8c-b8cf-27a0ef28f96a */  nullstat;/*##END 96eb4212-7698-4c8c-b8cf-27a0ef28f96a */ /* #REF1544# */
    ' 	/*##STRT 73fbf57a-61f6-4e7d-af02-5b18dce57d0c */ 
    '  T14_Data_Update_After_Operational := TRUE; nullstat;/*##END 73fbf57a-61f6-4e7d-af02-5b18dce57d0c */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL then
    ' /* #REF123# */
    ' 	/* a4636040-14bc-476e-ad26-646acfd7b1e2 OPERATIONAL */
    '   ThisState := "a4636040-14bc-476e-ad26-646acfd7b1e2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT ad46a84f-aa6f-4e96-8f0a-cdda9f057437 */ (NOT D20_Con_MDM_Used )/*##END ad46a84f-aa6f-4e96-8f0a-cdda9f057437 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_OPERATIONAL */
    ' 		/* standard */
    ' 		This.RtsExit_OPERATIONAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"234cc6ff-d067-4139-a4b7-18e4f7b18f93",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"29bf97ac-12cd-4348-b718-399618eddf48",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 96eb4212-7698-4c8c-b8cf-27a0ef28f96a */  nullstat;/*##END 96eb4212-7698-4c8c-b8cf-27a0ef28f96a */ /* #REF1544# */
    ' 	/*##STRT d6bf7556-c57a-4cee-9fe2-980de31ff589 */ 
    '  T21_Ready_For_PDI_Connection := TRUE; nullstat;/*##END d6bf7556-c57a-4cee-9fe2-980de31ff589 */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL then
    ' /* #REF123# */
    ' 	/* a4636040-14bc-476e-ad26-646acfd7b1e2 OPERATIONAL */
    '   ThisState := "a4636040-14bc-476e-ad26-646acfd7b1e2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_OPERATIONAL */
    ' 		/* standard */
    ' 		This.RtsExit_OPERATIONAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"4a4e18c4-9802-4412-812e-07b78a8b2898",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT e23443ca-2619-48f2-8ab3-9a64078a184d */ 
    '  T18_Not_Ready_For_PDI_Connection := TRUE; nullstat;/*##END e23443ca-2619-48f2-8ab3-9a64078a184d */ /* #REF1546# */
    ' 		This.RtsEnter_BOOTING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL then
    ' /* #REF123# */
    ' 	/* a4636040-14bc-476e-ad26-646acfd7b1e2 OPERATIONAL */
    '   ThisState := "a4636040-14bc-476e-ad26-646acfd7b1e2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_OPERATIONAL */
    ' 		/* standard */
    ' 		This.RtsExit_OPERATIONAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"38781306-21cd-4575-98c5-41e1fe7caa79",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT d36ab99b-3cab-4ee1-9547-7d8c929828cd */ 
    '  T18_Not_Ready_For_PDI_Connection := TRUE; nullstat;/*##END d36ab99b-3cab-4ee1-9547-7d8c929828cd */ /* #REF1546# */
    ' 		This.RtsEnter_FALLBACK_MODE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE then
    ' /* #REF123# */
    ' 	/* 27b5cf4a-4264-49c1-a4de-bb0da190439b FALLBACK_MODE */
    '   ThisState := "27b5cf4a-4264-49c1-a4de-bb0da190439b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_FALLBACK_MODE */
    ' 		/* standard */
    ' 		This.RtsExit_FALLBACK_MODE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e7686964-6df2-4a1c-8fbe-4c853eb72e48",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 0110ca88-06bd-4084-bfdd-8e069c074178 */  nullstat;/*##END 0110ca88-06bd-4084-bfdd-8e069c074178 */ /* #REF1546# */
    ' 		This.RtsEnter_BOOTING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_EST_EfeS_SR =  /* #REF121d# */ RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_NotIn_F_EST_EfeS_SR then
    ' /* #REF123# */
    ' 	/* 4e930f52-6a26-4347-96d1-af6980f7568a Initial0 */
    '   ThisState := "4e930f52-6a26-4347-96d1-af6980f7568a";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"4e930f52-6a26-4347-96d1-af6980f7568a",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"4e930f52-6a26-4347-96d1-af6980f7568a",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"3a5596ad-c593-4a3a-a9e3-5bf451d83277",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT e01bc6bf-0ce4-4785-a408-efe2e9e9a0a4 */  cOp1_init (); nullstat;/*##END e01bc6bf-0ce4-4785-a408-efe2e9e9a0a4 */ /* #REF1546# */
    ' 	This.RtsEnter_NO_OPERATING_VOLTAGE();/* #REF1590# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE then
    ' /* #REF123# */
    ' 	/* 48d2e301-6c43-4f1e-82ec-35deaeb2d862 NO_OPERATING_VOLTAGE */
    '   ThisState := "48d2e301-6c43-4f1e-82ec-35deaeb2d862";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NO_OPERATING_VOLTAGE */
    ' 		/* standard */
    ' 		This.RtsExit_NO_OPERATING_VOLTAGE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"3a434511-0eba-445e-80cd-df00c7bb50d0",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6f895cc2-9f02-4994-8ce2-c881c34b6acb */  nullstat;/*##END 6f895cc2-9f02-4994-8ce2-c881c34b6acb */ /* #REF1546# */
    ' 		This.RtsDefault_OPERATING_VOLTAGE_SUPPLIED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED then
    ' /* #REF123# */
    ' 	/* da616023-5253-4e05-b886-1b1bb3e7a15e OPERATING_VOLTAGE_SUPPLIED */
    '   ThisState := "da616023-5253-4e05-b886-1b1bb3e7a15e";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_OPERATING_VOLTAGE_SUPPLIED */
    ' 		/* standard */
    ' 		This.RtsExit_OPERATING_VOLTAGE_SUPPLIED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"f6de535f-bdb1-4d7f-9713-24010fa30ec1",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2bdff95d-1d26-4962-beee-38965938fd35 */ 
    '  T18_Not_Ready_For_PDI_Connection := TRUE;
    '  T22_Data_Update_Stop := TRUE; nullstat;/*##END 2bdff95d-1d26-4962-beee-38965938fd35 */ /* #REF1546# */
    ' 		This.RtsEnter_NO_OPERATING_VOLTAGE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If (D20_Con_MDM_Used.GetLatchedValue()) And SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "fc8af9bc-75cd-4d88-9fe2-6369b6c7c511", 0, NullString)
          T21_Ready_For_PDI_Connection.SetValue(True)
          ChgFlg8 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If (D20_Con_MDM_Used.GetLatchedValue()) And SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8b985e31-e34e-4285-af38-059b531fca84", 0, NullString)
          T15_Data_Update_In_Initialising.SetValue(True)
          ChgFlg7 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If (NOT D20_Con_MDM_Used.GetLatchedValue()) And SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ab90d899-4003-433f-ab83-771c71bcac95", 0, NullString)
          T21_Ready_For_PDI_Connection.SetValue(True)
          ChgFlg6 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        ThisState = "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) And (NOT D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5180c282-17be-4c00-8f87-88345df90804", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7660d238-1b79-4c1a-8cc3-0f6384838195", 0, NullString)
          T21_Ready_For_PDI_Connection.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        ThisState = "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) And (D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5180c282-17be-4c00-8f87-88345df90804", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c7094d38-759f-436b-a3b8-f768c9d79e17", 0, NullString)
          T13_Data_Update_After_Booting.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        ThisState = "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9"
        If SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "25a8d0fb-7a48-4d93-8165-36208b292bb6", 0, NullString)
          Me.RtsEnter_FALLBACK_MODE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        ThisState = "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "d9ef2cde-a46b-4c43-9030-d3c86c4ba0c9", 0, NullString)
          Me.RtsEnter_FALLBACK_MODE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If (D20_Con_MDM_Used.GetLatchedValue()) And SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "9d12b216-4515-4bb5-9e04-f04cc9f81fd8", 0, NullString)
          Me.RtsEnter_BOOTING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) Then
          Me.RtsExit_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a72da017-7802-4fae-b997-e619c6efa5f2", 0, NullString)
          T18_Not_Ready_For_PDI_Connection.SetValue(True)
          T22_Data_Update_Stop.SetValue(True)
          Me.RtsEnter_BOOTING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) Then
          Me.RtsExit_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c75dc6af-e202-447c-97b5-ba2c42aad68e", 0, NullString)
          T18_Not_Ready_For_PDI_Connection.SetValue(True)
          T22_Data_Update_Stop.SetValue(True)
          Me.RtsEnter_FALLBACK_MODE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        ThisState = "8029dc51-ea65-45ea-84a9-d2e30f071170"
        If SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) Then
          Me.RtsExit_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "af8b8404-ed40-45bc-9476-b2deb6477512", 0, NullString)
          Me.RtsEnter_OPERATIONAL()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL Then
        ThisState = "a4636040-14bc-476e-ad26-646acfd7b1e2"
        If SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) And (D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_OPERATIONAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "234cc6ff-d067-4139-a4b7-18e4f7b18f93", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "473a171b-c9aa-4c91-a99a-887b1b93c31b", 0, NullString)
          T14_Data_Update_After_Operational.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL Then
        ThisState = "a4636040-14bc-476e-ad26-646acfd7b1e2"
        If SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) And (NOT D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_OPERATIONAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "234cc6ff-d067-4139-a4b7-18e4f7b18f93", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "29bf97ac-12cd-4348-b718-399618eddf48", 0, NullString)
          T21_Ready_For_PDI_Connection.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL Then
        ThisState = "a4636040-14bc-476e-ad26-646acfd7b1e2"
        If SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) Then
          Me.RtsExit_OPERATIONAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "4a4e18c4-9802-4412-812e-07b78a8b2898", 0, NullString)
          T18_Not_Ready_For_PDI_Connection.SetValue(True)
          Me.RtsEnter_BOOTING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL Then
        ThisState = "a4636040-14bc-476e-ad26-646acfd7b1e2"
        If SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) Then
          Me.RtsExit_OPERATIONAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "38781306-21cd-4575-98c5-41e1fe7caa79", 0, NullString)
          T18_Not_Ready_For_PDI_Connection.SetValue(True)
          Me.RtsEnter_FALLBACK_MODE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE Then
        ThisState = "27b5cf4a-4264-49c1-a4de-bb0da190439b"
        If SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) Then
          Me.RtsExit_FALLBACK_MODE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e7686964-6df2-4a1c-8fbe-4c853eb72e48", 0, NullString)
          Me.RtsEnter_BOOTING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_NotIn_F_EST_EfeS_SR Then
        ThisState = "4e930f52-6a26-4347-96d1-af6980f7568a"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "4e930f52-6a26-4347-96d1-af6980f7568a", 0, NullString)
        RtsNotify(Me, SEXIT, "4e930f52-6a26-4347-96d1-af6980f7568a", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "3a5596ad-c593-4a3a-a9e3-5bf451d83277", 0, NullString)
        cOp1_init()
        Me.RtsEnter_NO_OPERATING_VOLTAGE()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE Then
        ThisState = "48d2e301-6c43-4f1e-82ec-35deaeb2d862"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NO_OPERATING_VOLTAGE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "3a434511-0eba-445e-80cd-df00c7bb50d0", 0, NullString)
          Me.RtsDefault_OPERATING_VOLTAGE_SUPPLIED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED Then
        ThisState = "da616023-5253-4e05-b886-1b1bb3e7a15e"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_OPERATING_VOLTAGE_SUPPLIED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "f6de535f-bdb1-4d7f-9713-24010fa30ec1", 0, NullString)
          T18_Not_Ready_For_PDI_Connection.SetValue(True)
          T22_Data_Update_Stop.SetValue(True)
          Me.RtsEnter_NO_OPERATING_VOLTAGE()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "e27d2f54-250b-41b4-93ec-84cbc2ed656f", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttBOOTING_Timer1);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_F_EST_EfeS_SR := RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_NotIn_F_EST_EfeS_SR;/* #REF1566# */
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_NotIn_OPERATING_VOLTAGE_SUPPLIED;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "e27d2f54-250b-41b4-93ec-84cbc2ed656f", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttBOOTING_Timer1)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_NotIn_F_EST_EfeS_SR
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_NotIn_OPERATING_VOLTAGE_SUPPLIED
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : NO_OPERATING_VOLTAGE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("48d2e301-6c43-4f1e-82ec-35deaeb2d862|") then
    '   OperatedStates := OperatedStates + "48d2e301-6c43-4f1e-82ec-35deaeb2d862|";
    ' end if
    ' // Simulation support : Notification function call for entering state : NO_OPERATING_VOLTAGE ///* #REF520# */
    ' RtsNotify(This,SENTER,"48d2e301-6c43-4f1e-82ec-35deaeb2d862",0,NullString);
    ' 
    ' SimCore.EnterState("48d2e301-6c43-4f1e-82ec-35deaeb2d862","NO_OPERATING_VOLTAGE");
    ' 
    ' This.RtsCurrent_F_EST_EfeS_SR := RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT ac32b218-fe6c-4739-8c97-6d5874aa29d4 */  D51_EST_EfeS_State := "NO_OPERATING_VOLTAGE"; nullstat;/*##END ac32b218-fe6c-4739-8c97-6d5874aa29d4 */ 
    Private Sub RtsEnter_NO_OPERATING_VOLTAGE()
      If not OperatedStates.Contains("48d2e301-6c43-4f1e-82ec-35deaeb2d862|") Then
        OperatedStates = OperatedStates + "48d2e301-6c43-4f1e-82ec-35deaeb2d862|"
      End If
      'Simulation support : Notification function call for entering state : NO_OPERATING_VOLTAGE ///* #REF520# */
      RtsNotify(Me, SENTER, "48d2e301-6c43-4f1e-82ec-35deaeb2d862", 0, NullString)
      SimCore.EnterState("48d2e301-6c43-4f1e-82ec-35deaeb2d862", "NO_OPERATING_VOLTAGE")
      Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE
      'Entry Actions
      D51_EST_EfeS_State.SetValue("NO_OPERATING_VOLTAGE")
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING_VOLTAGE_SUPPLIED
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("da616023-5253-4e05-b886-1b1bb3e7a15e|") then
    '   OperatedStates := OperatedStates + "da616023-5253-4e05-b886-1b1bb3e7a15e|";
    ' end if
    ' // Simulation support : Notification function call for entering state : OPERATING_VOLTAGE_SUPPLIED ///* #REF520# */
    ' RtsNotify(This,SENTER,"da616023-5253-4e05-b886-1b1bb3e7a15e",0,NullString);
    ' 
    ' SimCore.EnterState("da616023-5253-4e05-b886-1b1bb3e7a15e","OPERATING_VOLTAGE_SUPPLIED");
    ' 
    ' This.RtsCurrent_F_EST_EfeS_SR := RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED;/* #REF521# */
    ' 
    Private Sub RtsEnter_OPERATING_VOLTAGE_SUPPLIED()
      If not OperatedStates.Contains("da616023-5253-4e05-b886-1b1bb3e7a15e|") Then
        OperatedStates = OperatedStates + "da616023-5253-4e05-b886-1b1bb3e7a15e|"
      End If
      'Simulation support : Notification function call for entering state : OPERATING_VOLTAGE_SUPPLIED ///* #REF520# */
      RtsNotify(Me, SENTER, "da616023-5253-4e05-b886-1b1bb3e7a15e", 0, NullString)
      SimCore.EnterState("da616023-5253-4e05-b886-1b1bb3e7a15e", "OPERATING_VOLTAGE_SUPPLIED")
      Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED
    End Sub
    
    ' \ART_SMG :: Created for state : BOOTING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|") then
    '   OperatedStates := OperatedStates + "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|";
    ' end if
    ' // Simulation support : Notification function call for entering state : BOOTING ///* #REF520# */
    ' RtsNotify(This,SENTER,"584378e8-56e4-4e55-95b6-e6ab3b8cb2d9",0,NullString);
    ' 
    ' SimCore.EnterState("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9","OPERATING_VOLTAGE_SUPPLIED::BOOTING");
    ' 
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 20a23383-1b2f-42f8-963e-f0d697f8c142 */  D51_EST_EfeS_State := "BOOTING"; nullstat;/*##END 20a23383-1b2f-42f8-963e-f0d697f8c142 */ /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttBOOTING_Timer1, /*##STRT 5ca5bc20-8cc3-467e-9291-9783acb8568b */ D44_Con_tmax_Booting/*##END 5ca5bc20-8cc3-467e-9291-9783acb8568b */ , CurrentTime);
    Private Sub RtsEnter_BOOTING()
      If not OperatedStates.Contains("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|") Then
        OperatedStates = OperatedStates + "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|"
      End If
      'Simulation support : Notification function call for entering state : BOOTING ///* #REF520# */
      RtsNotify(Me, SENTER, "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9", 0, NullString)
      SimCore.EnterState("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9", "OPERATING_VOLTAGE_SUPPLIED::BOOTING")
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING
      'Entry Actions
      D51_EST_EfeS_State.SetValue("BOOTING")
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttBOOTING_Timer1, D44_Con_tmax_Booting.GetLatchedValue(), CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : INITIALISING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("8029dc51-ea65-45ea-84a9-d2e30f071170|") then
    '   OperatedStates := OperatedStates + "8029dc51-ea65-45ea-84a9-d2e30f071170|";
    ' end if
    ' // Simulation support : Notification function call for entering state : INITIALISING ///* #REF520# */
    ' RtsNotify(This,SENTER,"8029dc51-ea65-45ea-84a9-d2e30f071170",0,NullString);
    ' 
    ' SimCore.EnterState("8029dc51-ea65-45ea-84a9-d2e30f071170","OPERATING_VOLTAGE_SUPPLIED::INITIALISING");
    ' 
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 58e59a85-5b32-4615-b93d-156d10a568c5 */  D51_EST_EfeS_State := "INITIALISING"; nullstat;/*##END 58e59a85-5b32-4615-b93d-156d10a568c5 */ 
    Private Sub RtsEnter_INITIALISING()
      If not OperatedStates.Contains("8029dc51-ea65-45ea-84a9-d2e30f071170|") Then
        OperatedStates = OperatedStates + "8029dc51-ea65-45ea-84a9-d2e30f071170|"
      End If
      'Simulation support : Notification function call for entering state : INITIALISING ///* #REF520# */
      RtsNotify(Me, SENTER, "8029dc51-ea65-45ea-84a9-d2e30f071170", 0, NullString)
      SimCore.EnterState("8029dc51-ea65-45ea-84a9-d2e30f071170", "OPERATING_VOLTAGE_SUPPLIED::INITIALISING")
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING
      'Entry Actions
      D51_EST_EfeS_State.SetValue("INITIALISING")
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATIONAL
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("a4636040-14bc-476e-ad26-646acfd7b1e2|") then
    '   OperatedStates := OperatedStates + "a4636040-14bc-476e-ad26-646acfd7b1e2|";
    ' end if
    ' // Simulation support : Notification function call for entering state : OPERATIONAL ///* #REF520# */
    ' RtsNotify(This,SENTER,"a4636040-14bc-476e-ad26-646acfd7b1e2",0,NullString);
    ' 
    ' SimCore.EnterState("a4636040-14bc-476e-ad26-646acfd7b1e2","OPERATING_VOLTAGE_SUPPLIED::OPERATIONAL");
    ' 
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 3e37b8a7-1d4d-41c1-a953-94952b02767b */  D51_EST_EfeS_State := "OPERATIONAL"; nullstat;/*##END 3e37b8a7-1d4d-41c1-a953-94952b02767b */ 
    Private Sub RtsEnter_OPERATIONAL()
      If not OperatedStates.Contains("a4636040-14bc-476e-ad26-646acfd7b1e2|") Then
        OperatedStates = OperatedStates + "a4636040-14bc-476e-ad26-646acfd7b1e2|"
      End If
      'Simulation support : Notification function call for entering state : OPERATIONAL ///* #REF520# */
      RtsNotify(Me, SENTER, "a4636040-14bc-476e-ad26-646acfd7b1e2", 0, NullString)
      SimCore.EnterState("a4636040-14bc-476e-ad26-646acfd7b1e2", "OPERATING_VOLTAGE_SUPPLIED::OPERATIONAL")
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL
      'Entry Actions
      D51_EST_EfeS_State.SetValue("OPERATIONAL")
    End Sub
    
    ' \ART_SMG :: Created for state : FALLBACK_MODE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("27b5cf4a-4264-49c1-a4de-bb0da190439b|") then
    '   OperatedStates := OperatedStates + "27b5cf4a-4264-49c1-a4de-bb0da190439b|";
    ' end if
    ' // Simulation support : Notification function call for entering state : FALLBACK_MODE ///* #REF520# */
    ' RtsNotify(This,SENTER,"27b5cf4a-4264-49c1-a4de-bb0da190439b",0,NullString);
    ' 
    ' SimCore.EnterState("27b5cf4a-4264-49c1-a4de-bb0da190439b","OPERATING_VOLTAGE_SUPPLIED::FALLBACK_MODE");
    ' 
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 01d1dbf9-a264-4e8b-a940-dec3af1ea274 */  D51_EST_EfeS_State := "FALLBACK_MODE"; nullstat;/*##END 01d1dbf9-a264-4e8b-a940-dec3af1ea274 */ 
    Private Sub RtsEnter_FALLBACK_MODE()
      If not OperatedStates.Contains("27b5cf4a-4264-49c1-a4de-bb0da190439b|") Then
        OperatedStates = OperatedStates + "27b5cf4a-4264-49c1-a4de-bb0da190439b|"
      End If
      'Simulation support : Notification function call for entering state : FALLBACK_MODE ///* #REF520# */
      RtsNotify(Me, SENTER, "27b5cf4a-4264-49c1-a4de-bb0da190439b", 0, NullString)
      SimCore.EnterState("27b5cf4a-4264-49c1-a4de-bb0da190439b", "OPERATING_VOLTAGE_SUPPLIED::FALLBACK_MODE")
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE
      'Entry Actions
      D51_EST_EfeS_State.SetValue("FALLBACK_MODE")
    End Sub
    
    ' \ART_SMG :: Created for state : NO_OPERATING_VOLTAGE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : NO_OPERATING_VOLTAGE
    ' 	RtsNotify(This,SEXIT,"48d2e301-6c43-4f1e-82ec-35deaeb2d862",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_NO_OPERATING_VOLTAGE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_NO_OPERATING_VOLTAGE()
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_NO_OPERATING_VOLTAGE Then
        'Simulation support : Notification function call for exiting state : NO_OPERATING_VOLTAGE
        RtsNotify(Me, SEXIT, "48d2e301-6c43-4f1e-82ec-35deaeb2d862", 0, NullString)
        RtsExitSSOf_NO_OPERATING_VOLTAGE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING_VOLTAGE_SUPPLIED
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : OPERATING_VOLTAGE_SUPPLIED
    ' 	RtsNotify(This,SEXIT,"da616023-5253-4e05-b886-1b1bb3e7a15e",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_OPERATING_VOLTAGE_SUPPLIED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_OPERATING_VOLTAGE_SUPPLIED()
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED Then
        'Simulation support : Notification function call for exiting state : OPERATING_VOLTAGE_SUPPLIED
        RtsNotify(Me, SEXIT, "da616023-5253-4e05-b886-1b1bb3e7a15e", 0, NullString)
        RtsExitSSOf_OPERATING_VOLTAGE_SUPPLIED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : BOOTING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : BOOTING
    ' 	RtsNotify(This,SEXIT,"584378e8-56e4-4e55-95b6-e6ab3b8cb2d9",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_BOOTING ();
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttBOOTING_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_BOOTING()
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        'Simulation support : Notification function call for exiting state : BOOTING
        RtsNotify(Me, SEXIT, "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9", 0, NullString)
        RtsExitSSOf_BOOTING()
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttBOOTING_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : INITIALISING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : INITIALISING
    ' 	RtsNotify(This,SEXIT,"8029dc51-ea65-45ea-84a9-d2e30f071170",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_INITIALISING ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_INITIALISING()
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING Then
        'Simulation support : Notification function call for exiting state : INITIALISING
        RtsNotify(Me, SEXIT, "8029dc51-ea65-45ea-84a9-d2e30f071170", 0, NullString)
        RtsExitSSOf_INITIALISING()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATIONAL
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : OPERATIONAL
    ' 	RtsNotify(This,SEXIT,"a4636040-14bc-476e-ad26-646acfd7b1e2",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_OPERATIONAL ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_OPERATIONAL()
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL Then
        'Simulation support : Notification function call for exiting state : OPERATIONAL
        RtsNotify(Me, SEXIT, "a4636040-14bc-476e-ad26-646acfd7b1e2", 0, NullString)
        RtsExitSSOf_OPERATIONAL()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : FALLBACK_MODE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : FALLBACK_MODE
    ' 	RtsNotify(This,SEXIT,"27b5cf4a-4264-49c1-a4de-bb0da190439b",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_FALLBACK_MODE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_FALLBACK_MODE()
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE Then
        'Simulation support : Notification function call for exiting state : FALLBACK_MODE
        RtsNotify(Me, SEXIT, "27b5cf4a-4264-49c1-a4de-bb0da190439b", 0, NullString)
        RtsExitSSOf_FALLBACK_MODE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING_VOLTAGE_SUPPLIED
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"f8afd5a1-8c33-479f-9a3e-de908503cccf",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"f8afd5a1-8c33-479f-9a3e-de908503cccf",0,NullString);/* #REF1576# */
    ' This.RtsEnter_OPERATING_VOLTAGE_SUPPLIED();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"ed18ff19-8669-4d59-bde0-ef33252b7e94",0,NullString);/* #REF1585# */
    ' /*##STRT 701f6f98-a35b-4693-8df5-b904edcc6e48 */  nullstat;/*##END 701f6f98-a35b-4693-8df5-b904edcc6e48 */ /* #REF1546# */
    ' This.RtsEnter_BOOTING();/* #REF1590# */
    ' 
    Private Sub RtsDefault_OPERATING_VOLTAGE_SUPPLIED()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "f8afd5a1-8c33-479f-9a3e-de908503cccf", 0, NullString)
      RtsNotify(Me, SEXIT, "f8afd5a1-8c33-479f-9a3e-de908503cccf", 0, NullString)
      Me.RtsEnter_OPERATING_VOLTAGE_SUPPLIED()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "ed18ff19-8669-4d59-bde0-ef33252b7e94", 0, NullString)
      Me.RtsEnter_BOOTING()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As F_EST_EfeS_SR)
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_EST_EfeS_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_EST_EfeS_SR, "RtsF_EST_EfeS_SR_States");
    ' end if
    ' if Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_F_EST_EfeS_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_EST_EfeS_SR, "RtsF_EST_EfeS_SR_States");
    ' end if
    ' if Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "e27d2f54-250b-41b4-93ec-84cbc2ed656f";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "6";
    '   Value := Value + "|RtsCurrent_F_EST_EfeS_SR";
    '   Value := Value + "|RtsCurrent_OPERATING_VOLTAGE_SUPPLIED";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_F_EST_EfeS_SR";
    '   Value := Value + "|RtsCurrent_OPERATING_VOLTAGE_SUPPLIED";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As F_EST_EfeS_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_EST_EfeS_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_EST_EfeS_SR, "RtsF_EST_EfeS_SR_States")
      End If
      If Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_F_EST_EfeS_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_EST_EfeS_SR, "RtsF_EST_EfeS_SR_States")
      End If
      If Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "e27d2f54-250b-41b4-93ec-84cbc2ed656f"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "6"
        Value = Value + "|RtsCurrent_F_EST_EfeS_SR"
        Value = Value + "|RtsCurrent_OPERATING_VOLTAGE_SUPPLIED"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_F_EST_EfeS_SR"
        Value = Value + "|RtsCurrent_OPERATING_VOLTAGE_SUPPLIED"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_EST_EfeS_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_EST_EfeS_SR, Value, "RtsF_EST_EfeS_SR_States", GetType(F_EST_EfeS_SR.RtsF_EST_EfeS_SR_States));
    ' end if
    ' if Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, Value, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States", GetType(F_EST_EfeS_SR.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As F_EST_EfeS_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_EST_EfeS_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_EST_EfeS_SR, Value, "RtsF_EST_EfeS_SR_States", GetType(F_EST_EfeS_SR.RtsF_EST_EfeS_SR_States))
      End If
      If Name = "RtsCurrent_OPERATING_VOLTAGE_SUPPLIED" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED, Value, "RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States", GetType(F_EST_EfeS_SR.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : BOOTING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttBOOTING_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsBOOTING_Timer1_In_F_EST_EfeS_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsBOOTING_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttBOOTING_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsBOOTING_Timer1_In_F_EST_EfeS_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' // H1 OPERATING_VOLTAGE_SUPPLIED
    ' // H1 OPERATING_VOLTAGE_SUPPLIED - call into substate
    ' if This.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States{enum_datatype}.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsBOOTING_Timer1_In_OPERATING_VOLTAGE_SUPPLIED(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsBOOTING_Timer1_In_F_EST_EfeS_SR(ByRef RetValue As Boolean)
      'H1 OPERATING_VOLTAGE_SUPPLIED
      'H1 OPERATING_VOLTAGE_SUPPLIED - call into substate
      If Me.RtsCurrent_F_EST_EfeS_SR = RtsF_EST_EfeS_SR_States.RtsF_EST_EfeS_SR_States_OPERATING_VOLTAGE_SUPPLIED Then
        RtsBOOTING_Timer1_In_OPERATING_VOLTAGE_SUPPLIED(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' // H1 BOOTING
    ' if This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING then/* #REF5# */
    ' /* #REF6# */
    ' 	if /* #REF2000# *//*##STRT 92bfe9ad-8f20-4a7b-bc63-570d58d329b8 */ (NOT D20_Con_MDM_Used )/*##END 92bfe9ad-8f20-4a7b-bc63-570d58d329b8 */  then/* #REF11# */
    ' 	/* #REF12# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"84e0ede4-5fdc-4923-9320-951e086aa965",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7660d238-1b79-4c1a-8cc3-0f6384838195",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5ca5bc20-8cc3-467e-9291-9783acb8568b */  nullstat;/*##END 5ca5bc20-8cc3-467e-9291-9783acb8568b */ /* #REF1544# */
    ' 	/*##STRT 9e7107b0-623b-4ba4-b7f6-40f8dcd30ae7 */ 
    '  T21_Ready_For_PDI_Connection := TRUE; nullstat;/*##END 9e7107b0-623b-4ba4-b7f6-40f8dcd30ae7 */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		/* #REF13# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF14# */
    ' 	end if
    ' 	if /* #REF2000# *//*##STRT f25fceeb-8178-4ade-9253-4055bdb6fea3 */ ( D20_Con_MDM_Used )/*##END f25fceeb-8178-4ade-9253-4055bdb6fea3 */  then/* #REF11# */
    ' 	/* #REF12# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_BOOTING */
    ' 		/* standard */
    ' 		This.RtsExit_BOOTING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"84e0ede4-5fdc-4923-9320-951e086aa965",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c7094d38-759f-436b-a3b8-f768c9d79e17",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5ca5bc20-8cc3-467e-9291-9783acb8568b */  nullstat;/*##END 5ca5bc20-8cc3-467e-9291-9783acb8568b */ /* #REF1544# */
    ' 	/*##STRT 779111ac-4743-40e8-9fd3-fbed24761bb4 */ 
    '  T13_Data_Update_After_Booting := TRUE; nullstat;/*##END 779111ac-4743-40e8-9fd3-fbed24761bb4 */ /* #REF1546# */
    ' 		This.RtsEnter_INITIALISING();/* #REF1590# */
    ' 		/* #REF13# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF14# */
    ' 	end if
    ' 	/* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsBOOTING_Timer1_In_OPERATING_VOLTAGE_SUPPLIED(ByRef RetValue As Boolean)
      'H1 BOOTING
      If Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING Then
        If (NOT D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "84e0ede4-5fdc-4923-9320-951e086aa965", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7660d238-1b79-4c1a-8cc3-0f6384838195", 0, NullString)
          T21_Ready_For_PDI_Connection.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
        If (D20_Con_MDM_Used.GetLatchedValue()) Then
          Me.RtsExit_BOOTING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "84e0ede4-5fdc-4923-9320-951e086aa965", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c7094d38-759f-436b-a3b8-f768c9d79e17", 0, NullString)
          T13_Data_Update_After_Booting.SetValue(True)
          Me.RtsEnter_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Created for state : NO_OPERATING_VOLTAGE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("48d2e301-6c43-4f1e-82ec-35deaeb2d862|") then
    '   OperatedStates := OperatedStates + "48d2e301-6c43-4f1e-82ec-35deaeb2d862|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_NO_OPERATING_VOLTAGE()
      If not OperatedStates.Contains("48d2e301-6c43-4f1e-82ec-35deaeb2d862|") Then
        OperatedStates = OperatedStates + "48d2e301-6c43-4f1e-82ec-35deaeb2d862|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING_VOLTAGE_SUPPLIED
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("da616023-5253-4e05-b886-1b1bb3e7a15e|") then
    '   OperatedStates := OperatedStates + "da616023-5253-4e05-b886-1b1bb3e7a15e|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED
    ' /* #REF738# */
    ' 	case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_BOOTING();/* #REF742# */
    ' 	case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_INITIALISING();/* #REF742# */
    ' 	case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_OPERATIONAL();/* #REF742# */
    ' 	case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_FALLBACK_MODE();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED := RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States{enum_datatype}.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_NotIn_OPERATING_VOLTAGE_SUPPLIED;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_OPERATING_VOLTAGE_SUPPLIED()
      If not OperatedStates.Contains("da616023-5253-4e05-b886-1b1bb3e7a15e|") Then
        OperatedStates = OperatedStates + "da616023-5253-4e05-b886-1b1bb3e7a15e|"
      End If
      Select Case Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED
        Case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_BOOTING
          Me.RtsExit_BOOTING()
        Case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_INITIALISING
          Me.RtsExit_INITIALISING()
        Case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_OPERATIONAL
          Me.RtsExit_OPERATIONAL()
        Case RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_FALLBACK_MODE
          Me.RtsExit_FALLBACK_MODE()
      End Select
      Me.RtsCurrent_OPERATING_VOLTAGE_SUPPLIED = RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States.RtsF_EST_EfeS_SROPERATING_VOLTAGE_SUPPLIED_States_NotIn_OPERATING_VOLTAGE_SUPPLIED
    End Sub
    
    ' \ART_SMG :: Created for state : BOOTING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|") then
    '   OperatedStates := OperatedStates + "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_BOOTING()
      If not OperatedStates.Contains("584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|") Then
        OperatedStates = OperatedStates + "584378e8-56e4-4e55-95b6-e6ab3b8cb2d9|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : INITIALISING
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("8029dc51-ea65-45ea-84a9-d2e30f071170|") then
    '   OperatedStates := OperatedStates + "8029dc51-ea65-45ea-84a9-d2e30f071170|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_INITIALISING()
      If not OperatedStates.Contains("8029dc51-ea65-45ea-84a9-d2e30f071170|") Then
        OperatedStates = OperatedStates + "8029dc51-ea65-45ea-84a9-d2e30f071170|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATIONAL
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("a4636040-14bc-476e-ad26-646acfd7b1e2|") then
    '   OperatedStates := OperatedStates + "a4636040-14bc-476e-ad26-646acfd7b1e2|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_OPERATIONAL()
      If not OperatedStates.Contains("a4636040-14bc-476e-ad26-646acfd7b1e2|") Then
        OperatedStates = OperatedStates + "a4636040-14bc-476e-ad26-646acfd7b1e2|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : FALLBACK_MODE
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' if not OperatedStates.Contains ("27b5cf4a-4264-49c1-a4de-bb0da190439b|") then
    '   OperatedStates := OperatedStates + "27b5cf4a-4264-49c1-a4de-bb0da190439b|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_FALLBACK_MODE()
      If not OperatedStates.Contains("27b5cf4a-4264-49c1-a4de-bb0da190439b|") Then
        OperatedStates = OperatedStates + "27b5cf4a-4264-49c1-a4de-bb0da190439b|"
      End If
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' This.RtsAttBOOTING_Timer1.TStep(CurrentTime);
    ' if This.RtsAttBOOTING_Timer1.HasElapsed() then
    '   This.RtsAttBOOTING_Timer1.TStop();
    '   RtsBOOTING_Timer1_CallBack(This);
    ' end if
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttBOOTING_Timer1.TimeToLive());
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      Me.RtsAttBOOTING_Timer1.TStep(CurrentTime)
      If Me.RtsAttBOOTING_Timer1.HasElapsed() Then
        Me.RtsAttBOOTING_Timer1.TStop()
        RtsBOOTING_Timer1_CallBack(Me)
      End If
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttBOOTING_Timer1.TimeToLive())
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D20_Con_MDM_Used: a SySimInputPort;
    ' assume D44_Con_tmax_Booting: a SySimInputPort;
    ' assume D51_EST_EfeS_State: a SySimOutputPort;
    ' assume T10_PDI_Connection_Terminated: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimOutputPort;
    ' assume T14_Data_Update_After_Operational: a SySimOutputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimOutputPort;
    ' assume T16_Data_Installation_Complete: a SySimInputPort;
    ' assume T17_Data_Update_Finished: a SySimInputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T1_Power_On_Detected: a SySimInputPort;
    ' assume T21_Ready_For_PDI_Connection: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimOutputPort;
    ' assume T2_Power_Off_Detected: a SySimInputPort;
    ' assume T3_Reset: a SySimInputPort;
    ' assume T4_Booted: a SySimInputPort;
    ' assume T5_SIL_Not_Fulfilled: a SySimInputPort;
    ' assume T7_Invalid_Or_Missing_Basic_Data: a SySimInputPort;
    ' assume T9_PDI_Connection_Established: a SySimInputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg16Tmp := (/*##STRT 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ( T3_Reset )/*##END 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ) : Boolean;
    ' ChgFlg16 := EvalTrigger(ChgFlg16Tmp , ChgFlgLast16);
    ' declare ChgFlg9Tmp := (/*##STRT 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ( T16_Data_Installation_Complete )/*##END 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg5Tmp := (/*##STRT 6bfbe6fb-6672-44f5-804f-361f26110167 */ ( T7_Invalid_Or_Missing_Basic_Data )/*##END 6bfbe6fb-6672-44f5-804f-361f26110167 */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg2Tmp := (/*##STRT 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ( T2_Power_Off_Detected )/*##END 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' declare ChgFlg4Tmp := (/*##STRT 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ( T5_SIL_Not_Fulfilled )/*##END 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg3Tmp := (/*##STRT 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ( T4_Booted )/*##END 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg1Tmp := (/*##STRT 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ( T1_Power_On_Detected )/*##END 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg7Tmp := (/*##STRT 0d066d71-7739-43f3-802a-106a693591af */ ( T10_PDI_Connection_Terminated )/*##END 0d066d71-7739-43f3-802a-106a693591af */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg13Tmp := (/*##STRT 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ( T10_PDI_Connection_Terminated )/*##END 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ) : Boolean;
    ' ChgFlg13 := EvalTrigger(ChgFlg13Tmp , ChgFlgLast13);
    ' declare ChgFlg10Tmp := (/*##STRT 3088bce6-f058-407b-8a45-9c2ba023f274 */ ( T3_Reset )/*##END 3088bce6-f058-407b-8a45-9c2ba023f274 */ ) : Boolean;
    ' ChgFlg10 := EvalTrigger(ChgFlg10Tmp , ChgFlgLast10);
    ' declare ChgFlg6Tmp := (/*##STRT f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ( T10_PDI_Connection_Terminated )/*##END f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg11Tmp := (/*##STRT 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ( T5_SIL_Not_Fulfilled )/*##END 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ) : Boolean;
    ' ChgFlg11 := EvalTrigger(ChgFlg11Tmp , ChgFlgLast11);
    ' declare ChgFlg15Tmp := (/*##STRT 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ( T5_SIL_Not_Fulfilled )/*##END 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ) : Boolean;
    ' ChgFlg15 := EvalTrigger(ChgFlg15Tmp , ChgFlgLast15);
    ' declare ChgFlg12Tmp := (/*##STRT 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ( T9_PDI_Connection_Established )/*##END 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ) : Boolean;
    ' ChgFlg12 := EvalTrigger(ChgFlg12Tmp , ChgFlgLast12);
    ' declare ChgFlg14Tmp := (/*##STRT 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ( T3_Reset )/*##END 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ) : Boolean;
    ' ChgFlg14 := EvalTrigger(ChgFlg14Tmp , ChgFlgLast14);
    ' declare ChgFlg8Tmp := (/*##STRT 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ( T17_Data_Update_Finished )/*##END 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast16 := ChgFlg16Tmp;
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast13 := ChgFlg13Tmp;
    ' ChgFlgLast10 := ChgFlg10Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast11 := ChgFlg11Tmp;
    ' ChgFlgLast15 := ChgFlg15Tmp;
    ' ChgFlgLast12 := ChgFlg12Tmp;
    ' ChgFlgLast14 := ChgFlg14Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg16 := (/*##STRT 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ( T3_Reset )/*##END 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ) : Boolean;
    '   declare MaskedChgFlg9 := (/*##STRT 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ( T16_Data_Installation_Complete )/*##END 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT 6bfbe6fb-6672-44f5-804f-361f26110167 */ ( T7_Invalid_Or_Missing_Basic_Data )/*##END 6bfbe6fb-6672-44f5-804f-361f26110167 */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ( T2_Power_Off_Detected )/*##END 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ( T5_SIL_Not_Fulfilled )/*##END 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ( T4_Booted )/*##END 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ( T1_Power_On_Detected )/*##END 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT 0d066d71-7739-43f3-802a-106a693591af */ ( T10_PDI_Connection_Terminated )/*##END 0d066d71-7739-43f3-802a-106a693591af */ ) : Boolean;
    '   declare MaskedChgFlg13 := (/*##STRT 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ( T10_PDI_Connection_Terminated )/*##END 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ) : Boolean;
    '   declare MaskedChgFlg10 := (/*##STRT 3088bce6-f058-407b-8a45-9c2ba023f274 */ ( T3_Reset )/*##END 3088bce6-f058-407b-8a45-9c2ba023f274 */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ( T10_PDI_Connection_Terminated )/*##END f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ) : Boolean;
    '   declare MaskedChgFlg11 := (/*##STRT 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ( T5_SIL_Not_Fulfilled )/*##END 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ) : Boolean;
    '   declare MaskedChgFlg15 := (/*##STRT 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ( T5_SIL_Not_Fulfilled )/*##END 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ) : Boolean;
    '   declare MaskedChgFlg12 := (/*##STRT 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ( T9_PDI_Connection_Established )/*##END 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ) : Boolean;
    '   declare MaskedChgFlg14 := (/*##STRT 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ( T3_Reset )/*##END 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ( T17_Data_Update_Finished )/*##END 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg16 := (/*##STRT 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ( T3_Reset )/*##END 2aac0b22-2761-4f74-80f0-f878a56ff51c */ ) : Boolean;
    '   declare UnMaskedChgFlg9 := (/*##STRT 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ( T16_Data_Installation_Complete )/*##END 2dc41f65-3e4e-4e26-a6b3-f22924283e8a */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT 6bfbe6fb-6672-44f5-804f-361f26110167 */ ( T7_Invalid_Or_Missing_Basic_Data )/*##END 6bfbe6fb-6672-44f5-804f-361f26110167 */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ( T2_Power_Off_Detected )/*##END 5a7a4dde-405d-4d9c-8103-afa9ac1dded7 */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ( T5_SIL_Not_Fulfilled )/*##END 426b843f-a0ec-4dbb-ab93-4e42799d9fa9 */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ( T4_Booted )/*##END 8b57f920-1616-4dbb-bd2f-0069a1796c04 */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ( T1_Power_On_Detected )/*##END 5c571ddd-ee68-4292-ad8a-5731f0eb03c3 */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT 0d066d71-7739-43f3-802a-106a693591af */ ( T10_PDI_Connection_Terminated )/*##END 0d066d71-7739-43f3-802a-106a693591af */ ) : Boolean;
    '   declare UnMaskedChgFlg13 := (/*##STRT 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ( T10_PDI_Connection_Terminated )/*##END 81e60bbe-992a-4a08-a2f5-e5e18cbc51a8 */ ) : Boolean;
    '   declare UnMaskedChgFlg10 := (/*##STRT 3088bce6-f058-407b-8a45-9c2ba023f274 */ ( T3_Reset )/*##END 3088bce6-f058-407b-8a45-9c2ba023f274 */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ( T10_PDI_Connection_Terminated )/*##END f79ec9ae-4643-498e-930c-986adfb3e5b8 */ ) : Boolean;
    '   declare UnMaskedChgFlg11 := (/*##STRT 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ( T5_SIL_Not_Fulfilled )/*##END 6b0b1c61-3156-4808-b212-3f6f1098c3da */ ) : Boolean;
    '   declare UnMaskedChgFlg15 := (/*##STRT 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ( T5_SIL_Not_Fulfilled )/*##END 21f6bd97-32da-4b5f-aaef-bd0cc2752b71 */ ) : Boolean;
    '   declare UnMaskedChgFlg12 := (/*##STRT 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ( T9_PDI_Connection_Established )/*##END 7fe246d7-d82a-4271-950b-5bb1a97fce55 */ ) : Boolean;
    '   declare UnMaskedChgFlg14 := (/*##STRT 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ( T3_Reset )/*##END 649b94ea-b1b5-4e22-b9c1-30910f825081 */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ( T17_Data_Update_Finished )/*##END 209fe0ab-f7c0-46d0-ae44-8f6d32f68503 */ ) : Boolean;
    '   declare PreviousChgFlg16 := ChgFlg16 : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg13 := ChgFlg13 : Boolean;
    '   declare PreviousChgFlg10 := ChgFlg10 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg11 := ChgFlg11 : Boolean;
    '   declare PreviousChgFlg15 := ChgFlg15 : Boolean;
    '   declare PreviousChgFlg12 := ChgFlg12 : Boolean;
    '   declare PreviousChgFlg14 := ChgFlg14 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := True;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := True;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := True;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := True;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := True;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := True;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := True;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := True;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := True;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := True;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := True;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := True;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := True;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := True;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := True;
    '   ChgFlg8 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg16 := False;
    '   ChgFlg9 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '   ChgFlg4 := False;
    '   ChgFlg3 := False;
    '   ChgFlg1 := False;
    '   ChgFlg7 := False;
    '   ChgFlg13 := False;
    '   ChgFlg10 := False;
    '   ChgFlg6 := False;
    '   ChgFlg11 := False;
    '   ChgFlg15 := False;
    '   ChgFlg12 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg16 := false;
    ' ChgFlg9 := false;
    ' ChgFlg5 := false;
    ' ChgFlg2 := false;
    ' ChgFlg4 := false;
    ' ChgFlg3 := false;
    ' ChgFlg1 := false;
    ' ChgFlg7 := false;
    ' ChgFlg13 := false;
    ' ChgFlg10 := false;
    ' ChgFlg6 := false;
    ' ChgFlg11 := false;
    ' ChgFlg15 := false;
    ' ChgFlg12 := false;
    ' ChgFlg14 := false;
    ' ChgFlg8 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg16Tmp As Boolean = ((T3_Reset.GetLatchedValue()))
      ChgFlg16 = EvalTrigger(ChgFlg16Tmp, ChgFlgLast16)
      Dim ChgFlg9Tmp As Boolean = ((T16_Data_Installation_Complete.GetLatchedValue()))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg5Tmp As Boolean = ((T7_Invalid_Or_Missing_Basic_Data.GetLatchedValue()))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg2Tmp As Boolean = ((T2_Power_Off_Detected.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      Dim ChgFlg4Tmp As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg3Tmp As Boolean = ((T4_Booted.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg1Tmp As Boolean = ((T1_Power_On_Detected.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg7Tmp As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg13Tmp As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
      ChgFlg13 = EvalTrigger(ChgFlg13Tmp, ChgFlgLast13)
      Dim ChgFlg10Tmp As Boolean = ((T3_Reset.GetLatchedValue()))
      ChgFlg10 = EvalTrigger(ChgFlg10Tmp, ChgFlgLast10)
      Dim ChgFlg6Tmp As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg11Tmp As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
      ChgFlg11 = EvalTrigger(ChgFlg11Tmp, ChgFlgLast11)
      Dim ChgFlg15Tmp As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
      ChgFlg15 = EvalTrigger(ChgFlg15Tmp, ChgFlgLast15)
      Dim ChgFlg12Tmp As Boolean = ((T9_PDI_Connection_Established.GetLatchedValue()))
      ChgFlg12 = EvalTrigger(ChgFlg12Tmp, ChgFlgLast12)
      Dim ChgFlg14Tmp As Boolean = ((T3_Reset.GetLatchedValue()))
      ChgFlg14 = EvalTrigger(ChgFlg14Tmp, ChgFlgLast14)
      Dim ChgFlg8Tmp As Boolean = ((T17_Data_Update_Finished.GetLatchedValue()))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast16 = ChgFlg16Tmp
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast13 = ChgFlg13Tmp
      ChgFlgLast10 = ChgFlg10Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast11 = ChgFlg11Tmp
      ChgFlgLast15 = ChgFlg15Tmp
      ChgFlgLast12 = ChgFlg12Tmp
      ChgFlgLast14 = ChgFlg14Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg16 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim MaskedChgFlg9 As Boolean = ((T16_Data_Installation_Complete.GetLatchedValue()))
        Dim MaskedChgFlg5 As Boolean = ((T7_Invalid_Or_Missing_Basic_Data.GetLatchedValue()))
        Dim MaskedChgFlg2 As Boolean = ((T2_Power_Off_Detected.GetLatchedValue()))
        Dim MaskedChgFlg4 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T4_Booted.GetLatchedValue()))
        Dim MaskedChgFlg1 As Boolean = ((T1_Power_On_Detected.GetLatchedValue()))
        Dim MaskedChgFlg7 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg13 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg10 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim MaskedChgFlg6 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg11 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim MaskedChgFlg15 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim MaskedChgFlg12 As Boolean = ((T9_PDI_Connection_Established.GetLatchedValue()))
        Dim MaskedChgFlg14 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim MaskedChgFlg8 As Boolean = ((T17_Data_Update_Finished.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg16 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim UnMaskedChgFlg9 As Boolean = ((T16_Data_Installation_Complete.GetLatchedValue()))
        Dim UnMaskedChgFlg5 As Boolean = ((T7_Invalid_Or_Missing_Basic_Data.GetLatchedValue()))
        Dim UnMaskedChgFlg2 As Boolean = ((T2_Power_Off_Detected.GetLatchedValue()))
        Dim UnMaskedChgFlg4 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T4_Booted.GetLatchedValue()))
        Dim UnMaskedChgFlg1 As Boolean = ((T1_Power_On_Detected.GetLatchedValue()))
        Dim UnMaskedChgFlg7 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg13 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg10 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim UnMaskedChgFlg6 As Boolean = ((T10_PDI_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg11 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim UnMaskedChgFlg15 As Boolean = ((T5_SIL_Not_Fulfilled.GetLatchedValue()))
        Dim UnMaskedChgFlg12 As Boolean = ((T9_PDI_Connection_Established.GetLatchedValue()))
        Dim UnMaskedChgFlg14 As Boolean = ((T3_Reset.GetLatchedValue()))
        Dim UnMaskedChgFlg8 As Boolean = ((T17_Data_Update_Finished.GetLatchedValue()))
        Dim PreviousChgFlg16 As Boolean = ChgFlg16
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg13 As Boolean = ChgFlg13
        Dim PreviousChgFlg10 As Boolean = ChgFlg10
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg11 As Boolean = ChgFlg11
        Dim PreviousChgFlg15 As Boolean = ChgFlg15
        Dim PreviousChgFlg12 As Boolean = ChgFlg12
        Dim PreviousChgFlg14 As Boolean = ChgFlg14
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = True
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = True
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = True
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = True
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = True
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = True
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = True
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = True
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = True
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = True
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = True
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = True
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = True
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = True
          ChgFlg14 = False
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = True
          ChgFlg8 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg16 = False
          ChgFlg9 = False
          ChgFlg5 = False
          ChgFlg2 = False
          ChgFlg4 = False
          ChgFlg3 = False
          ChgFlg1 = False
          ChgFlg7 = False
          ChgFlg13 = False
          ChgFlg10 = False
          ChgFlg6 = False
          ChgFlg11 = False
          ChgFlg15 = False
          ChgFlg12 = False
          ChgFlg14 = False
          ChgFlg8 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg16 = False
      ChgFlg9 = False
      ChgFlg5 = False
      ChgFlg2 = False
      ChgFlg4 = False
      ChgFlg3 = False
      ChgFlg1 = False
      ChgFlg7 = False
      ChgFlg13 = False
      ChgFlg10 = False
      ChgFlg6 = False
      ChgFlg11 = False
      ChgFlg15 = False
      ChgFlg12 = False
      ChgFlg14 = False
      ChgFlg8 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D20_Con_MDM_Used.Decrement())
      Ret = (Ret Or D44_Con_tmax_Booting.Decrement())
      Ret = (Ret Or T10_PDI_Connection_Terminated.Decrement())
      Ret = (Ret Or T16_Data_Installation_Complete.Decrement())
      Ret = (Ret Or T17_Data_Update_Finished.Decrement())
      Ret = (Ret Or T1_Power_On_Detected.Decrement())
      Ret = (Ret Or T2_Power_Off_Detected.Decrement())
      Ret = (Ret Or T3_Reset.Decrement())
      Ret = (Ret Or T4_Booted.Decrement())
      Ret = (Ret Or T5_SIL_Not_Fulfilled.Decrement())
      Ret = (Ret Or T7_Invalid_Or_Missing_Basic_Data.Decrement())
      Ret = (Ret Or T9_PDI_Connection_Established.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D20_Con_MDM_Used.Mask(What)
      D44_Con_tmax_Booting.Mask(What)
      T10_PDI_Connection_Terminated.Mask(What)
      T16_Data_Installation_Complete.Mask(What)
      T17_Data_Update_Finished.Mask(What)
      T1_Power_On_Detected.Mask(What)
      T2_Power_Off_Detected.Mask(What)
      T3_Reset.Mask(What)
      T4_Booted.Mask(What)
      T5_SIL_Not_Fulfilled.Mask(What)
      T7_Invalid_Or_Missing_Basic_Data.Mask(What)
      T9_PDI_Connection_Established.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class F_P3_SR : Implements SMSupport.SMQueued 
    Protected Class F_P3_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As F_P3_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsF_P3_SR_States
      RtsF_P3_SR_States_OPERATING
      RtsF_P3_SR_States_NotIn_F_P3_SR
    End Enum
    Public Enum RtsF_P3_SRDETECTION_States
      RtsF_P3_SRDETECTION_States_ALL_LEFT
      RtsF_P3_SRDETECTION_States_NO_END_POSITION
      RtsF_P3_SRDETECTION_States_ALL_RIGHT
      RtsF_P3_SRDETECTION_States_TRAILED
      RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING
      RtsF_P3_SRDETECTION_States_NotIn_DETECTION
    End Enum
    Public Enum RtsF_P3_SRDRIVE_States
      RtsF_P3_SRDRIVE_States_STOPPED
      RtsF_P3_SRDRIVE_States_MOVING_LEFT
      RtsF_P3_SRDRIVE_States_MOVING_RIGHT
      RtsF_P3_SRDRIVE_States_NotIn_DRIVE
    End Enum
    ' \ART_SMG :: Created for state : F_P3_SR
    Private RtsCurrent_F_P3_SR As F_P3_SR.RtsF_P3_SR_States
    ' \ART_SMG :: Created for state : DETECTION
    Private RtsCurrent_DETECTION As F_P3_SR.RtsF_P3_SRDETECTION_States
    ' \ART_SMG :: Created for state : DRIVE
    Private RtsCurrent_DRIVE As F_P3_SR.RtsF_P3_SRDRIVE_States
    ' \ART_SMG :: Created for state : MOVING_LEFT
    Private RtsAttMOVING_LEFT_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    Private RtsAttMOVING_RIGHT_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast25 As Boolean
    Private ChgFlg25 As Boolean
    Private ChgFlgLast20 As Boolean
    Private ChgFlg20 As Boolean
    Private ChgFlgLast11 As Boolean
    Private ChgFlg11 As Boolean
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast18 As Boolean
    Private ChgFlg18 As Boolean
    Private ChgFlgLast12 As Boolean
    Private ChgFlg12 As Boolean
    Private ChgFlgLast19 As Boolean
    Private ChgFlg19 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast23 As Boolean
    Private ChgFlg23 As Boolean
    Private ChgFlgLast26 As Boolean
    Private ChgFlg26 As Boolean
    Private ChgFlgLast28 As Boolean
    Private ChgFlg28 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast29 As Boolean
    Private ChgFlg29 As Boolean
    Private ChgFlgLast22 As Boolean
    Private ChgFlg22 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast21 As Boolean
    Private ChgFlg21 As Boolean
    Private ChgFlgLast15 As Boolean
    Private ChgFlg15 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast17 As Boolean
    Private ChgFlg17 As Boolean
    Private ChgFlgLast16 As Boolean
    Private ChgFlg16 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast10 As Boolean
    Private ChgFlg10 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private ChgFlgLast13 As Boolean
    Private ChgFlg13 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast14 As Boolean
    Private ChgFlg14 As Boolean
    Private ChgFlgLast27 As Boolean
    Private ChgFlg27 As Boolean
    Private ChgFlgLast24 As Boolean
    Private ChgFlg24 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As F_P3_SRSMQueue = New F_P3_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    Protected T1_Move As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected DT1_Move_Target As OInputPort(Of String)
    Protected T2_Stop_Operation As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T4_Information_No_End_Position refines the Flow Property Information_No_End_Position.
    Protected T4_Information_No_End_Position As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected DT20_Point_Position As OOutputPort(Of String)
    ' The FlowPort T6_Information_Trailed_Point refines the Flow Property Information_Trailed_Point.
    Protected T6_Information_Trailed_Point As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T7_Information_Out_Of_Sequence As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected D10_Move_Left As OOutputPort(Of Boolean)
    Protected D11_Move_Right As OOutputPort(Of Boolean)
    Protected D21_PM1_Position As OInputPort(Of String)
    Protected D22_PM2_Position As OInputPort(Of String)
    ' The FlowPort D30_Con_007000 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 007000.
    Protected D30_Con_007000 As OInputPort(Of Boolean)
    ' The FlowPort D32_Con_007600 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 007600.
    Protected D32_Con_007600 As OInputPort(Of Boolean)
    ' The FlowPort D33_Con_007900 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 007900.
    ' 
    Protected D33_Con_007900 As OInputPort(Of Boolean)
    ' The FlowPort D34_Con_008000 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 008000.
    Protected D34_Con_008000 As OInputPort(Of Boolean)
    ' The FlowPort D35_Con_008200 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 008200.
    ' 
    Protected D35_Con_008200 As OInputPort(Of Boolean)
    ' The FlowPort D36_Con_008300 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 008300.
    Private D36_Con_008300 As Boolean
    ' The FlowPort D37_Con_008400 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 008400.
    Protected D37_Con_008400 As OInputPort(Of Boolean)
    ' The FlowPort D38_Con_008500 provides the configuration value whether the Subsystem - Point is configured for the infrastructure manager 008500.
    Protected D38_Con_008500 As OInputPort(Of Boolean)
    Private Mem_last_Target_Requested As String
    Protected D25_Redrive As OOutputPort(Of Boolean)
    Private Mem_Current_Point_Position As String
    Protected D20_F_EST_EfeS_Gen_SR_State As OInputPort(Of String)
    Protected D5_Drive_State As OOutputPort(Of String)
    ' The FlowPort D4_Con_tmax_Point_Operation refines the time value for Con_tmax_Point_Operation.
    ' The standardized time value is configured: 
    ' Con_tmax_Point_Operation := 12 s (008000, 007600, 007000)
    ' Con_tmax_Point_Operation := 10 s (008200)
    ' Con_tmax_Point_Operation := 7 s (007000) - additional value selectable by dataprep  
    Protected D4_Con_tmax_Point_Operation As OInputPort(Of Integer)
    Protected T30_Report_Timeout As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected D6_Detection_State As OOutputPort(Of String)
    Protected T20_Point_Position As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T40_Report_Status As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T5_Info_End_Position_Arrived refines the Flow Property Information_End_Position_Arrived.
    Protected T5_Info_End_Position_Arrived As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected D13_PM2_Activation As OInputPort(Of String)
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' 
    ' T4_Information_No_End_Position := FALSE;
    ' T5_Info_End_Position_Arrived := FALSE;
    ' D5_Drive_State := "STOPPED";
    ' D6_Detection_State := FALSE;
    ' T6_Information_Trailed_Point := FALSE;
    ' T7_Information_Out_Of_Sequence := FALSE;
    ' D10_Move_Left := FALSE;
    ' D11_Move_Right := FALSE;
    ' T20_Point_Position := FALSE;
    ' DT20_Point_Position := "UNKNOWN";
    ' D25_Redrive := FALSE;
    ' T30_Report_Timeout := FALSE;
    ' Mem_last_Target_Requested := "";
    ' Mem_Current_Point_Position := "";
    Public Sub cOp1_Init()
      T4_Information_No_End_Position.SetValue(False)
      T5_Info_End_Position_Arrived.SetValue(False)
      D5_Drive_State.SetValue("STOPPED")
      D6_Detection_State.SetValue(False)
      T6_Information_Trailed_Point.SetValue(False)
      T7_Information_Out_Of_Sequence.SetValue(False)
      D10_Move_Left.SetValue(False)
      D11_Move_Right.SetValue(False)
      T20_Point_Position.SetValue(False)
      DT20_Point_Position.SetValue("UNKNOWN")
      D25_Redrive.SetValue(False)
      T30_Report_Timeout.SetValue(False)
      Mem_last_Target_Requested = ""
      Mem_Current_Point_Position = ""
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if cOp8_Supports_Multiple_PMs() then
    '     return (
    '       (D21_PM1_Position = "LEFT") and
    '       (D22_PM2_Position = "LEFT" or D13_PM2_Activation= "INACTIVE")
    ' 			);
    ' else
    '     return D21_PM1_Position = "LEFT";
    ' end if
    Public Function cOp2_All_Left() As Boolean
      If cOp8_Supports_Multiple_PMs() Then
        Return ((D21_PM1_Position.GetLatchedValue() = "LEFT") And (D22_PM2_Position.GetLatchedValue() = "LEFT" Or D13_PM2_Activation.GetLatchedValue() = "INACTIVE"))
      Else
        Return D21_PM1_Position.GetLatchedValue() = "LEFT"
      End If
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return ((Not cOp6_Error()) and (Not cOp5_Trailed()) and (Not cOp2_All_Left()) and (Not cOp4_All_Right())); 
    Public Function cOp3_No_End_Position() As Boolean
      Return ((Not cOp6_Error()) And (Not cOp5_Trailed()) And (Not cOp2_All_Left()) And (Not cOp4_All_Right()))
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if cOp8_Supports_Multiple_PMs() then
    '     return (
    '       (D21_PM1_Position = "RIGHT") and
    '       (D22_PM2_Position = "RIGHT" or D13_PM2_Activation = "INACTIVE")
    ' 			);
    ' else
    '     return D21_PM1_Position = "RIGHT";
    ' end if
    Public Function cOp4_All_Right() As Boolean
      If cOp8_Supports_Multiple_PMs() Then
        Return ((D21_PM1_Position.GetLatchedValue() = "RIGHT") And (D22_PM2_Position.GetLatchedValue() = "RIGHT" Or D13_PM2_Activation.GetLatchedValue() = "INACTIVE"))
      Else
        Return D21_PM1_Position.GetLatchedValue() = "RIGHT"
      End If
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not cOp6_Error() then
    ' 	if cOp8_Supports_Multiple_PMs() then
    ' 		return	(
    ' 			    (D21_PM1_Position = "TRAILED") or
    ' 				(D22_PM2_Position = "TRAILED")
    ' 				);			          
    ' 	else
    ' 		return D21_PM1_Position = "TRAILED";
    ' 	end if
    ' else
    ' 	return FALSE;
    ' end if
    Public Function cOp5_Trailed() As Boolean
      If not cOp6_Error() Then
        If cOp8_Supports_Multiple_PMs() Then
          Return ((D21_PM1_Position.GetLatchedValue() = "TRAILED") Or (D22_PM2_Position.GetLatchedValue() = "TRAILED"))
        Else
          Return D21_PM1_Position.GetLatchedValue() = "TRAILED"
        End If
      Else
        Return False
      End If
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if cOp8_Supports_Multiple_PMs() then
    '     return	(
    ' 			(D21_PM1_Position = "ERROR") or
    ' 			(D22_PM2_Position = "ERROR") 
    '       );
    ' else
    '     return D21_PM1_Position = "ERROR";
    ' end if
    Public Function cOp6_Error() As Boolean
      If cOp8_Supports_Multiple_PMs() Then
        Return ((D21_PM1_Position.GetLatchedValue() = "ERROR") Or (D22_PM2_Position.GetLatchedValue() = "ERROR"))
      Else
        Return D21_PM1_Position.GetLatchedValue() = "ERROR"
      End If
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return (D32_Con_007600 Or D33_Con_007900 Or D34_Con_008000 Or D35_Con_008200);
    Public Function cOp7_Is_Trailable() As Boolean
      Return (D32_Con_007600.GetLatchedValue() Or D33_Con_007900.GetLatchedValue() Or D34_Con_008000.GetLatchedValue() Or D35_Con_008200.GetLatchedValue())
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return (D30_Con_007000 Or D32_Con_007600 Or D33_Con_007900 Or D34_Con_008000 Or D35_Con_008200 Or D37_Con_008400);
    Public Function cOp8_Supports_Multiple_PMs() As Boolean
      Return (D30_Con_007000.GetLatchedValue() Or D32_Con_007600.GetLatchedValue() Or D33_Con_007900.GetLatchedValue() Or D34_Con_008000.GetLatchedValue() Or D35_Con_008200.GetLatchedValue() Or D37_Con_008400.GetLatchedValue())
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return D30_Con_007000;
    Public Function cOp9_Redrive_Enabled() As Boolean
      Return D30_Con_007000.GetLatchedValue()
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return (cOp3_No_End_Position and (Mem_last_Target_Requested = "RIGHT") and (Mem_Current_Point_Position = "RIGHT"));
    Public Function cOp10_Redrive_Right() As Boolean
      Return (cOp3_No_End_Position And (Mem_last_Target_Requested = "RIGHT") And (Mem_Current_Point_Position = "RIGHT"))
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return (cOp3_No_End_Position and (Mem_last_Target_Requested = "LEFT") and (Mem_Current_Point_Position = "LEFT"));
    Public Function cOp11_Redrive_Left() As Boolean
      Return (cOp3_No_End_Position And (Mem_last_Target_Requested = "LEFT") And (Mem_Current_Point_Position = "LEFT"))
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' D5_Drive_State := "STOPPED";
    ' if (D32_Con_007600 or D33_Con_007900 or D34_Con_008000 or D35_Con_008200 or D37_Con_008400) then
    ' 	T30_Report_Timeout := TRUE;
    ' end if
    Public Sub cOp12_Timeout()
      D5_Drive_State.SetValue("STOPPED")
      If (D32_Con_007600.GetLatchedValue() Or D33_Con_007900.GetLatchedValue() Or D34_Con_008000.GetLatchedValue() Or D35_Con_008200.GetLatchedValue() Or D37_Con_008400.GetLatchedValue()) Then
        T30_Report_Timeout.SetValue(True)
      End If
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' return D20_F_EST_EfeS_Gen_SR_State = "NO_OPERATING_VOLTAGE" or D20_F_EST_EfeS_Gen_SR_State = "BOOTING" or D20_F_EST_EfeS_Gen_SR_State = "FALLBACK_MODE";
    Public Function cOp13_Not_Initialised() As Boolean
      Return D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "NO_OPERATING_VOLTAGE" Or D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "BOOTING" Or D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "FALLBACK_MODE"
    End Function
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if (not D34_Con_008000) then
    ' 	T20_Point_Position := "TRUE";	          
    ' end if
    Public Sub cOp14_Send_Same_Position()
      If (not D34_Con_008000.GetLatchedValue()) Then
        T20_Point_Position.SetValue("TRUE")
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' pInstance.RtsMOVING_LEFT_Timer1();
    Private Shared Sub RtsMOVING_LEFT_Timer1_CallBack(ByRef pInstance As F_P3_SR)
      pInstance.RtsMOVING_LEFT_Timer1()
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' pInstance.RtsMOVING_RIGHT_Timer1();
    Private Shared Sub RtsMOVING_RIGHT_Timer1_CallBack(ByRef pInstance As F_P3_SR)
      pInstance.RtsMOVING_RIGHT_Timer1()
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' assume RtsCurrent_F_P3_SR: on object;
    ' assume RtsCurrent_DETECTION: on object;
    ' assume RtsCurrent_DRIVE: on object;
    ' assume RtsAttMOVING_LEFT_Timer1: on object;
    ' assume RtsAttMOVING_RIGHT_Timer1: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then
    ' /* #REF123# */
    ' 	/* 2e73d7de-809c-496d-899b-fe80a8941bb9 TRAILED */
    '   ThisState := "2e73d7de-809c-496d-899b-fe80a8941bb9";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"da2dc3d1-243d-4070-ad46-09ffdddf2082",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT da2dc3d1-243d-4070-ad46-09ffdddf2082 */  DT20_Point_Position := "TRAILED";
    '  T20_Point_Position := TRUE; nullstat;/*##END da2dc3d1-243d-4070-ad46-09ffdddf2082 */ /* #REF1546# */
    ' 		ChgFlg16 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then
    ' /* #REF123# */
    ' 	/* 9a81cc79-961b-46cc-9267-43f5d7756555 ALL_RIGHT */
    '   ThisState := "9a81cc79-961b-46cc-9267-43f5d7756555";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5c4197bc-1684-4d5f-a5c7-fd17aebf53a7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5c4197bc-1684-4d5f-a5c7-fd17aebf53a7 */ 
    '  DT20_Point_Position := "RIGHT";
    '  T20_Point_Position := TRUE; nullstat;/*##END 5c4197bc-1684-4d5f-a5c7-fd17aebf53a7 */ /* #REF1546# */
    ' 		ChgFlg11 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then
    ' /* #REF123# */
    ' 	/* e261c445-aaad-4442-af30-bbea3464768b NO_END_POSITION */
    '   ThisState := "e261c445-aaad-4442-af30-bbea3464768b";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"9d7b4937-e775-4752-aaaf-dd259d813d3f",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 9d7b4937-e775-4752-aaaf-dd259d813d3f */ 
    '  DT20_Point_Position := "NO_END_POSITION";
    '  T20_Point_Position := TRUE; nullstat;/*##END 9d7b4937-e775-4752-aaaf-dd259d813d3f */ /* #REF1546# */
    ' 		ChgFlg6 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then
    ' /* #REF123# */
    ' 	/* 49a7622b-d31d-42b6-961e-d95714d97558 ALL_LEFT */
    '   ThisState := "49a7622b-d31d-42b6-961e-d95714d97558";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ea9cab9a-eda1-447a-bf06-3d68fd465192",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ea9cab9a-eda1-447a-bf06-3d68fd465192 */ 
    '  DT20_Point_Position := "LEFT";
    '  T20_Point_Position := TRUE; nullstat;/*##END ea9cab9a-eda1-447a-bf06-3d68fd465192 */ /* #REF1546# */
    ' 		ChgFlg1 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then
    ' /* #REF123# */
    ' 	/* 49a7622b-d31d-42b6-961e-d95714d97558 ALL_LEFT */
    '   ThisState := "49a7622b-d31d-42b6-961e-d95714d97558";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a375ef52-3d5c-47fc-bd1a-533eceba6a58",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT e78ad539-96ff-4667-b80a-7a8e39fbcb94 */  nullstat;/*##END e78ad539-96ff-4667-b80a-7a8e39fbcb94 */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then
    ' /* #REF123# */
    ' 	/* 49a7622b-d31d-42b6-961e-d95714d97558 ALL_LEFT */
    '   ThisState := "49a7622b-d31d-42b6-961e-d95714d97558";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"18b251da-eb2e-4cc4-b9c1-7ee376e4beff",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 93e2cf42-ecb9-4b23-b744-d4924b88c67a */  nullstat;/*##END 93e2cf42-ecb9-4b23-b744-d4924b88c67a */ /* #REF1546# */
    ' 		This.RtsEnter_NO_END_POSITION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then
    ' /* #REF123# */
    ' 	/* 49a7622b-d31d-42b6-961e-d95714d97558 ALL_LEFT */
    '   ThisState := "49a7622b-d31d-42b6-961e-d95714d97558";
    ' 	if /* #REF2000# *//*##STRT 587d2d7f-0b7d-460b-b0da-390754d4c3bd */ (not D34_Con_008000 )/*##END 587d2d7f-0b7d-460b-b0da-390754d4c3bd */  and /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b009d4ba-02c5-4b39-be27-5f2da9b63964",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT bb1a09d6-1f6c-4abd-b81b-0678d243c159 */  nullstat;/*##END bb1a09d6-1f6c-4abd-b81b-0678d243c159 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then
    ' /* #REF123# */
    ' 	/* 49a7622b-d31d-42b6-961e-d95714d97558 ALL_LEFT */
    '   ThisState := "49a7622b-d31d-42b6-961e-d95714d97558";
    ' 	if /* #REF2000# *//*##STRT e2dd1acf-2bb5-41d4-bbb7-d7755bd71604 */ ( cOp7_Is_Trailable )/*##END e2dd1acf-2bb5-41d4-bbb7-d7755bd71604 */  and /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"32aba5d3-5fd5-42e1-bcc9-32c7674c99fe",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT dba64d6d-3731-4ab5-b482-519eac6c5b46 */  nullstat;/*##END dba64d6d-3731-4ab5-b482-519eac6c5b46 */ /* #REF1546# */
    ' 		This.RtsEnter_TRAILED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then
    ' /* #REF123# */
    ' 	/* e261c445-aaad-4442-af30-bbea3464768b NO_END_POSITION */
    '   ThisState := "e261c445-aaad-4442-af30-bbea3464768b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NO_END_POSITION */
    ' 		/* standard */
    ' 		This.RtsExit_NO_END_POSITION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"2f719fc2-cb05-49f2-ac19-b8ddfcab153b",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6efbb70b-710d-400d-b40a-f4185d1ba486 */  nullstat;/*##END 6efbb70b-710d-400d-b40a-f4185d1ba486 */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then
    ' /* #REF123# */
    ' 	/* e261c445-aaad-4442-af30-bbea3464768b NO_END_POSITION */
    '   ThisState := "e261c445-aaad-4442-af30-bbea3464768b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NO_END_POSITION */
    ' 		/* standard */
    ' 		This.RtsExit_NO_END_POSITION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"53736bc4-f3f0-409d-a24a-ab33ef448fb6",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ddf693ff-0ef2-497b-b50f-128ccfa32baa */  nullstat;/*##END ddf693ff-0ef2-497b-b50f-128ccfa32baa */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then
    ' /* #REF123# */
    ' 	/* e261c445-aaad-4442-af30-bbea3464768b NO_END_POSITION */
    '   ThisState := "e261c445-aaad-4442-af30-bbea3464768b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NO_END_POSITION */
    ' 		/* standard */
    ' 		This.RtsExit_NO_END_POSITION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"521e865f-7eef-46f8-8670-ad6920059cd0",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5e497bd7-1552-4488-b4c3-19385c8cadc3 */  nullstat;/*##END 5e497bd7-1552-4488-b4c3-19385c8cadc3 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then
    ' /* #REF123# */
    ' 	/* e261c445-aaad-4442-af30-bbea3464768b NO_END_POSITION */
    '   ThisState := "e261c445-aaad-4442-af30-bbea3464768b";
    ' 	if /* #REF2000# *//*##STRT bbeef6d3-67ce-4b5b-bbdb-3a1b34880317 */ ( cOp7_Is_Trailable )/*##END bbeef6d3-67ce-4b5b-bbdb-3a1b34880317 */  and /* #REF2001# */ SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NO_END_POSITION */
    ' 		/* standard */
    ' 		This.RtsExit_NO_END_POSITION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"68e45543-5f0b-40b7-9bbc-1d2bd74fd616",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ddefc650-69c8-454c-8484-a0e22ef09bd0 */  nullstat;/*##END ddefc650-69c8-454c-8484-a0e22ef09bd0 */ /* #REF1546# */
    ' 		This.RtsEnter_TRAILED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then
    ' /* #REF123# */
    ' 	/* 9a81cc79-961b-46cc-9267-43f5d7756555 ALL_RIGHT */
    '   ThisState := "9a81cc79-961b-46cc-9267-43f5d7756555";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"deb59587-7230-43d0-85f6-8f157efef35c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 68d3555d-99cf-4bde-ae84-16ad1567f9f9 */  nullstat;/*##END 68d3555d-99cf-4bde-ae84-16ad1567f9f9 */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then
    ' /* #REF123# */
    ' 	/* 9a81cc79-961b-46cc-9267-43f5d7756555 ALL_RIGHT */
    '   ThisState := "9a81cc79-961b-46cc-9267-43f5d7756555";
    ' 	if /* #REF2000# *//*##STRT f95eae23-e835-4ce8-b3d4-8648d899e535 */ (not D34_Con_008000 )/*##END f95eae23-e835-4ce8-b3d4-8648d899e535 */  and /* #REF2001# */ SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ad8f6b50-c64c-468f-895e-0dd1aae822b2",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT e8c4bfdb-4af1-49af-a2cd-aaa46b4b9c4c */  nullstat;/*##END e8c4bfdb-4af1-49af-a2cd-aaa46b4b9c4c */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then
    ' /* #REF123# */
    ' 	/* 9a81cc79-961b-46cc-9267-43f5d7756555 ALL_RIGHT */
    '   ThisState := "9a81cc79-961b-46cc-9267-43f5d7756555";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"9eb37094-1fa6-4c41-ab4b-d26d42a80bc4",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f528b481-41a5-461a-84d4-a64faa9573fa */  nullstat;/*##END f528b481-41a5-461a-84d4-a64faa9573fa */ /* #REF1546# */
    ' 		This.RtsEnter_NO_END_POSITION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then
    ' /* #REF123# */
    ' 	/* 9a81cc79-961b-46cc-9267-43f5d7756555 ALL_RIGHT */
    '   ThisState := "9a81cc79-961b-46cc-9267-43f5d7756555";
    ' 	if /* #REF2000# *//*##STRT 1db6345c-e2d1-44a1-bda4-85f2e88c89ca */ ( cOp7_Is_Trailable )/*##END 1db6345c-e2d1-44a1-bda4-85f2e88c89ca */  and /* #REF2001# */ SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ALL_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_ALL_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c9047f60-39fb-4840-8dbf-661914ab5f97",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ae247852-1a51-41a2-9d26-60a405d442d3 */  nullstat;/*##END ae247852-1a51-41a2-9d26-60a405d442d3 */ /* #REF1546# */
    ' 		This.RtsEnter_TRAILED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then
    ' /* #REF123# */
    ' 	/* 2e73d7de-809c-496d-899b-fe80a8941bb9 TRAILED */
    '   ThisState := "2e73d7de-809c-496d-899b-fe80a8941bb9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_TRAILED */
    ' 		/* standard */
    ' 		This.RtsExit_TRAILED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"1697bffd-64b6-49eb-bda7-db7100314afa",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c4ea6502-cd93-432f-8b96-98fa0ca132e9 */  nullstat;/*##END c4ea6502-cd93-432f-8b96-98fa0ca132e9 */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISING();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then
    ' /* #REF123# */
    ' 	/* 2e73d7de-809c-496d-899b-fe80a8941bb9 TRAILED */
    '   ThisState := "2e73d7de-809c-496d-899b-fe80a8941bb9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg18, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_TRAILED */
    ' 		/* standard */
    ' 		This.RtsExit_TRAILED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ddd0fd6c-5e3e-4f16-9272-9ee6bd09f695",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6147357e-45bf-4cd1-b708-7f803bb394ef */  nullstat;/*##END 6147357e-45bf-4cd1-b708-7f803bb394ef */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then
    ' /* #REF123# */
    ' 	/* 2e73d7de-809c-496d-899b-fe80a8941bb9 TRAILED */
    '   ThisState := "2e73d7de-809c-496d-899b-fe80a8941bb9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg19, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_TRAILED */
    ' 		/* standard */
    ' 		This.RtsExit_TRAILED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"28fc662a-22f8-4cf2-bde2-5c389773d656",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6d0eaae7-ceef-48ae-ace4-451ff9545ece */  nullstat;/*##END 6d0eaae7-ceef-48ae-ace4-451ff9545ece */ /* #REF1546# */
    ' 		This.RtsEnter_NO_END_POSITION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then
    ' /* #REF123# */
    ' 	/* 2e73d7de-809c-496d-899b-fe80a8941bb9 TRAILED */
    '   ThisState := "2e73d7de-809c-496d-899b-fe80a8941bb9";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg20, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_TRAILED */
    ' 		/* standard */
    ' 		This.RtsExit_TRAILED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c6b51b9e-0ff6-4393-a25f-a5b26d6ab289",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 55561195-84c4-423c-8fde-ce35a4e6b68c */  nullstat;/*##END 55561195-84c4-423c-8fde-ce35a4e6b68c */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2000# *//*##STRT c77879f5-dc1c-4d11-84a6-333f6a3947b9 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END c77879f5-dc1c-4d11-84a6-333f6a3947b9 */  and /* #REF2000# *//*##STRT 736567dc-2012-41fd-8595-099ed004c70e */ ( cOp2_All_Left )/*##END 736567dc-2012-41fd-8595-099ed004c70e */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"81749b48-0d51-4a65-8095-2c06b267b4a5",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a7ddb70f-d7ad-44de-8e53-607563c11a94",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */  nullstat;/*##END 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */ /* #REF1544# */
    ' 	/*##STRT 32e8210e-faaf-49eb-94ae-d62571ab72b6 */  nullstat;/*##END 32e8210e-faaf-49eb-94ae-d62571ab72b6 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2000# *//*##STRT c77879f5-dc1c-4d11-84a6-333f6a3947b9 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END c77879f5-dc1c-4d11-84a6-333f6a3947b9 */  and /* #REF2000# *//*##STRT c25182c1-bae3-485d-8919-2fa1bc51e4a0 */ ( cOp4_All_Right )/*##END c25182c1-bae3-485d-8919-2fa1bc51e4a0 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"81749b48-0d51-4a65-8095-2c06b267b4a5",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5da1e9e8-fc6c-4ada-b700-939f474f02c7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */  nullstat;/*##END 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */ /* #REF1544# */
    ' 	/*##STRT 900f5718-841c-4f92-84cb-1d333a32bc38 */  nullstat;/*##END 900f5718-841c-4f92-84cb-1d333a32bc38 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2000# *//*##STRT c77879f5-dc1c-4d11-84a6-333f6a3947b9 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END c77879f5-dc1c-4d11-84a6-333f6a3947b9 */  and /* #REF2000# *//*##STRT dc5738d4-ac8f-4560-abf4-7f2be9295ce9 */ ( cOp3_No_End_Position )/*##END dc5738d4-ac8f-4560-abf4-7f2be9295ce9 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"81749b48-0d51-4a65-8095-2c06b267b4a5",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7d8c4a6e-e8b8-43b3-8901-104e272ff37e",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */  nullstat;/*##END 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */ /* #REF1544# */
    ' 	/*##STRT 2a14ac17-3a5a-4855-b193-2362162d7fc6 */  nullstat;/*##END 2a14ac17-3a5a-4855-b193-2362162d7fc6 */ /* #REF1546# */
    ' 		This.RtsEnter_NO_END_POSITION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2000# *//*##STRT c77879f5-dc1c-4d11-84a6-333f6a3947b9 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END c77879f5-dc1c-4d11-84a6-333f6a3947b9 */  and /* #REF2000# *//*##STRT 0289b031-4c4e-41f2-ba77-d4c1ca259208 */ ( cOp5_Trailed and cOp7_Is_Trailable )/*##END 0289b031-4c4e-41f2-ba77-d4c1ca259208 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"81749b48-0d51-4a65-8095-2c06b267b4a5",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"27015775-911c-48cd-a707-5ed9bcad0f20",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */  nullstat;/*##END 949feb58-f2e8-4a95-9fbc-b837fd5448e4 */ /* #REF1544# */
    ' 	/*##STRT 2547095e-c69f-4fdc-b8a4-ae69d237f03a */  nullstat;/*##END 2547095e-c69f-4fdc-b8a4-ae69d237f03a */ /* #REF1546# */
    ' 		This.RtsEnter_TRAILED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 736567dc-2012-41fd-8595-099ed004c70e */ ( cOp2_All_Left )/*##END 736567dc-2012-41fd-8595-099ed004c70e */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"58545474-1aa5-4a38-ad5a-4d40ad8033bc",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a7ddb70f-d7ad-44de-8e53-607563c11a94",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT a86502f7-aadc-4de0-9ea5-ebc7488effbc */  nullstat;/*##END a86502f7-aadc-4de0-9ea5-ebc7488effbc */ /* #REF1544# */
    ' 	/*##STRT 32e8210e-faaf-49eb-94ae-d62571ab72b6 */  nullstat;/*##END 32e8210e-faaf-49eb-94ae-d62571ab72b6 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT c25182c1-bae3-485d-8919-2fa1bc51e4a0 */ ( cOp4_All_Right )/*##END c25182c1-bae3-485d-8919-2fa1bc51e4a0 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"58545474-1aa5-4a38-ad5a-4d40ad8033bc",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5da1e9e8-fc6c-4ada-b700-939f474f02c7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT a86502f7-aadc-4de0-9ea5-ebc7488effbc */  nullstat;/*##END a86502f7-aadc-4de0-9ea5-ebc7488effbc */ /* #REF1544# */
    ' 	/*##STRT 900f5718-841c-4f92-84cb-1d333a32bc38 */  nullstat;/*##END 900f5718-841c-4f92-84cb-1d333a32bc38 */ /* #REF1546# */
    ' 		This.RtsEnter_ALL_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT dc5738d4-ac8f-4560-abf4-7f2be9295ce9 */ ( cOp3_No_End_Position )/*##END dc5738d4-ac8f-4560-abf4-7f2be9295ce9 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"58545474-1aa5-4a38-ad5a-4d40ad8033bc",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7d8c4a6e-e8b8-43b3-8901-104e272ff37e",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT a86502f7-aadc-4de0-9ea5-ebc7488effbc */  nullstat;/*##END a86502f7-aadc-4de0-9ea5-ebc7488effbc */ /* #REF1544# */
    ' 	/*##STRT 2a14ac17-3a5a-4855-b193-2362162d7fc6 */  nullstat;/*##END 2a14ac17-3a5a-4855-b193-2362162d7fc6 */ /* #REF1546# */
    ' 		This.RtsEnter_NO_END_POSITION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then
    ' /* #REF123# */
    ' 	/* 05ebc1c1-994b-43aa-a452-529b2aa1ac44 WAITING_FOR_INITIALISING */
    '   ThisState := "05ebc1c1-994b-43aa-a452-529b2aa1ac44";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 0289b031-4c4e-41f2-ba77-d4c1ca259208 */ ( cOp5_Trailed and cOp7_Is_Trailable )/*##END 0289b031-4c4e-41f2-ba77-d4c1ca259208 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISING */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"58545474-1aa5-4a38-ad5a-4d40ad8033bc",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"27015775-911c-48cd-a707-5ed9bcad0f20",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT a86502f7-aadc-4de0-9ea5-ebc7488effbc */  nullstat;/*##END a86502f7-aadc-4de0-9ea5-ebc7488effbc */ /* #REF1544# */
    ' 	/*##STRT 2547095e-c69f-4fdc-b8a4-ae69d237f03a */  nullstat;/*##END 2547095e-c69f-4fdc-b8a4-ae69d237f03a */ /* #REF1546# */
    ' 		This.RtsEnter_TRAILED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT 5d19f33c-8d0f-4eb2-845e-015189d827ba */ ( cOp9_Redrive_Enabled )/*##END 5d19f33c-8d0f-4eb2-845e-015189d827ba */  and /* #REF2001# */ SenseTrigger(ChgFlg22, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"d1fe7c0f-d5fa-43aa-8fb4-f8599987b26a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 97c5cc37-6dd5-4a8d-aaa5-b781f0f304c5 */  D25_Redrive := TRUE; nullstat;/*##END 97c5cc37-6dd5-4a8d-aaa5-b781f0f304c5 */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT 99de1c06-2405-4454-80cf-f786da14614f */ ( cOp9_Redrive_Enabled )/*##END 99de1c06-2405-4454-80cf-f786da14614f */  and /* #REF2001# */ SenseTrigger(ChgFlg23, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"96859a1c-611b-4d47-acbd-9518ac9ac722",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 767a9ce7-a91b-4e88-9536-bdf49e60f6dd */  D25_Redrive := TRUE; nullstat;/*##END 767a9ce7-a91b-4e88-9536-bdf49e60f6dd */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT e80c59ca-e2cd-4de9-adb2-3f0435f808bf */ ( DT1_Move_Target = "LEFT")/*##END e80c59ca-e2cd-4de9-adb2-3f0435f808bf */  and /* #REF2001# */ SenseTrigger(ChgFlg24, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 6175cf15-331e-4797-a5ba-cc93bbf34149 */ ( DT1_Move_Target <> Mem_Current_Point_Position )/*##END 6175cf15-331e-4797-a5ba-cc93bbf34149 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"da7b34e8-77d7-434c-80b8-154b7b4a3252",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ff074e0c-b1d7-44dc-9e82-7bab5e12809d",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f90f10fc-d97b-4c02-a45d-a4b38ac429e2 */  nullstat;/*##END f90f10fc-d97b-4c02-a45d-a4b38ac429e2 */ /* #REF1544# */
    ' 	/*##STRT a478a1a3-dbd6-49f0-9271-a44b71f99297 */  nullstat;/*##END a478a1a3-dbd6-49f0-9271-a44b71f99297 */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT e80c59ca-e2cd-4de9-adb2-3f0435f808bf */ ( DT1_Move_Target = "LEFT")/*##END e80c59ca-e2cd-4de9-adb2-3f0435f808bf */  and /* #REF2001# */ SenseTrigger(ChgFlg24, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 27f86d8a-192d-46d9-b410-908c61919344 */ ( DT1_Move_Target = Mem_Current_Point_Position )/*##END 27f86d8a-192d-46d9-b410-908c61919344 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"da7b34e8-77d7-434c-80b8-154b7b4a3252",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"472d7d70-6fdc-4351-b438-c518eca51b1e",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f90f10fc-d97b-4c02-a45d-a4b38ac429e2 */  nullstat;/*##END f90f10fc-d97b-4c02-a45d-a4b38ac429e2 */ /* #REF1544# */
    ' 	/*##STRT 4a9494cf-39af-4b49-be89-0fbd9b103bea */  cOp14_Send_Same_Position (); nullstat;/*##END 4a9494cf-39af-4b49-be89-0fbd9b103bea */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT 0204f99f-c8c1-4ea6-b834-9bf28dfd5c1e */ ( DT1_Move_Target = "RIGHT")/*##END 0204f99f-c8c1-4ea6-b834-9bf28dfd5c1e */  and /* #REF2001# */ SenseTrigger(ChgFlg25, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT b4d89c5f-f773-436c-a0d2-ff23f29c1b10 */ ( DT1_Move_Target <> Mem_Current_Point_Position )/*##END b4d89c5f-f773-436c-a0d2-ff23f29c1b10 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5a09653f-9bed-46c1-8050-37aa6b0ecb1d",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6014de9e-295f-4b51-9767-db1237fd9828",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2efdf052-bccd-4676-9958-19f251455ee8 */  nullstat;/*##END 2efdf052-bccd-4676-9958-19f251455ee8 */ /* #REF1544# */
    ' 	/*##STRT 0aee56c8-a05a-47d3-ad49-0032b71f1040 */  nullstat;/*##END 0aee56c8-a05a-47d3-ad49-0032b71f1040 */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then
    ' /* #REF123# */
    ' 	/* 733afdfa-88cc-4498-a8f0-055a3e997929 STOPPED */
    '   ThisState := "733afdfa-88cc-4498-a8f0-055a3e997929";
    ' 	if /* #REF2000# *//*##STRT 0204f99f-c8c1-4ea6-b834-9bf28dfd5c1e */ ( DT1_Move_Target = "RIGHT")/*##END 0204f99f-c8c1-4ea6-b834-9bf28dfd5c1e */  and /* #REF2001# */ SenseTrigger(ChgFlg25, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 380c863b-31ba-457d-9230-769bba2a395d */ ( DT1_Move_Target = Mem_Current_Point_Position )/*##END 380c863b-31ba-457d-9230-769bba2a395d */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_STOPPED */
    ' 		/* standard */
    ' 		This.RtsExit_STOPPED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5a09653f-9bed-46c1-8050-37aa6b0ecb1d",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"47c2cf7d-74fb-4a86-95f3-71585561def3",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2efdf052-bccd-4676-9958-19f251455ee8 */  nullstat;/*##END 2efdf052-bccd-4676-9958-19f251455ee8 */ /* #REF1544# */
    ' 	/*##STRT 3b7fca1b-e64e-4c1b-bdd9-aa5e9f9fa680 */  cOp14_Send_Same_Position (); nullstat;/*##END 3b7fca1b-e64e-4c1b-bdd9-aa5e9f9fa680 */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT then
    ' /* #REF123# */
    ' 	/* d4819a64-5488-47b5-a1a7-59ac142bedbc MOVING_LEFT */
    '   ThisState := "d4819a64-5488-47b5-a1a7-59ac142bedbc";
    ' 	if /* #REF2000# *//*##STRT 5c42960f-a737-4537-a6de-634138dfcbaf */ ( cOp13_Not_Initialised )/*##END 5c42960f-a737-4537-a6de-634138dfcbaf */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"60404085-2ea4-44b3-af45-c8d765c1d83b",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 271da6ff-ba5a-494e-b2d4-6094c030506e */  nullstat;/*##END 271da6ff-ba5a-494e-b2d4-6094c030506e */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT then
    ' /* #REF123# */
    ' 	/* d4819a64-5488-47b5-a1a7-59ac142bedbc MOVING_LEFT */
    '   ThisState := "d4819a64-5488-47b5-a1a7-59ac142bedbc";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg26, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"506ecd1d-d82e-4658-a223-e36412f8ad81",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8a8dd480-966d-4bc7-8add-a0f6ac920876 */  nullstat;/*##END 8a8dd480-966d-4bc7-8add-a0f6ac920876 */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT then
    ' /* #REF123# */
    ' 	/* d4819a64-5488-47b5-a1a7-59ac142bedbc MOVING_LEFT */
    '   ThisState := "d4819a64-5488-47b5-a1a7-59ac142bedbc";
    ' 	if /* #REF2000# *//*##STRT 5b204977-5b5e-4e51-8fcf-b416e1e7a975 */ ( DT1_Move_Target = "RIGHT")/*##END 5b204977-5b5e-4e51-8fcf-b416e1e7a975 */  and /* #REF2001# */ SenseTrigger(ChgFlg27, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_LEFT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_LEFT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6fe6c723-aef0-499a-a664-08fc3948d0fc",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f589285c-d756-43c5-a18c-85cd1159b98e */  nullstat;/*##END f589285c-d756-43c5-a18c-85cd1159b98e */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_RIGHT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT then
    ' /* #REF123# */
    ' 	/* 958897da-fd5d-4883-8112-0eeefdc5bfce MOVING_RIGHT */
    '   ThisState := "958897da-fd5d-4883-8112-0eeefdc5bfce";
    ' 	if /* #REF2000# *//*##STRT 94f41b5b-d5c6-4d0d-a3b0-be403b6624f3 */ ( cOp13_Not_Initialised )/*##END 94f41b5b-d5c6-4d0d-a3b0-be403b6624f3 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"047ed1de-13a4-4a3f-8dd6-372772f3e245",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 774bce3e-6b6a-4562-b9a3-a3b6c192af51 */  nullstat;/*##END 774bce3e-6b6a-4562-b9a3-a3b6c192af51 */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT then
    ' /* #REF123# */
    ' 	/* 958897da-fd5d-4883-8112-0eeefdc5bfce MOVING_RIGHT */
    '   ThisState := "958897da-fd5d-4883-8112-0eeefdc5bfce";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg28, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a30d2cbc-641c-4989-a860-dd09c8a5d71c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 939286cc-d63f-44ce-bb1f-770ad59a88c7 */  nullstat;/*##END 939286cc-d63f-44ce-bb1f-770ad59a88c7 */ /* #REF1546# */
    ' 		This.RtsEnter_STOPPED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT then
    ' /* #REF123# */
    ' 	/* 958897da-fd5d-4883-8112-0eeefdc5bfce MOVING_RIGHT */
    '   ThisState := "958897da-fd5d-4883-8112-0eeefdc5bfce";
    ' 	if /* #REF2000# *//*##STRT 0293a3e3-637e-41be-b0a2-65ba2d739e4b */ ( DT1_Move_Target = "LEFT")/*##END 0293a3e3-637e-41be-b0a2-65ba2d739e4b */  and /* #REF2001# */ SenseTrigger(ChgFlg29, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_MOVING_RIGHT */
    ' 		/* standard */
    ' 		This.RtsExit_MOVING_RIGHT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8f07b792-0d15-4820-ac39-b375092cf15c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 9758e600-0210-4660-8bbf-11ce8ad4afef */  nullstat;/*##END 9758e600-0210-4660-8bbf-11ce8ad4afef */ /* #REF1546# */
    ' 		This.RtsEnter_MOVING_LEFT();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_P3_SR =  /* #REF121d# */ RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_NotIn_F_P3_SR then
    ' /* #REF123# */
    ' 	/* 8363fc7a-2143-4184-a5d5-5fe3c7d4eba2 Initial0 */
    '   ThisState := "8363fc7a-2143-4184-a5d5-5fe3c7d4eba2";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"8363fc7a-2143-4184-a5d5-5fe3c7d4eba2",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"8363fc7a-2143-4184-a5d5-5fe3c7d4eba2",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"bbca214c-a3ae-4e28-9670-ae5be6963cc5",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 501d6c66-3066-420b-9d27-05ded89c8039 */  cOp1_Init (); nullstat;/*##END 501d6c66-3066-420b-9d27-05ded89c8039 */ /* #REF1546# */
    ' 	This.RtsDefault_OPERATING();/* #REF1587# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        ThisState = "2e73d7de-809c-496d-899b-fe80a8941bb9"
        If SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "da2dc3d1-243d-4070-ad46-09ffdddf2082", 0, NullString)
          DT20_Point_Position.SetValue("TRAILED")
          T20_Point_Position.SetValue(True)
          ChgFlg16 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        ThisState = "9a81cc79-961b-46cc-9267-43f5d7756555"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5c4197bc-1684-4d5f-a5c7-fd17aebf53a7", 0, NullString)
          DT20_Point_Position.SetValue("RIGHT")
          T20_Point_Position.SetValue(True)
          ChgFlg11 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        ThisState = "e261c445-aaad-4442-af30-bbea3464768b"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "9d7b4937-e775-4752-aaaf-dd259d813d3f", 0, NullString)
          DT20_Point_Position.SetValue("NO_END_POSITION")
          T20_Point_Position.SetValue(True)
          ChgFlg6 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        ThisState = "49a7622b-d31d-42b6-961e-d95714d97558"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ea9cab9a-eda1-447a-bf06-3d68fd465192", 0, NullString)
          DT20_Point_Position.SetValue("LEFT")
          T20_Point_Position.SetValue(True)
          ChgFlg1 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        ThisState = "49a7622b-d31d-42b6-961e-d95714d97558"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a375ef52-3d5c-47fc-bd1a-533eceba6a58", 0, NullString)
          Me.RtsEnter_WAITING_FOR_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        ThisState = "49a7622b-d31d-42b6-961e-d95714d97558"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "18b251da-eb2e-4cc4-b9c1-7ee376e4beff", 0, NullString)
          Me.RtsEnter_NO_END_POSITION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        ThisState = "49a7622b-d31d-42b6-961e-d95714d97558"
        If (not D34_Con_008000.GetLatchedValue()) And SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b009d4ba-02c5-4b39-be27-5f2da9b63964", 0, NullString)
          Me.RtsEnter_ALL_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        ThisState = "49a7622b-d31d-42b6-961e-d95714d97558"
        If (cOp7_Is_Trailable) And SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "32aba5d3-5fd5-42e1-bcc9-32c7674c99fe", 0, NullString)
          Me.RtsEnter_TRAILED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        ThisState = "e261c445-aaad-4442-af30-bbea3464768b"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NO_END_POSITION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "2f719fc2-cb05-49f2-ac19-b8ddfcab153b", 0, NullString)
          Me.RtsEnter_WAITING_FOR_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        ThisState = "e261c445-aaad-4442-af30-bbea3464768b"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NO_END_POSITION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "53736bc4-f3f0-409d-a24a-ab33ef448fb6", 0, NullString)
          Me.RtsEnter_ALL_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        ThisState = "e261c445-aaad-4442-af30-bbea3464768b"
        If SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NO_END_POSITION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "521e865f-7eef-46f8-8670-ad6920059cd0", 0, NullString)
          Me.RtsEnter_ALL_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        ThisState = "e261c445-aaad-4442-af30-bbea3464768b"
        If (cOp7_Is_Trailable) And SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NO_END_POSITION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "68e45543-5f0b-40b7-9bbc-1d2bd74fd616", 0, NullString)
          Me.RtsEnter_TRAILED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        ThisState = "9a81cc79-961b-46cc-9267-43f5d7756555"
        If SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "deb59587-7230-43d0-85f6-8f157efef35c", 0, NullString)
          Me.RtsEnter_WAITING_FOR_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        ThisState = "9a81cc79-961b-46cc-9267-43f5d7756555"
        If (not D34_Con_008000.GetLatchedValue()) And SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ad8f6b50-c64c-468f-895e-0dd1aae822b2", 0, NullString)
          Me.RtsEnter_ALL_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        ThisState = "9a81cc79-961b-46cc-9267-43f5d7756555"
        If SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "9eb37094-1fa6-4c41-ab4b-d26d42a80bc4", 0, NullString)
          Me.RtsEnter_NO_END_POSITION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        ThisState = "9a81cc79-961b-46cc-9267-43f5d7756555"
        If (cOp7_Is_Trailable) And SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ALL_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c9047f60-39fb-4840-8dbf-661914ab5f97", 0, NullString)
          Me.RtsEnter_TRAILED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        ThisState = "2e73d7de-809c-496d-899b-fe80a8941bb9"
        If SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) Then
          Me.RtsExit_TRAILED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "1697bffd-64b6-49eb-bda7-db7100314afa", 0, NullString)
          Me.RtsEnter_WAITING_FOR_INITIALISING()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        ThisState = "2e73d7de-809c-496d-899b-fe80a8941bb9"
        If SenseTrigger(ChgFlg18, ChangeEventsActive, ThisState) Then
          Me.RtsExit_TRAILED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ddd0fd6c-5e3e-4f16-9272-9ee6bd09f695", 0, NullString)
          Me.RtsEnter_ALL_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        ThisState = "2e73d7de-809c-496d-899b-fe80a8941bb9"
        If SenseTrigger(ChgFlg19, ChangeEventsActive, ThisState) Then
          Me.RtsExit_TRAILED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "28fc662a-22f8-4cf2-bde2-5c389773d656", 0, NullString)
          Me.RtsEnter_NO_END_POSITION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        ThisState = "2e73d7de-809c-496d-899b-fe80a8941bb9"
        If SenseTrigger(ChgFlg20, ChangeEventsActive, ThisState) Then
          Me.RtsExit_TRAILED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c6b51b9e-0ff6-4393-a25f-a5b26d6ab289", 0, NullString)
          Me.RtsEnter_ALL_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If (D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING") And (cOp2_All_Left) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "81749b48-0d51-4a65-8095-2c06b267b4a5", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a7ddb70f-d7ad-44de-8e53-607563c11a94", 0, NullString)
          Me.RtsEnter_ALL_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If (D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING") And (cOp4_All_Right) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "81749b48-0d51-4a65-8095-2c06b267b4a5", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5da1e9e8-fc6c-4ada-b700-939f474f02c7", 0, NullString)
          Me.RtsEnter_ALL_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If (D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING") And (cOp3_No_End_Position) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "81749b48-0d51-4a65-8095-2c06b267b4a5", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7d8c4a6e-e8b8-43b3-8901-104e272ff37e", 0, NullString)
          Me.RtsEnter_NO_END_POSITION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If (D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING") And (cOp5_Trailed And cOp7_Is_Trailable) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "81749b48-0d51-4a65-8095-2c06b267b4a5", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "27015775-911c-48cd-a707-5ed9bcad0f20", 0, NullString)
          Me.RtsEnter_TRAILED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) And (cOp2_All_Left) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "58545474-1aa5-4a38-ad5a-4d40ad8033bc", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a7ddb70f-d7ad-44de-8e53-607563c11a94", 0, NullString)
          Me.RtsEnter_ALL_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) And (cOp4_All_Right) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "58545474-1aa5-4a38-ad5a-4d40ad8033bc", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5da1e9e8-fc6c-4ada-b700-939f474f02c7", 0, NullString)
          Me.RtsEnter_ALL_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) And (cOp3_No_End_Position) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "58545474-1aa5-4a38-ad5a-4d40ad8033bc", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7d8c4a6e-e8b8-43b3-8901-104e272ff37e", 0, NullString)
          Me.RtsEnter_NO_END_POSITION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        ThisState = "05ebc1c1-994b-43aa-a452-529b2aa1ac44"
        If SenseTrigger(ChgFlg21, ChangeEventsActive, ThisState) And (cOp5_Trailed And cOp7_Is_Trailable) Then
          Me.RtsExit_WAITING_FOR_INITIALISING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "58545474-1aa5-4a38-ad5a-4d40ad8033bc", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "27015775-911c-48cd-a707-5ed9bcad0f20", 0, NullString)
          Me.RtsEnter_TRAILED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (cOp9_Redrive_Enabled) And SenseTrigger(ChgFlg22, ChangeEventsActive, ThisState) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "d1fe7c0f-d5fa-43aa-8fb4-f8599987b26a", 0, NullString)
          D25_Redrive.SetValue(True)
          Me.RtsEnter_MOVING_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (cOp9_Redrive_Enabled) And SenseTrigger(ChgFlg23, ChangeEventsActive, ThisState) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "96859a1c-611b-4d47-acbd-9518ac9ac722", 0, NullString)
          D25_Redrive.SetValue(True)
          Me.RtsEnter_MOVING_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (DT1_Move_Target.GetLatchedValue() = "LEFT") And SenseTrigger(ChgFlg24, ChangeEventsActive, ThisState) And (DT1_Move_Target.GetLatchedValue() <> Mem_Current_Point_Position) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "da7b34e8-77d7-434c-80b8-154b7b4a3252", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ff074e0c-b1d7-44dc-9e82-7bab5e12809d", 0, NullString)
          Me.RtsEnter_MOVING_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (DT1_Move_Target.GetLatchedValue() = "LEFT") And SenseTrigger(ChgFlg24, ChangeEventsActive, ThisState) And (DT1_Move_Target.GetLatchedValue() = Mem_Current_Point_Position) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "da7b34e8-77d7-434c-80b8-154b7b4a3252", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "472d7d70-6fdc-4351-b438-c518eca51b1e", 0, NullString)
          cOp14_Send_Same_Position()
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (DT1_Move_Target.GetLatchedValue() = "RIGHT") And SenseTrigger(ChgFlg25, ChangeEventsActive, ThisState) And (DT1_Move_Target.GetLatchedValue() <> Mem_Current_Point_Position) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5a09653f-9bed-46c1-8050-37aa6b0ecb1d", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6014de9e-295f-4b51-9767-db1237fd9828", 0, NullString)
          Me.RtsEnter_MOVING_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        ThisState = "733afdfa-88cc-4498-a8f0-055a3e997929"
        If (DT1_Move_Target.GetLatchedValue() = "RIGHT") And SenseTrigger(ChgFlg25, ChangeEventsActive, ThisState) And (DT1_Move_Target.GetLatchedValue() = Mem_Current_Point_Position) Then
          Me.RtsExit_STOPPED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5a09653f-9bed-46c1-8050-37aa6b0ecb1d", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "47c2cf7d-74fb-4a86-95f3-71585561def3", 0, NullString)
          cOp14_Send_Same_Position()
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT Then
        ThisState = "d4819a64-5488-47b5-a1a7-59ac142bedbc"
        If (cOp13_Not_Initialised) Then
          Me.RtsExit_MOVING_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "60404085-2ea4-44b3-af45-c8d765c1d83b", 0, NullString)
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT Then
        ThisState = "d4819a64-5488-47b5-a1a7-59ac142bedbc"
        If SenseTrigger(ChgFlg26, ChangeEventsActive, ThisState) Then
          Me.RtsExit_MOVING_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "506ecd1d-d82e-4658-a223-e36412f8ad81", 0, NullString)
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT Then
        ThisState = "d4819a64-5488-47b5-a1a7-59ac142bedbc"
        If (DT1_Move_Target.GetLatchedValue() = "RIGHT") And SenseTrigger(ChgFlg27, ChangeEventsActive, ThisState) Then
          Me.RtsExit_MOVING_LEFT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6fe6c723-aef0-499a-a664-08fc3948d0fc", 0, NullString)
          Me.RtsEnter_MOVING_RIGHT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT Then
        ThisState = "958897da-fd5d-4883-8112-0eeefdc5bfce"
        If (cOp13_Not_Initialised) Then
          Me.RtsExit_MOVING_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "047ed1de-13a4-4a3f-8dd6-372772f3e245", 0, NullString)
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT Then
        ThisState = "958897da-fd5d-4883-8112-0eeefdc5bfce"
        If SenseTrigger(ChgFlg28, ChangeEventsActive, ThisState) Then
          Me.RtsExit_MOVING_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a30d2cbc-641c-4989-a860-dd09c8a5d71c", 0, NullString)
          Me.RtsEnter_STOPPED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT Then
        ThisState = "958897da-fd5d-4883-8112-0eeefdc5bfce"
        If (DT1_Move_Target.GetLatchedValue() = "LEFT") And SenseTrigger(ChgFlg29, ChangeEventsActive, ThisState) Then
          Me.RtsExit_MOVING_RIGHT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8f07b792-0d15-4820-ac39-b375092cf15c", 0, NullString)
          Me.RtsEnter_MOVING_LEFT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_NotIn_F_P3_SR Then
        ThisState = "8363fc7a-2143-4184-a5d5-5fe3c7d4eba2"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "8363fc7a-2143-4184-a5d5-5fe3c7d4eba2", 0, NullString)
        RtsNotify(Me, SEXIT, "8363fc7a-2143-4184-a5d5-5fe3c7d4eba2", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "bbca214c-a3ae-4e28-9670-ae5be6963cc5", 0, NullString)
        cOp1_Init()
        Me.RtsDefault_OPERATING()
        RetValue = True
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "1152d584-a15d-451f-9222-0481cad4a72e", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttMOVING_LEFT_Timer1);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttMOVING_RIGHT_Timer1);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_F_P3_SR := RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_NotIn_F_P3_SR;/* #REF1566# */
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NotIn_DETECTION;/* #REF1566# */
    ' This.RtsCurrent_DRIVE := RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_NotIn_DRIVE;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "1152d584-a15d-451f-9222-0481cad4a72e", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttMOVING_LEFT_Timer1)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttMOVING_RIGHT_Timer1)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_NotIn_F_P3_SR
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NotIn_DETECTION
      Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_NotIn_DRIVE
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|") then
    '   OperatedStates := OperatedStates + "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|";
    ' end if
    ' // Simulation support : Notification function call for entering state : OPERATING ///* #REF520# */
    ' RtsNotify(This,SENTER,"1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f",0,NullString);
    ' 
    ' SimCore.EnterState("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f","OPERATING");
    ' 
    ' This.RtsCurrent_F_P3_SR := RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_OPERATING;/* #REF521# */
    ' 
    Private Sub RtsEnter_OPERATING()
      If not OperatedStates.Contains("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|") Then
        OperatedStates = OperatedStates + "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|"
      End If
      'Simulation support : Notification function call for entering state : OPERATING ///* #REF520# */
      RtsNotify(Me, SENTER, "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f", 0, NullString)
      SimCore.EnterState("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f", "OPERATING")
      Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_OPERATING
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("49a7622b-d31d-42b6-961e-d95714d97558|") then
    '   OperatedStates := OperatedStates + "49a7622b-d31d-42b6-961e-d95714d97558|";
    ' end if
    ' // Simulation support : Notification function call for entering state : ALL_LEFT ///* #REF520# */
    ' RtsNotify(This,SENTER,"49a7622b-d31d-42b6-961e-d95714d97558",0,NullString);
    ' 
    ' SimCore.EnterState("49a7622b-d31d-42b6-961e-d95714d97558","OPERATING::DETECTION::ALL_LEFT");
    ' 
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT c03bdf41-ad62-4675-9c9b-de7b13263237 */  DT20_Point_Position := "LEFT";
    '  T20_Point_Position := TRUE;
    '  Mem_Current_Point_Position := "LEFT";
    '  T5_Info_End_Position_Arrived := TRUE;
    '  D6_Detection_State := "END_POSITION"; nullstat;/*##END c03bdf41-ad62-4675-9c9b-de7b13263237 */ 
    Private Sub RtsEnter_ALL_LEFT()
      If not OperatedStates.Contains("49a7622b-d31d-42b6-961e-d95714d97558|") Then
        OperatedStates = OperatedStates + "49a7622b-d31d-42b6-961e-d95714d97558|"
      End If
      'Simulation support : Notification function call for entering state : ALL_LEFT ///* #REF520# */
      RtsNotify(Me, SENTER, "49a7622b-d31d-42b6-961e-d95714d97558", 0, NullString)
      SimCore.EnterState("49a7622b-d31d-42b6-961e-d95714d97558", "OPERATING::DETECTION::ALL_LEFT")
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT
      'Entry Actions
      DT20_Point_Position.SetValue("LEFT")
      T20_Point_Position.SetValue(True)
      Mem_Current_Point_Position = "LEFT"
      T5_Info_End_Position_Arrived.SetValue(True)
      D6_Detection_State.SetValue("END_POSITION")
    End Sub
    
    ' \ART_SMG :: Created for state : NO_END_POSITION
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("e261c445-aaad-4442-af30-bbea3464768b|") then
    '   OperatedStates := OperatedStates + "e261c445-aaad-4442-af30-bbea3464768b|";
    ' end if
    ' // Simulation support : Notification function call for entering state : NO_END_POSITION ///* #REF520# */
    ' RtsNotify(This,SENTER,"e261c445-aaad-4442-af30-bbea3464768b",0,NullString);
    ' 
    ' SimCore.EnterState("e261c445-aaad-4442-af30-bbea3464768b","OPERATING::DETECTION::NO_END_POSITION");
    ' 
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 45ab7787-5a9c-4026-aedd-20efbdf99c9c */  DT20_Point_Position := "NO_END_POSITION";
    '  T20_Point_Position := TRUE;
    '  Mem_Current_Point_Position := "NO_END_POSITION";
    '  T4_Information_No_End_Position := TRUE;
    '  D6_Detection_State := "NO_END_POSITION"; nullstat;/*##END 45ab7787-5a9c-4026-aedd-20efbdf99c9c */ 
    Private Sub RtsEnter_NO_END_POSITION()
      If not OperatedStates.Contains("e261c445-aaad-4442-af30-bbea3464768b|") Then
        OperatedStates = OperatedStates + "e261c445-aaad-4442-af30-bbea3464768b|"
      End If
      'Simulation support : Notification function call for entering state : NO_END_POSITION ///* #REF520# */
      RtsNotify(Me, SENTER, "e261c445-aaad-4442-af30-bbea3464768b", 0, NullString)
      SimCore.EnterState("e261c445-aaad-4442-af30-bbea3464768b", "OPERATING::DETECTION::NO_END_POSITION")
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION
      'Entry Actions
      DT20_Point_Position.SetValue("NO_END_POSITION")
      T20_Point_Position.SetValue(True)
      Mem_Current_Point_Position = "NO_END_POSITION"
      T4_Information_No_End_Position.SetValue(True)
      D6_Detection_State.SetValue("NO_END_POSITION")
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("9a81cc79-961b-46cc-9267-43f5d7756555|") then
    '   OperatedStates := OperatedStates + "9a81cc79-961b-46cc-9267-43f5d7756555|";
    ' end if
    ' // Simulation support : Notification function call for entering state : ALL_RIGHT ///* #REF520# */
    ' RtsNotify(This,SENTER,"9a81cc79-961b-46cc-9267-43f5d7756555",0,NullString);
    ' 
    ' SimCore.EnterState("9a81cc79-961b-46cc-9267-43f5d7756555","OPERATING::DETECTION::ALL_RIGHT");
    ' 
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 00656d7d-7584-44b7-a328-8763839863ef */  DT20_Point_Position := "RIGHT";
    '  T20_Point_Position := TRUE;
    '  Mem_Current_Point_Position := "RIGHT";
    '  T5_Info_End_Position_Arrived := TRUE;
    '  D6_Detection_State := "END_POSITION"; nullstat;/*##END 00656d7d-7584-44b7-a328-8763839863ef */ 
    Private Sub RtsEnter_ALL_RIGHT()
      If not OperatedStates.Contains("9a81cc79-961b-46cc-9267-43f5d7756555|") Then
        OperatedStates = OperatedStates + "9a81cc79-961b-46cc-9267-43f5d7756555|"
      End If
      'Simulation support : Notification function call for entering state : ALL_RIGHT ///* #REF520# */
      RtsNotify(Me, SENTER, "9a81cc79-961b-46cc-9267-43f5d7756555", 0, NullString)
      SimCore.EnterState("9a81cc79-961b-46cc-9267-43f5d7756555", "OPERATING::DETECTION::ALL_RIGHT")
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT
      'Entry Actions
      DT20_Point_Position.SetValue("RIGHT")
      T20_Point_Position.SetValue(True)
      Mem_Current_Point_Position = "RIGHT"
      T5_Info_End_Position_Arrived.SetValue(True)
      D6_Detection_State.SetValue("END_POSITION")
    End Sub
    
    ' \ART_SMG :: Created for state : TRAILED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("2e73d7de-809c-496d-899b-fe80a8941bb9|") then
    '   OperatedStates := OperatedStates + "2e73d7de-809c-496d-899b-fe80a8941bb9|";
    ' end if
    ' // Simulation support : Notification function call for entering state : TRAILED ///* #REF520# */
    ' RtsNotify(This,SENTER,"2e73d7de-809c-496d-899b-fe80a8941bb9",0,NullString);
    ' 
    ' SimCore.EnterState("2e73d7de-809c-496d-899b-fe80a8941bb9","OPERATING::DETECTION::TRAILED");
    ' 
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 372fb3bf-0f7e-400d-8b71-973d99a8dba1 */  DT20_Point_Position := "TRAILED";
    '  T20_Point_Position := TRUE;
    '  Mem_Current_Point_Position := "TRAILED";
    '  T6_Information_Trailed_Point := TRUE;
    '  D6_Detection_State := "TRAILED"; nullstat;/*##END 372fb3bf-0f7e-400d-8b71-973d99a8dba1 */ 
    Private Sub RtsEnter_TRAILED()
      If not OperatedStates.Contains("2e73d7de-809c-496d-899b-fe80a8941bb9|") Then
        OperatedStates = OperatedStates + "2e73d7de-809c-496d-899b-fe80a8941bb9|"
      End If
      'Simulation support : Notification function call for entering state : TRAILED ///* #REF520# */
      RtsNotify(Me, SENTER, "2e73d7de-809c-496d-899b-fe80a8941bb9", 0, NullString)
      SimCore.EnterState("2e73d7de-809c-496d-899b-fe80a8941bb9", "OPERATING::DETECTION::TRAILED")
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED
      'Entry Actions
      DT20_Point_Position.SetValue("TRAILED")
      T20_Point_Position.SetValue(True)
      Mem_Current_Point_Position = "TRAILED"
      T6_Information_Trailed_Point.SetValue(True)
      D6_Detection_State.SetValue("TRAILED")
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("05ebc1c1-994b-43aa-a452-529b2aa1ac44|") then
    '   OperatedStates := OperatedStates + "05ebc1c1-994b-43aa-a452-529b2aa1ac44|";
    ' end if
    ' // Simulation support : Notification function call for entering state : WAITING_FOR_INITIALISING ///* #REF520# */
    ' RtsNotify(This,SENTER,"05ebc1c1-994b-43aa-a452-529b2aa1ac44",0,NullString);
    ' 
    ' SimCore.EnterState("05ebc1c1-994b-43aa-a452-529b2aa1ac44","OPERATING::DETECTION::WAITING_FOR_INITIALISING");
    ' 
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING;/* #REF521# */
    ' 
    Private Sub RtsEnter_WAITING_FOR_INITIALISING()
      If not OperatedStates.Contains("05ebc1c1-994b-43aa-a452-529b2aa1ac44|") Then
        OperatedStates = OperatedStates + "05ebc1c1-994b-43aa-a452-529b2aa1ac44|"
      End If
      'Simulation support : Notification function call for entering state : WAITING_FOR_INITIALISING ///* #REF520# */
      RtsNotify(Me, SENTER, "05ebc1c1-994b-43aa-a452-529b2aa1ac44", 0, NullString)
      SimCore.EnterState("05ebc1c1-994b-43aa-a452-529b2aa1ac44", "OPERATING::DETECTION::WAITING_FOR_INITIALISING")
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING
    End Sub
    
    ' \ART_SMG :: Created for state : STOPPED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("733afdfa-88cc-4498-a8f0-055a3e997929|") then
    '   OperatedStates := OperatedStates + "733afdfa-88cc-4498-a8f0-055a3e997929|";
    ' end if
    ' // Simulation support : Notification function call for entering state : STOPPED ///* #REF520# */
    ' RtsNotify(This,SENTER,"733afdfa-88cc-4498-a8f0-055a3e997929",0,NullString);
    ' 
    ' SimCore.EnterState("733afdfa-88cc-4498-a8f0-055a3e997929","OPERATING::DRIVE::STOPPED");
    ' 
    ' This.RtsCurrent_DRIVE := RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 8872571e-080a-4646-8ce5-34b55ad52f65 */  D25_Redrive := FALSE;
    '  D5_Drive_State := "STOPPED"; nullstat;/*##END 8872571e-080a-4646-8ce5-34b55ad52f65 */ 
    Private Sub RtsEnter_STOPPED()
      If not OperatedStates.Contains("733afdfa-88cc-4498-a8f0-055a3e997929|") Then
        OperatedStates = OperatedStates + "733afdfa-88cc-4498-a8f0-055a3e997929|"
      End If
      'Simulation support : Notification function call for entering state : STOPPED ///* #REF520# */
      RtsNotify(Me, SENTER, "733afdfa-88cc-4498-a8f0-055a3e997929", 0, NullString)
      SimCore.EnterState("733afdfa-88cc-4498-a8f0-055a3e997929", "OPERATING::DRIVE::STOPPED")
      Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED
      'Entry Actions
      D25_Redrive.SetValue(False)
      D5_Drive_State.SetValue("STOPPED")
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("d4819a64-5488-47b5-a1a7-59ac142bedbc|") then
    '   OperatedStates := OperatedStates + "d4819a64-5488-47b5-a1a7-59ac142bedbc|";
    ' end if
    ' // Simulation support : Notification function call for entering state : MOVING_LEFT ///* #REF520# */
    ' RtsNotify(This,SENTER,"d4819a64-5488-47b5-a1a7-59ac142bedbc",0,NullString);
    ' 
    ' SimCore.EnterState("d4819a64-5488-47b5-a1a7-59ac142bedbc","OPERATING::DRIVE::MOVING_LEFT");
    ' 
    ' This.RtsCurrent_DRIVE := RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT f3351341-6ecb-4670-a5ff-dccce4f440c1 */  D10_Move_Left := TRUE;
    '  D5_Drive_State := "MOVING";
    '  Mem_last_Target_Requested := "LEFT"; nullstat;/*##END f3351341-6ecb-4670-a5ff-dccce4f440c1 */ /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttMOVING_LEFT_Timer1, /*##STRT 1479c82d-9a19-4459-aa23-e36a01b1865f */ D4_Con_tmax_Point_Operation/*##END 1479c82d-9a19-4459-aa23-e36a01b1865f */ , CurrentTime);
    Private Sub RtsEnter_MOVING_LEFT()
      If not OperatedStates.Contains("d4819a64-5488-47b5-a1a7-59ac142bedbc|") Then
        OperatedStates = OperatedStates + "d4819a64-5488-47b5-a1a7-59ac142bedbc|"
      End If
      'Simulation support : Notification function call for entering state : MOVING_LEFT ///* #REF520# */
      RtsNotify(Me, SENTER, "d4819a64-5488-47b5-a1a7-59ac142bedbc", 0, NullString)
      SimCore.EnterState("d4819a64-5488-47b5-a1a7-59ac142bedbc", "OPERATING::DRIVE::MOVING_LEFT")
      Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT
      'Entry Actions
      D10_Move_Left.SetValue(True)
      D5_Drive_State.SetValue("MOVING")
      Mem_last_Target_Requested = "LEFT"
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttMOVING_LEFT_Timer1, D4_Con_tmax_Point_Operation.GetLatchedValue(), CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("958897da-fd5d-4883-8112-0eeefdc5bfce|") then
    '   OperatedStates := OperatedStates + "958897da-fd5d-4883-8112-0eeefdc5bfce|";
    ' end if
    ' // Simulation support : Notification function call for entering state : MOVING_RIGHT ///* #REF520# */
    ' RtsNotify(This,SENTER,"958897da-fd5d-4883-8112-0eeefdc5bfce",0,NullString);
    ' 
    ' SimCore.EnterState("958897da-fd5d-4883-8112-0eeefdc5bfce","OPERATING::DRIVE::MOVING_RIGHT");
    ' 
    ' This.RtsCurrent_DRIVE := RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 4b8c9e3e-dc39-4fd3-8a10-4a4ab6018c6c */  D11_Move_Right := TRUE;
    '  D5_Drive_State := "MOVING";
    '  Mem_last_Target_Requested = "RIGHT"; nullstat;/*##END 4b8c9e3e-dc39-4fd3-8a10-4a4ab6018c6c */ /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttMOVING_RIGHT_Timer1, /*##STRT 3c99eeca-1362-479b-9f9f-3e23c2bff327 */ D4_Con_tmax_Point_Operation/*##END 3c99eeca-1362-479b-9f9f-3e23c2bff327 */ , CurrentTime);
    Private Sub RtsEnter_MOVING_RIGHT()
      If not OperatedStates.Contains("958897da-fd5d-4883-8112-0eeefdc5bfce|") Then
        OperatedStates = OperatedStates + "958897da-fd5d-4883-8112-0eeefdc5bfce|"
      End If
      'Simulation support : Notification function call for entering state : MOVING_RIGHT ///* #REF520# */
      RtsNotify(Me, SENTER, "958897da-fd5d-4883-8112-0eeefdc5bfce", 0, NullString)
      SimCore.EnterState("958897da-fd5d-4883-8112-0eeefdc5bfce", "OPERATING::DRIVE::MOVING_RIGHT")
      Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT
      'Entry Actions
      D11_Move_Right.SetValue(True)
      D5_Drive_State.SetValue("MOVING")
      Mem_last_Target_Requested = "RIGHT"
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttMOVING_RIGHT_Timer1, D4_Con_tmax_Point_Operation.GetLatchedValue(), CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_F_P3_SR = RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_OPERATING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : OPERATING
    ' 	RtsNotify(This,SEXIT,"1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_OPERATING ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_OPERATING()
      If Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_OPERATING Then
        'Simulation support : Notification function call for exiting state : OPERATING
        RtsNotify(Me, SEXIT, "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f", 0, NullString)
        RtsExitSSOf_OPERATING()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : ALL_LEFT
    ' 	RtsNotify(This,SEXIT,"49a7622b-d31d-42b6-961e-d95714d97558",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_ALL_LEFT ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT dbfaa88c-a6b9-4325-ad63-3f69ee88bfc3 */  T5_Info_End_Position_Arrived := FALSE; nullstat;/*##END dbfaa88c-a6b9-4325-ad63-3f69ee88bfc3 */ 
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_ALL_LEFT()
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT Then
        'Simulation support : Notification function call for exiting state : ALL_LEFT
        RtsNotify(Me, SEXIT, "49a7622b-d31d-42b6-961e-d95714d97558", 0, NullString)
        RtsExitSSOf_ALL_LEFT()
        'Exit Actions
        T5_Info_End_Position_Arrived.SetValue(False)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : NO_END_POSITION
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : NO_END_POSITION
    ' 	RtsNotify(This,SEXIT,"e261c445-aaad-4442-af30-bbea3464768b",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_NO_END_POSITION ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT d14d8ce2-b1c9-4026-b0ec-00bf35b52390 */  T4_Information_No_End_Position := FALSE; nullstat;/*##END d14d8ce2-b1c9-4026-b0ec-00bf35b52390 */ 
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_NO_END_POSITION()
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION Then
        'Simulation support : Notification function call for exiting state : NO_END_POSITION
        RtsNotify(Me, SEXIT, "e261c445-aaad-4442-af30-bbea3464768b", 0, NullString)
        RtsExitSSOf_NO_END_POSITION()
        'Exit Actions
        T4_Information_No_End_Position.SetValue(False)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : ALL_RIGHT
    ' 	RtsNotify(This,SEXIT,"9a81cc79-961b-46cc-9267-43f5d7756555",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_ALL_RIGHT ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT a0d08fbd-7662-471a-9f98-d9320c93c16d */  T5_Info_End_Position_Arrived := FALSE; nullstat;/*##END a0d08fbd-7662-471a-9f98-d9320c93c16d */ 
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_ALL_RIGHT()
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT Then
        'Simulation support : Notification function call for exiting state : ALL_RIGHT
        RtsNotify(Me, SEXIT, "9a81cc79-961b-46cc-9267-43f5d7756555", 0, NullString)
        RtsExitSSOf_ALL_RIGHT()
        'Exit Actions
        T5_Info_End_Position_Arrived.SetValue(False)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : TRAILED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : TRAILED
    ' 	RtsNotify(This,SEXIT,"2e73d7de-809c-496d-899b-fe80a8941bb9",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_TRAILED ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT 9a45f2c8-be99-43a1-b106-b6541473260d */  T6_Information_Trailed_Point := FALSE; nullstat;/*##END 9a45f2c8-be99-43a1-b106-b6541473260d */ 
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_TRAILED()
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED Then
        'Simulation support : Notification function call for exiting state : TRAILED
        RtsNotify(Me, SEXIT, "2e73d7de-809c-496d-899b-fe80a8941bb9", 0, NullString)
        RtsExitSSOf_TRAILED()
        'Exit Actions
        T6_Information_Trailed_Point.SetValue(False)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : WAITING_FOR_INITIALISING
    ' 	RtsNotify(This,SEXIT,"05ebc1c1-994b-43aa-a452-529b2aa1ac44",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_WAITING_FOR_INITIALISING ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_WAITING_FOR_INITIALISING()
      If Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING Then
        'Simulation support : Notification function call for exiting state : WAITING_FOR_INITIALISING
        RtsNotify(Me, SEXIT, "05ebc1c1-994b-43aa-a452-529b2aa1ac44", 0, NullString)
        RtsExitSSOf_WAITING_FOR_INITIALISING()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STOPPED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : STOPPED
    ' 	RtsNotify(This,SEXIT,"733afdfa-88cc-4498-a8f0-055a3e997929",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_STOPPED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_STOPPED()
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED Then
        'Simulation support : Notification function call for exiting state : STOPPED
        RtsNotify(Me, SEXIT, "733afdfa-88cc-4498-a8f0-055a3e997929", 0, NullString)
        RtsExitSSOf_STOPPED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : MOVING_LEFT
    ' 	RtsNotify(This,SEXIT,"d4819a64-5488-47b5-a1a7-59ac142bedbc",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_MOVING_LEFT ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT 511fb007-5d4f-424f-833a-9f1798654796 */  D10_Move_Left := FALSE; nullstat;/*##END 511fb007-5d4f-424f-833a-9f1798654796 */ 
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttMOVING_LEFT_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_MOVING_LEFT()
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT Then
        'Simulation support : Notification function call for exiting state : MOVING_LEFT
        RtsNotify(Me, SEXIT, "d4819a64-5488-47b5-a1a7-59ac142bedbc", 0, NullString)
        RtsExitSSOf_MOVING_LEFT()
        'Exit Actions
        D10_Move_Left.SetValue(False)
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttMOVING_LEFT_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : MOVING_RIGHT
    ' 	RtsNotify(This,SEXIT,"958897da-fd5d-4883-8112-0eeefdc5bfce",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_MOVING_RIGHT ();
    ' 	/* #REF749# */
    ' 	// Exit Actions
    ' 	/*##STRT 086f160d-f843-42c9-bf66-877c80aeff67 */  D11_Move_Right := FALSE; nullstat;/*##END 086f160d-f843-42c9-bf66-877c80aeff67 */ 
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttMOVING_RIGHT_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_MOVING_RIGHT()
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT Then
        'Simulation support : Notification function call for exiting state : MOVING_RIGHT
        RtsNotify(Me, SEXIT, "958897da-fd5d-4883-8112-0eeefdc5bfce", 0, NullString)
        RtsExitSSOf_MOVING_RIGHT()
        'Exit Actions
        D11_Move_Right.SetValue(False)
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttMOVING_RIGHT_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DETECTION
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"ff610af7-8dae-4928-9f6a-618185cda572",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"ff610af7-8dae-4928-9f6a-618185cda572",0,NullString);/* #REF1576# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"3906895d-afa3-4820-8715-764a1611524f",0,NullString);/* #REF1585# */
    ' /*##STRT 041fcf77-21f2-4f40-9146-cdc49c587279 */  nullstat;/*##END 041fcf77-21f2-4f40-9146-cdc49c587279 */ /* #REF1546# */
    ' This.RtsEnter_WAITING_FOR_INITIALISING();/* #REF1590# */
    ' 
    Private Sub RtsDefault_DETECTION()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "ff610af7-8dae-4928-9f6a-618185cda572", 0, NullString)
      RtsNotify(Me, SEXIT, "ff610af7-8dae-4928-9f6a-618185cda572", 0, NullString)
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "3906895d-afa3-4820-8715-764a1611524f", 0, NullString)
      Me.RtsEnter_WAITING_FOR_INITIALISING()
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' This.RtsEnter_OPERATING();/* #REF1572# */
    ' This.RtsDefault_DETECTION();/* #REF1573# */
    ' This.RtsDefault_DRIVE();/* #REF1573# */
    ' 
    Private Sub RtsDefault_OPERATING()
      Me.RtsEnter_OPERATING()
      Me.RtsDefault_DETECTION()
      Me.RtsDefault_DRIVE()
    End Sub
    
    ' \ART_SMG :: Created for state : DRIVE
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"9f6bc858-d31b-41c6-a265-7b75ee344d95",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"9f6bc858-d31b-41c6-a265-7b75ee344d95",0,NullString);/* #REF1576# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"e2602df2-128a-43d5-91fd-7e449f929a7a",0,NullString);/* #REF1585# */
    ' /*##STRT e0e9219b-3e01-4283-844a-6c5d9badcf7c */  nullstat;/*##END e0e9219b-3e01-4283-844a-6c5d9badcf7c */ /* #REF1546# */
    ' This.RtsEnter_STOPPED();/* #REF1590# */
    ' 
    Private Sub RtsDefault_DRIVE()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "9f6bc858-d31b-41c6-a265-7b75ee344d95", 0, NullString)
      RtsNotify(Me, SEXIT, "9f6bc858-d31b-41c6-a265-7b75ee344d95", 0, NullString)
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "e2602df2-128a-43d5-91fd-7e449f929a7a", 0, NullString)
      Me.RtsEnter_STOPPED()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As F_P3_SR)
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_P3_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_P3_SR, "RtsF_P3_SR_States");
    ' end if
    ' if Name = "RtsCurrent_DETECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DETECTION, "RtsF_P3_SRDETECTION_States");
    ' end if
    ' if Name = "RtsCurrent_DRIVE" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DRIVE, "RtsF_P3_SRDRIVE_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_F_P3_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_P3_SR, "RtsF_P3_SR_States");
    ' end if
    ' if Name = "RtsCurrent_DETECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DETECTION, "RtsF_P3_SRDETECTION_States");
    ' end if
    ' if Name = "RtsCurrent_DRIVE" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DRIVE, "RtsF_P3_SRDRIVE_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "1152d584-a15d-451f-9222-0481cad4a72e";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "8";
    '   Value := Value + "|RtsCurrent_F_P3_SR";
    '   Value := Value + "|RtsCurrent_DETECTION";
    '   Value := Value + "|RtsCurrent_DRIVE";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_F_P3_SR";
    '   Value := Value + "|RtsCurrent_DETECTION";
    '   Value := Value + "|RtsCurrent_DRIVE";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As F_P3_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_P3_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_P3_SR, "RtsF_P3_SR_States")
      End If
      If Name = "RtsCurrent_DETECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DETECTION, "RtsF_P3_SRDETECTION_States")
      End If
      If Name = "RtsCurrent_DRIVE" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DRIVE, "RtsF_P3_SRDRIVE_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_F_P3_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_P3_SR, "RtsF_P3_SR_States")
      End If
      If Name = "RtsCurrent_DETECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DETECTION, "RtsF_P3_SRDETECTION_States")
      End If
      If Name = "RtsCurrent_DRIVE" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DRIVE, "RtsF_P3_SRDRIVE_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "1152d584-a15d-451f-9222-0481cad4a72e"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "8"
        Value = Value + "|RtsCurrent_F_P3_SR"
        Value = Value + "|RtsCurrent_DETECTION"
        Value = Value + "|RtsCurrent_DRIVE"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_F_P3_SR"
        Value = Value + "|RtsCurrent_DETECTION"
        Value = Value + "|RtsCurrent_DRIVE"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_P3_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_P3_SR, Value, "RtsF_P3_SR_States", GetType(F_P3_SR.RtsF_P3_SR_States));
    ' end if
    ' if Name = "RtsCurrent_DETECTION" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_DETECTION, Value, "RtsF_P3_SRDETECTION_States", GetType(F_P3_SR.RtsF_P3_SRDETECTION_States));
    ' end if
    ' if Name = "RtsCurrent_DRIVE" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_DRIVE, Value, "RtsF_P3_SRDRIVE_States", GetType(F_P3_SR.RtsF_P3_SRDRIVE_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As F_P3_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_P3_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_P3_SR, Value, "RtsF_P3_SR_States", GetType(F_P3_SR.RtsF_P3_SR_States))
      End If
      If Name = "RtsCurrent_DETECTION" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_DETECTION, Value, "RtsF_P3_SRDETECTION_States", GetType(F_P3_SR.RtsF_P3_SRDETECTION_States))
      End If
      If Name = "RtsCurrent_DRIVE" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_DRIVE, Value, "RtsF_P3_SRDRIVE_States", GetType(F_P3_SR.RtsF_P3_SRDRIVE_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttMOVING_LEFT_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsMOVING_LEFT_Timer1_In_F_P3_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsMOVING_LEFT_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttMOVING_LEFT_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsMOVING_LEFT_Timer1_In_F_P3_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttMOVING_RIGHT_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsMOVING_RIGHT_Timer1_In_F_P3_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsMOVING_RIGHT_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttMOVING_RIGHT_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsMOVING_RIGHT_Timer1_In_F_P3_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // H1 OPERATING
    ' // H1 OPERATING - call into substate
    ' if This.RtsCurrent_F_P3_SR = RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_OPERATING then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsMOVING_LEFT_Timer1_In_OPERATING(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_LEFT_Timer1_In_F_P3_SR(ByRef RetValue As Boolean)
      'H1 OPERATING
      'H1 OPERATING - call into substate
      If Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_OPERATING Then
        RtsMOVING_LEFT_Timer1_In_OPERATING(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' declare InternalRetValue := False: boolean;
    ' RtsMOVING_LEFT_Timer1_In_DRIVE(InternalRetValue);
    ' RetValue := RetValue or InternalRetValue;
    ' if RetValue then
    ' 	return;
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_LEFT_Timer1_In_OPERATING(ByRef RetValue As Boolean)
      Dim InternalRetValue As boolean = False
      RtsMOVING_LEFT_Timer1_In_DRIVE(InternalRetValue)
      RetValue = RetValue Or InternalRetValue
      If RetValue Then
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // H1 MOVING_LEFT
    ' if This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT then/* #REF5# */
    ' /* #REF6# */
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_MOVING_LEFT */
    ' 	/* standard */
    ' 	This.RtsExit_MOVING_LEFT();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"8240f3f3-afe7-437e-93c7-9ea3bdc3fa06",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 1479c82d-9a19-4459-aa23-e36a01b1865f */  cOp12_Timeout (); nullstat;/*##END 1479c82d-9a19-4459-aa23-e36a01b1865f */ /* #REF1546# */
    ' 	This.RtsEnter_STOPPED();/* #REF1590# */
    ' 	/* #REF13# */
    ' 	RetValue := true;
    ' 	return;
    ' 	/* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_LEFT_Timer1_In_DRIVE(ByRef RetValue As Boolean)
      'H1 MOVING_LEFT
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT Then
        Me.RtsExit_MOVING_LEFT()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "8240f3f3-afe7-437e-93c7-9ea3bdc3fa06", 0, NullString)
        cOp12_Timeout()
        Me.RtsEnter_STOPPED()
        RetValue = True
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // H1 OPERATING
    ' // H1 OPERATING - call into substate
    ' if This.RtsCurrent_F_P3_SR = RtsF_P3_SR_States{enum_datatype}.RtsF_P3_SR_States_OPERATING then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsMOVING_RIGHT_Timer1_In_OPERATING(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_RIGHT_Timer1_In_F_P3_SR(ByRef RetValue As Boolean)
      'H1 OPERATING
      'H1 OPERATING - call into substate
      If Me.RtsCurrent_F_P3_SR = RtsF_P3_SR_States.RtsF_P3_SR_States_OPERATING Then
        RtsMOVING_RIGHT_Timer1_In_OPERATING(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' declare InternalRetValue := False: boolean;
    ' RtsMOVING_RIGHT_Timer1_In_DRIVE(InternalRetValue);
    ' RetValue := RetValue or InternalRetValue;
    ' if RetValue then
    ' 	return;
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_RIGHT_Timer1_In_OPERATING(ByRef RetValue As Boolean)
      Dim InternalRetValue As boolean = False
      RtsMOVING_RIGHT_Timer1_In_DRIVE(InternalRetValue)
      RetValue = RetValue Or InternalRetValue
      If RetValue Then
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' // H1 MOVING_RIGHT
    ' if This.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT then/* #REF5# */
    ' /* #REF6# */
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_MOVING_RIGHT */
    ' 	/* standard */
    ' 	This.RtsExit_MOVING_RIGHT();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"c289395c-3cd1-4967-ac73-f119b294ad98",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 3c99eeca-1362-479b-9f9f-3e23c2bff327 */  cOp12_Timeout (); nullstat;/*##END 3c99eeca-1362-479b-9f9f-3e23c2bff327 */ /* #REF1546# */
    ' 	This.RtsEnter_STOPPED();/* #REF1590# */
    ' 	/* #REF13# */
    ' 	RetValue := true;
    ' 	return;
    ' 	/* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsMOVING_RIGHT_Timer1_In_DRIVE(ByRef RetValue As Boolean)
      'H1 MOVING_RIGHT
      If Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT Then
        Me.RtsExit_MOVING_RIGHT()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "c289395c-3cd1-4967-ac73-f119b294ad98", 0, NullString)
        cOp12_Timeout()
        Me.RtsEnter_STOPPED()
        RetValue = True
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Created for state : OPERATING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|") then
    '   OperatedStates := OperatedStates + "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|";
    ' end if
    ' /* #REF724# */
    ' select case This.RtsCurrent_DETECTION/* #REF725# */
    ' /* #REF726# */
    ' 	case RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_LEFT:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_ALL_LEFT();/* #REF730# */
    ' 	case RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NO_END_POSITION:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_NO_END_POSITION();/* #REF730# */
    ' 	case RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_ALL_RIGHT:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_ALL_RIGHT();/* #REF730# */
    ' 	case RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_TRAILED:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_TRAILED();/* #REF730# */
    ' 	case RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_WAITING_FOR_INITIALISING();/* #REF730# */
    ' 	case else:/* #REF731# */
    ' 		/* #REF732# */
    ' end select
    ' This.RtsCurrent_DETECTION := RtsF_P3_SRDETECTION_States{enum_datatype}.RtsF_P3_SRDETECTION_States_NotIn_DETECTION;/* #REF736# */
    ' /* #REF724# */
    ' select case This.RtsCurrent_DRIVE/* #REF725# */
    ' /* #REF726# */
    ' 	case RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_STOPPED:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_STOPPED();/* #REF730# */
    ' 	case RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_LEFT:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_MOVING_LEFT();/* #REF730# */
    ' 	case RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_MOVING_RIGHT:/* #REF728# */
    ' 	/* #REF729# */
    ' 		This.RtsExit_MOVING_RIGHT();/* #REF730# */
    ' 	case else:/* #REF731# */
    ' 		/* #REF732# */
    ' end select
    ' This.RtsCurrent_DRIVE := RtsF_P3_SRDRIVE_States{enum_datatype}.RtsF_P3_SRDRIVE_States_NotIn_DRIVE;/* #REF736# */
    ' 
    Private Sub RtsExitSSOf_OPERATING()
      If not OperatedStates.Contains("1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|") Then
        OperatedStates = OperatedStates + "1ae9f8a2-db38-4e24-9aa5-39fa1dd6533f|"
      End If
      Select Case Me.RtsCurrent_DETECTION
        Case RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_LEFT
          Me.RtsExit_ALL_LEFT()
        Case RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NO_END_POSITION
          Me.RtsExit_NO_END_POSITION()
        Case RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_ALL_RIGHT
          Me.RtsExit_ALL_RIGHT()
        Case RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_TRAILED
          Me.RtsExit_TRAILED()
        Case RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_WAITING_FOR_INITIALISING
          Me.RtsExit_WAITING_FOR_INITIALISING()
      End Select
      Me.RtsCurrent_DETECTION = RtsF_P3_SRDETECTION_States.RtsF_P3_SRDETECTION_States_NotIn_DETECTION
      Select Case Me.RtsCurrent_DRIVE
        Case RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_STOPPED
          Me.RtsExit_STOPPED()
        Case RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_LEFT
          Me.RtsExit_MOVING_LEFT()
        Case RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_MOVING_RIGHT
          Me.RtsExit_MOVING_RIGHT()
      End Select
      Me.RtsCurrent_DRIVE = RtsF_P3_SRDRIVE_States.RtsF_P3_SRDRIVE_States_NotIn_DRIVE
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("49a7622b-d31d-42b6-961e-d95714d97558|") then
    '   OperatedStates := OperatedStates + "49a7622b-d31d-42b6-961e-d95714d97558|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_ALL_LEFT()
      If not OperatedStates.Contains("49a7622b-d31d-42b6-961e-d95714d97558|") Then
        OperatedStates = OperatedStates + "49a7622b-d31d-42b6-961e-d95714d97558|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : NO_END_POSITION
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("e261c445-aaad-4442-af30-bbea3464768b|") then
    '   OperatedStates := OperatedStates + "e261c445-aaad-4442-af30-bbea3464768b|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_NO_END_POSITION()
      If not OperatedStates.Contains("e261c445-aaad-4442-af30-bbea3464768b|") Then
        OperatedStates = OperatedStates + "e261c445-aaad-4442-af30-bbea3464768b|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ALL_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("9a81cc79-961b-46cc-9267-43f5d7756555|") then
    '   OperatedStates := OperatedStates + "9a81cc79-961b-46cc-9267-43f5d7756555|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_ALL_RIGHT()
      If not OperatedStates.Contains("9a81cc79-961b-46cc-9267-43f5d7756555|") Then
        OperatedStates = OperatedStates + "9a81cc79-961b-46cc-9267-43f5d7756555|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : TRAILED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("2e73d7de-809c-496d-899b-fe80a8941bb9|") then
    '   OperatedStates := OperatedStates + "2e73d7de-809c-496d-899b-fe80a8941bb9|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_TRAILED()
      If not OperatedStates.Contains("2e73d7de-809c-496d-899b-fe80a8941bb9|") Then
        OperatedStates = OperatedStates + "2e73d7de-809c-496d-899b-fe80a8941bb9|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISING
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("05ebc1c1-994b-43aa-a452-529b2aa1ac44|") then
    '   OperatedStates := OperatedStates + "05ebc1c1-994b-43aa-a452-529b2aa1ac44|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_WAITING_FOR_INITIALISING()
      If not OperatedStates.Contains("05ebc1c1-994b-43aa-a452-529b2aa1ac44|") Then
        OperatedStates = OperatedStates + "05ebc1c1-994b-43aa-a452-529b2aa1ac44|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STOPPED
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("733afdfa-88cc-4498-a8f0-055a3e997929|") then
    '   OperatedStates := OperatedStates + "733afdfa-88cc-4498-a8f0-055a3e997929|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_STOPPED()
      If not OperatedStates.Contains("733afdfa-88cc-4498-a8f0-055a3e997929|") Then
        OperatedStates = OperatedStates + "733afdfa-88cc-4498-a8f0-055a3e997929|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_LEFT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("d4819a64-5488-47b5-a1a7-59ac142bedbc|") then
    '   OperatedStates := OperatedStates + "d4819a64-5488-47b5-a1a7-59ac142bedbc|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_MOVING_LEFT()
      If not OperatedStates.Contains("d4819a64-5488-47b5-a1a7-59ac142bedbc|") Then
        OperatedStates = OperatedStates + "d4819a64-5488-47b5-a1a7-59ac142bedbc|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : MOVING_RIGHT
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' if not OperatedStates.Contains ("958897da-fd5d-4883-8112-0eeefdc5bfce|") then
    '   OperatedStates := OperatedStates + "958897da-fd5d-4883-8112-0eeefdc5bfce|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_MOVING_RIGHT()
      If not OperatedStates.Contains("958897da-fd5d-4883-8112-0eeefdc5bfce|") Then
        OperatedStates = OperatedStates + "958897da-fd5d-4883-8112-0eeefdc5bfce|"
      End If
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' This.RtsAttMOVING_LEFT_Timer1.TStep(CurrentTime);
    ' This.RtsAttMOVING_RIGHT_Timer1.TStep(CurrentTime);
    ' if This.RtsAttMOVING_LEFT_Timer1.HasElapsed() then
    '   This.RtsAttMOVING_LEFT_Timer1.TStop();
    '   RtsMOVING_LEFT_Timer1_CallBack(This);
    ' end if
    ' if This.RtsAttMOVING_RIGHT_Timer1.HasElapsed() then
    '   This.RtsAttMOVING_RIGHT_Timer1.TStop();
    '   RtsMOVING_RIGHT_Timer1_CallBack(This);
    ' end if
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttMOVING_LEFT_Timer1.TimeToLive());
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttMOVING_RIGHT_Timer1.TimeToLive());
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      Me.RtsAttMOVING_LEFT_Timer1.TStep(CurrentTime)
      Me.RtsAttMOVING_RIGHT_Timer1.TStep(CurrentTime)
      If Me.RtsAttMOVING_LEFT_Timer1.HasElapsed() Then
        Me.RtsAttMOVING_LEFT_Timer1.TStop()
        RtsMOVING_LEFT_Timer1_CallBack(Me)
      End If
      If Me.RtsAttMOVING_RIGHT_Timer1.HasElapsed() Then
        Me.RtsAttMOVING_RIGHT_Timer1.TStop()
        RtsMOVING_RIGHT_Timer1_CallBack(Me)
      End If
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttMOVING_LEFT_Timer1.TimeToLive())
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttMOVING_RIGHT_Timer1.TimeToLive())
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D10_Move_Left: a SySimOutputPort;
    ' assume D11_Move_Right: a SySimOutputPort;
    ' assume D13_PM2_Activation: a SySimInputPort;
    ' assume D20_F_EST_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume D21_PM1_Position: a SySimInputPort;
    ' assume D22_PM2_Position: a SySimInputPort;
    ' assume D25_Redrive: a SySimOutputPort;
    ' assume D30_Con_007000: a SySimInputPort;
    ' assume D32_Con_007600: a SySimInputPort;
    ' assume D33_Con_007900: a SySimInputPort;
    ' assume D34_Con_008000: a SySimInputPort;
    ' assume D35_Con_008200: a SySimInputPort;
    ' assume D37_Con_008400: a SySimInputPort;
    ' assume D38_Con_008500: a SySimInputPort;
    ' assume D4_Con_tmax_Point_Operation: a SySimInputPort;
    ' assume D5_Drive_State: a SySimOutputPort;
    ' assume D6_Detection_State: a SySimOutputPort;
    ' assume DT1_Move_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume T1_Move: a SySimInputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Stop_Operation: a SySimInputPort;
    ' assume T30_Report_Timeout: a SySimOutputPort;
    ' assume T40_Report_Status: a SySimInputPort;
    ' assume T4_Information_No_End_Position: a SySimOutputPort;
    ' assume T5_Info_End_Position_Arrived: a SySimOutputPort;
    ' assume T6_Information_Trailed_Point: a SySimOutputPort;
    ' assume T7_Information_Out_Of_Sequence: a SySimOutputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg25Tmp := (/*##STRT 86bc7725-45ec-4785-91d6-7deed95fc380 */ ( T1_Move )/*##END 86bc7725-45ec-4785-91d6-7deed95fc380 */ ) : Boolean;
    ' ChgFlg25 := EvalTrigger(ChgFlg25Tmp , ChgFlgLast25);
    ' declare ChgFlg20Tmp := (/*##STRT 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ( cOp4_All_Right )/*##END 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ) : Boolean;
    ' ChgFlg20 := EvalTrigger(ChgFlg20Tmp , ChgFlgLast20);
    ' declare ChgFlg11Tmp := (/*##STRT 1a744567-78ff-42e9-996f-e8809e8779b0 */ ( T40_Report_Status )/*##END 1a744567-78ff-42e9-996f-e8809e8779b0 */ ) : Boolean;
    ' ChgFlg11 := EvalTrigger(ChgFlg11Tmp , ChgFlgLast11);
    ' declare ChgFlg9Tmp := (/*##STRT 4dce5100-963b-4d62-913b-946988aa5de1 */ ( cOp4_All_Right )/*##END 4dce5100-963b-4d62-913b-946988aa5de1 */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg18Tmp := (/*##STRT a324997b-8be0-453e-adcb-e0c771501df4 */ ( cOp2_All_Left )/*##END a324997b-8be0-453e-adcb-e0c771501df4 */ ) : Boolean;
    ' ChgFlg18 := EvalTrigger(ChgFlg18Tmp , ChgFlgLast18);
    ' declare ChgFlg12Tmp := (/*##STRT 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ( cOp13_Not_Initialised )/*##END 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ) : Boolean;
    ' ChgFlg12 := EvalTrigger(ChgFlg12Tmp , ChgFlgLast12);
    ' declare ChgFlg19Tmp := (/*##STRT 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ( cOp3_No_End_Position )/*##END 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ) : Boolean;
    ' ChgFlg19 := EvalTrigger(ChgFlg19Tmp , ChgFlgLast19);
    ' declare ChgFlg7Tmp := (/*##STRT 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ( cOp13_Not_Initialised )/*##END 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg23Tmp := (/*##STRT a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ( cOp11_Redrive_Left )/*##END a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ) : Boolean;
    ' ChgFlg23 := EvalTrigger(ChgFlg23Tmp , ChgFlgLast23);
    ' declare ChgFlg26Tmp := (/*##STRT 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ( cOp2_All_Left )/*##END 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ) : Boolean;
    ' ChgFlg26 := EvalTrigger(ChgFlg26Tmp , ChgFlgLast26);
    ' declare ChgFlg28Tmp := (/*##STRT 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ( cOp4_All_Right )/*##END 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ) : Boolean;
    ' ChgFlg28 := EvalTrigger(ChgFlg28Tmp , ChgFlgLast28);
    ' declare ChgFlg3Tmp := (/*##STRT 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ( cOp3_No_End_Position )/*##END 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg29Tmp := (/*##STRT ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ( T1_Move )/*##END ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ) : Boolean;
    ' ChgFlg29 := EvalTrigger(ChgFlg29Tmp , ChgFlgLast29);
    ' declare ChgFlg22Tmp := (/*##STRT 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ( cOp10_Redrive_Right )/*##END 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ) : Boolean;
    ' ChgFlg22 := EvalTrigger(ChgFlg22Tmp , ChgFlgLast22);
    ' declare ChgFlg6Tmp := (/*##STRT e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ( T40_Report_Status )/*##END e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg21Tmp := (/*##STRT 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ) : Boolean;
    ' ChgFlg21 := EvalTrigger(ChgFlg21Tmp , ChgFlgLast21);
    ' declare ChgFlg15Tmp := (/*##STRT 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ( cOp5_Trailed )/*##END 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ) : Boolean;
    ' ChgFlg15 := EvalTrigger(ChgFlg15Tmp , ChgFlgLast15);
    ' declare ChgFlg4Tmp := (/*##STRT 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ( cOp4_All_Right )/*##END 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg17Tmp := (/*##STRT 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ( cOp13_Not_Initialised )/*##END 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ) : Boolean;
    ' ChgFlg17 := EvalTrigger(ChgFlg17Tmp , ChgFlgLast17);
    ' declare ChgFlg16Tmp := (/*##STRT bdb80df3-5adb-424a-af08-c830664275f1 */ ( T40_Report_Status )/*##END bdb80df3-5adb-424a-af08-c830664275f1 */ ) : Boolean;
    ' ChgFlg16 := EvalTrigger(ChgFlg16Tmp , ChgFlgLast16);
    ' declare ChgFlg5Tmp := (/*##STRT b2094af2-afd0-4499-897a-abf6b132e17f */ ( cOp5_Trailed )/*##END b2094af2-afd0-4499-897a-abf6b132e17f */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg10Tmp := (/*##STRT 36dce538-d3ed-44bf-9503-f04505896442 */ ( cOp5_Trailed )/*##END 36dce538-d3ed-44bf-9503-f04505896442 */ ) : Boolean;
    ' ChgFlg10 := EvalTrigger(ChgFlg10Tmp , ChgFlgLast10);
    ' declare ChgFlg8Tmp := (/*##STRT d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ( cOp2_All_Left )/*##END d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg2Tmp := (/*##STRT c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ( cOp13_Not_Initialised )/*##END c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' declare ChgFlg13Tmp := (/*##STRT 48e4241e-6883-4856-9782-5ed60a2553fd */ ( cOp2_All_Left )/*##END 48e4241e-6883-4856-9782-5ed60a2553fd */ ) : Boolean;
    ' ChgFlg13 := EvalTrigger(ChgFlg13Tmp , ChgFlgLast13);
    ' declare ChgFlg1Tmp := (/*##STRT aa640392-3338-4165-b3e8-b3d6a7772111 */ ( T40_Report_Status )/*##END aa640392-3338-4165-b3e8-b3d6a7772111 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg14Tmp := (/*##STRT 23d1cbba-588a-458b-a585-1fc0159c331f */ ( cOp3_No_End_Position )/*##END 23d1cbba-588a-458b-a585-1fc0159c331f */ ) : Boolean;
    ' ChgFlg14 := EvalTrigger(ChgFlg14Tmp , ChgFlgLast14);
    ' declare ChgFlg27Tmp := (/*##STRT 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ( T1_Move )/*##END 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ) : Boolean;
    ' ChgFlg27 := EvalTrigger(ChgFlg27Tmp , ChgFlgLast27);
    ' declare ChgFlg24Tmp := (/*##STRT 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ( T1_Move )/*##END 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ) : Boolean;
    ' ChgFlg24 := EvalTrigger(ChgFlg24Tmp , ChgFlgLast24);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast25 := ChgFlg25Tmp;
    ' ChgFlgLast20 := ChgFlg20Tmp;
    ' ChgFlgLast11 := ChgFlg11Tmp;
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast18 := ChgFlg18Tmp;
    ' ChgFlgLast12 := ChgFlg12Tmp;
    ' ChgFlgLast19 := ChgFlg19Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast23 := ChgFlg23Tmp;
    ' ChgFlgLast26 := ChgFlg26Tmp;
    ' ChgFlgLast28 := ChgFlg28Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast29 := ChgFlg29Tmp;
    ' ChgFlgLast22 := ChgFlg22Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast21 := ChgFlg21Tmp;
    ' ChgFlgLast15 := ChgFlg15Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast17 := ChgFlg17Tmp;
    ' ChgFlgLast16 := ChgFlg16Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast10 := ChgFlg10Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' ChgFlgLast13 := ChgFlg13Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast14 := ChgFlg14Tmp;
    ' ChgFlgLast27 := ChgFlg27Tmp;
    ' ChgFlgLast24 := ChgFlg24Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg25 := (/*##STRT 86bc7725-45ec-4785-91d6-7deed95fc380 */ ( T1_Move )/*##END 86bc7725-45ec-4785-91d6-7deed95fc380 */ ) : Boolean;
    '   declare MaskedChgFlg20 := (/*##STRT 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ( cOp4_All_Right )/*##END 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ) : Boolean;
    '   declare MaskedChgFlg11 := (/*##STRT 1a744567-78ff-42e9-996f-e8809e8779b0 */ ( T40_Report_Status )/*##END 1a744567-78ff-42e9-996f-e8809e8779b0 */ ) : Boolean;
    '   declare MaskedChgFlg9 := (/*##STRT 4dce5100-963b-4d62-913b-946988aa5de1 */ ( cOp4_All_Right )/*##END 4dce5100-963b-4d62-913b-946988aa5de1 */ ) : Boolean;
    '   declare MaskedChgFlg18 := (/*##STRT a324997b-8be0-453e-adcb-e0c771501df4 */ ( cOp2_All_Left )/*##END a324997b-8be0-453e-adcb-e0c771501df4 */ ) : Boolean;
    '   declare MaskedChgFlg12 := (/*##STRT 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ( cOp13_Not_Initialised )/*##END 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ) : Boolean;
    '   declare MaskedChgFlg19 := (/*##STRT 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ( cOp3_No_End_Position )/*##END 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ( cOp13_Not_Initialised )/*##END 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ) : Boolean;
    '   declare MaskedChgFlg23 := (/*##STRT a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ( cOp11_Redrive_Left )/*##END a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ) : Boolean;
    '   declare MaskedChgFlg26 := (/*##STRT 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ( cOp2_All_Left )/*##END 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ) : Boolean;
    '   declare MaskedChgFlg28 := (/*##STRT 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ( cOp4_All_Right )/*##END 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ( cOp3_No_End_Position )/*##END 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ) : Boolean;
    '   declare MaskedChgFlg29 := (/*##STRT ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ( T1_Move )/*##END ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ) : Boolean;
    '   declare MaskedChgFlg22 := (/*##STRT 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ( cOp10_Redrive_Right )/*##END 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ( T40_Report_Status )/*##END e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ) : Boolean;
    '   declare MaskedChgFlg21 := (/*##STRT 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ) : Boolean;
    '   declare MaskedChgFlg15 := (/*##STRT 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ( cOp5_Trailed )/*##END 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ( cOp4_All_Right )/*##END 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ) : Boolean;
    '   declare MaskedChgFlg17 := (/*##STRT 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ( cOp13_Not_Initialised )/*##END 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ) : Boolean;
    '   declare MaskedChgFlg16 := (/*##STRT bdb80df3-5adb-424a-af08-c830664275f1 */ ( T40_Report_Status )/*##END bdb80df3-5adb-424a-af08-c830664275f1 */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT b2094af2-afd0-4499-897a-abf6b132e17f */ ( cOp5_Trailed )/*##END b2094af2-afd0-4499-897a-abf6b132e17f */ ) : Boolean;
    '   declare MaskedChgFlg10 := (/*##STRT 36dce538-d3ed-44bf-9503-f04505896442 */ ( cOp5_Trailed )/*##END 36dce538-d3ed-44bf-9503-f04505896442 */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ( cOp2_All_Left )/*##END d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ( cOp13_Not_Initialised )/*##END c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ) : Boolean;
    '   declare MaskedChgFlg13 := (/*##STRT 48e4241e-6883-4856-9782-5ed60a2553fd */ ( cOp2_All_Left )/*##END 48e4241e-6883-4856-9782-5ed60a2553fd */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT aa640392-3338-4165-b3e8-b3d6a7772111 */ ( T40_Report_Status )/*##END aa640392-3338-4165-b3e8-b3d6a7772111 */ ) : Boolean;
    '   declare MaskedChgFlg14 := (/*##STRT 23d1cbba-588a-458b-a585-1fc0159c331f */ ( cOp3_No_End_Position )/*##END 23d1cbba-588a-458b-a585-1fc0159c331f */ ) : Boolean;
    '   declare MaskedChgFlg27 := (/*##STRT 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ( T1_Move )/*##END 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ) : Boolean;
    '   declare MaskedChgFlg24 := (/*##STRT 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ( T1_Move )/*##END 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg25 := (/*##STRT 86bc7725-45ec-4785-91d6-7deed95fc380 */ ( T1_Move )/*##END 86bc7725-45ec-4785-91d6-7deed95fc380 */ ) : Boolean;
    '   declare UnMaskedChgFlg20 := (/*##STRT 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ( cOp4_All_Right )/*##END 0e4fb4ce-fc29-4cca-b2e9-c6be7b21ef6f */ ) : Boolean;
    '   declare UnMaskedChgFlg11 := (/*##STRT 1a744567-78ff-42e9-996f-e8809e8779b0 */ ( T40_Report_Status )/*##END 1a744567-78ff-42e9-996f-e8809e8779b0 */ ) : Boolean;
    '   declare UnMaskedChgFlg9 := (/*##STRT 4dce5100-963b-4d62-913b-946988aa5de1 */ ( cOp4_All_Right )/*##END 4dce5100-963b-4d62-913b-946988aa5de1 */ ) : Boolean;
    '   declare UnMaskedChgFlg18 := (/*##STRT a324997b-8be0-453e-adcb-e0c771501df4 */ ( cOp2_All_Left )/*##END a324997b-8be0-453e-adcb-e0c771501df4 */ ) : Boolean;
    '   declare UnMaskedChgFlg12 := (/*##STRT 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ( cOp13_Not_Initialised )/*##END 6cd04c78-b0ae-44c4-8f1e-ca94a9d6c720 */ ) : Boolean;
    '   declare UnMaskedChgFlg19 := (/*##STRT 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ( cOp3_No_End_Position )/*##END 69e5d12b-f836-49cf-9284-fcd1eb6dc38b */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ( cOp13_Not_Initialised )/*##END 82364b9a-7758-40b9-aac6-91ea3c6b59bf */ ) : Boolean;
    '   declare UnMaskedChgFlg23 := (/*##STRT a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ( cOp11_Redrive_Left )/*##END a7eb0c06-7ebf-4247-99cd-c40cf7bbb866 */ ) : Boolean;
    '   declare UnMaskedChgFlg26 := (/*##STRT 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ( cOp2_All_Left )/*##END 081d09cc-d78a-4ee4-bcef-1cc572ba1c9c */ ) : Boolean;
    '   declare UnMaskedChgFlg28 := (/*##STRT 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ( cOp4_All_Right )/*##END 72da7c78-ca8f-432c-9dcd-844d03eff0f6 */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ( cOp3_No_End_Position )/*##END 4701a8f1-e6b2-455a-9ec7-928bae7cb06b */ ) : Boolean;
    '   declare UnMaskedChgFlg29 := (/*##STRT ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ( T1_Move )/*##END ab378fb5-4295-4d4f-bb70-f9a289a6066f */ ) : Boolean;
    '   declare UnMaskedChgFlg22 := (/*##STRT 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ( cOp10_Redrive_Right )/*##END 0f599fc0-d41d-4ee5-9a37-90cfd1fef4b9 */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ( T40_Report_Status )/*##END e71d3713-6e7f-4a05-8baf-9263e2c74b66 */ ) : Boolean;
    '   declare UnMaskedChgFlg21 := (/*##STRT 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ( D20_F_EST_EfeS_Gen_SR_State = "INITIALISING")/*##END 144caecb-8167-4ff7-96f9-a3c6b46aa926 */ ) : Boolean;
    '   declare UnMaskedChgFlg15 := (/*##STRT 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ( cOp5_Trailed )/*##END 28111a94-3d5d-41f1-8ec5-bbf44606122c */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ( cOp4_All_Right )/*##END 2e20499a-2eb3-4600-9be0-bd46f0b8b146 */ ) : Boolean;
    '   declare UnMaskedChgFlg17 := (/*##STRT 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ( cOp13_Not_Initialised )/*##END 73d0adbb-7882-439a-b1a7-28b93403bba0 */ ) : Boolean;
    '   declare UnMaskedChgFlg16 := (/*##STRT bdb80df3-5adb-424a-af08-c830664275f1 */ ( T40_Report_Status )/*##END bdb80df3-5adb-424a-af08-c830664275f1 */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT b2094af2-afd0-4499-897a-abf6b132e17f */ ( cOp5_Trailed )/*##END b2094af2-afd0-4499-897a-abf6b132e17f */ ) : Boolean;
    '   declare UnMaskedChgFlg10 := (/*##STRT 36dce538-d3ed-44bf-9503-f04505896442 */ ( cOp5_Trailed )/*##END 36dce538-d3ed-44bf-9503-f04505896442 */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ( cOp2_All_Left )/*##END d6172530-6deb-4bdb-a99e-800af8fe7a43 */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ( cOp13_Not_Initialised )/*##END c579c9fa-3d2a-455e-89c7-2f3b636cccac */ ) : Boolean;
    '   declare UnMaskedChgFlg13 := (/*##STRT 48e4241e-6883-4856-9782-5ed60a2553fd */ ( cOp2_All_Left )/*##END 48e4241e-6883-4856-9782-5ed60a2553fd */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT aa640392-3338-4165-b3e8-b3d6a7772111 */ ( T40_Report_Status )/*##END aa640392-3338-4165-b3e8-b3d6a7772111 */ ) : Boolean;
    '   declare UnMaskedChgFlg14 := (/*##STRT 23d1cbba-588a-458b-a585-1fc0159c331f */ ( cOp3_No_End_Position )/*##END 23d1cbba-588a-458b-a585-1fc0159c331f */ ) : Boolean;
    '   declare UnMaskedChgFlg27 := (/*##STRT 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ( T1_Move )/*##END 5dcc3775-d82d-4074-929f-5cdd0f877ae5 */ ) : Boolean;
    '   declare UnMaskedChgFlg24 := (/*##STRT 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ( T1_Move )/*##END 6e587cc3-4c92-40ba-9209-d4fa882bf230 */ ) : Boolean;
    '   declare PreviousChgFlg25 := ChgFlg25 : Boolean;
    '   declare PreviousChgFlg20 := ChgFlg20 : Boolean;
    '   declare PreviousChgFlg11 := ChgFlg11 : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg18 := ChgFlg18 : Boolean;
    '   declare PreviousChgFlg12 := ChgFlg12 : Boolean;
    '   declare PreviousChgFlg19 := ChgFlg19 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg23 := ChgFlg23 : Boolean;
    '   declare PreviousChgFlg26 := ChgFlg26 : Boolean;
    '   declare PreviousChgFlg28 := ChgFlg28 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg29 := ChgFlg29 : Boolean;
    '   declare PreviousChgFlg22 := ChgFlg22 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg21 := ChgFlg21 : Boolean;
    '   declare PreviousChgFlg15 := ChgFlg15 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg17 := ChgFlg17 : Boolean;
    '   declare PreviousChgFlg16 := ChgFlg16 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg10 := ChgFlg10 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   declare PreviousChgFlg13 := ChgFlg13 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg14 := ChgFlg14 : Boolean;
    '   declare PreviousChgFlg27 := ChgFlg27 : Boolean;
    '   declare PreviousChgFlg24 := ChgFlg24 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg25 And UnMaskedChgFlg25 And Not MaskedChgFlg25 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := True;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg20 And UnMaskedChgFlg20 And Not MaskedChgFlg20 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := True;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := True;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := True;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg18 And UnMaskedChgFlg18 And Not MaskedChgFlg18 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := True;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := True;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg19 And UnMaskedChgFlg19 And Not MaskedChgFlg19 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := True;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := True;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg23 And UnMaskedChgFlg23 And Not MaskedChgFlg23 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := True;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg26 And UnMaskedChgFlg26 And Not MaskedChgFlg26 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := True;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg28 And UnMaskedChgFlg28 And Not MaskedChgFlg28 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := True;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := True;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg29 And UnMaskedChgFlg29 And Not MaskedChgFlg29 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := True;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg22 And UnMaskedChgFlg22 And Not MaskedChgFlg22 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := True;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := True;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg21 And UnMaskedChgFlg21 And Not MaskedChgFlg21 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := True;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := True;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := True;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := True;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := True;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := True;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := True;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := True;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := True;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := True;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := True;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := True;
    '   ChgFlg27 := False;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg27 And UnMaskedChgFlg27 And Not MaskedChgFlg27 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := True;
    '   ChgFlg24 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg24 And UnMaskedChgFlg24 And Not MaskedChgFlg24 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg25 := False;
    '   ChgFlg20 := False;
    '   ChgFlg11 := False;
    '   ChgFlg9 := False;
    '   ChgFlg18 := False;
    '   ChgFlg12 := False;
    '   ChgFlg19 := False;
    '   ChgFlg7 := False;
    '   ChgFlg23 := False;
    '   ChgFlg26 := False;
    '   ChgFlg28 := False;
    '   ChgFlg3 := False;
    '   ChgFlg29 := False;
    '   ChgFlg22 := False;
    '   ChgFlg6 := False;
    '   ChgFlg21 := False;
    '   ChgFlg15 := False;
    '   ChgFlg4 := False;
    '   ChgFlg17 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg2 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg14 := False;
    '   ChgFlg27 := False;
    '   ChgFlg24 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg25 := false;
    ' ChgFlg20 := false;
    ' ChgFlg11 := false;
    ' ChgFlg9 := false;
    ' ChgFlg18 := false;
    ' ChgFlg12 := false;
    ' ChgFlg19 := false;
    ' ChgFlg7 := false;
    ' ChgFlg23 := false;
    ' ChgFlg26 := false;
    ' ChgFlg28 := false;
    ' ChgFlg3 := false;
    ' ChgFlg29 := false;
    ' ChgFlg22 := false;
    ' ChgFlg6 := false;
    ' ChgFlg21 := false;
    ' ChgFlg15 := false;
    ' ChgFlg4 := false;
    ' ChgFlg17 := false;
    ' ChgFlg16 := false;
    ' ChgFlg5 := false;
    ' ChgFlg10 := false;
    ' ChgFlg8 := false;
    ' ChgFlg2 := false;
    ' ChgFlg13 := false;
    ' ChgFlg1 := false;
    ' ChgFlg14 := false;
    ' ChgFlg27 := false;
    ' ChgFlg24 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg25Tmp As Boolean = ((T1_Move.GetLatchedValue()))
      ChgFlg25 = EvalTrigger(ChgFlg25Tmp, ChgFlgLast25)
      Dim ChgFlg20Tmp As Boolean = ((cOp4_All_Right))
      ChgFlg20 = EvalTrigger(ChgFlg20Tmp, ChgFlgLast20)
      Dim ChgFlg11Tmp As Boolean = ((T40_Report_Status.GetLatchedValue()))
      ChgFlg11 = EvalTrigger(ChgFlg11Tmp, ChgFlgLast11)
      Dim ChgFlg9Tmp As Boolean = ((cOp4_All_Right))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg18Tmp As Boolean = ((cOp2_All_Left))
      ChgFlg18 = EvalTrigger(ChgFlg18Tmp, ChgFlgLast18)
      Dim ChgFlg12Tmp As Boolean = ((cOp13_Not_Initialised))
      ChgFlg12 = EvalTrigger(ChgFlg12Tmp, ChgFlgLast12)
      Dim ChgFlg19Tmp As Boolean = ((cOp3_No_End_Position))
      ChgFlg19 = EvalTrigger(ChgFlg19Tmp, ChgFlgLast19)
      Dim ChgFlg7Tmp As Boolean = ((cOp13_Not_Initialised))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg23Tmp As Boolean = ((cOp11_Redrive_Left))
      ChgFlg23 = EvalTrigger(ChgFlg23Tmp, ChgFlgLast23)
      Dim ChgFlg26Tmp As Boolean = ((cOp2_All_Left))
      ChgFlg26 = EvalTrigger(ChgFlg26Tmp, ChgFlgLast26)
      Dim ChgFlg28Tmp As Boolean = ((cOp4_All_Right))
      ChgFlg28 = EvalTrigger(ChgFlg28Tmp, ChgFlgLast28)
      Dim ChgFlg3Tmp As Boolean = ((cOp3_No_End_Position))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg29Tmp As Boolean = ((T1_Move.GetLatchedValue()))
      ChgFlg29 = EvalTrigger(ChgFlg29Tmp, ChgFlgLast29)
      Dim ChgFlg22Tmp As Boolean = ((cOp10_Redrive_Right))
      ChgFlg22 = EvalTrigger(ChgFlg22Tmp, ChgFlgLast22)
      Dim ChgFlg6Tmp As Boolean = ((T40_Report_Status.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg21Tmp As Boolean = ((D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING"))
      ChgFlg21 = EvalTrigger(ChgFlg21Tmp, ChgFlgLast21)
      Dim ChgFlg15Tmp As Boolean = ((cOp5_Trailed))
      ChgFlg15 = EvalTrigger(ChgFlg15Tmp, ChgFlgLast15)
      Dim ChgFlg4Tmp As Boolean = ((cOp4_All_Right))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg17Tmp As Boolean = ((cOp13_Not_Initialised))
      ChgFlg17 = EvalTrigger(ChgFlg17Tmp, ChgFlgLast17)
      Dim ChgFlg16Tmp As Boolean = ((T40_Report_Status.GetLatchedValue()))
      ChgFlg16 = EvalTrigger(ChgFlg16Tmp, ChgFlgLast16)
      Dim ChgFlg5Tmp As Boolean = ((cOp5_Trailed))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg10Tmp As Boolean = ((cOp5_Trailed))
      ChgFlg10 = EvalTrigger(ChgFlg10Tmp, ChgFlgLast10)
      Dim ChgFlg8Tmp As Boolean = ((cOp2_All_Left))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg2Tmp As Boolean = ((cOp13_Not_Initialised))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      Dim ChgFlg13Tmp As Boolean = ((cOp2_All_Left))
      ChgFlg13 = EvalTrigger(ChgFlg13Tmp, ChgFlgLast13)
      Dim ChgFlg1Tmp As Boolean = ((T40_Report_Status.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg14Tmp As Boolean = ((cOp3_No_End_Position))
      ChgFlg14 = EvalTrigger(ChgFlg14Tmp, ChgFlgLast14)
      Dim ChgFlg27Tmp As Boolean = ((T1_Move.GetLatchedValue()))
      ChgFlg27 = EvalTrigger(ChgFlg27Tmp, ChgFlgLast27)
      Dim ChgFlg24Tmp As Boolean = ((T1_Move.GetLatchedValue()))
      ChgFlg24 = EvalTrigger(ChgFlg24Tmp, ChgFlgLast24)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast25 = ChgFlg25Tmp
      ChgFlgLast20 = ChgFlg20Tmp
      ChgFlgLast11 = ChgFlg11Tmp
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast18 = ChgFlg18Tmp
      ChgFlgLast12 = ChgFlg12Tmp
      ChgFlgLast19 = ChgFlg19Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast23 = ChgFlg23Tmp
      ChgFlgLast26 = ChgFlg26Tmp
      ChgFlgLast28 = ChgFlg28Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast29 = ChgFlg29Tmp
      ChgFlgLast22 = ChgFlg22Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast21 = ChgFlg21Tmp
      ChgFlgLast15 = ChgFlg15Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast17 = ChgFlg17Tmp
      ChgFlgLast16 = ChgFlg16Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast10 = ChgFlg10Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      ChgFlgLast13 = ChgFlg13Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast14 = ChgFlg14Tmp
      ChgFlgLast27 = ChgFlg27Tmp
      ChgFlgLast24 = ChgFlg24Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg25 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim MaskedChgFlg20 As Boolean = ((cOp4_All_Right))
        Dim MaskedChgFlg11 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim MaskedChgFlg9 As Boolean = ((cOp4_All_Right))
        Dim MaskedChgFlg18 As Boolean = ((cOp2_All_Left))
        Dim MaskedChgFlg12 As Boolean = ((cOp13_Not_Initialised))
        Dim MaskedChgFlg19 As Boolean = ((cOp3_No_End_Position))
        Dim MaskedChgFlg7 As Boolean = ((cOp13_Not_Initialised))
        Dim MaskedChgFlg23 As Boolean = ((cOp11_Redrive_Left))
        Dim MaskedChgFlg26 As Boolean = ((cOp2_All_Left))
        Dim MaskedChgFlg28 As Boolean = ((cOp4_All_Right))
        Dim MaskedChgFlg3 As Boolean = ((cOp3_No_End_Position))
        Dim MaskedChgFlg29 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim MaskedChgFlg22 As Boolean = ((cOp10_Redrive_Right))
        Dim MaskedChgFlg6 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim MaskedChgFlg21 As Boolean = ((D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING"))
        Dim MaskedChgFlg15 As Boolean = ((cOp5_Trailed))
        Dim MaskedChgFlg4 As Boolean = ((cOp4_All_Right))
        Dim MaskedChgFlg17 As Boolean = ((cOp13_Not_Initialised))
        Dim MaskedChgFlg16 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim MaskedChgFlg5 As Boolean = ((cOp5_Trailed))
        Dim MaskedChgFlg10 As Boolean = ((cOp5_Trailed))
        Dim MaskedChgFlg8 As Boolean = ((cOp2_All_Left))
        Dim MaskedChgFlg2 As Boolean = ((cOp13_Not_Initialised))
        Dim MaskedChgFlg13 As Boolean = ((cOp2_All_Left))
        Dim MaskedChgFlg1 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim MaskedChgFlg14 As Boolean = ((cOp3_No_End_Position))
        Dim MaskedChgFlg27 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim MaskedChgFlg24 As Boolean = ((T1_Move.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg25 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim UnMaskedChgFlg20 As Boolean = ((cOp4_All_Right))
        Dim UnMaskedChgFlg11 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim UnMaskedChgFlg9 As Boolean = ((cOp4_All_Right))
        Dim UnMaskedChgFlg18 As Boolean = ((cOp2_All_Left))
        Dim UnMaskedChgFlg12 As Boolean = ((cOp13_Not_Initialised))
        Dim UnMaskedChgFlg19 As Boolean = ((cOp3_No_End_Position))
        Dim UnMaskedChgFlg7 As Boolean = ((cOp13_Not_Initialised))
        Dim UnMaskedChgFlg23 As Boolean = ((cOp11_Redrive_Left))
        Dim UnMaskedChgFlg26 As Boolean = ((cOp2_All_Left))
        Dim UnMaskedChgFlg28 As Boolean = ((cOp4_All_Right))
        Dim UnMaskedChgFlg3 As Boolean = ((cOp3_No_End_Position))
        Dim UnMaskedChgFlg29 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim UnMaskedChgFlg22 As Boolean = ((cOp10_Redrive_Right))
        Dim UnMaskedChgFlg6 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim UnMaskedChgFlg21 As Boolean = ((D20_F_EST_EfeS_Gen_SR_State.GetLatchedValue() = "INITIALISING"))
        Dim UnMaskedChgFlg15 As Boolean = ((cOp5_Trailed))
        Dim UnMaskedChgFlg4 As Boolean = ((cOp4_All_Right))
        Dim UnMaskedChgFlg17 As Boolean = ((cOp13_Not_Initialised))
        Dim UnMaskedChgFlg16 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim UnMaskedChgFlg5 As Boolean = ((cOp5_Trailed))
        Dim UnMaskedChgFlg10 As Boolean = ((cOp5_Trailed))
        Dim UnMaskedChgFlg8 As Boolean = ((cOp2_All_Left))
        Dim UnMaskedChgFlg2 As Boolean = ((cOp13_Not_Initialised))
        Dim UnMaskedChgFlg13 As Boolean = ((cOp2_All_Left))
        Dim UnMaskedChgFlg1 As Boolean = ((T40_Report_Status.GetLatchedValue()))
        Dim UnMaskedChgFlg14 As Boolean = ((cOp3_No_End_Position))
        Dim UnMaskedChgFlg27 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim UnMaskedChgFlg24 As Boolean = ((T1_Move.GetLatchedValue()))
        Dim PreviousChgFlg25 As Boolean = ChgFlg25
        Dim PreviousChgFlg20 As Boolean = ChgFlg20
        Dim PreviousChgFlg11 As Boolean = ChgFlg11
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg18 As Boolean = ChgFlg18
        Dim PreviousChgFlg12 As Boolean = ChgFlg12
        Dim PreviousChgFlg19 As Boolean = ChgFlg19
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg23 As Boolean = ChgFlg23
        Dim PreviousChgFlg26 As Boolean = ChgFlg26
        Dim PreviousChgFlg28 As Boolean = ChgFlg28
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg29 As Boolean = ChgFlg29
        Dim PreviousChgFlg22 As Boolean = ChgFlg22
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg21 As Boolean = ChgFlg21
        Dim PreviousChgFlg15 As Boolean = ChgFlg15
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg17 As Boolean = ChgFlg17
        Dim PreviousChgFlg16 As Boolean = ChgFlg16
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg10 As Boolean = ChgFlg10
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        Dim PreviousChgFlg13 As Boolean = ChgFlg13
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg14 As Boolean = ChgFlg14
        Dim PreviousChgFlg27 As Boolean = ChgFlg27
        Dim PreviousChgFlg24 As Boolean = ChgFlg24
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg25 And UnMaskedChgFlg25 And Not MaskedChgFlg25 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = True
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg20 And UnMaskedChgFlg20 And Not MaskedChgFlg20 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = True
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = True
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = True
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg18 And UnMaskedChgFlg18 And Not MaskedChgFlg18 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = True
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = True
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg19 And UnMaskedChgFlg19 And Not MaskedChgFlg19 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = True
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = True
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg23 And UnMaskedChgFlg23 And Not MaskedChgFlg23 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = True
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg26 And UnMaskedChgFlg26 And Not MaskedChgFlg26 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = True
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg28 And UnMaskedChgFlg28 And Not MaskedChgFlg28 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = True
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = True
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg29 And UnMaskedChgFlg29 And Not MaskedChgFlg29 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = True
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg22 And UnMaskedChgFlg22 And Not MaskedChgFlg22 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = True
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = True
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg21 And UnMaskedChgFlg21 And Not MaskedChgFlg21 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = True
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = True
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = True
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = True
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = True
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = True
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = True
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = True
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = True
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = True
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = True
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = True
          ChgFlg27 = False
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg27 And UnMaskedChgFlg27 And Not MaskedChgFlg27 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = True
          ChgFlg24 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg24 And UnMaskedChgFlg24 And Not MaskedChgFlg24 Then
          'This is sensitive to ports - run it again
          ChgFlg25 = False
          ChgFlg20 = False
          ChgFlg11 = False
          ChgFlg9 = False
          ChgFlg18 = False
          ChgFlg12 = False
          ChgFlg19 = False
          ChgFlg7 = False
          ChgFlg23 = False
          ChgFlg26 = False
          ChgFlg28 = False
          ChgFlg3 = False
          ChgFlg29 = False
          ChgFlg22 = False
          ChgFlg6 = False
          ChgFlg21 = False
          ChgFlg15 = False
          ChgFlg4 = False
          ChgFlg17 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg2 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg14 = False
          ChgFlg27 = False
          ChgFlg24 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg25 = False
      ChgFlg20 = False
      ChgFlg11 = False
      ChgFlg9 = False
      ChgFlg18 = False
      ChgFlg12 = False
      ChgFlg19 = False
      ChgFlg7 = False
      ChgFlg23 = False
      ChgFlg26 = False
      ChgFlg28 = False
      ChgFlg3 = False
      ChgFlg29 = False
      ChgFlg22 = False
      ChgFlg6 = False
      ChgFlg21 = False
      ChgFlg15 = False
      ChgFlg4 = False
      ChgFlg17 = False
      ChgFlg16 = False
      ChgFlg5 = False
      ChgFlg10 = False
      ChgFlg8 = False
      ChgFlg2 = False
      ChgFlg13 = False
      ChgFlg1 = False
      ChgFlg14 = False
      ChgFlg27 = False
      ChgFlg24 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D13_PM2_Activation.Decrement())
      Ret = (Ret Or D20_F_EST_EfeS_Gen_SR_State.Decrement())
      Ret = (Ret Or D21_PM1_Position.Decrement())
      Ret = (Ret Or D22_PM2_Position.Decrement())
      Ret = (Ret Or D30_Con_007000.Decrement())
      Ret = (Ret Or D32_Con_007600.Decrement())
      Ret = (Ret Or D33_Con_007900.Decrement())
      Ret = (Ret Or D34_Con_008000.Decrement())
      Ret = (Ret Or D35_Con_008200.Decrement())
      Ret = (Ret Or D37_Con_008400.Decrement())
      Ret = (Ret Or D38_Con_008500.Decrement())
      Ret = (Ret Or D4_Con_tmax_Point_Operation.Decrement())
      Ret = (Ret Or DT1_Move_Target.Decrement())
      Ret = (Ret Or T1_Move.Decrement())
      Ret = (Ret Or T2_Stop_Operation.Decrement())
      Ret = (Ret Or T40_Report_Status.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D13_PM2_Activation.Mask(What)
      D20_F_EST_EfeS_Gen_SR_State.Mask(What)
      D21_PM1_Position.Mask(What)
      D22_PM2_Position.Mask(What)
      D30_Con_007000.Mask(What)
      D32_Con_007600.Mask(What)
      D33_Con_007900.Mask(What)
      D34_Con_008000.Mask(What)
      D35_Con_008200.Mask(What)
      D37_Con_008400.Mask(What)
      D38_Con_008500.Mask(What)
      D4_Con_tmax_Point_Operation.Mask(What)
      DT1_Move_Target.Mask(What)
      T1_Move.Mask(What)
      T2_Stop_Operation.Mask(What)
      T40_Report_Status.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class F_SCI_EfeS_Sec_SR : Implements SMSupport.SMQueued 
    Protected Class F_SCI_EfeS_Sec_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As F_SCI_EfeS_Sec_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsF_SCI_EfeS_Sec_SR_States
      RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION
      RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION
      RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_CLOSED
      RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED
      RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_IMPERMISSIBLE
      RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR
      RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR
      RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL
      RtsF_SCI_EfeS_Sec_SR_States_NotIn_F_SCI_EfeS_Sec_SR
    End Enum
    Public Enum RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States
      RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK
      RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION
      RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS
      RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Enum
    Public Enum RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States
      RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION
      RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION
      RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NotIn_PDI_CONNECTION_CLOSED
    End Enum
    ' \ART_SMG :: Created for state : F_SCI_EfeS_Sec_SR
    Private RtsCurrent_F_SCI_EfeS_Sec_SR As F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SR_States
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    Private RtsCurrent_ESTABLISHING_PDI_CONNECTION As F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    Private RtsCurrent_PDI_CONNECTION_CLOSED As F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast14 As Boolean
    Private ChgFlg14 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast11 As Boolean
    Private ChgFlg11 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast15 As Boolean
    Private ChgFlg15 As Boolean
    Private ChgFlgLast13 As Boolean
    Private ChgFlg13 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast16 As Boolean
    Private ChgFlg16 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private ChgFlgLast12 As Boolean
    Private ChgFlg12 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast18 As Boolean
    Private ChgFlg18 As Boolean
    Private ChgFlgLast19 As Boolean
    Private ChgFlg19 As Boolean
    Private ChgFlgLast17 As Boolean
    Private ChgFlg17 As Boolean
    Private ChgFlgLast20 As Boolean
    Private ChgFlg20 As Boolean
    Private ChgFlgLast10 As Boolean
    Private ChgFlg10 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As F_SCI_EfeS_Sec_SRSMQueue = New F_SCI_EfeS_Sec_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    ' The FlowPort T5_SCP_Connection_Established represents the event of the established SCP connection.
    Protected T5_SCP_Connection_Established As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T10_SCP_Connection_Terminated represents the event of the terminated SCP connection.
    Protected T10_SCP_Connection_Terminated As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T9_Status_Report_Completed As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T14_Msg_Start_Initialisation refines the FlowProperty Msg_Start_Initialisation.
    Protected T14_Msg_Start_Initialisation As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T15_Msg_Initialisation_Completed refines the FlowProperty Msg_Initialisation_Completed.
    Protected T15_Msg_Initialisation_Completed As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T8_Cd_Initialisation_Request refines the FlowProperty Cd_Initialisation_Request.
    Protected T8_Cd_Initialisation_Request As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T7_Cd_PDI_Version_Check refines the FlowProperty Cd_PDI_Version_Check.
    Protected T7_Cd_PDI_Version_Check As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort DT7_PDI_Version belongs to T7_Cd_PDI_Version_Check.
    Protected DT7_PDI_Version As OInputPort(Of String)
    ' The FlowPort T13_Msg_PDI_Version_Check refines the FlowProperty Msg_PDI_Version_Check.
    Protected T13_Msg_PDI_Version_Check As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort DT13_Result belongs to T13_Msg_PDI_Version_Check.
    Protected DT13_Result As OOutputPort(Of String)
    ' The FlowPort DT13_Checksum_Data belongs to T13_Msg_PDI_Version_Check.
    Protected DT13_Checksum_Data As OOutputPort(Of String)
    ' The FlowPort D3_Con_PDI_Version provides the configured PDIVer.
    Protected D3_Con_PDI_Version As OInputPort(Of String)
    ' The FlowPort D4_Con_Checksum_Data provides the configured CSS.
    Protected D4_Con_Checksum_Data As OInputPort(Of String)
    Protected T11_PDI_Connection_Established As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort D50_PDI_Connection_State provides the status of the PDI connection.
    Protected D50_PDI_Connection_State As OOutputPort(Of String)
    Protected T1_Ready_For_PDI_Connection As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T22_Content_Telegram_Error represents the event of a content telegram error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - improper value
    ' - locally improper value
    ' - improper combination of values
    Protected T22_Content_Telegram_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T20_Protocol_Error represents the event of a protocol error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - incomplete activation
    ' - improper message sequence
    ' - message at improper instant case
    Protected T20_Protocol_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T21_Formal_Telegram_Error represents the event of a formal telegram error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - deviating message type
    ' - deviating protocol type
    ' - message length
    Protected T21_Formal_Telegram_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T18_Not_Ready_For_PDI_Connection As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T12_Terminate_SCP_Connection represents the event to terminate the SCP connection.
    Protected T12_Terminate_SCP_Connection As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T17_PDI_Connection_Terminated As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T6_Start_Status_Report As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort D23_Con_Checksum_Data_Used provides configuration values whether the CSS is used and checked during initialisation.
    ' 
    ' The following values are permitted:
    ' - True: CSS is used
    ' - False: CSS is not used
    Protected D23_Con_Checksum_Data_Used As OInputPort(Of Boolean)
    ' The operation cOp1_init initialises all output ports and block properties.
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' D50_PDI_Connection_State := "";
    ' T11_PDI_Connection_Established := FALSE;
    ' T13_Msg_PDI_Version_Check := FALSE;
    ' DT13_Result := "";
    ' DT13_Checksum_Data := "";
    ' T14_Msg_Start_Initialisation := FALSE;
    ' T15_Msg_Initialisation_Completed := FALSE;
    ' T12_Terminate_SCP_Connection := FALSE;
    ' T17_PDI_Connection_Terminated := FALSE;
    Public Sub cOp1_init()
      D50_PDI_Connection_State.SetValue("")
      T11_PDI_Connection_Established.SetValue(False)
      T13_Msg_PDI_Version_Check.SetValue(False)
      DT13_Result.SetValue("")
      DT13_Checksum_Data.SetValue("")
      T14_Msg_Start_Initialisation.SetValue(False)
      T15_Msg_Initialisation_Completed.SetValue(False)
      T12_Terminate_SCP_Connection.SetValue(False)
      T17_PDI_Connection_Terminated.SetValue(False)
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' assume RtsCurrent_F_SCI_EfeS_Sec_SR: on object;
    ' assume RtsCurrent_ESTABLISHING_PDI_CONNECTION: on object;
    ' assume RtsCurrent_PDI_CONNECTION_CLOSED: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 7d9586c7-d170-4d6e-8126-65f5bc706506 READY_FOR_VERSION_CHECK */
    '   ThisState := "7d9586c7-d170-4d6e-8126-65f5bc706506";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 22654261-20ce-4c2d-8d95-7e78a4ea78f0 */ (NOT ( DT7_PDI_Version = D3_Con_PDI_Version ))/*##END 22654261-20ce-4c2d-8d95-7e78a4ea78f0 */  and /* #REF2000# *//*##STRT b1e767fe-2d4f-4cfc-a8d8-872f01e34e57 */ (NOT D23_Con_Checksum_Data_Used )/*##END b1e767fe-2d4f-4cfc-a8d8-872f01e34e57 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"631e67a7-1845-4cde-bb42-9057f6a1fdba",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c6ea305b-9f31-4e69-a11b-af14d2021f80",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"677dd95d-4f96-4db0-b49a-c1ce4f465e47",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 198d421c-6947-425d-8b75-4fb344e84620 */  nullstat;/*##END 198d421c-6947-425d-8b75-4fb344e84620 */ /* #REF1544# */
    ' 	/*##STRT deb22415-9a64-48e2-b6fa-2a0bfd09b044 */  nullstat;/*##END deb22415-9a64-48e2-b6fa-2a0bfd09b044 */ /* #REF1544# */
    ' 	/*##STRT fe1753d1-4229-4603-a60d-cb8cbb12aad2 */ 
    '  DT13_Result := "not match";
    '  DT13_Checksum_Data := "not applicable";
    '  T13_Msg_PDI_Version_Check := TRUE; nullstat;/*##END fe1753d1-4229-4603-a60d-cb8cbb12aad2 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_VERSION_UNEQUAL();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 7d9586c7-d170-4d6e-8126-65f5bc706506 READY_FOR_VERSION_CHECK */
    '   ThisState := "7d9586c7-d170-4d6e-8126-65f5bc706506";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 22654261-20ce-4c2d-8d95-7e78a4ea78f0 */ (NOT ( DT7_PDI_Version = D3_Con_PDI_Version ))/*##END 22654261-20ce-4c2d-8d95-7e78a4ea78f0 */  and /* #REF2000# *//*##STRT be9b23b1-5bd1-411f-b1bd-afe96a692d2f */ ( D23_Con_Checksum_Data_Used )/*##END be9b23b1-5bd1-411f-b1bd-afe96a692d2f */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"631e67a7-1845-4cde-bb42-9057f6a1fdba",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c6ea305b-9f31-4e69-a11b-af14d2021f80",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"d2abf82b-0437-4c2a-acf7-19fb3794a29f",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 198d421c-6947-425d-8b75-4fb344e84620 */  nullstat;/*##END 198d421c-6947-425d-8b75-4fb344e84620 */ /* #REF1544# */
    ' 	/*##STRT deb22415-9a64-48e2-b6fa-2a0bfd09b044 */  nullstat;/*##END deb22415-9a64-48e2-b6fa-2a0bfd09b044 */ /* #REF1544# */
    ' 	/*##STRT b3010b4b-85d8-4b93-ac96-5b1117a6ca78 */ 
    '  DT13_Result := "not match";
    '  DT13_Checksum_Data := D4_Con_Checksum_Data ;
    '  T13_Msg_PDI_Version_Check := TRUE; nullstat;/*##END b3010b4b-85d8-4b93-ac96-5b1117a6ca78 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_VERSION_UNEQUAL();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 7d9586c7-d170-4d6e-8126-65f5bc706506 READY_FOR_VERSION_CHECK */
    '   ThisState := "7d9586c7-d170-4d6e-8126-65f5bc706506";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 416a8be8-360a-4644-bc85-e73c4a175d80 */ ( DT7_PDI_Version = D3_Con_PDI_Version )/*##END 416a8be8-360a-4644-bc85-e73c4a175d80 */  and /* #REF2000# *//*##STRT a377d934-0d41-42af-ab23-d35d761ced05 */ ( D23_Con_Checksum_Data_Used )/*##END a377d934-0d41-42af-ab23-d35d761ced05 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_READY_FOR_VERSION_CHECK */
    ' 		/* standard */
    ' 		This.RtsExit_READY_FOR_VERSION_CHECK();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"631e67a7-1845-4cde-bb42-9057f6a1fdba",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ef866f65-4adb-4344-af03-6a0b67773c0d",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"16bac714-7b83-49f9-a7b3-f2a11bf60574",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 198d421c-6947-425d-8b75-4fb344e84620 */  nullstat;/*##END 198d421c-6947-425d-8b75-4fb344e84620 */ /* #REF1544# */
    ' 	/*##STRT 69a4d08b-9756-450c-a794-1959c97ee631 */  nullstat;/*##END 69a4d08b-9756-450c-a794-1959c97ee631 */ /* #REF1544# */
    ' 	/*##STRT a0482703-1f59-4588-84f3-77d741036231 */ 
    '  DT13_Result := "match";
    '  DT13_Checksum_Data := D4_Con_Checksum_Data ;
    '  T13_Msg_PDI_Version_Check := TRUE; nullstat;/*##END a0482703-1f59-4588-84f3-77d741036231 */ /* #REF1546# */
    ' 		This.RtsEnter_READY_FOR_INITIALISATION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 7d9586c7-d170-4d6e-8126-65f5bc706506 READY_FOR_VERSION_CHECK */
    '   ThisState := "7d9586c7-d170-4d6e-8126-65f5bc706506";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 416a8be8-360a-4644-bc85-e73c4a175d80 */ ( DT7_PDI_Version = D3_Con_PDI_Version )/*##END 416a8be8-360a-4644-bc85-e73c4a175d80 */  and /* #REF2000# *//*##STRT 17fffcca-db63-47f5-a94e-b281ec5e2f20 */ (NOT D23_Con_Checksum_Data_Used )/*##END 17fffcca-db63-47f5-a94e-b281ec5e2f20 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_READY_FOR_VERSION_CHECK */
    ' 		/* standard */
    ' 		This.RtsExit_READY_FOR_VERSION_CHECK();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"631e67a7-1845-4cde-bb42-9057f6a1fdba",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ef866f65-4adb-4344-af03-6a0b67773c0d",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"dedc6025-2db2-4c92-bf31-44010f27f2e9",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 198d421c-6947-425d-8b75-4fb344e84620 */  nullstat;/*##END 198d421c-6947-425d-8b75-4fb344e84620 */ /* #REF1544# */
    ' 	/*##STRT 69a4d08b-9756-450c-a794-1959c97ee631 */  nullstat;/*##END 69a4d08b-9756-450c-a794-1959c97ee631 */ /* #REF1544# */
    ' 	/*##STRT d74cd0d6-45f1-4ca9-84b7-b3f68c676547 */ 
    '  DT13_Result := "match";
    '  DT13_Checksum_Data := "not applicable";
    '  T13_Msg_PDI_Version_Check := TRUE; nullstat;/*##END d74cd0d6-45f1-4ca9-84b7-b3f68c676547 */ /* #REF1546# */
    ' 		This.RtsEnter_READY_FOR_INITIALISATION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION then
    ' /* #REF123# */
    ' 	/* 06869a26-5c83-4188-9e40-7a9bfc6b1837 READY_FOR_INITIALISATION */
    '   ThisState := "06869a26-5c83-4188-9e40-7a9bfc6b1837";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_READY_FOR_INITIALISATION */
    ' 		/* standard */
    ' 		This.RtsExit_READY_FOR_INITIALISATION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a3ae2a9e-0507-40aa-90f2-0e8034fdeee7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2889babb-26a4-421f-9f35-aaaa5b2bb49d */ 
    '  T14_Msg_Start_Initialisation := TRUE; nullstat;/*##END 2889babb-26a4-421f-9f35-aaaa5b2bb49d */ /* #REF1546# */
    ' 		This.RtsEnter_SENDING_STATUS();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS then
    ' /* #REF123# */
    ' 	/* 201ad4bd-4e5f-4ede-8224-164d12195079 SENDING_STATUS */
    '   ThisState := "201ad4bd-4e5f-4ede-8224-164d12195079";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"0b79334c-e72d-49d0-b8a8-5731c6d0ffc7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 7df60ae6-724f-4654-b3ce-19516c18f92c */ 
    '  T15_Msg_Initialisation_Completed := TRUE; nullstat;/*##END 7df60ae6-724f-4654-b3ce-19516c18f92c */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION then
    ' /* #REF123# */
    ' 	/* 42606dab-58fb-43b2-8c6d-5940edcc3dda NOT_READY_FOR_CONNECTION */
    '   ThisState := "42606dab-58fb-43b2-8c6d-5940edcc3dda";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_NOT_READY_FOR_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_NOT_READY_FOR_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"77152be5-e06b-495d-a047-0d77da00b0c4",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT da3c7b0b-4e76-48b8-98a2-7a027ae10b9b */  nullstat;/*##END da3c7b0b-4e76-48b8-98a2-7a027ae10b9b */ /* #REF1546# */
    ' 		This.RtsEnter_READY_FOR_CONNECTION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION then
    ' /* #REF123# */
    ' 	/* 5020d939-d5ce-463d-bede-1b9945f73ed2 READY_FOR_CONNECTION */
    '   ThisState := "5020d939-d5ce-463d-bede-1b9945f73ed2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_READY_FOR_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_READY_FOR_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"edbdb987-42e8-419e-a315-d3a55944648c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 185a8bd7-517e-4440-a625-08af25472462 */  nullstat;/*##END 185a8bd7-517e-4440-a625-08af25472462 */ /* #REF1546# */
    ' 		This.RtsEnter_NOT_READY_FOR_CONNECTION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION then
    ' /* #REF123# */
    ' 	/* 5020d939-d5ce-463d-bede-1b9945f73ed2 READY_FOR_CONNECTION */
    '   ThisState := "5020d939-d5ce-463d-bede-1b9945f73ed2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_CLOSED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_CLOSED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"df8c1440-81b0-43f2-a3df-7c661ac00a32",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 911a6726-c4ef-430c-a5c2-a6b8622c3d11 */  nullstat;/*##END 911a6726-c4ef-430c-a5c2-a6b8622c3d11 */ /* #REF1546# */
    ' 		This.RtsDefault_ESTABLISHING_PDI_CONNECTION();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 05bf2abc-032a-4bdf-8d77-bcb757c8f793 CLOSING_PDI_CONNECTION */
    '   ThisState := "05bf2abc-032a-4bdf-8d77-bcb757c8f793";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_CLOSING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_CLOSING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b35ffe93-4fe4-47d1-b333-71c74de2f8c9",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5d9b0df1-3058-43f3-963a-721fddadfc67 */ 
    '  T17_PDI_Connection_Terminated := TRUE; nullstat;/*##END 5d9b0df1-3058-43f3-963a-721fddadfc67 */ /* #REF1546# */
    ' 		This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 934edf42-0231-4aa8-8619-acc8e372638d ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "934edf42-0231-4aa8-8619-acc8e372638d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"2af924d7-87e7-46b5-a106-20b4c2321e90",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8a79836f-64b8-4867-832e-b596c16594fe */  nullstat;/*##END 8a79836f-64b8-4867-832e-b596c16594fe */ /* #REF1546# */
    ' 		This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 934edf42-0231-4aa8-8619-acc8e372638d ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "934edf42-0231-4aa8-8619-acc8e372638d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8e9ef0c7-d5b6-4dbf-8e01-5d35254f04eb",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT fd5d7acf-6da8-4634-a97e-e576c9380b60 */  nullstat;/*##END fd5d7acf-6da8-4634-a97e-e576c9380b60 */ /* #REF1546# */
    ' 		This.RtsEnter_CLOSING_PDI_CONNECTION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 934edf42-0231-4aa8-8619-acc8e372638d ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "934edf42-0231-4aa8-8619-acc8e372638d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a19069bc-a83a-4b6a-8182-9c45e42e169f",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 15fe5615-344e-4dce-b83c-a8f6477d81fa */  nullstat;/*##END 15fe5615-344e-4dce-b83c-a8f6477d81fa */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_PROTOCOL_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 934edf42-0231-4aa8-8619-acc8e372638d ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "934edf42-0231-4aa8-8619-acc8e372638d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"625f267b-e1d5-4baf-bd34-bd7cd77ecbe3",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 95fdd021-9dba-46f0-9d37-ebcea21f5868 */  nullstat;/*##END 95fdd021-9dba-46f0-9d37-ebcea21f5868 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 934edf42-0231-4aa8-8619-acc8e372638d ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "934edf42-0231-4aa8-8619-acc8e372638d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"990ea904-c48b-4217-89d9-0f2111b007ce",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 81ea87fe-f76b-4d79-9d17-5dbc188ddf2e */  nullstat;/*##END 81ea87fe-f76b-4d79-9d17-5dbc188ddf2e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR =  /* #REF121d# */ RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_NotIn_F_SCI_EfeS_Sec_SR then
    ' /* #REF123# */
    ' 	/* 34a063bd-6cc8-4705-b822-38a697b5a9ca Initial0 */
    '   ThisState := "34a063bd-6cc8-4705-b822-38a697b5a9ca";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"34a063bd-6cc8-4705-b822-38a697b5a9ca",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"34a063bd-6cc8-4705-b822-38a697b5a9ca",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"aaf24e4f-6a3d-4ca0-a436-25eb213ab353",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT ae85d6cc-abea-4ab5-a3b2-b22206a5bd0f */  cOp1_init (); nullstat;/*##END ae85d6cc-abea-4ab5-a3b2-b22206a5bd0f */ /* #REF1546# */
    ' 	This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 31dca9ac-8214-4192-aae9-ca4acdd441ba PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "31dca9ac-8214-4192-aae9-ca4acdd441ba";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"2aef6a1a-c829-407d-865d-2c96af5668f2",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 45524c96-9989-41b9-bb8a-30729516e69b */ 
    '  T17_PDI_Connection_Terminated := TRUE; nullstat;/*##END 45524c96-9989-41b9-bb8a-30729516e69b */ /* #REF1546# */
    ' 		This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 31dca9ac-8214-4192-aae9-ca4acdd441ba PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "31dca9ac-8214-4192-aae9-ca4acdd441ba";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"3c4e4a00-1000-4ee8-9a72-c929dea8ae21",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 15779e9a-9b46-4582-bd1c-462145548008 */  nullstat;/*##END 15779e9a-9b46-4582-bd1c-462145548008 */ /* #REF1546# */
    ' 		This.RtsEnter_CLOSING_PDI_CONNECTION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 31dca9ac-8214-4192-aae9-ca4acdd441ba PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "31dca9ac-8214-4192-aae9-ca4acdd441ba";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ee9b4289-1fb3-49b9-b2b7-52bd8c2103e1",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 3f87fc5c-3cdf-432b-89c1-1a8798eb33d3 */  nullstat;/*##END 3f87fc5c-3cdf-432b-89c1-1a8798eb33d3 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_PROTOCOL_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 31dca9ac-8214-4192-aae9-ca4acdd441ba PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "31dca9ac-8214-4192-aae9-ca4acdd441ba";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"0bed3d47-80a9-451a-9b7d-9f6fab0ff9bb",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8595b220-ba15-4f29-978b-bd6dd56eb66a */  nullstat;/*##END 8595b220-ba15-4f29-978b-bd6dd56eb66a */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 31dca9ac-8214-4192-aae9-ca4acdd441ba PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "31dca9ac-8214-4192-aae9-ca4acdd441ba";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e9745b96-12e0-447c-bfe2-5aa8d1f39003",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT cd260f88-c44a-4e87-b9cf-879ddd399f2e */  nullstat;/*##END cd260f88-c44a-4e87-b9cf-879ddd399f2e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR then
    ' /* #REF123# */
    ' 	/* 52ceb8f1-b423-4d60-bff4-998f3a425d8b PDI_PROTOCOL_ERROR */
    '   ThisState := "52ceb8f1-b423-4d60-bff4-998f3a425d8b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg18, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_PROTOCOL_ERROR */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_PROTOCOL_ERROR();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ee933180-5510-45c2-98f0-b7784135d4ff",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT bed5d463-ca32-4939-a72d-533fdb207727 */ 
    '  T17_PDI_Connection_Terminated := TRUE; nullstat;/*##END bed5d463-ca32-4939-a72d-533fdb207727 */ /* #REF1546# */
    ' 		This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR then
    ' /* #REF123# */
    ' 	/* fa6c9fbd-aa63-4cff-9c92-d03647effe4c PDI_TELEGRAM_ERROR */
    '   ThisState := "fa6c9fbd-aa63-4cff-9c92-d03647effe4c";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg19, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_TELEGRAM_ERROR */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_TELEGRAM_ERROR();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"651f7fe3-fab7-4515-95ea-f01a05746650",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c0641914-b205-4951-91de-c11fdb0bdec3 */  nullstat;/*##END c0641914-b205-4951-91de-c11fdb0bdec3 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_IMPERMISSIBLE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL then
    ' /* #REF123# */
    ' 	/* 09581792-b5ef-4212-a501-ba79efd84fb2 PDI_VERSION_UNEQUAL */
    '   ThisState := "09581792-b5ef-4212-a501-ba79efd84fb2";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg20, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_VERSION_UNEQUAL */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_VERSION_UNEQUAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"2dffe91d-4e40-4645-8d8b-bce441fd6193",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ceea435d-eebe-4ba5-a3e5-e9cd1517b2c5 */ 
    '  T17_PDI_Connection_Terminated := TRUE; nullstat;/*##END ceea435d-eebe-4ba5-a3e5-e9cd1517b2c5 */ /* #REF1546# */
    ' 		This.RtsDefault_PDI_CONNECTION_CLOSED();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK Then
        ThisState = "7d9586c7-d170-4d6e-8126-65f5bc706506"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) And (NOT (DT7_PDI_Version.GetLatchedValue() = D3_Con_PDI_Version.GetLatchedValue())) And (NOT D23_Con_Checksum_Data_Used.GetLatchedValue()) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "631e67a7-1845-4cde-bb42-9057f6a1fdba", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c6ea305b-9f31-4e69-a11b-af14d2021f80", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "677dd95d-4f96-4db0-b49a-c1ce4f465e47", 0, NullString)
          DT13_Result.SetValue("not match")
          DT13_Checksum_Data.SetValue("not applicable")
          T13_Msg_PDI_Version_Check.SetValue(True)
          Me.RtsEnter_PDI_VERSION_UNEQUAL()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK Then
        ThisState = "7d9586c7-d170-4d6e-8126-65f5bc706506"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) And (NOT (DT7_PDI_Version.GetLatchedValue() = D3_Con_PDI_Version.GetLatchedValue())) And (D23_Con_Checksum_Data_Used.GetLatchedValue()) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "631e67a7-1845-4cde-bb42-9057f6a1fdba", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c6ea305b-9f31-4e69-a11b-af14d2021f80", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "d2abf82b-0437-4c2a-acf7-19fb3794a29f", 0, NullString)
          DT13_Result.SetValue("not match")
          DT13_Checksum_Data.SetValue(D4_Con_Checksum_Data.GetLatchedValue())
          T13_Msg_PDI_Version_Check.SetValue(True)
          Me.RtsEnter_PDI_VERSION_UNEQUAL()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK Then
        ThisState = "7d9586c7-d170-4d6e-8126-65f5bc706506"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) And (DT7_PDI_Version.GetLatchedValue() = D3_Con_PDI_Version.GetLatchedValue()) And (D23_Con_Checksum_Data_Used.GetLatchedValue()) Then
          Me.RtsExit_READY_FOR_VERSION_CHECK()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "631e67a7-1845-4cde-bb42-9057f6a1fdba", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ef866f65-4adb-4344-af03-6a0b67773c0d", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "16bac714-7b83-49f9-a7b3-f2a11bf60574", 0, NullString)
          DT13_Result.SetValue("match")
          DT13_Checksum_Data.SetValue(D4_Con_Checksum_Data.GetLatchedValue())
          T13_Msg_PDI_Version_Check.SetValue(True)
          Me.RtsEnter_READY_FOR_INITIALISATION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK Then
        ThisState = "7d9586c7-d170-4d6e-8126-65f5bc706506"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) And (DT7_PDI_Version.GetLatchedValue() = D3_Con_PDI_Version.GetLatchedValue()) And (NOT D23_Con_Checksum_Data_Used.GetLatchedValue()) Then
          Me.RtsExit_READY_FOR_VERSION_CHECK()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "631e67a7-1845-4cde-bb42-9057f6a1fdba", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ef866f65-4adb-4344-af03-6a0b67773c0d", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "dedc6025-2db2-4c92-bf31-44010f27f2e9", 0, NullString)
          DT13_Result.SetValue("match")
          DT13_Checksum_Data.SetValue("not applicable")
          T13_Msg_PDI_Version_Check.SetValue(True)
          Me.RtsEnter_READY_FOR_INITIALISATION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION Then
        ThisState = "06869a26-5c83-4188-9e40-7a9bfc6b1837"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          Me.RtsExit_READY_FOR_INITIALISATION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a3ae2a9e-0507-40aa-90f2-0e8034fdeee7", 0, NullString)
          T14_Msg_Start_Initialisation.SetValue(True)
          Me.RtsEnter_SENDING_STATUS()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS Then
        ThisState = "201ad4bd-4e5f-4ede-8224-164d12195079"
        If SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "0b79334c-e72d-49d0-b8a8-5731c6d0ffc7", 0, NullString)
          T15_Msg_Initialisation_Completed.SetValue(True)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION Then
        ThisState = "42606dab-58fb-43b2-8c6d-5940edcc3dda"
        If SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) Then
          Me.RtsExit_NOT_READY_FOR_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "77152be5-e06b-495d-a047-0d77da00b0c4", 0, NullString)
          Me.RtsEnter_READY_FOR_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION Then
        ThisState = "5020d939-d5ce-463d-bede-1b9945f73ed2"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) Then
          Me.RtsExit_READY_FOR_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "edbdb987-42e8-419e-a315-d3a55944648c", 0, NullString)
          Me.RtsEnter_NOT_READY_FOR_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION Then
        ThisState = "5020d939-d5ce-463d-bede-1b9945f73ed2"
        If SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_CLOSED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "df8c1440-81b0-43f2-a3df-7c661ac00a32", 0, NullString)
          Me.RtsDefault_ESTABLISHING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION Then
        ThisState = "05bf2abc-032a-4bdf-8d77-bcb757c8f793"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          Me.RtsExit_CLOSING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b35ffe93-4fe4-47d1-b333-71c74de2f8c9", 0, NullString)
          T17_PDI_Connection_Terminated.SetValue(True)
          Me.RtsDefault_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "934edf42-0231-4aa8-8619-acc8e372638d"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "2af924d7-87e7-46b5-a106-20b4c2321e90", 0, NullString)
          Me.RtsDefault_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "934edf42-0231-4aa8-8619-acc8e372638d"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8e9ef0c7-d5b6-4dbf-8e01-5d35254f04eb", 0, NullString)
          Me.RtsEnter_CLOSING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "934edf42-0231-4aa8-8619-acc8e372638d"
        If SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a19069bc-a83a-4b6a-8182-9c45e42e169f", 0, NullString)
          Me.RtsEnter_PDI_PROTOCOL_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "934edf42-0231-4aa8-8619-acc8e372638d"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "625f267b-e1d5-4baf-bd34-bd7cd77ecbe3", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "934edf42-0231-4aa8-8619-acc8e372638d"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "990ea904-c48b-4217-89d9-0f2111b007ce", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_NotIn_F_SCI_EfeS_Sec_SR Then
        ThisState = "34a063bd-6cc8-4705-b822-38a697b5a9ca"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "34a063bd-6cc8-4705-b822-38a697b5a9ca", 0, NullString)
        RtsNotify(Me, SEXIT, "34a063bd-6cc8-4705-b822-38a697b5a9ca", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "aaf24e4f-6a3d-4ca0-a436-25eb213ab353", 0, NullString)
        cOp1_init()
        Me.RtsDefault_PDI_CONNECTION_CLOSED()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "31dca9ac-8214-4192-aae9-ca4acdd441ba"
        If SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "2aef6a1a-c829-407d-865d-2c96af5668f2", 0, NullString)
          T17_PDI_Connection_Terminated.SetValue(True)
          Me.RtsDefault_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "31dca9ac-8214-4192-aae9-ca4acdd441ba"
        If SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "3c4e4a00-1000-4ee8-9a72-c929dea8ae21", 0, NullString)
          Me.RtsEnter_CLOSING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "31dca9ac-8214-4192-aae9-ca4acdd441ba"
        If SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ee9b4289-1fb3-49b9-b2b7-52bd8c2103e1", 0, NullString)
          Me.RtsEnter_PDI_PROTOCOL_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "31dca9ac-8214-4192-aae9-ca4acdd441ba"
        If SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "0bed3d47-80a9-451a-9b7d-9f6fab0ff9bb", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "31dca9ac-8214-4192-aae9-ca4acdd441ba"
        If SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e9745b96-12e0-447c-bfe2-5aa8d1f39003", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR Then
        ThisState = "52ceb8f1-b423-4d60-bff4-998f3a425d8b"
        If SenseTrigger(ChgFlg18, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_PROTOCOL_ERROR()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ee933180-5510-45c2-98f0-b7784135d4ff", 0, NullString)
          T17_PDI_Connection_Terminated.SetValue(True)
          Me.RtsDefault_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR Then
        ThisState = "fa6c9fbd-aa63-4cff-9c92-d03647effe4c"
        If SenseTrigger(ChgFlg19, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_TELEGRAM_ERROR()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "651f7fe3-fab7-4515-95ea-f01a05746650", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_IMPERMISSIBLE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL Then
        ThisState = "09581792-b5ef-4212-a501-ba79efd84fb2"
        If SenseTrigger(ChgFlg20, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_VERSION_UNEQUAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "2dffe91d-4e40-4645-8d8b-bce441fd6193", 0, NullString)
          T17_PDI_Connection_Terminated.SetValue(True)
          Me.RtsDefault_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "f08f6060-1bb8-4cc2-86f2-92124ca69497", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_NotIn_F_SCI_EfeS_Sec_SR;/* #REF1566# */
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF1566# */
    ' This.RtsCurrent_PDI_CONNECTION_CLOSED := RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NotIn_PDI_CONNECTION_CLOSED;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "f08f6060-1bb8-4cc2-86f2-92124ca69497", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_NotIn_F_SCI_EfeS_Sec_SR
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
      Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NotIn_PDI_CONNECTION_CLOSED
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : CLOSING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("05bf2abc-032a-4bdf-8d77-bcb757c8f793|") then
    '   OperatedStates := OperatedStates + "05bf2abc-032a-4bdf-8d77-bcb757c8f793|";
    ' end if
    ' // Simulation support : Notification function call for entering state : CLOSING_PDI_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"05bf2abc-032a-4bdf-8d77-bcb757c8f793",0,NullString);
    ' 
    ' SimCore.EnterState("05bf2abc-032a-4bdf-8d77-bcb757c8f793","CLOSING_PDI_CONNECTION");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT c32ca684-ec21-402e-b1b6-22d8168ec30f */  D50_PDI_Connection_State := "CLOSING";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END c32ca684-ec21-402e-b1b6-22d8168ec30f */ 
    Private Sub RtsEnter_CLOSING_PDI_CONNECTION()
      If not OperatedStates.Contains("05bf2abc-032a-4bdf-8d77-bcb757c8f793|") Then
        OperatedStates = OperatedStates + "05bf2abc-032a-4bdf-8d77-bcb757c8f793|"
      End If
      'Simulation support : Notification function call for entering state : CLOSING_PDI_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "05bf2abc-032a-4bdf-8d77-bcb757c8f793", 0, NullString)
      SimCore.EnterState("05bf2abc-032a-4bdf-8d77-bcb757c8f793", "CLOSING_PDI_CONNECTION")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION
      'Entry Actions
      D50_PDI_Connection_State.SetValue("CLOSING")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("934edf42-0231-4aa8-8619-acc8e372638d|") then
    '   OperatedStates := OperatedStates + "934edf42-0231-4aa8-8619-acc8e372638d|";
    ' end if
    ' // Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"934edf42-0231-4aa8-8619-acc8e372638d",0,NullString);
    ' 
    ' SimCore.EnterState("934edf42-0231-4aa8-8619-acc8e372638d","ESTABLISHING_PDI_CONNECTION");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION;/* #REF521# */
    ' 
    Private Sub RtsEnter_ESTABLISHING_PDI_CONNECTION()
      If not OperatedStates.Contains("934edf42-0231-4aa8-8619-acc8e372638d|") Then
        OperatedStates = OperatedStates + "934edf42-0231-4aa8-8619-acc8e372638d|"
      End If
      'Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "934edf42-0231-4aa8-8619-acc8e372638d", 0, NullString)
      SimCore.EnterState("934edf42-0231-4aa8-8619-acc8e372638d", "ESTABLISHING_PDI_CONNECTION")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|") then
    '   OperatedStates := OperatedStates + "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_CLOSED ///* #REF520# */
    ' RtsNotify(This,SENTER,"ca23fc2f-d60f-4fee-a0eb-b3cec623fc63",0,NullString);
    ' 
    ' SimCore.EnterState("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63","PDI_CONNECTION_CLOSED");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_CLOSED;/* #REF521# */
    ' 
    Private Sub RtsEnter_PDI_CONNECTION_CLOSED()
      If not OperatedStates.Contains("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|") Then
        OperatedStates = OperatedStates + "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_CLOSED ///* #REF520# */
      RtsNotify(Me, SENTER, "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63", 0, NullString)
      SimCore.EnterState("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63", "PDI_CONNECTION_CLOSED")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_CLOSED
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("31dca9ac-8214-4192-aae9-ca4acdd441ba|") then
    '   OperatedStates := OperatedStates + "31dca9ac-8214-4192-aae9-ca4acdd441ba|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
    ' RtsNotify(This,SENTER,"31dca9ac-8214-4192-aae9-ca4acdd441ba",0,NullString);
    ' 
    ' SimCore.EnterState("31dca9ac-8214-4192-aae9-ca4acdd441ba","PDI_CONNECTION_ESTABLISHED");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 643b7598-ff16-4f52-abd6-070a8de9af69 */  D50_PDI_Connection_State := "ESTABLISHED";
    '  T11_PDI_Connection_Established := TRUE; nullstat;/*##END 643b7598-ff16-4f52-abd6-070a8de9af69 */ 
    Private Sub RtsEnter_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("31dca9ac-8214-4192-aae9-ca4acdd441ba|") Then
        OperatedStates = OperatedStates + "31dca9ac-8214-4192-aae9-ca4acdd441ba|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
      RtsNotify(Me, SENTER, "31dca9ac-8214-4192-aae9-ca4acdd441ba", 0, NullString)
      SimCore.EnterState("31dca9ac-8214-4192-aae9-ca4acdd441ba", "PDI_CONNECTION_ESTABLISHED")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED
      'Entry Actions
      D50_PDI_Connection_State.SetValue("ESTABLISHED")
      T11_PDI_Connection_Established.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("d0ac6499-0795-4a81-aac7-695f2bd8671e|") then
    '   OperatedStates := OperatedStates + "d0ac6499-0795-4a81-aac7-695f2bd8671e|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_IMPERMISSIBLE ///* #REF520# */
    ' RtsNotify(This,SENTER,"d0ac6499-0795-4a81-aac7-695f2bd8671e",0,NullString);
    ' 
    ' SimCore.EnterState("d0ac6499-0795-4a81-aac7-695f2bd8671e","PDI_CONNECTION_IMPERMISSIBLE");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_IMPERMISSIBLE;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT dde6ffb0-3124-425e-880b-6760df2e1b35 */  D50_PDI_Connection_State := "IMPERMISSIBLE"; nullstat;/*##END dde6ffb0-3124-425e-880b-6760df2e1b35 */ 
    Private Sub RtsEnter_PDI_CONNECTION_IMPERMISSIBLE()
      If not OperatedStates.Contains("d0ac6499-0795-4a81-aac7-695f2bd8671e|") Then
        OperatedStates = OperatedStates + "d0ac6499-0795-4a81-aac7-695f2bd8671e|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_IMPERMISSIBLE ///* #REF520# */
      RtsNotify(Me, SENTER, "d0ac6499-0795-4a81-aac7-695f2bd8671e", 0, NullString)
      SimCore.EnterState("d0ac6499-0795-4a81-aac7-695f2bd8671e", "PDI_CONNECTION_IMPERMISSIBLE")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_IMPERMISSIBLE
      'Entry Actions
      D50_PDI_Connection_State.SetValue("IMPERMISSIBLE")
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("52ceb8f1-b423-4d60-bff4-998f3a425d8b|") then
    '   OperatedStates := OperatedStates + "52ceb8f1-b423-4d60-bff4-998f3a425d8b|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_PROTOCOL_ERROR ///* #REF520# */
    ' RtsNotify(This,SENTER,"52ceb8f1-b423-4d60-bff4-998f3a425d8b",0,NullString);
    ' 
    ' SimCore.EnterState("52ceb8f1-b423-4d60-bff4-998f3a425d8b","PDI_PROTOCOL_ERROR");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT f5b0c8ab-7823-47ee-864a-49ae63eaf9c1 */  D50_PDI_Connection_State := "PROTOCOL_ERROR";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END f5b0c8ab-7823-47ee-864a-49ae63eaf9c1 */ 
    Private Sub RtsEnter_PDI_PROTOCOL_ERROR()
      If not OperatedStates.Contains("52ceb8f1-b423-4d60-bff4-998f3a425d8b|") Then
        OperatedStates = OperatedStates + "52ceb8f1-b423-4d60-bff4-998f3a425d8b|"
      End If
      'Simulation support : Notification function call for entering state : PDI_PROTOCOL_ERROR ///* #REF520# */
      RtsNotify(Me, SENTER, "52ceb8f1-b423-4d60-bff4-998f3a425d8b", 0, NullString)
      SimCore.EnterState("52ceb8f1-b423-4d60-bff4-998f3a425d8b", "PDI_PROTOCOL_ERROR")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR
      'Entry Actions
      D50_PDI_Connection_State.SetValue("PROTOCOL_ERROR")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("fa6c9fbd-aa63-4cff-9c92-d03647effe4c|") then
    '   OperatedStates := OperatedStates + "fa6c9fbd-aa63-4cff-9c92-d03647effe4c|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_TELEGRAM_ERROR ///* #REF520# */
    ' RtsNotify(This,SENTER,"fa6c9fbd-aa63-4cff-9c92-d03647effe4c",0,NullString);
    ' 
    ' SimCore.EnterState("fa6c9fbd-aa63-4cff-9c92-d03647effe4c","PDI_TELEGRAM_ERROR");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 15e088ac-061f-4aec-8bc0-1e3c99e5230b */  D50_PDI_Connection_State := "TELEGRAM_ERROR";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END 15e088ac-061f-4aec-8bc0-1e3c99e5230b */ 
    Private Sub RtsEnter_PDI_TELEGRAM_ERROR()
      If not OperatedStates.Contains("fa6c9fbd-aa63-4cff-9c92-d03647effe4c|") Then
        OperatedStates = OperatedStates + "fa6c9fbd-aa63-4cff-9c92-d03647effe4c|"
      End If
      'Simulation support : Notification function call for entering state : PDI_TELEGRAM_ERROR ///* #REF520# */
      RtsNotify(Me, SENTER, "fa6c9fbd-aa63-4cff-9c92-d03647effe4c", 0, NullString)
      SimCore.EnterState("fa6c9fbd-aa63-4cff-9c92-d03647effe4c", "PDI_TELEGRAM_ERROR")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR
      'Entry Actions
      D50_PDI_Connection_State.SetValue("TELEGRAM_ERROR")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("09581792-b5ef-4212-a501-ba79efd84fb2|") then
    '   OperatedStates := OperatedStates + "09581792-b5ef-4212-a501-ba79efd84fb2|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_VERSION_UNEQUAL ///* #REF520# */
    ' RtsNotify(This,SENTER,"09581792-b5ef-4212-a501-ba79efd84fb2",0,NullString);
    ' 
    ' SimCore.EnterState("09581792-b5ef-4212-a501-ba79efd84fb2","PDI_VERSION_UNEQUAL");
    ' 
    ' This.RtsCurrent_F_SCI_EfeS_Sec_SR := RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 5537e6d7-8c6e-4dd5-a4f8-a97a518a9522 */  D50_PDI_Connection_State := "VERSION_UNEQUAL";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END 5537e6d7-8c6e-4dd5-a4f8-a97a518a9522 */ 
    Private Sub RtsEnter_PDI_VERSION_UNEQUAL()
      If not OperatedStates.Contains("09581792-b5ef-4212-a501-ba79efd84fb2|") Then
        OperatedStates = OperatedStates + "09581792-b5ef-4212-a501-ba79efd84fb2|"
      End If
      'Simulation support : Notification function call for entering state : PDI_VERSION_UNEQUAL ///* #REF520# */
      RtsNotify(Me, SENTER, "09581792-b5ef-4212-a501-ba79efd84fb2", 0, NullString)
      SimCore.EnterState("09581792-b5ef-4212-a501-ba79efd84fb2", "PDI_VERSION_UNEQUAL")
      Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL
      'Entry Actions
      D50_PDI_Connection_State.SetValue("VERSION_UNEQUAL")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("7d9586c7-d170-4d6e-8126-65f5bc706506|") then
    '   OperatedStates := OperatedStates + "7d9586c7-d170-4d6e-8126-65f5bc706506|";
    ' end if
    ' // Simulation support : Notification function call for entering state : READY_FOR_VERSION_CHECK ///* #REF520# */
    ' RtsNotify(This,SENTER,"7d9586c7-d170-4d6e-8126-65f5bc706506",0,NullString);
    ' 
    ' SimCore.EnterState("7d9586c7-d170-4d6e-8126-65f5bc706506","ESTABLISHING_PDI_CONNECTION::READY_FOR_VERSION_CHECK");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 3843aad6-69dd-49b6-8a79-0f64a2e91e7b */  D50_PDI_Connection_State := "READY_FOR_VERSION_CHECK"; nullstat;/*##END 3843aad6-69dd-49b6-8a79-0f64a2e91e7b */ 
    Private Sub RtsEnter_READY_FOR_VERSION_CHECK()
      If not OperatedStates.Contains("7d9586c7-d170-4d6e-8126-65f5bc706506|") Then
        OperatedStates = OperatedStates + "7d9586c7-d170-4d6e-8126-65f5bc706506|"
      End If
      'Simulation support : Notification function call for entering state : READY_FOR_VERSION_CHECK ///* #REF520# */
      RtsNotify(Me, SENTER, "7d9586c7-d170-4d6e-8126-65f5bc706506", 0, NullString)
      SimCore.EnterState("7d9586c7-d170-4d6e-8126-65f5bc706506", "ESTABLISHING_PDI_CONNECTION::READY_FOR_VERSION_CHECK")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK
      'Entry Actions
      D50_PDI_Connection_State.SetValue("READY_FOR_VERSION_CHECK")
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("06869a26-5c83-4188-9e40-7a9bfc6b1837|") then
    '   OperatedStates := OperatedStates + "06869a26-5c83-4188-9e40-7a9bfc6b1837|";
    ' end if
    ' // Simulation support : Notification function call for entering state : READY_FOR_INITIALISATION ///* #REF520# */
    ' RtsNotify(This,SENTER,"06869a26-5c83-4188-9e40-7a9bfc6b1837",0,NullString);
    ' 
    ' SimCore.EnterState("06869a26-5c83-4188-9e40-7a9bfc6b1837","ESTABLISHING_PDI_CONNECTION::READY_FOR_INITIALISATION");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 11c09e3f-3f1b-49ed-9953-09d4be1827bf */  D50_PDI_Connection_State := "READY_FOR_INITIALISATION"; nullstat;/*##END 11c09e3f-3f1b-49ed-9953-09d4be1827bf */ 
    Private Sub RtsEnter_READY_FOR_INITIALISATION()
      If not OperatedStates.Contains("06869a26-5c83-4188-9e40-7a9bfc6b1837|") Then
        OperatedStates = OperatedStates + "06869a26-5c83-4188-9e40-7a9bfc6b1837|"
      End If
      'Simulation support : Notification function call for entering state : READY_FOR_INITIALISATION ///* #REF520# */
      RtsNotify(Me, SENTER, "06869a26-5c83-4188-9e40-7a9bfc6b1837", 0, NullString)
      SimCore.EnterState("06869a26-5c83-4188-9e40-7a9bfc6b1837", "ESTABLISHING_PDI_CONNECTION::READY_FOR_INITIALISATION")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION
      'Entry Actions
      D50_PDI_Connection_State.SetValue("READY_FOR_INITIALISATION")
    End Sub
    
    ' \ART_SMG :: Created for state : SENDING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("201ad4bd-4e5f-4ede-8224-164d12195079|") then
    '   OperatedStates := OperatedStates + "201ad4bd-4e5f-4ede-8224-164d12195079|";
    ' end if
    ' // Simulation support : Notification function call for entering state : SENDING_STATUS ///* #REF520# */
    ' RtsNotify(This,SENTER,"201ad4bd-4e5f-4ede-8224-164d12195079",0,NullString);
    ' 
    ' SimCore.EnterState("201ad4bd-4e5f-4ede-8224-164d12195079","ESTABLISHING_PDI_CONNECTION::SENDING_STATUS");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 416ce04a-cb0c-4277-b309-f00b477f86d2 */  D50_PDI_Connection_State := "SENDING_STATUS";
    '  T6_Start_Status_Report := TRUE; nullstat;/*##END 416ce04a-cb0c-4277-b309-f00b477f86d2 */ 
    Private Sub RtsEnter_SENDING_STATUS()
      If not OperatedStates.Contains("201ad4bd-4e5f-4ede-8224-164d12195079|") Then
        OperatedStates = OperatedStates + "201ad4bd-4e5f-4ede-8224-164d12195079|"
      End If
      'Simulation support : Notification function call for entering state : SENDING_STATUS ///* #REF520# */
      RtsNotify(Me, SENTER, "201ad4bd-4e5f-4ede-8224-164d12195079", 0, NullString)
      SimCore.EnterState("201ad4bd-4e5f-4ede-8224-164d12195079", "ESTABLISHING_PDI_CONNECTION::SENDING_STATUS")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS
      'Entry Actions
      D50_PDI_Connection_State.SetValue("SENDING_STATUS")
      T6_Start_Status_Report.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : NOT_READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("42606dab-58fb-43b2-8c6d-5940edcc3dda|") then
    '   OperatedStates := OperatedStates + "42606dab-58fb-43b2-8c6d-5940edcc3dda|";
    ' end if
    ' // Simulation support : Notification function call for entering state : NOT_READY_FOR_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"42606dab-58fb-43b2-8c6d-5940edcc3dda",0,NullString);
    ' 
    ' SimCore.EnterState("42606dab-58fb-43b2-8c6d-5940edcc3dda","PDI_CONNECTION_CLOSED::NOT_READY_FOR_CONNECTION");
    ' 
    ' This.RtsCurrent_PDI_CONNECTION_CLOSED := RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 50dad94f-bf1e-4d55-9ae0-24eba6d79da5 */  D50_PDI_Connection_State := "CLOSED"; nullstat;/*##END 50dad94f-bf1e-4d55-9ae0-24eba6d79da5 */ 
    Private Sub RtsEnter_NOT_READY_FOR_CONNECTION()
      If not OperatedStates.Contains("42606dab-58fb-43b2-8c6d-5940edcc3dda|") Then
        OperatedStates = OperatedStates + "42606dab-58fb-43b2-8c6d-5940edcc3dda|"
      End If
      'Simulation support : Notification function call for entering state : NOT_READY_FOR_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "42606dab-58fb-43b2-8c6d-5940edcc3dda", 0, NullString)
      SimCore.EnterState("42606dab-58fb-43b2-8c6d-5940edcc3dda", "PDI_CONNECTION_CLOSED::NOT_READY_FOR_CONNECTION")
      Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION
      'Entry Actions
      D50_PDI_Connection_State.SetValue("CLOSED")
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("5020d939-d5ce-463d-bede-1b9945f73ed2|") then
    '   OperatedStates := OperatedStates + "5020d939-d5ce-463d-bede-1b9945f73ed2|";
    ' end if
    ' // Simulation support : Notification function call for entering state : READY_FOR_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"5020d939-d5ce-463d-bede-1b9945f73ed2",0,NullString);
    ' 
    ' SimCore.EnterState("5020d939-d5ce-463d-bede-1b9945f73ed2","PDI_CONNECTION_CLOSED::READY_FOR_CONNECTION");
    ' 
    ' This.RtsCurrent_PDI_CONNECTION_CLOSED := RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT fa62cef1-041d-42c2-9724-9ec02df5fde9 */  D50_PDI_Connection_State := "CLOSED_READY"; nullstat;/*##END fa62cef1-041d-42c2-9724-9ec02df5fde9 */ 
    Private Sub RtsEnter_READY_FOR_CONNECTION()
      If not OperatedStates.Contains("5020d939-d5ce-463d-bede-1b9945f73ed2|") Then
        OperatedStates = OperatedStates + "5020d939-d5ce-463d-bede-1b9945f73ed2|"
      End If
      'Simulation support : Notification function call for entering state : READY_FOR_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "5020d939-d5ce-463d-bede-1b9945f73ed2", 0, NullString)
      SimCore.EnterState("5020d939-d5ce-463d-bede-1b9945f73ed2", "PDI_CONNECTION_CLOSED::READY_FOR_CONNECTION")
      Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION
      'Entry Actions
      D50_PDI_Connection_State.SetValue("CLOSED_READY")
    End Sub
    
    ' \ART_SMG :: Created for state : CLOSING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : CLOSING_PDI_CONNECTION
    ' 	RtsNotify(This,SEXIT,"05bf2abc-032a-4bdf-8d77-bcb757c8f793",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_CLOSING_PDI_CONNECTION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_CLOSING_PDI_CONNECTION()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_CLOSING_PDI_CONNECTION Then
        'Simulation support : Notification function call for exiting state : CLOSING_PDI_CONNECTION
        RtsNotify(Me, SEXIT, "05bf2abc-032a-4bdf-8d77-bcb757c8f793", 0, NullString)
        RtsExitSSOf_CLOSING_PDI_CONNECTION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
    ' 	RtsNotify(This,SEXIT,"934edf42-0231-4aa8-8619-acc8e372638d",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_ESTABLISHING_PDI_CONNECTION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_ESTABLISHING_PDI_CONNECTION()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_ESTABLISHING_PDI_CONNECTION Then
        'Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
        RtsNotify(Me, SEXIT, "934edf42-0231-4aa8-8619-acc8e372638d", 0, NullString)
        RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_CLOSED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_CLOSED
    ' 	RtsNotify(This,SEXIT,"ca23fc2f-d60f-4fee-a0eb-b3cec623fc63",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_CLOSED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_CLOSED()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_CLOSED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_CLOSED
        RtsNotify(Me, SEXIT, "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_CLOSED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
    ' 	RtsNotify(This,SEXIT,"31dca9ac-8214-4192-aae9-ca4acdd441ba",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_ESTABLISHED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_ESTABLISHED()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_ESTABLISHED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
        RtsNotify(Me, SEXIT, "31dca9ac-8214-4192-aae9-ca4acdd441ba", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_IMPERMISSIBLE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_IMPERMISSIBLE
    ' 	RtsNotify(This,SEXIT,"d0ac6499-0795-4a81-aac7-695f2bd8671e",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_IMPERMISSIBLE()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_CONNECTION_IMPERMISSIBLE Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_IMPERMISSIBLE
        RtsNotify(Me, SEXIT, "d0ac6499-0795-4a81-aac7-695f2bd8671e", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_PROTOCOL_ERROR
    ' 	RtsNotify(This,SEXIT,"52ceb8f1-b423-4d60-bff4-998f3a425d8b",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_PROTOCOL_ERROR ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_PROTOCOL_ERROR()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_PROTOCOL_ERROR Then
        'Simulation support : Notification function call for exiting state : PDI_PROTOCOL_ERROR
        RtsNotify(Me, SEXIT, "52ceb8f1-b423-4d60-bff4-998f3a425d8b", 0, NullString)
        RtsExitSSOf_PDI_PROTOCOL_ERROR()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_TELEGRAM_ERROR
    ' 	RtsNotify(This,SEXIT,"fa6c9fbd-aa63-4cff-9c92-d03647effe4c",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_TELEGRAM_ERROR ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_TELEGRAM_ERROR()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_TELEGRAM_ERROR Then
        'Simulation support : Notification function call for exiting state : PDI_TELEGRAM_ERROR
        RtsNotify(Me, SEXIT, "fa6c9fbd-aa63-4cff-9c92-d03647effe4c", 0, NullString)
        RtsExitSSOf_PDI_TELEGRAM_ERROR()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_VERSION_UNEQUAL
    ' 	RtsNotify(This,SEXIT,"09581792-b5ef-4212-a501-ba79efd84fb2",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_VERSION_UNEQUAL ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_VERSION_UNEQUAL()
      If Me.RtsCurrent_F_SCI_EfeS_Sec_SR = RtsF_SCI_EfeS_Sec_SR_States.RtsF_SCI_EfeS_Sec_SR_States_PDI_VERSION_UNEQUAL Then
        'Simulation support : Notification function call for exiting state : PDI_VERSION_UNEQUAL
        RtsNotify(Me, SEXIT, "09581792-b5ef-4212-a501-ba79efd84fb2", 0, NullString)
        RtsExitSSOf_PDI_VERSION_UNEQUAL()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : READY_FOR_VERSION_CHECK
    ' 	RtsNotify(This,SEXIT,"7d9586c7-d170-4d6e-8126-65f5bc706506",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_READY_FOR_VERSION_CHECK ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_READY_FOR_VERSION_CHECK()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK Then
        'Simulation support : Notification function call for exiting state : READY_FOR_VERSION_CHECK
        RtsNotify(Me, SEXIT, "7d9586c7-d170-4d6e-8126-65f5bc706506", 0, NullString)
        RtsExitSSOf_READY_FOR_VERSION_CHECK()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : READY_FOR_INITIALISATION
    ' 	RtsNotify(This,SEXIT,"06869a26-5c83-4188-9e40-7a9bfc6b1837",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_READY_FOR_INITIALISATION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_READY_FOR_INITIALISATION()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION Then
        'Simulation support : Notification function call for exiting state : READY_FOR_INITIALISATION
        RtsNotify(Me, SEXIT, "06869a26-5c83-4188-9e40-7a9bfc6b1837", 0, NullString)
        RtsExitSSOf_READY_FOR_INITIALISATION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : SENDING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : SENDING_STATUS
    ' 	RtsNotify(This,SEXIT,"201ad4bd-4e5f-4ede-8224-164d12195079",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_SENDING_STATUS ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_SENDING_STATUS()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS Then
        'Simulation support : Notification function call for exiting state : SENDING_STATUS
        RtsNotify(Me, SEXIT, "201ad4bd-4e5f-4ede-8224-164d12195079", 0, NullString)
        RtsExitSSOf_SENDING_STATUS()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : NOT_READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : NOT_READY_FOR_CONNECTION
    ' 	RtsNotify(This,SEXIT,"42606dab-58fb-43b2-8c6d-5940edcc3dda",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_NOT_READY_FOR_CONNECTION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_NOT_READY_FOR_CONNECTION()
      If Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION Then
        'Simulation support : Notification function call for exiting state : NOT_READY_FOR_CONNECTION
        RtsNotify(Me, SEXIT, "42606dab-58fb-43b2-8c6d-5940edcc3dda", 0, NullString)
        RtsExitSSOf_NOT_READY_FOR_CONNECTION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if This.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : READY_FOR_CONNECTION
    ' 	RtsNotify(This,SEXIT,"5020d939-d5ce-463d-bede-1b9945f73ed2",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_READY_FOR_CONNECTION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_READY_FOR_CONNECTION()
      If Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION Then
        'Simulation support : Notification function call for exiting state : READY_FOR_CONNECTION
        RtsNotify(Me, SEXIT, "5020d939-d5ce-463d-bede-1b9945f73ed2", 0, NullString)
        RtsExitSSOf_READY_FOR_CONNECTION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"388bfb0b-92b1-416c-af61-4e4d8912d08a",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"388bfb0b-92b1-416c-af61-4e4d8912d08a",0,NullString);/* #REF1576# */
    ' This.RtsEnter_ESTABLISHING_PDI_CONNECTION();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"2f54ba20-95ba-4754-9e37-80299d1cf394",0,NullString);/* #REF1585# */
    ' /*##STRT 003d582e-886d-46e8-a568-f41098cef02d */  nullstat;/*##END 003d582e-886d-46e8-a568-f41098cef02d */ /* #REF1546# */
    ' This.RtsEnter_READY_FOR_VERSION_CHECK();/* #REF1590# */
    ' 
    Private Sub RtsDefault_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "388bfb0b-92b1-416c-af61-4e4d8912d08a", 0, NullString)
      RtsNotify(Me, SEXIT, "388bfb0b-92b1-416c-af61-4e4d8912d08a", 0, NullString)
      Me.RtsEnter_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "2f54ba20-95ba-4754-9e37-80299d1cf394", 0, NullString)
      Me.RtsEnter_READY_FOR_VERSION_CHECK()
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"7b264f67-699c-48f5-a3a1-278c3060d507",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"7b264f67-699c-48f5-a3a1-278c3060d507",0,NullString);/* #REF1576# */
    ' This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"f0096739-541e-41f4-87ec-5c446198a17e",0,NullString);/* #REF1585# */
    ' /*##STRT 39c8c71f-d08b-4464-a0ff-c71f5ef02283 */  nullstat;/*##END 39c8c71f-d08b-4464-a0ff-c71f5ef02283 */ /* #REF1546# */
    ' This.RtsEnter_NOT_READY_FOR_CONNECTION();/* #REF1590# */
    ' 
    Private Sub RtsDefault_PDI_CONNECTION_CLOSED()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "7b264f67-699c-48f5-a3a1-278c3060d507", 0, NullString)
      RtsNotify(Me, SEXIT, "7b264f67-699c-48f5-a3a1-278c3060d507", 0, NullString)
      Me.RtsEnter_PDI_CONNECTION_CLOSED()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "f0096739-541e-41f4-87ec-5c446198a17e", 0, NullString)
      Me.RtsEnter_NOT_READY_FOR_CONNECTION()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As F_SCI_EfeS_Sec_SR)
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, "RtsF_SCI_EfeS_Sec_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsCurrent_PDI_CONNECTION_CLOSED" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, "RtsF_SCI_EfeS_Sec_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsCurrent_PDI_CONNECTION_CLOSED" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "f08f6060-1bb8-4cc2-86f2-92124ca69497";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "8";
    '   Value := Value + "|RtsCurrent_F_SCI_EfeS_Sec_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsCurrent_PDI_CONNECTION_CLOSED";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_F_SCI_EfeS_Sec_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsCurrent_PDI_CONNECTION_CLOSED";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As F_SCI_EfeS_Sec_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, "RtsF_SCI_EfeS_Sec_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsCurrent_PDI_CONNECTION_CLOSED" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, "RtsF_SCI_EfeS_Sec_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsCurrent_PDI_CONNECTION_CLOSED" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "f08f6060-1bb8-4cc2-86f2-92124ca69497"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "8"
        Value = Value + "|RtsCurrent_F_SCI_EfeS_Sec_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsCurrent_PDI_CONNECTION_CLOSED"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_F_SCI_EfeS_Sec_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsCurrent_PDI_CONNECTION_CLOSED"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, Value, "RtsF_SCI_EfeS_Sec_SR_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SR_States));
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States));
    ' end if
    ' if Name = "RtsCurrent_PDI_CONNECTION_CLOSED" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, Value, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As F_SCI_EfeS_Sec_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SCI_EfeS_Sec_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SCI_EfeS_Sec_SR, Value, "RtsF_SCI_EfeS_Sec_SR_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SR_States))
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States))
      End If
      If Name = "RtsCurrent_PDI_CONNECTION_CLOSED" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_PDI_CONNECTION_CLOSED, Value, "RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States", GetType(F_SCI_EfeS_Sec_SR.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : CLOSING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("05bf2abc-032a-4bdf-8d77-bcb757c8f793|") then
    '   OperatedStates := OperatedStates + "05bf2abc-032a-4bdf-8d77-bcb757c8f793|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_CLOSING_PDI_CONNECTION()
      If not OperatedStates.Contains("05bf2abc-032a-4bdf-8d77-bcb757c8f793|") Then
        OperatedStates = OperatedStates + "05bf2abc-032a-4bdf-8d77-bcb757c8f793|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("934edf42-0231-4aa8-8619-acc8e372638d|") then
    '   OperatedStates := OperatedStates + "934edf42-0231-4aa8-8619-acc8e372638d|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_ESTABLISHING_PDI_CONNECTION
    ' /* #REF738# */
    ' 	case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_READY_FOR_VERSION_CHECK();/* #REF742# */
    ' 	case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_READY_FOR_INITIALISATION();/* #REF742# */
    ' 	case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_SENDING_STATUS();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
      If not OperatedStates.Contains("934edf42-0231-4aa8-8619-acc8e372638d|") Then
        OperatedStates = OperatedStates + "934edf42-0231-4aa8-8619-acc8e372638d|"
      End If
      Select Case Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION
        Case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_VERSION_CHECK
          Me.RtsExit_READY_FOR_VERSION_CHECK()
        Case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_READY_FOR_INITIALISATION
          Me.RtsExit_READY_FOR_INITIALISATION()
        Case RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_SENDING_STATUS
          Me.RtsExit_SENDING_STATUS()
      End Select
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_EfeS_Sec_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|") then
    '   OperatedStates := OperatedStates + "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_PDI_CONNECTION_CLOSED
    ' /* #REF738# */
    ' 	case RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_NOT_READY_FOR_CONNECTION();/* #REF742# */
    ' 	case RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_READY_FOR_CONNECTION();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_PDI_CONNECTION_CLOSED := RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States{enum_datatype}.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NotIn_PDI_CONNECTION_CLOSED;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_CLOSED()
      If not OperatedStates.Contains("ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|") Then
        OperatedStates = OperatedStates + "ca23fc2f-d60f-4fee-a0eb-b3cec623fc63|"
      End If
      Select Case Me.RtsCurrent_PDI_CONNECTION_CLOSED
        Case RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NOT_READY_FOR_CONNECTION
          Me.RtsExit_NOT_READY_FOR_CONNECTION()
        Case RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_READY_FOR_CONNECTION
          Me.RtsExit_READY_FOR_CONNECTION()
      End Select
      Me.RtsCurrent_PDI_CONNECTION_CLOSED = RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States.RtsF_SCI_EfeS_Sec_SRPDI_CONNECTION_CLOSED_States_NotIn_PDI_CONNECTION_CLOSED
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("31dca9ac-8214-4192-aae9-ca4acdd441ba|") then
    '   OperatedStates := OperatedStates + "31dca9ac-8214-4192-aae9-ca4acdd441ba|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("31dca9ac-8214-4192-aae9-ca4acdd441ba|") Then
        OperatedStates = OperatedStates + "31dca9ac-8214-4192-aae9-ca4acdd441ba|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("d0ac6499-0795-4a81-aac7-695f2bd8671e|") then
    '   OperatedStates := OperatedStates + "d0ac6499-0795-4a81-aac7-695f2bd8671e|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE()
      If not OperatedStates.Contains("d0ac6499-0795-4a81-aac7-695f2bd8671e|") Then
        OperatedStates = OperatedStates + "d0ac6499-0795-4a81-aac7-695f2bd8671e|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("52ceb8f1-b423-4d60-bff4-998f3a425d8b|") then
    '   OperatedStates := OperatedStates + "52ceb8f1-b423-4d60-bff4-998f3a425d8b|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_PROTOCOL_ERROR()
      If not OperatedStates.Contains("52ceb8f1-b423-4d60-bff4-998f3a425d8b|") Then
        OperatedStates = OperatedStates + "52ceb8f1-b423-4d60-bff4-998f3a425d8b|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("fa6c9fbd-aa63-4cff-9c92-d03647effe4c|") then
    '   OperatedStates := OperatedStates + "fa6c9fbd-aa63-4cff-9c92-d03647effe4c|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_TELEGRAM_ERROR()
      If not OperatedStates.Contains("fa6c9fbd-aa63-4cff-9c92-d03647effe4c|") Then
        OperatedStates = OperatedStates + "fa6c9fbd-aa63-4cff-9c92-d03647effe4c|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("09581792-b5ef-4212-a501-ba79efd84fb2|") then
    '   OperatedStates := OperatedStates + "09581792-b5ef-4212-a501-ba79efd84fb2|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_VERSION_UNEQUAL()
      If not OperatedStates.Contains("09581792-b5ef-4212-a501-ba79efd84fb2|") Then
        OperatedStates = OperatedStates + "09581792-b5ef-4212-a501-ba79efd84fb2|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("7d9586c7-d170-4d6e-8126-65f5bc706506|") then
    '   OperatedStates := OperatedStates + "7d9586c7-d170-4d6e-8126-65f5bc706506|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_READY_FOR_VERSION_CHECK()
      If not OperatedStates.Contains("7d9586c7-d170-4d6e-8126-65f5bc706506|") Then
        OperatedStates = OperatedStates + "7d9586c7-d170-4d6e-8126-65f5bc706506|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("06869a26-5c83-4188-9e40-7a9bfc6b1837|") then
    '   OperatedStates := OperatedStates + "06869a26-5c83-4188-9e40-7a9bfc6b1837|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_READY_FOR_INITIALISATION()
      If not OperatedStates.Contains("06869a26-5c83-4188-9e40-7a9bfc6b1837|") Then
        OperatedStates = OperatedStates + "06869a26-5c83-4188-9e40-7a9bfc6b1837|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : SENDING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("201ad4bd-4e5f-4ede-8224-164d12195079|") then
    '   OperatedStates := OperatedStates + "201ad4bd-4e5f-4ede-8224-164d12195079|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_SENDING_STATUS()
      If not OperatedStates.Contains("201ad4bd-4e5f-4ede-8224-164d12195079|") Then
        OperatedStates = OperatedStates + "201ad4bd-4e5f-4ede-8224-164d12195079|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : NOT_READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("42606dab-58fb-43b2-8c6d-5940edcc3dda|") then
    '   OperatedStates := OperatedStates + "42606dab-58fb-43b2-8c6d-5940edcc3dda|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_NOT_READY_FOR_CONNECTION()
      If not OperatedStates.Contains("42606dab-58fb-43b2-8c6d-5940edcc3dda|") Then
        OperatedStates = OperatedStates + "42606dab-58fb-43b2-8c6d-5940edcc3dda|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : READY_FOR_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' if not OperatedStates.Contains ("5020d939-d5ce-463d-bede-1b9945f73ed2|") then
    '   OperatedStates := OperatedStates + "5020d939-d5ce-463d-bede-1b9945f73ed2|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_READY_FOR_CONNECTION()
      If not OperatedStates.Contains("5020d939-d5ce-463d-bede-1b9945f73ed2|") Then
        OperatedStates = OperatedStates + "5020d939-d5ce-463d-bede-1b9945f73ed2|"
      End If
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimOutputPort;
    ' assume DT13_Result: a SySimOutputPort;
    ' assume DT7_PDI_Version: a SySimInputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T11_PDI_Connection_Established: a SySimOutputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimOutputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimOutputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimOutputPort;
    ' assume T17_PDI_Connection_Terminated: a SySimOutputPort;
    ' assume T18_Not_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T1_Ready_For_PDI_Connection: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Start_Status_Report: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimInputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimInputPort;
    ' assume T9_Status_Report_Completed: a SySimInputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg14Tmp := (/*##STRT 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ( T18_Not_Ready_For_PDI_Connection )/*##END 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ) : Boolean;
    ' ChgFlg14 := EvalTrigger(ChgFlg14Tmp , ChgFlgLast14);
    ' declare ChgFlg4Tmp := (/*##STRT b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ( T20_Protocol_Error )/*##END b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg11Tmp := (/*##STRT 44e731d3-978f-4448-bc12-6f371db85eec */ ( T18_Not_Ready_For_PDI_Connection )/*##END 44e731d3-978f-4448-bc12-6f371db85eec */ ) : Boolean;
    ' ChgFlg11 := EvalTrigger(ChgFlg11Tmp , ChgFlgLast11);
    ' declare ChgFlg7Tmp := (/*##STRT a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ( T7_Cd_PDI_Version_Check )/*##END a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg8Tmp := (/*##STRT 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ( T8_Cd_Initialisation_Request )/*##END 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg15Tmp := (/*##STRT e62dcc81-425f-4662-bd95-85257a5da9ce */ ( T20_Protocol_Error )/*##END e62dcc81-425f-4662-bd95-85257a5da9ce */ ) : Boolean;
    ' ChgFlg15 := EvalTrigger(ChgFlg15Tmp , ChgFlgLast15);
    ' declare ChgFlg13Tmp := (/*##STRT d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ( T10_SCP_Connection_Terminated )/*##END d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ) : Boolean;
    ' ChgFlg13 := EvalTrigger(ChgFlg13Tmp , ChgFlgLast13);
    ' declare ChgFlg1Tmp := (/*##STRT 2a0821d3-def3-4514-b720-d733ddd27948 */ ( T10_SCP_Connection_Terminated )/*##END 2a0821d3-def3-4514-b720-d733ddd27948 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg9Tmp := (/*##STRT aac2215f-a728-4b61-9acb-d32b75d77af2 */ ( T9_Status_Report_Completed )/*##END aac2215f-a728-4b61-9acb-d32b75d77af2 */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg6Tmp := (/*##STRT 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ( T22_Content_Telegram_Error )/*##END 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg16Tmp := (/*##STRT 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ( T21_Formal_Telegram_Error )/*##END 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ) : Boolean;
    ' ChgFlg16 := EvalTrigger(ChgFlg16Tmp , ChgFlgLast16);
    ' declare ChgFlg2Tmp := (/*##STRT 196d8d77-a78e-4345-9994-3741f07d5d38 */ ( T10_SCP_Connection_Terminated )/*##END 196d8d77-a78e-4345-9994-3741f07d5d38 */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' declare ChgFlg12Tmp := (/*##STRT c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ( T5_SCP_Connection_Established )/*##END c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ) : Boolean;
    ' ChgFlg12 := EvalTrigger(ChgFlg12Tmp , ChgFlgLast12);
    ' declare ChgFlg5Tmp := (/*##STRT 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ( T21_Formal_Telegram_Error )/*##END 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg18Tmp := (/*##STRT 12e538c4-5b85-4d69-a911-6c355a886801 */ ( T10_SCP_Connection_Terminated )/*##END 12e538c4-5b85-4d69-a911-6c355a886801 */ ) : Boolean;
    ' ChgFlg18 := EvalTrigger(ChgFlg18Tmp , ChgFlgLast18);
    ' declare ChgFlg19Tmp := (/*##STRT f629e098-62e6-46a6-8fa1-bd691abbc677 */ ( T10_SCP_Connection_Terminated )/*##END f629e098-62e6-46a6-8fa1-bd691abbc677 */ ) : Boolean;
    ' ChgFlg19 := EvalTrigger(ChgFlg19Tmp , ChgFlgLast19);
    ' declare ChgFlg17Tmp := (/*##STRT d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ( T22_Content_Telegram_Error )/*##END d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ) : Boolean;
    ' ChgFlg17 := EvalTrigger(ChgFlg17Tmp , ChgFlgLast17);
    ' declare ChgFlg20Tmp := (/*##STRT ce5026fd-3798-411d-ba16-8f3766b976f3 */ ( T10_SCP_Connection_Terminated )/*##END ce5026fd-3798-411d-ba16-8f3766b976f3 */ ) : Boolean;
    ' ChgFlg20 := EvalTrigger(ChgFlg20Tmp , ChgFlgLast20);
    ' declare ChgFlg10Tmp := (/*##STRT a8072653-e540-443b-a962-61972fdaa140 */ ( T1_Ready_For_PDI_Connection )/*##END a8072653-e540-443b-a962-61972fdaa140 */ ) : Boolean;
    ' ChgFlg10 := EvalTrigger(ChgFlg10Tmp , ChgFlgLast10);
    ' declare ChgFlg3Tmp := (/*##STRT 79d1118e-00e7-4bfe-8107-d42267997dea */ ( T18_Not_Ready_For_PDI_Connection )/*##END 79d1118e-00e7-4bfe-8107-d42267997dea */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast14 := ChgFlg14Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast11 := ChgFlg11Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast15 := ChgFlg15Tmp;
    ' ChgFlgLast13 := ChgFlg13Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast16 := ChgFlg16Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' ChgFlgLast12 := ChgFlg12Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast18 := ChgFlg18Tmp;
    ' ChgFlgLast19 := ChgFlg19Tmp;
    ' ChgFlgLast17 := ChgFlg17Tmp;
    ' ChgFlgLast20 := ChgFlg20Tmp;
    ' ChgFlgLast10 := ChgFlg10Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg14 := (/*##STRT 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ( T18_Not_Ready_For_PDI_Connection )/*##END 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ( T20_Protocol_Error )/*##END b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ) : Boolean;
    '   declare MaskedChgFlg11 := (/*##STRT 44e731d3-978f-4448-bc12-6f371db85eec */ ( T18_Not_Ready_For_PDI_Connection )/*##END 44e731d3-978f-4448-bc12-6f371db85eec */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ( T7_Cd_PDI_Version_Check )/*##END a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ( T8_Cd_Initialisation_Request )/*##END 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ) : Boolean;
    '   declare MaskedChgFlg15 := (/*##STRT e62dcc81-425f-4662-bd95-85257a5da9ce */ ( T20_Protocol_Error )/*##END e62dcc81-425f-4662-bd95-85257a5da9ce */ ) : Boolean;
    '   declare MaskedChgFlg13 := (/*##STRT d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ( T10_SCP_Connection_Terminated )/*##END d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT 2a0821d3-def3-4514-b720-d733ddd27948 */ ( T10_SCP_Connection_Terminated )/*##END 2a0821d3-def3-4514-b720-d733ddd27948 */ ) : Boolean;
    '   declare MaskedChgFlg9 := (/*##STRT aac2215f-a728-4b61-9acb-d32b75d77af2 */ ( T9_Status_Report_Completed )/*##END aac2215f-a728-4b61-9acb-d32b75d77af2 */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ( T22_Content_Telegram_Error )/*##END 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ) : Boolean;
    '   declare MaskedChgFlg16 := (/*##STRT 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ( T21_Formal_Telegram_Error )/*##END 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT 196d8d77-a78e-4345-9994-3741f07d5d38 */ ( T10_SCP_Connection_Terminated )/*##END 196d8d77-a78e-4345-9994-3741f07d5d38 */ ) : Boolean;
    '   declare MaskedChgFlg12 := (/*##STRT c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ( T5_SCP_Connection_Established )/*##END c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ( T21_Formal_Telegram_Error )/*##END 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ) : Boolean;
    '   declare MaskedChgFlg18 := (/*##STRT 12e538c4-5b85-4d69-a911-6c355a886801 */ ( T10_SCP_Connection_Terminated )/*##END 12e538c4-5b85-4d69-a911-6c355a886801 */ ) : Boolean;
    '   declare MaskedChgFlg19 := (/*##STRT f629e098-62e6-46a6-8fa1-bd691abbc677 */ ( T10_SCP_Connection_Terminated )/*##END f629e098-62e6-46a6-8fa1-bd691abbc677 */ ) : Boolean;
    '   declare MaskedChgFlg17 := (/*##STRT d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ( T22_Content_Telegram_Error )/*##END d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ) : Boolean;
    '   declare MaskedChgFlg20 := (/*##STRT ce5026fd-3798-411d-ba16-8f3766b976f3 */ ( T10_SCP_Connection_Terminated )/*##END ce5026fd-3798-411d-ba16-8f3766b976f3 */ ) : Boolean;
    '   declare MaskedChgFlg10 := (/*##STRT a8072653-e540-443b-a962-61972fdaa140 */ ( T1_Ready_For_PDI_Connection )/*##END a8072653-e540-443b-a962-61972fdaa140 */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 79d1118e-00e7-4bfe-8107-d42267997dea */ ( T18_Not_Ready_For_PDI_Connection )/*##END 79d1118e-00e7-4bfe-8107-d42267997dea */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg14 := (/*##STRT 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ( T18_Not_Ready_For_PDI_Connection )/*##END 6f517d01-0cc4-4657-81dc-4849b91dc754 */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ( T20_Protocol_Error )/*##END b22c6f70-4e5d-47cf-a41c-4ca0e81ffcc5 */ ) : Boolean;
    '   declare UnMaskedChgFlg11 := (/*##STRT 44e731d3-978f-4448-bc12-6f371db85eec */ ( T18_Not_Ready_For_PDI_Connection )/*##END 44e731d3-978f-4448-bc12-6f371db85eec */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ( T7_Cd_PDI_Version_Check )/*##END a4f23ef8-f17e-4786-b1c7-e6c60465c6f1 */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ( T8_Cd_Initialisation_Request )/*##END 4c3c5c78-33c6-4e1e-9ea5-0047cc2351a0 */ ) : Boolean;
    '   declare UnMaskedChgFlg15 := (/*##STRT e62dcc81-425f-4662-bd95-85257a5da9ce */ ( T20_Protocol_Error )/*##END e62dcc81-425f-4662-bd95-85257a5da9ce */ ) : Boolean;
    '   declare UnMaskedChgFlg13 := (/*##STRT d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ( T10_SCP_Connection_Terminated )/*##END d9f224ca-2da2-4ac1-97f1-f6634e38e7a8 */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT 2a0821d3-def3-4514-b720-d733ddd27948 */ ( T10_SCP_Connection_Terminated )/*##END 2a0821d3-def3-4514-b720-d733ddd27948 */ ) : Boolean;
    '   declare UnMaskedChgFlg9 := (/*##STRT aac2215f-a728-4b61-9acb-d32b75d77af2 */ ( T9_Status_Report_Completed )/*##END aac2215f-a728-4b61-9acb-d32b75d77af2 */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ( T22_Content_Telegram_Error )/*##END 95fc32bc-5086-4b21-bf41-1eb9064be98a */ ) : Boolean;
    '   declare UnMaskedChgFlg16 := (/*##STRT 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ( T21_Formal_Telegram_Error )/*##END 32a5dc37-e0d0-4d87-ac7d-17e7e52b6453 */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT 196d8d77-a78e-4345-9994-3741f07d5d38 */ ( T10_SCP_Connection_Terminated )/*##END 196d8d77-a78e-4345-9994-3741f07d5d38 */ ) : Boolean;
    '   declare UnMaskedChgFlg12 := (/*##STRT c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ( T5_SCP_Connection_Established )/*##END c51ab949-3888-4efc-aa49-e0ab93c2f37e */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ( T21_Formal_Telegram_Error )/*##END 21313772-91bc-42d8-8ec4-a9412c1ea598 */ ) : Boolean;
    '   declare UnMaskedChgFlg18 := (/*##STRT 12e538c4-5b85-4d69-a911-6c355a886801 */ ( T10_SCP_Connection_Terminated )/*##END 12e538c4-5b85-4d69-a911-6c355a886801 */ ) : Boolean;
    '   declare UnMaskedChgFlg19 := (/*##STRT f629e098-62e6-46a6-8fa1-bd691abbc677 */ ( T10_SCP_Connection_Terminated )/*##END f629e098-62e6-46a6-8fa1-bd691abbc677 */ ) : Boolean;
    '   declare UnMaskedChgFlg17 := (/*##STRT d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ( T22_Content_Telegram_Error )/*##END d72cb0e8-08ad-4fe8-b83d-328fa17bdd0c */ ) : Boolean;
    '   declare UnMaskedChgFlg20 := (/*##STRT ce5026fd-3798-411d-ba16-8f3766b976f3 */ ( T10_SCP_Connection_Terminated )/*##END ce5026fd-3798-411d-ba16-8f3766b976f3 */ ) : Boolean;
    '   declare UnMaskedChgFlg10 := (/*##STRT a8072653-e540-443b-a962-61972fdaa140 */ ( T1_Ready_For_PDI_Connection )/*##END a8072653-e540-443b-a962-61972fdaa140 */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 79d1118e-00e7-4bfe-8107-d42267997dea */ ( T18_Not_Ready_For_PDI_Connection )/*##END 79d1118e-00e7-4bfe-8107-d42267997dea */ ) : Boolean;
    '   declare PreviousChgFlg14 := ChgFlg14 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg11 := ChgFlg11 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg15 := ChgFlg15 : Boolean;
    '   declare PreviousChgFlg13 := ChgFlg13 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg16 := ChgFlg16 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   declare PreviousChgFlg12 := ChgFlg12 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg18 := ChgFlg18 : Boolean;
    '   declare PreviousChgFlg19 := ChgFlg19 : Boolean;
    '   declare PreviousChgFlg17 := ChgFlg17 : Boolean;
    '   declare PreviousChgFlg20 := ChgFlg20 : Boolean;
    '   declare PreviousChgFlg10 := ChgFlg10 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := True;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := True;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := True;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := True;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := True;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := True;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := True;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := True;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := True;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := True;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := True;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := True;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := True;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := True;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg18 And UnMaskedChgFlg18 And Not MaskedChgFlg18 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := True;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg19 And UnMaskedChgFlg19 And Not MaskedChgFlg19 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := True;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := True;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg20 And UnMaskedChgFlg20 And Not MaskedChgFlg20 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := True;
    '   ChgFlg10 := False;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := True;
    '   ChgFlg3 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg14 := False;
    '   ChgFlg4 := False;
    '   ChgFlg11 := False;
    '   ChgFlg7 := False;
    '   ChgFlg8 := False;
    '   ChgFlg15 := False;
    '   ChgFlg13 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg6 := False;
    '   ChgFlg16 := False;
    '   ChgFlg2 := False;
    '   ChgFlg12 := False;
    '   ChgFlg5 := False;
    '   ChgFlg18 := False;
    '   ChgFlg19 := False;
    '   ChgFlg17 := False;
    '   ChgFlg20 := False;
    '   ChgFlg10 := False;
    '   ChgFlg3 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg14 := false;
    ' ChgFlg4 := false;
    ' ChgFlg11 := false;
    ' ChgFlg7 := false;
    ' ChgFlg8 := false;
    ' ChgFlg15 := false;
    ' ChgFlg13 := false;
    ' ChgFlg1 := false;
    ' ChgFlg9 := false;
    ' ChgFlg6 := false;
    ' ChgFlg16 := false;
    ' ChgFlg2 := false;
    ' ChgFlg12 := false;
    ' ChgFlg5 := false;
    ' ChgFlg18 := false;
    ' ChgFlg19 := false;
    ' ChgFlg17 := false;
    ' ChgFlg20 := false;
    ' ChgFlg10 := false;
    ' ChgFlg3 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg14Tmp As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
      ChgFlg14 = EvalTrigger(ChgFlg14Tmp, ChgFlgLast14)
      Dim ChgFlg4Tmp As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg11Tmp As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
      ChgFlg11 = EvalTrigger(ChgFlg11Tmp, ChgFlgLast11)
      Dim ChgFlg7Tmp As Boolean = ((T7_Cd_PDI_Version_Check.GetLatchedValue()))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg8Tmp As Boolean = ((T8_Cd_Initialisation_Request.GetLatchedValue()))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg15Tmp As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
      ChgFlg15 = EvalTrigger(ChgFlg15Tmp, ChgFlgLast15)
      Dim ChgFlg13Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg13 = EvalTrigger(ChgFlg13Tmp, ChgFlgLast13)
      Dim ChgFlg1Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg9Tmp As Boolean = ((T9_Status_Report_Completed.GetLatchedValue()))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg6Tmp As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg16Tmp As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
      ChgFlg16 = EvalTrigger(ChgFlg16Tmp, ChgFlgLast16)
      Dim ChgFlg2Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      Dim ChgFlg12Tmp As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
      ChgFlg12 = EvalTrigger(ChgFlg12Tmp, ChgFlgLast12)
      Dim ChgFlg5Tmp As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg18Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg18 = EvalTrigger(ChgFlg18Tmp, ChgFlgLast18)
      Dim ChgFlg19Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg19 = EvalTrigger(ChgFlg19Tmp, ChgFlgLast19)
      Dim ChgFlg17Tmp As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
      ChgFlg17 = EvalTrigger(ChgFlg17Tmp, ChgFlgLast17)
      Dim ChgFlg20Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg20 = EvalTrigger(ChgFlg20Tmp, ChgFlgLast20)
      Dim ChgFlg10Tmp As Boolean = ((T1_Ready_For_PDI_Connection.GetLatchedValue()))
      ChgFlg10 = EvalTrigger(ChgFlg10Tmp, ChgFlgLast10)
      Dim ChgFlg3Tmp As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast14 = ChgFlg14Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast11 = ChgFlg11Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast15 = ChgFlg15Tmp
      ChgFlgLast13 = ChgFlg13Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast16 = ChgFlg16Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      ChgFlgLast12 = ChgFlg12Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast18 = ChgFlg18Tmp
      ChgFlgLast19 = ChgFlg19Tmp
      ChgFlgLast17 = ChgFlg17Tmp
      ChgFlgLast20 = ChgFlg20Tmp
      ChgFlgLast10 = ChgFlg10Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg14 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim MaskedChgFlg4 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim MaskedChgFlg11 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim MaskedChgFlg7 As Boolean = ((T7_Cd_PDI_Version_Check.GetLatchedValue()))
        Dim MaskedChgFlg8 As Boolean = ((T8_Cd_Initialisation_Request.GetLatchedValue()))
        Dim MaskedChgFlg15 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim MaskedChgFlg13 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg1 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg9 As Boolean = ((T9_Status_Report_Completed.GetLatchedValue()))
        Dim MaskedChgFlg6 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg16 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg2 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg12 As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
        Dim MaskedChgFlg5 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg18 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg19 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg17 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg20 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg10 As Boolean = ((T1_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg14 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim UnMaskedChgFlg4 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg11 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim UnMaskedChgFlg7 As Boolean = ((T7_Cd_PDI_Version_Check.GetLatchedValue()))
        Dim UnMaskedChgFlg8 As Boolean = ((T8_Cd_Initialisation_Request.GetLatchedValue()))
        Dim UnMaskedChgFlg15 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg13 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg1 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg9 As Boolean = ((T9_Status_Report_Completed.GetLatchedValue()))
        Dim UnMaskedChgFlg6 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg16 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg2 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg12 As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
        Dim UnMaskedChgFlg5 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg18 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg19 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg17 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg20 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg10 As Boolean = ((T1_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T18_Not_Ready_For_PDI_Connection.GetLatchedValue()))
        Dim PreviousChgFlg14 As Boolean = ChgFlg14
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg11 As Boolean = ChgFlg11
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg15 As Boolean = ChgFlg15
        Dim PreviousChgFlg13 As Boolean = ChgFlg13
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg16 As Boolean = ChgFlg16
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        Dim PreviousChgFlg12 As Boolean = ChgFlg12
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg18 As Boolean = ChgFlg18
        Dim PreviousChgFlg19 As Boolean = ChgFlg19
        Dim PreviousChgFlg17 As Boolean = ChgFlg17
        Dim PreviousChgFlg20 As Boolean = ChgFlg20
        Dim PreviousChgFlg10 As Boolean = ChgFlg10
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = True
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = True
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = True
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = True
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = True
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = True
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = True
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = True
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = True
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = True
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = True
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = True
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = True
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = True
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg18 And UnMaskedChgFlg18 And Not MaskedChgFlg18 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = True
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg19 And UnMaskedChgFlg19 And Not MaskedChgFlg19 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = True
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = True
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg20 And UnMaskedChgFlg20 And Not MaskedChgFlg20 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = True
          ChgFlg10 = False
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = True
          ChgFlg3 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg14 = False
          ChgFlg4 = False
          ChgFlg11 = False
          ChgFlg7 = False
          ChgFlg8 = False
          ChgFlg15 = False
          ChgFlg13 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg6 = False
          ChgFlg16 = False
          ChgFlg2 = False
          ChgFlg12 = False
          ChgFlg5 = False
          ChgFlg18 = False
          ChgFlg19 = False
          ChgFlg17 = False
          ChgFlg20 = False
          ChgFlg10 = False
          ChgFlg3 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg14 = False
      ChgFlg4 = False
      ChgFlg11 = False
      ChgFlg7 = False
      ChgFlg8 = False
      ChgFlg15 = False
      ChgFlg13 = False
      ChgFlg1 = False
      ChgFlg9 = False
      ChgFlg6 = False
      ChgFlg16 = False
      ChgFlg2 = False
      ChgFlg12 = False
      ChgFlg5 = False
      ChgFlg18 = False
      ChgFlg19 = False
      ChgFlg17 = False
      ChgFlg20 = False
      ChgFlg10 = False
      ChgFlg3 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D23_Con_Checksum_Data_Used.Decrement())
      Ret = (Ret Or D3_Con_PDI_Version.Decrement())
      Ret = (Ret Or D4_Con_Checksum_Data.Decrement())
      Ret = (Ret Or DT7_PDI_Version.Decrement())
      Ret = (Ret Or T10_SCP_Connection_Terminated.Decrement())
      Ret = (Ret Or T18_Not_Ready_For_PDI_Connection.Decrement())
      Ret = (Ret Or T1_Ready_For_PDI_Connection.Decrement())
      Ret = (Ret Or T20_Protocol_Error.Decrement())
      Ret = (Ret Or T21_Formal_Telegram_Error.Decrement())
      Ret = (Ret Or T22_Content_Telegram_Error.Decrement())
      Ret = (Ret Or T5_SCP_Connection_Established.Decrement())
      Ret = (Ret Or T7_Cd_PDI_Version_Check.Decrement())
      Ret = (Ret Or T8_Cd_Initialisation_Request.Decrement())
      Ret = (Ret Or T9_Status_Report_Completed.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D23_Con_Checksum_Data_Used.Mask(What)
      D3_Con_PDI_Version.Mask(What)
      D4_Con_Checksum_Data.Mask(What)
      DT7_PDI_Version.Mask(What)
      T10_SCP_Connection_Terminated.Mask(What)
      T18_Not_Ready_For_PDI_Connection.Mask(What)
      T1_Ready_For_PDI_Connection.Mask(What)
      T20_Protocol_Error.Mask(What)
      T21_Formal_Telegram_Error.Mask(What)
      T22_Content_Telegram_Error.Mask(What)
      T5_SCP_Connection_Established.Mask(What)
      T7_Cd_PDI_Version_Check.Mask(What)
      T8_Cd_Initialisation_Request.Mask(What)
      T9_Status_Report_Completed.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class F_SCI_P_SR : Implements SMSupport.SMQueued 
    Protected Class F_SCI_P_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As F_SCI_P_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsF_SCI_P_SR_States
      RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION
      RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED
      RtsF_SCI_P_SR_States_NotIn_F_SCI_P_SR
    End Enum
    Public Enum RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States
      RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING
      RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS
      RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED
      RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Enum
    ' \ART_SMG :: Created for state : F_SCI_P_SR
    Private RtsCurrent_F_SCI_P_SR As F_SCI_P_SR.RtsF_SCI_P_SR_States
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    Private RtsCurrent_ESTABLISHING_PDI_CONNECTION As F_SCI_P_SR.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As F_SCI_P_SRSMQueue = New F_SCI_P_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    Private Mem_Move_Point As String
    ' The FlowPort T1_Cd_Move_Point refines the Flow Property Cd_Move_Point.
    Protected T1_Cd_Move_Point As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort DT1_Move_Point_Target belongs to T1_Cd_Move_Point.
    Protected DT1_Move_Point_Target As OInputPort(Of String)
    ' The FlowPortT2_Msg_Point_Position  refines the Flow Property Msg_Point_Position.
    Protected T2_Msg_Point_Position As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort DT2_Point_Position belongs to T2_Msg_Point_Position.
    Protected DT2_Point_Position As OOutputPort(Of String)
    ' The FlowPort T3_Msg_Timeout refines the Flow Property Msg_Timeout.
    Protected T3_Msg_Timeout As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T10_Move As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected DT10_Move_Target As OOutputPort(Of String)
    Protected T11_Stop_Operation As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected D21_F_SCI_EfeS_Gen_SR_State As OInputPort(Of String)
    Protected T18_Start_Status_Report As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T30_Report_Timeout As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T20_Point_Position As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected DT20_Point_Position As OInputPort(Of String)
    Protected T40_Send_Status_Report As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Private Mem_Point_Position As String
    Protected T23_Sending_Status_Report_Completed As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' T2_Msg_Point_Position := FALSE;
    ' DT2_Point_Position := "";
    ' T3_Msg_Timeout := FALSE;
    ' T10_Move := FALSE;
    ' DT10_Move_Target := "";
    ' T11_Stop_Operation := FALSE;
    ' T23_Sending_Status_Report_Completed := FALSE;
    ' T40_Send_Status_Report := FALSE;
    ' Mem_Move_Point := "";
    ' Mem_Point_Position := "";
    Public Sub cOp1_Init()
      T2_Msg_Point_Position.SetValue(False)
      DT2_Point_Position.SetValue("")
      T3_Msg_Timeout.SetValue(False)
      T10_Move.SetValue(False)
      DT10_Move_Target.SetValue("")
      T11_Stop_Operation.SetValue(False)
      T23_Sending_Status_Report_Completed.SetValue(False)
      T40_Send_Status_Report.SetValue(False)
      Mem_Move_Point = ""
      Mem_Point_Position = ""
    End Sub
    
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' assume RtsCurrent_F_SCI_P_SR: on object;
    ' assume RtsCurrent_ESTABLISHING_PDI_CONNECTION: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING then
    ' /* #REF123# */
    ' 	/* 2859eb9a-6350-41a3-b13e-73313e01749b WATING */
    '   ThisState := "2859eb9a-6350-41a3-b13e-73313e01749b";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WATING */
    ' 		/* standard */
    ' 		This.RtsExit_WATING();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"94829c4b-e884-4ef7-ba8c-0f93158996c5",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT d4344aa6-ee7f-487e-ba31-66d94af28660 */ 
    '  T40_Send_Status_Report := TRUE; nullstat;/*##END d4344aa6-ee7f-487e-ba31-66d94af28660 */ /* #REF1546# */
    ' 		This.RtsEnter_REPORT_STATUS();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS then
    ' /* #REF123# */
    ' 	/* 30bf219c-6bbf-48fd-88b2-3cc9be572ae8 REPORT_STATUS */
    '   ThisState := "30bf219c-6bbf-48fd-88b2-3cc9be572ae8";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_REPORT_STATUS */
    ' 		/* standard */
    ' 		This.RtsExit_REPORT_STATUS();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"75015032-d34e-4e4c-94c4-fd66e205500d",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT acf872ed-f2cc-47ac-b352-451c6345c432 */ 
    '  DT2_Point_Position := DT20_Point_Position ;
    '  T2_Msg_Point_Position := TRUE;
    '  Mem_Point_Position := DT20_Point_Position ;
    '  T23_Sending_Status_Report_Completed := TRUE; nullstat;/*##END acf872ed-f2cc-47ac-b352-451c6345c432 */ /* #REF1546# */
    ' 		This.RtsEnter_STATUS_REPORTED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED then
    ' /* #REF123# */
    ' 	/* b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2 STATUS_REPORTED */
    '   ThisState := "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2";
    ' 	if /* #REF2000# *//*##STRT 18d80367-038f-4a0d-86aa-023023e8641e */ (
    '  Mem_Point_Position = DT20_Point_Position )/*##END 18d80367-038f-4a0d-86aa-023023e8641e */  and /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5618819a-d860-441b-b89a-dbcaf507ac8c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8cb8c390-5f17-4d75-868a-4d45dc24e86e */  nullstat;/*##END 8cb8c390-5f17-4d75-868a-4d45dc24e86e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED then
    ' /* #REF123# */
    ' 	/* b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2 STATUS_REPORTED */
    '   ThisState := "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2";
    ' 	if /* #REF2000# *//*##STRT 574efaa6-83fb-4c69-af0a-72cf558d0e10 */ (
    '  Mem_Point_Position <> DT20_Point_Position )/*##END 574efaa6-83fb-4c69-af0a-72cf558d0e10 */  and /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6cc3444a-23ac-476f-9410-22ec812397ad",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6e8c214b-add6-4957-b0e8-d0906521ea42 */ 
    '  Mem_Point_Position := DT20_Point_Position ;
    '  DT2_Point_Position := DT20_Point_Position ;
    '  T2_Msg_Point_Position := TRUE; nullstat;/*##END 6e8c214b-add6-4957-b0e8-d0906521ea42 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 483817b9-4c89-4b12-85c1-3373666d3f20 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "483817b9-4c89-4b12-85c1-3373666d3f20";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"4a51b33e-2dc8-42d4-8939-2589a022bf07",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 4a51b33e-2dc8-42d4-8939-2589a022bf07 */  T3_Msg_Timeout := TRUE; nullstat;/*##END 4a51b33e-2dc8-42d4-8939-2589a022bf07 */ /* #REF1546# */
    ' 		ChgFlg8 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 483817b9-4c89-4b12-85c1-3373666d3f20 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "483817b9-4c89-4b12-85c1-3373666d3f20";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"9dc86a80-3dcf-4c92-9d0a-aff277222455",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 9dc86a80-3dcf-4c92-9d0a-aff277222455 */  DT2_Point_Position := DT20_Point_Position ;
    '  T2_Msg_Point_Position := TRUE; nullstat;/*##END 9dc86a80-3dcf-4c92-9d0a-aff277222455 */ /* #REF1546# */
    ' 		ChgFlg7 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 483817b9-4c89-4b12-85c1-3373666d3f20 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "483817b9-4c89-4b12-85c1-3373666d3f20";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ef67e590-334a-4f66-96ee-66f233df5a2e",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ef67e590-334a-4f66-96ee-66f233df5a2e */  DT10_Move_Target := DT1_Move_Point_Target ;
    '  T10_Move := TRUE; nullstat;/*##END ef67e590-334a-4f66-96ee-66f233df5a2e */ /* #REF1546# */
    ' 		ChgFlg6 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* 62505340-98d8-447c-ba6f-2223894472bc ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "62505340-98d8-447c-ba6f-2223894472bc";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"47d449e9-1f08-4a72-9e6b-4ecb56c8e386",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 6e027932-3af2-4bd3-956e-425bff682e84 */  nullstat;/*##END 6e027932-3af2-4bd3-956e-425bff682e84 */ /* #REF1546# */
    ' 		This.RtsDefault_ESTABLISHING_PDI_CONNECTION();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR =  /* #REF121d# */ RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_NotIn_F_SCI_P_SR then
    ' /* #REF123# */
    ' 	/* e945c452-9e1e-4115-a037-e6762e287a92 Initial0 */
    '   ThisState := "e945c452-9e1e-4115-a037-e6762e287a92";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"e945c452-9e1e-4115-a037-e6762e287a92",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"e945c452-9e1e-4115-a037-e6762e287a92",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"2508c322-44f7-474a-8bd4-081e4beedd04",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 0b33fa87-6f8f-4c50-ac6e-f1abd65ef2b6 */  cOp1_init (); nullstat;/*##END 0b33fa87-6f8f-4c50-ac6e-f1abd65ef2b6 */ /* #REF1546# */
    ' 	This.RtsDefault_ESTABLISHING_PDI_CONNECTION();/* #REF1587# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 483817b9-4c89-4b12-85c1-3373666d3f20 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "483817b9-4c89-4b12-85c1-3373666d3f20";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"1c31bf7c-b51d-4c7f-8eed-5133894c5d6a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 8e25254e-a16a-4f66-bb40-cf1ff17ad91b */  nullstat;/*##END 8e25254e-a16a-4f66-bb40-cf1ff17ad91b */ /* #REF1546# */
    ' 		This.RtsDefault_ESTABLISHING_PDI_CONNECTION();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING Then
        ThisState = "2859eb9a-6350-41a3-b13e-73313e01749b"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_WATING()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "94829c4b-e884-4ef7-ba8c-0f93158996c5", 0, NullString)
          T40_Send_Status_Report.SetValue(True)
          Me.RtsEnter_REPORT_STATUS()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS Then
        ThisState = "30bf219c-6bbf-48fd-88b2-3cc9be572ae8"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          Me.RtsExit_REPORT_STATUS()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "75015032-d34e-4e4c-94c4-fd66e205500d", 0, NullString)
          DT2_Point_Position.SetValue(DT20_Point_Position.GetLatchedValue())
          T2_Msg_Point_Position.SetValue(True)
          Mem_Point_Position = DT20_Point_Position.GetLatchedValue()
          T23_Sending_Status_Report_Completed.SetValue(True)
          Me.RtsEnter_STATUS_REPORTED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED Then
        ThisState = "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2"
        If (Mem_Point_Position = DT20_Point_Position.GetLatchedValue()) And SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5618819a-d860-441b-b89a-dbcaf507ac8c", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED Then
        ThisState = "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2"
        If (Mem_Point_Position <> DT20_Point_Position.GetLatchedValue()) And SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6cc3444a-23ac-476f-9410-22ec812397ad", 0, NullString)
          Mem_Point_Position = DT20_Point_Position.GetLatchedValue()
          DT2_Point_Position.SetValue(DT20_Point_Position.GetLatchedValue())
          T2_Msg_Point_Position.SetValue(True)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "483817b9-4c89-4b12-85c1-3373666d3f20"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "4a51b33e-2dc8-42d4-8939-2589a022bf07", 0, NullString)
          T3_Msg_Timeout.SetValue(True)
          ChgFlg8 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "483817b9-4c89-4b12-85c1-3373666d3f20"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "9dc86a80-3dcf-4c92-9d0a-aff277222455", 0, NullString)
          DT2_Point_Position.SetValue(DT20_Point_Position.GetLatchedValue())
          T2_Msg_Point_Position.SetValue(True)
          ChgFlg7 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "483817b9-4c89-4b12-85c1-3373666d3f20"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ef67e590-334a-4f66-96ee-66f233df5a2e", 0, NullString)
          DT10_Move_Target.SetValue(DT1_Move_Point_Target.GetLatchedValue())
          T10_Move.SetValue(True)
          ChgFlg6 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "62505340-98d8-447c-ba6f-2223894472bc"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "47d449e9-1f08-4a72-9e6b-4ecb56c8e386", 0, NullString)
          Me.RtsDefault_ESTABLISHING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_NotIn_F_SCI_P_SR Then
        ThisState = "e945c452-9e1e-4115-a037-e6762e287a92"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "e945c452-9e1e-4115-a037-e6762e287a92", 0, NullString)
        RtsNotify(Me, SEXIT, "e945c452-9e1e-4115-a037-e6762e287a92", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "2508c322-44f7-474a-8bd4-081e4beedd04", 0, NullString)
        cOp1_init()
        Me.RtsDefault_ESTABLISHING_PDI_CONNECTION()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "483817b9-4c89-4b12-85c1-3373666d3f20"
        If SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "1c31bf7c-b51d-4c7f-8eed-5133894c5d6a", 0, NullString)
          Me.RtsDefault_ESTABLISHING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "f06e0e7e-dd33-4e2e-b2b9-de313ce4452c", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_F_SCI_P_SR := RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_NotIn_F_SCI_P_SR;/* #REF1566# */
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "f06e0e7e-dd33-4e2e-b2b9-de313ce4452c", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_NotIn_F_SCI_P_SR
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("62505340-98d8-447c-ba6f-2223894472bc|") then
    '   OperatedStates := OperatedStates + "62505340-98d8-447c-ba6f-2223894472bc|";
    ' end if
    ' // Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"62505340-98d8-447c-ba6f-2223894472bc",0,NullString);
    ' 
    ' SimCore.EnterState("62505340-98d8-447c-ba6f-2223894472bc","ESTABLISHING_PDI_CONNECTION");
    ' 
    ' This.RtsCurrent_F_SCI_P_SR := RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION;/* #REF521# */
    ' 
    Private Sub RtsEnter_ESTABLISHING_PDI_CONNECTION()
      If not OperatedStates.Contains("62505340-98d8-447c-ba6f-2223894472bc|") Then
        OperatedStates = OperatedStates + "62505340-98d8-447c-ba6f-2223894472bc|"
      End If
      'Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "62505340-98d8-447c-ba6f-2223894472bc", 0, NullString)
      SimCore.EnterState("62505340-98d8-447c-ba6f-2223894472bc", "ESTABLISHING_PDI_CONNECTION")
      Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("483817b9-4c89-4b12-85c1-3373666d3f20|") then
    '   OperatedStates := OperatedStates + "483817b9-4c89-4b12-85c1-3373666d3f20|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
    ' RtsNotify(This,SENTER,"483817b9-4c89-4b12-85c1-3373666d3f20",0,NullString);
    ' 
    ' SimCore.EnterState("483817b9-4c89-4b12-85c1-3373666d3f20","PDI_CONNECTION_ESTABLISHED");
    ' 
    ' This.RtsCurrent_F_SCI_P_SR := RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED;/* #REF521# */
    ' 
    Private Sub RtsEnter_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("483817b9-4c89-4b12-85c1-3373666d3f20|") Then
        OperatedStates = OperatedStates + "483817b9-4c89-4b12-85c1-3373666d3f20|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
      RtsNotify(Me, SENTER, "483817b9-4c89-4b12-85c1-3373666d3f20", 0, NullString)
      SimCore.EnterState("483817b9-4c89-4b12-85c1-3373666d3f20", "PDI_CONNECTION_ESTABLISHED")
      Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED
    End Sub
    
    ' \ART_SMG :: Created for state : WATING
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("2859eb9a-6350-41a3-b13e-73313e01749b|") then
    '   OperatedStates := OperatedStates + "2859eb9a-6350-41a3-b13e-73313e01749b|";
    ' end if
    ' // Simulation support : Notification function call for entering state : WATING ///* #REF520# */
    ' RtsNotify(This,SENTER,"2859eb9a-6350-41a3-b13e-73313e01749b",0,NullString);
    ' 
    ' SimCore.EnterState("2859eb9a-6350-41a3-b13e-73313e01749b","ESTABLISHING_PDI_CONNECTION::WATING");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING;/* #REF521# */
    ' 
    Private Sub RtsEnter_WATING()
      If not OperatedStates.Contains("2859eb9a-6350-41a3-b13e-73313e01749b|") Then
        OperatedStates = OperatedStates + "2859eb9a-6350-41a3-b13e-73313e01749b|"
      End If
      'Simulation support : Notification function call for entering state : WATING ///* #REF520# */
      RtsNotify(Me, SENTER, "2859eb9a-6350-41a3-b13e-73313e01749b", 0, NullString)
      SimCore.EnterState("2859eb9a-6350-41a3-b13e-73313e01749b", "ESTABLISHING_PDI_CONNECTION::WATING")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("30bf219c-6bbf-48fd-88b2-3cc9be572ae8|") then
    '   OperatedStates := OperatedStates + "30bf219c-6bbf-48fd-88b2-3cc9be572ae8|";
    ' end if
    ' // Simulation support : Notification function call for entering state : REPORT_STATUS ///* #REF520# */
    ' RtsNotify(This,SENTER,"30bf219c-6bbf-48fd-88b2-3cc9be572ae8",0,NullString);
    ' 
    ' SimCore.EnterState("30bf219c-6bbf-48fd-88b2-3cc9be572ae8","ESTABLISHING_PDI_CONNECTION::REPORT_STATUS");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS;/* #REF521# */
    ' 
    Private Sub RtsEnter_REPORT_STATUS()
      If not OperatedStates.Contains("30bf219c-6bbf-48fd-88b2-3cc9be572ae8|") Then
        OperatedStates = OperatedStates + "30bf219c-6bbf-48fd-88b2-3cc9be572ae8|"
      End If
      'Simulation support : Notification function call for entering state : REPORT_STATUS ///* #REF520# */
      RtsNotify(Me, SENTER, "30bf219c-6bbf-48fd-88b2-3cc9be572ae8", 0, NullString)
      SimCore.EnterState("30bf219c-6bbf-48fd-88b2-3cc9be572ae8", "ESTABLISHING_PDI_CONNECTION::REPORT_STATUS")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|") then
    '   OperatedStates := OperatedStates + "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|";
    ' end if
    ' // Simulation support : Notification function call for entering state : STATUS_REPORTED ///* #REF520# */
    ' RtsNotify(This,SENTER,"b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2",0,NullString);
    ' 
    ' SimCore.EnterState("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2","ESTABLISHING_PDI_CONNECTION::STATUS_REPORTED");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED;/* #REF521# */
    ' 
    Private Sub RtsEnter_STATUS_REPORTED()
      If not OperatedStates.Contains("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|") Then
        OperatedStates = OperatedStates + "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|"
      End If
      'Simulation support : Notification function call for entering state : STATUS_REPORTED ///* #REF520# */
      RtsNotify(Me, SENTER, "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2", 0, NullString)
      SimCore.EnterState("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2", "ESTABLISHING_PDI_CONNECTION::STATUS_REPORTED")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
    ' 	RtsNotify(This,SEXIT,"62505340-98d8-447c-ba6f-2223894472bc",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_ESTABLISHING_PDI_CONNECTION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_ESTABLISHING_PDI_CONNECTION()
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_ESTABLISHING_PDI_CONNECTION Then
        'Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
        RtsNotify(Me, SEXIT, "62505340-98d8-447c-ba6f-2223894472bc", 0, NullString)
        RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if This.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States{enum_datatype}.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
    ' 	RtsNotify(This,SEXIT,"483817b9-4c89-4b12-85c1-3373666d3f20",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_ESTABLISHED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_ESTABLISHED()
      If Me.RtsCurrent_F_SCI_P_SR = RtsF_SCI_P_SR_States.RtsF_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
        RtsNotify(Me, SEXIT, "483817b9-4c89-4b12-85c1-3373666d3f20", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WATING
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : WATING
    ' 	RtsNotify(This,SEXIT,"2859eb9a-6350-41a3-b13e-73313e01749b",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_WATING ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_WATING()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING Then
        'Simulation support : Notification function call for exiting state : WATING
        RtsNotify(Me, SEXIT, "2859eb9a-6350-41a3-b13e-73313e01749b", 0, NullString)
        RtsExitSSOf_WATING()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : REPORT_STATUS
    ' 	RtsNotify(This,SEXIT,"30bf219c-6bbf-48fd-88b2-3cc9be572ae8",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_REPORT_STATUS ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_REPORT_STATUS()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS Then
        'Simulation support : Notification function call for exiting state : REPORT_STATUS
        RtsNotify(Me, SEXIT, "30bf219c-6bbf-48fd-88b2-3cc9be572ae8", 0, NullString)
        RtsExitSSOf_REPORT_STATUS()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : STATUS_REPORTED
    ' 	RtsNotify(This,SEXIT,"b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_STATUS_REPORTED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_STATUS_REPORTED()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED Then
        'Simulation support : Notification function call for exiting state : STATUS_REPORTED
        RtsNotify(Me, SEXIT, "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2", 0, NullString)
        RtsExitSSOf_STATUS_REPORTED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"d8b8cfc4-ec99-443d-9510-2ff971c96b1c",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"d8b8cfc4-ec99-443d-9510-2ff971c96b1c",0,NullString);/* #REF1576# */
    ' This.RtsEnter_ESTABLISHING_PDI_CONNECTION();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"7dac8a1a-c55d-4fd3-b21b-0c842e7e2580",0,NullString);/* #REF1585# */
    ' /*##STRT 4eef50a9-cf1a-4e6a-89ab-25cb091253ec */  nullstat;/*##END 4eef50a9-cf1a-4e6a-89ab-25cb091253ec */ /* #REF1546# */
    ' This.RtsEnter_WATING();/* #REF1590# */
    ' 
    Private Sub RtsDefault_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "d8b8cfc4-ec99-443d-9510-2ff971c96b1c", 0, NullString)
      RtsNotify(Me, SEXIT, "d8b8cfc4-ec99-443d-9510-2ff971c96b1c", 0, NullString)
      Me.RtsEnter_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "7dac8a1a-c55d-4fd3-b21b-0c842e7e2580", 0, NullString)
      Me.RtsEnter_WATING()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As F_SCI_P_SR)
    End Sub
    
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_P_SR, "RtsF_SCI_P_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_F_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_P_SR, "RtsF_SCI_P_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "f06e0e7e-dd33-4e2e-b2b9-de313ce4452c";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "6";
    '   Value := Value + "|RtsCurrent_F_SCI_P_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_F_SCI_P_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As F_SCI_P_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SCI_P_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_P_SR, "RtsF_SCI_P_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_F_SCI_P_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SCI_P_SR, "RtsF_SCI_P_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "f06e0e7e-dd33-4e2e-b2b9-de313ce4452c"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "6"
        Value = Value + "|RtsCurrent_F_SCI_P_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_F_SCI_P_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SCI_P_SR, Value, "RtsF_SCI_P_SR_States", GetType(F_SCI_P_SR.RtsF_SCI_P_SR_States));
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States", GetType(F_SCI_P_SR.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As F_SCI_P_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SCI_P_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SCI_P_SR, Value, "RtsF_SCI_P_SR_States", GetType(F_SCI_P_SR.RtsF_SCI_P_SR_States))
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States", GetType(F_SCI_P_SR.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("62505340-98d8-447c-ba6f-2223894472bc|") then
    '   OperatedStates := OperatedStates + "62505340-98d8-447c-ba6f-2223894472bc|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_ESTABLISHING_PDI_CONNECTION
    ' /* #REF738# */
    ' 	case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_WATING();/* #REF742# */
    ' 	case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_REPORT_STATUS();/* #REF742# */
    ' 	case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_STATUS_REPORTED();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
      If not OperatedStates.Contains("62505340-98d8-447c-ba6f-2223894472bc|") Then
        OperatedStates = OperatedStates + "62505340-98d8-447c-ba6f-2223894472bc|"
      End If
      Select Case Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION
        Case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_WATING
          Me.RtsExit_WATING()
        Case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_REPORT_STATUS
          Me.RtsExit_REPORT_STATUS()
        Case RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_STATUS_REPORTED
          Me.RtsExit_STATUS_REPORTED()
      End Select
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States.RtsF_SCI_P_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("483817b9-4c89-4b12-85c1-3373666d3f20|") then
    '   OperatedStates := OperatedStates + "483817b9-4c89-4b12-85c1-3373666d3f20|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("483817b9-4c89-4b12-85c1-3373666d3f20|") Then
        OperatedStates = OperatedStates + "483817b9-4c89-4b12-85c1-3373666d3f20|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WATING
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("2859eb9a-6350-41a3-b13e-73313e01749b|") then
    '   OperatedStates := OperatedStates + "2859eb9a-6350-41a3-b13e-73313e01749b|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_WATING()
      If not OperatedStates.Contains("2859eb9a-6350-41a3-b13e-73313e01749b|") Then
        OperatedStates = OperatedStates + "2859eb9a-6350-41a3-b13e-73313e01749b|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("30bf219c-6bbf-48fd-88b2-3cc9be572ae8|") then
    '   OperatedStates := OperatedStates + "30bf219c-6bbf-48fd-88b2-3cc9be572ae8|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_REPORT_STATUS()
      If not OperatedStates.Contains("30bf219c-6bbf-48fd-88b2-3cc9be572ae8|") Then
        OperatedStates = OperatedStates + "30bf219c-6bbf-48fd-88b2-3cc9be572ae8|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|") then
    '   OperatedStates := OperatedStates + "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_STATUS_REPORTED()
      If not OperatedStates.Contains("b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|") Then
        OperatedStates = OperatedStates + "b65ad6a4-3f0c-4c82-a2b6-7ad4705f17d2|"
      End If
    End Sub
    
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D21_F_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Target: a SySimOutputPort;
    ' assume DT1_Move_Point_Target: a SySimInputPort;
    ' assume DT20_Point_Position: a SySimInputPort;
    ' assume DT2_Point_Position: a SySimOutputPort;
    ' assume T10_Move: a SySimOutputPort;
    ' assume T11_Stop_Operation: a SySimOutputPort;
    ' assume T18_Start_Status_Report: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimInputPort;
    ' assume T20_Point_Position: a SySimInputPort;
    ' assume T23_Sending_Status_Report_Completed: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimOutputPort;
    ' assume T30_Report_Timeout: a SySimInputPort;
    ' assume T3_Msg_Timeout: a SySimOutputPort;
    ' assume T40_Send_Status_Report: a SySimOutputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg8Tmp := (/*##STRT 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ( T30_Report_Timeout )/*##END 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg1Tmp := (/*##STRT 30568092-3d93-4a4f-9df6-64f6be4433bb */ ( D21_F_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 30568092-3d93-4a4f-9df6-64f6be4433bb */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg5Tmp := (/*##STRT ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg4Tmp := (/*##STRT 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg9Tmp := (/*##STRT 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ( D21_F_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg7Tmp := (/*##STRT f1ced951-719e-49d2-89ef-ad18a098c6be */ ( T20_Point_Position )/*##END f1ced951-719e-49d2-89ef-ad18a098c6be */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg3Tmp := (/*##STRT 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ( T20_Point_Position )/*##END 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg2Tmp := (/*##STRT 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ( T18_Start_Status_Report )/*##END 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' declare ChgFlg6Tmp := (/*##STRT 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ( T1_Cd_Move_Point )/*##END 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg8 := (/*##STRT 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ( T30_Report_Timeout )/*##END 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT 30568092-3d93-4a4f-9df6-64f6be4433bb */ ( D21_F_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 30568092-3d93-4a4f-9df6-64f6be4433bb */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ) : Boolean;
    '   declare MaskedChgFlg9 := (/*##STRT 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ( D21_F_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT f1ced951-719e-49d2-89ef-ad18a098c6be */ ( T20_Point_Position )/*##END f1ced951-719e-49d2-89ef-ad18a098c6be */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ( T20_Point_Position )/*##END 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ( T18_Start_Status_Report )/*##END 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ( T1_Cd_Move_Point )/*##END 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg8 := (/*##STRT 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ( T30_Report_Timeout )/*##END 12fbcbf0-9f79-48fa-ac18-729bcdf8b039 */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT 30568092-3d93-4a4f-9df6-64f6be4433bb */ ( D21_F_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 30568092-3d93-4a4f-9df6-64f6be4433bb */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END ff973ace-6d5c-4c91-8cd6-25b7477f3b38 */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ( D21_F_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END 7587316e-0f0c-40e7-aec9-a62fe2206419 */ ) : Boolean;
    '   declare UnMaskedChgFlg9 := (/*##STRT 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ( D21_F_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 3701dd1d-e29b-4b5e-a448-22e82ade4b1d */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT f1ced951-719e-49d2-89ef-ad18a098c6be */ ( T20_Point_Position )/*##END f1ced951-719e-49d2-89ef-ad18a098c6be */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ( T20_Point_Position )/*##END 638e2537-7a7a-4ced-91f4-89b7d6b6c255 */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ( T18_Start_Status_Report )/*##END 5ecaffed-322e-4c52-b2f1-efe448d8afa7 */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ( T1_Cd_Move_Point )/*##END 0fe3e858-a9af-46ba-bc2c-15e3fbaac0b6 */ ) : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := True;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := True;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := True;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := True;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := True;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := True;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := True;
    '   ChgFlg2 := False;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := True;
    '   ChgFlg6 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg8 := False;
    '   ChgFlg1 := False;
    '   ChgFlg5 := False;
    '   ChgFlg4 := False;
    '   ChgFlg9 := False;
    '   ChgFlg7 := False;
    '   ChgFlg3 := False;
    '   ChgFlg2 := False;
    '   ChgFlg6 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg8 := false;
    ' ChgFlg1 := false;
    ' ChgFlg5 := false;
    ' ChgFlg4 := false;
    ' ChgFlg9 := false;
    ' ChgFlg7 := false;
    ' ChgFlg3 := false;
    ' ChgFlg2 := false;
    ' ChgFlg6 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg8Tmp As Boolean = ((T30_Report_Timeout.GetLatchedValue()))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg1Tmp As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg5Tmp As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg4Tmp As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg9Tmp As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg7Tmp As Boolean = ((T20_Point_Position.GetLatchedValue()))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg3Tmp As Boolean = ((T20_Point_Position.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg2Tmp As Boolean = ((T18_Start_Status_Report.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      Dim ChgFlg6Tmp As Boolean = ((T1_Cd_Move_Point.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg8 As Boolean = ((T30_Report_Timeout.GetLatchedValue()))
        Dim MaskedChgFlg1 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
        Dim MaskedChgFlg5 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim MaskedChgFlg4 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim MaskedChgFlg9 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
        Dim MaskedChgFlg7 As Boolean = ((T20_Point_Position.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T20_Point_Position.GetLatchedValue()))
        Dim MaskedChgFlg2 As Boolean = ((T18_Start_Status_Report.GetLatchedValue()))
        Dim MaskedChgFlg6 As Boolean = ((T1_Cd_Move_Point.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg8 As Boolean = ((T30_Report_Timeout.GetLatchedValue()))
        Dim UnMaskedChgFlg1 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
        Dim UnMaskedChgFlg5 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim UnMaskedChgFlg4 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim UnMaskedChgFlg9 As Boolean = ((D21_F_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
        Dim UnMaskedChgFlg7 As Boolean = ((T20_Point_Position.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T20_Point_Position.GetLatchedValue()))
        Dim UnMaskedChgFlg2 As Boolean = ((T18_Start_Status_Report.GetLatchedValue()))
        Dim UnMaskedChgFlg6 As Boolean = ((T1_Cd_Move_Point.GetLatchedValue()))
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = True
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = True
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = True
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = True
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = True
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = True
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = True
          ChgFlg2 = False
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = True
          ChgFlg6 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg8 = False
          ChgFlg1 = False
          ChgFlg5 = False
          ChgFlg4 = False
          ChgFlg9 = False
          ChgFlg7 = False
          ChgFlg3 = False
          ChgFlg2 = False
          ChgFlg6 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg8 = False
      ChgFlg1 = False
      ChgFlg5 = False
      ChgFlg4 = False
      ChgFlg9 = False
      ChgFlg7 = False
      ChgFlg3 = False
      ChgFlg2 = False
      ChgFlg6 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D21_F_SCI_EfeS_Gen_SR_State.Decrement())
      Ret = (Ret Or DT1_Move_Point_Target.Decrement())
      Ret = (Ret Or DT20_Point_Position.Decrement())
      Ret = (Ret Or T18_Start_Status_Report.Decrement())
      Ret = (Ret Or T1_Cd_Move_Point.Decrement())
      Ret = (Ret Or T20_Point_Position.Decrement())
      Ret = (Ret Or T30_Report_Timeout.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D21_F_SCI_EfeS_Gen_SR_State.Mask(What)
      DT1_Move_Point_Target.Mask(What)
      DT20_Point_Position.Mask(What)
      T18_Start_Status_Report.Mask(What)
      T1_Cd_Move_Point.Mask(What)
      T20_Point_Position.Mask(What)
      T30_Report_Timeout.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class F_SMI_EfeS_SR : Implements SMSupport.SMQueued 
    Protected Class F_SMI_EfeS_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As F_SMI_EfeS_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsF_SMI_EfeS_SR_States
      RtsF_SMI_EfeS_SR_States_DATA_UPDATE
      RtsF_SMI_EfeS_SR_States_IDLE
      RtsF_SMI_EfeS_SR_States_NotIn_F_SMI_EfeS_SR
    End Enum
    Public Enum RtsF_SMI_EfeS_SRDATA_UPDATE_States
      RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS
      RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA
      RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING
      RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION
      RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
    End Enum
    Public Enum RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States
      RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA
      RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA
      RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA
      RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_NotIn_DATA_TRANSMISSION
    End Enum
    ' \ART_SMG :: Created for state : F_SMI_EfeS_SR
    Private RtsCurrent_F_SMI_EfeS_SR As F_SMI_EfeS_SR.RtsF_SMI_EfeS_SR_States
    ' \ART_SMG :: Created for state : DATA_UPDATE
    Private RtsCurrent_DATA_UPDATE As F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_UPDATE_States
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    Private RtsAttCHECKING_UP_TO_DATENESS_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    Private RtsAttDELAY_TIME_EXPIRING_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    Private RtsAttDATA_TRANSMISSION_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    Private RtsCurrent_DATA_TRANSMISSION As F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast10 As Boolean
    Private ChgFlg10 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast11 As Boolean
    Private ChgFlg11 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As F_SMI_EfeS_SRSMQueue = New F_SMI_EfeS_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    ' The FlowPort T19_Validate_Data refines the FlowProperty Validate_Data.
    Protected T19_Validate_Data As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T6_Data_Up_To_Date refines the FlowProperty Data_Up_To_Date.
    Protected T6_Data_Up_To_Date As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort D4_Con_tmax_Response_MDM provides the configured value of Con_tmax_Response_MDM.
    Protected D4_Con_tmax_Response_MDM As OInputPort(Of Integer)
    ' The FlowPort T7_Data_Not_Up_To_Date refines the FlowProperty Data_Not_Up_To_Date.
    Protected T7_Data_Not_Up_To_Date As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T20_Ready_For_Update_Of_Data refines the FlowProperty Ready_For_Update_Of_Data.
    Protected T20_Ready_For_Update_Of_Data As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T8_Data refines the FlowProperty Data.
    Protected T8_Data As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort D5_Con_tmax_DataTransmission provides the configured value of Con_tmax_DataTransmission.
    Protected D5_Con_tmax_DataTransmission As OInputPort(Of Integer)
    ' The FlowPort T9_Transmission_Complete refines the FlowProperty Transmission_Complete.
    Protected T9_Transmission_Complete As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T10_Data_Valid indicates, that the EULYNX field element Subsystem detected, that data was transmitted correctly.
    Protected T10_Data_Valid As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T11_Data_Invalid indicates, that the EULYNX field element Subsystem detected, that the transmitted data was not transmitted correctly.
    Protected T11_Data_Invalid As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T12_Data_Installation_Successfully indicates, that the EULYNX field element Subsystem detected, that the installation of the received data has completed successfully.
    Protected T12_Data_Installation_Successfully As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T16_Data_Installation_Complete As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T21_Data_Update_Finished As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T14_Data_Update_After_Operational As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort D1_Con_t_Ini_Def_Delay provides the time value Con_t_Ini_Def_Delay.
    Protected D1_Con_t_Ini_Def_Delay As OInputPort(Of Integer)
    ' The FlowPort D2_Con_t_Ini_Step provides the time value Con_t_Ini_Step.
    Protected D2_Con_t_Ini_Step As OInputPort(Of Integer)
    Private Mem_t_Ini_Delay As Integer
    ' The FlowPort D3_Con_t_Ini_Max provides the time value Con_t_Ini_Max.
    Protected D3_Con_t_Ini_Max As OInputPort(Of Integer)
    Protected T13_Data_Update_After_Booting As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T15_Data_Update_In_Initialising As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T22_Data_Update_Stop As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The operation cOp1_init initialises all output ports and block properties.
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' T16_Data_Installation_Complete := FALSE;
    ' T19_Validate_Data := FALSE;
    ' T20_Ready_For_Update_Of_Data := FALSE;
    ' T21_Data_Update_Finished := FALSE;
    Public Sub cOp1_init()
      T16_Data_Installation_Complete.SetValue(False)
      T19_Validate_Data.SetValue(False)
      T20_Ready_For_Update_Of_Data.SetValue(False)
      T21_Data_Update_Finished.SetValue(False)
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' pInstance.RtsCHECKING_UP_TO_DATENESS_Timer1();
    Private Shared Sub RtsCHECKING_UP_TO_DATENESS_Timer1_CallBack(ByRef pInstance As F_SMI_EfeS_SR)
      pInstance.RtsCHECKING_UP_TO_DATENESS_Timer1()
    End Sub
    
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' pInstance.RtsDELAY_TIME_EXPIRING_Timer1();
    Private Shared Sub RtsDELAY_TIME_EXPIRING_Timer1_CallBack(ByRef pInstance As F_SMI_EfeS_SR)
      pInstance.RtsDELAY_TIME_EXPIRING_Timer1()
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' pInstance.RtsDATA_TRANSMISSION_Timer1();
    Private Shared Sub RtsDATA_TRANSMISSION_Timer1_CallBack(ByRef pInstance As F_SMI_EfeS_SR)
      pInstance.RtsDATA_TRANSMISSION_Timer1()
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' assume RtsCurrent_F_SMI_EfeS_SR: on object;
    ' assume RtsCurrent_DATA_UPDATE: on object;
    ' assume RtsAttCHECKING_UP_TO_DATENESS_Timer1: on object;
    ' assume RtsAttDELAY_TIME_EXPIRING_Timer1: on object;
    ' assume RtsCurrent_DATA_TRANSMISSION: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA then
    ' /* #REF123# */
    ' 	/* c59ea63a-29d5-489c-808a-2a9c8fa73e40 WAITING_FOR_DATA */
    '   ThisState := "c59ea63a-29d5-489c-808a-2a9c8fa73e40";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_DATA */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_DATA();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"319b2830-5c84-4f84-80c5-d27d0ab5ac1a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT ee9ab581-4a3f-48c4-bd1a-57f8440dd1a9 */  nullstat;/*##END ee9ab581-4a3f-48c4-bd1a-57f8440dd1a9 */ /* #REF1546# */
    ' 		This.RtsEnter_RECEIVING_DATA();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA then
    ' /* #REF123# */
    ' 	/* 08f0de2c-1e86-4997-be9c-c226bc320f61 RECEIVING_DATA */
    '   ThisState := "08f0de2c-1e86-4997-be9c-c226bc320f61";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_RECEIVING_DATA */
    ' 		/* standard */
    ' 		This.RtsExit_RECEIVING_DATA();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"af2a229b-7493-41cf-a2d8-cba74bed640c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT e3d043c8-a5e6-41e0-8f70-7d262ecaffce */  nullstat;/*##END e3d043c8-a5e6-41e0-8f70-7d262ecaffce */ /* #REF1546# */
    ' 		This.RtsEnter_CHECKING_DATA();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA then
    ' /* #REF123# */
    ' 	/* 813bfdce-3db3-4883-bd4a-dd891fe49cc7 CHECKING_DATA */
    '   ThisState := "813bfdce-3db3-4883-bd4a-dd891fe49cc7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_TRANSMISSION */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_TRANSMISSION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c3c8da66-46aa-497b-bf03-b1af19af3913",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f555f1c2-e09a-441a-aa43-ad614a26756b */  nullstat;/*##END f555f1c2-e09a-441a-aa43-ad614a26756b */ /* #REF1546# */
    ' 		This.RtsEnter_INSTALLING_DATA();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA then
    ' /* #REF123# */
    ' 	/* 813bfdce-3db3-4883-bd4a-dd891fe49cc7 CHECKING_DATA */
    '   ThisState := "813bfdce-3db3-4883-bd4a-dd891fe49cc7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */ (( D2_Con_t_Ini_Step <= Mem_t_Ini_Delay ) AND 
    ' ( Mem_t_Ini_Delay < D3_Con_t_Ini_Max ))/*##END 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"066c24e4-3d9c-4dc6-869d-6a209d6807b7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT b31cdab8-9a34-4cc9-b566-688374750f08 */  nullstat;/*##END b31cdab8-9a34-4cc9-b566-688374750f08 */ /* #REF1544# */
    ' 	/*##STRT 928c670f-11e8-420d-a611-2b01cc96ecda */ 
    '  Mem_t_Ini_Delay := Mem_t_Ini_Delay + D2_Con_t_Ini_Step ; nullstat;/*##END 928c670f-11e8-420d-a611-2b01cc96ecda */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA then
    ' /* #REF123# */
    ' 	/* 813bfdce-3db3-4883-bd4a-dd891fe49cc7 CHECKING_DATA */
    '   ThisState := "813bfdce-3db3-4883-bd4a-dd891fe49cc7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT c74150c6-b437-4139-977a-0b0e47be0c41 */ ( Mem_t_Ini_Delay >= D3_Con_t_Ini_Max )/*##END c74150c6-b437-4139-977a-0b0e47be0c41 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6c40d2b2-de44-4469-b51d-5f14d1c345e5",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT b31cdab8-9a34-4cc9-b566-688374750f08 */  nullstat;/*##END b31cdab8-9a34-4cc9-b566-688374750f08 */ /* #REF1544# */
    ' 	/*##STRT aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ 
    '  Mem_t_Ini_Delay := D3_Con_t_Ini_Max ; nullstat;/*##END aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA then
    ' /* #REF123# */
    ' 	/* 813bfdce-3db3-4883-bd4a-dd891fe49cc7 CHECKING_DATA */
    '   ThisState := "813bfdce-3db3-4883-bd4a-dd891fe49cc7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT c567a5e1-1efa-4add-8114-72a15b3575ac */ ((0 = Mem_t_Ini_Delay ) OR
    ' ( Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay ))/*##END c567a5e1-1efa-4add-8114-72a15b3575ac */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"764e0d19-feb7-48f9-82e2-613f06fad06a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT b31cdab8-9a34-4cc9-b566-688374750f08 */  nullstat;/*##END b31cdab8-9a34-4cc9-b566-688374750f08 */ /* #REF1544# */
    ' 	/*##STRT 6325d39a-3f11-4f24-9933-917545e2a991 */ 
    '  Mem_t_Ini_Delay := D2_Con_t_Ini_Step ; nullstat;/*##END 6325d39a-3f11-4f24-9933-917545e2a991 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS then
    ' /* #REF123# */
    ' 	/* 2d391355-f891-46bf-a56d-93a0361b8288 CHECKING_UP_TO_DATENESS */
    '   ThisState := "2d391355-f891-46bf-a56d-93a0361b8288";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_CHECKING_UP_TO_DATENESS */
    ' 		/* standard */
    ' 		This.RtsExit_CHECKING_UP_TO_DATENESS();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"05f7e693-f5a3-4eb3-8ae8-af059395fddb",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 42a8a14f-3ec7-4d3e-9d47-7535ab4a27fe */ 
    '  T21_Data_Update_Finished := TRUE; nullstat;/*##END 42a8a14f-3ec7-4d3e-9d47-7535ab4a27fe */ /* #REF1546# */
    ' 		This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE;/* #REF1552# */
    ' 		// Simulation support : Notification function call for entering final state/* #REF1553# */
    ' 		RtsNotify(This,SENTER,"ddeb1d69-2891-4582-a28a-9e4addbedbd4",0,NullString);RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS then
    ' /* #REF123# */
    ' 	/* 2d391355-f891-46bf-a56d-93a0361b8288 CHECKING_UP_TO_DATENESS */
    '   ThisState := "2d391355-f891-46bf-a56d-93a0361b8288";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_CHECKING_UP_TO_DATENESS */
    ' 		/* standard */
    ' 		This.RtsExit_CHECKING_UP_TO_DATENESS();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"121edbaf-2966-46d7-a275-36cc9f601f3a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 74ad398e-8735-4a7d-8362-ee0bd3e4735b */ 
    '  T20_Ready_For_Update_Of_Data := TRUE; nullstat;/*##END 74ad398e-8735-4a7d-8362-ee0bd3e4735b */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_TRANSMISSION();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA then
    ' /* #REF123# */
    ' 	/* e5a5c9fe-4326-4b40-9e4a-372d37180ea7 INSTALLING_DATA */
    '   ThisState := "e5a5c9fe-4326-4b40-9e4a-372d37180ea7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_INSTALLING_DATA */
    ' 		/* standard */
    ' 		This.RtsExit_INSTALLING_DATA();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"a3ec39b5-3a39-4287-bf67-0b55fe51aa29",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c5acbcb6-08eb-49e6-aaae-e11e583eec86 */ 
    '  T16_Data_Installation_Complete := TRUE; nullstat;/*##END c5acbcb6-08eb-49e6-aaae-e11e583eec86 */ /* #REF1546# */
    ' 		This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE;/* #REF1552# */
    ' 		// Simulation support : Notification function call for entering final state/* #REF1553# */
    ' 		RtsNotify(This,SENTER,"5db9752c-cc79-4a22-afff-b4e1251f5092",0,NullString);RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE /* #REF121a# */ and This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE then
    ' /* #REF123# */
    ' 	/* c4f7e728-9cca-41a7-8750-fba8ff7a93bb DATA_UPDATE */
    '   ThisState := "c4f7e728-9cca-41a7-8750-fba8ff7a93bb";
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 	/* standard */
    ' 	This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"c92fa080-2671-48da-a44b-7f8238fdb082",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT d1377203-6d64-4a2b-8034-8b225a9f0dcc */  nullstat;/*##END d1377203-6d64-4a2b-8034-8b225a9f0dcc */ /* #REF1546# */
    ' 	This.RtsEnter_IDLE();/* #REF1590# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE then
    ' /* #REF123# */
    ' 	/* c4f7e728-9cca-41a7-8750-fba8ff7a93bb DATA_UPDATE */
    '   ThisState := "c4f7e728-9cca-41a7-8750-fba8ff7a93bb";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"89d1bd39-c3d3-464a-a293-e12f8cebecc0",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5d21cfd9-1876-4ee8-aa51-aaa6b62d6c2f */  nullstat;/*##END 5d21cfd9-1876-4ee8-aa51-aaa6b62d6c2f */ /* #REF1546# */
    ' 		This.RtsEnter_IDLE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then
    ' /* #REF123# */
    ' 	/* 87160484-66d7-40df-87e3-8dc777d3c84d IDLE */
    '   ThisState := "87160484-66d7-40df-87e3-8dc777d3c84d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_IDLE */
    ' 		/* standard */
    ' 		This.RtsExit_IDLE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"4be447c0-ab5a-494c-8163-8b1572873158",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5e78f3e0-f41f-4cb2-9dda-f2d9e6c4f0c4 */ 
    '  Mem_t_Ini_Delay := 0; nullstat;/*##END 5e78f3e0-f41f-4cb2-9dda-f2d9e6c4f0c4 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then
    ' /* #REF123# */
    ' 	/* 87160484-66d7-40df-87e3-8dc777d3c84d IDLE */
    '   ThisState := "87160484-66d7-40df-87e3-8dc777d3c84d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_IDLE */
    ' 		/* standard */
    ' 		This.RtsExit_IDLE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"bb05ccab-1669-4a78-b0a3-fdaace5f12eb",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 788e7da1-9ae1-4cbe-ac6a-0ad026cb8fa3 */ 
    '  Mem_t_Ini_Delay := D1_Con_t_Ini_Def_Delay ; nullstat;/*##END 788e7da1-9ae1-4cbe-ac6a-0ad026cb8fa3 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then
    ' /* #REF123# */
    ' 	/* 87160484-66d7-40df-87e3-8dc777d3c84d IDLE */
    '   ThisState := "87160484-66d7-40df-87e3-8dc777d3c84d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */ (( D2_Con_t_Ini_Step <= Mem_t_Ini_Delay ) AND 
    ' ( Mem_t_Ini_Delay < D3_Con_t_Ini_Max ))/*##END 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_IDLE */
    ' 		/* standard */
    ' 		This.RtsExit_IDLE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b89cc6c4-638f-41a3-968b-7a41fd3dfadf",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"066c24e4-3d9c-4dc6-869d-6a209d6807b7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c0362077-13b4-42b4-b387-60cc122e7bb1 */  nullstat;/*##END c0362077-13b4-42b4-b387-60cc122e7bb1 */ /* #REF1544# */
    ' 	/*##STRT 928c670f-11e8-420d-a611-2b01cc96ecda */ 
    '  Mem_t_Ini_Delay := Mem_t_Ini_Delay + D2_Con_t_Ini_Step ; nullstat;/*##END 928c670f-11e8-420d-a611-2b01cc96ecda */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then
    ' /* #REF123# */
    ' 	/* 87160484-66d7-40df-87e3-8dc777d3c84d IDLE */
    '   ThisState := "87160484-66d7-40df-87e3-8dc777d3c84d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT c74150c6-b437-4139-977a-0b0e47be0c41 */ ( Mem_t_Ini_Delay >= D3_Con_t_Ini_Max )/*##END c74150c6-b437-4139-977a-0b0e47be0c41 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_IDLE */
    ' 		/* standard */
    ' 		This.RtsExit_IDLE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b89cc6c4-638f-41a3-968b-7a41fd3dfadf",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6c40d2b2-de44-4469-b51d-5f14d1c345e5",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c0362077-13b4-42b4-b387-60cc122e7bb1 */  nullstat;/*##END c0362077-13b4-42b4-b387-60cc122e7bb1 */ /* #REF1544# */
    ' 	/*##STRT aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ 
    '  Mem_t_Ini_Delay := D3_Con_t_Ini_Max ; nullstat;/*##END aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then
    ' /* #REF123# */
    ' 	/* 87160484-66d7-40df-87e3-8dc777d3c84d IDLE */
    '   ThisState := "87160484-66d7-40df-87e3-8dc777d3c84d";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT c567a5e1-1efa-4add-8114-72a15b3575ac */ ((0 = Mem_t_Ini_Delay ) OR
    ' ( Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay ))/*##END c567a5e1-1efa-4add-8114-72a15b3575ac */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_IDLE */
    ' 		/* standard */
    ' 		This.RtsExit_IDLE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b89cc6c4-638f-41a3-968b-7a41fd3dfadf",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"764e0d19-feb7-48f9-82e2-613f06fad06a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT c0362077-13b4-42b4-b387-60cc122e7bb1 */  nullstat;/*##END c0362077-13b4-42b4-b387-60cc122e7bb1 */ /* #REF1544# */
    ' 	/*##STRT 6325d39a-3f11-4f24-9933-917545e2a991 */ 
    '  Mem_t_Ini_Delay := D2_Con_t_Ini_Step ; nullstat;/*##END 6325d39a-3f11-4f24-9933-917545e2a991 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_F_SMI_EfeS_SR =  /* #REF121d# */ RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_NotIn_F_SMI_EfeS_SR then
    ' /* #REF123# */
    ' 	/* 5cb51e72-a568-4255-a0a1-6449aa2a9e3b Initial0 */
    '   ThisState := "5cb51e72-a568-4255-a0a1-6449aa2a9e3b";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"5cb51e72-a568-4255-a0a1-6449aa2a9e3b",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"5cb51e72-a568-4255-a0a1-6449aa2a9e3b",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"b543082b-36c3-43af-8564-b101f7d28275",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 67288800-dbe5-4700-ae8a-4804cf40cd3b */  cOp1_init (); nullstat;/*##END 67288800-dbe5-4700-ae8a-4804cf40cd3b */ /* #REF1546# */
    ' 	This.RtsEnter_IDLE();/* #REF1590# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA Then
        ThisState = "c59ea63a-29d5-489c-808a-2a9c8fa73e40"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_WAITING_FOR_DATA()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "319b2830-5c84-4f84-80c5-d27d0ab5ac1a", 0, NullString)
          Me.RtsEnter_RECEIVING_DATA()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA Then
        ThisState = "08f0de2c-1e86-4997-be9c-c226bc320f61"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          Me.RtsExit_RECEIVING_DATA()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "af2a229b-7493-41cf-a2d8-cba74bed640c", 0, NullString)
          Me.RtsEnter_CHECKING_DATA()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA Then
        ThisState = "813bfdce-3db3-4883-bd4a-dd891fe49cc7"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          Me.RtsExit_DATA_TRANSMISSION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c3c8da66-46aa-497b-bf03-b1af19af3913", 0, NullString)
          Me.RtsEnter_INSTALLING_DATA()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA Then
        ThisState = "813bfdce-3db3-4883-bd4a-dd891fe49cc7"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) And ((D2_Con_t_Ini_Step.GetLatchedValue() <= Mem_t_Ini_Delay) And (Mem_t_Ini_Delay < D3_Con_t_Ini_Max.GetLatchedValue())) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "066c24e4-3d9c-4dc6-869d-6a209d6807b7", 0, NullString)
          Mem_t_Ini_Delay = Mem_t_Ini_Delay + D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA Then
        ThisState = "813bfdce-3db3-4883-bd4a-dd891fe49cc7"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) And (Mem_t_Ini_Delay >= D3_Con_t_Ini_Max.GetLatchedValue()) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6c40d2b2-de44-4469-b51d-5f14d1c345e5", 0, NullString)
          Mem_t_Ini_Delay = D3_Con_t_Ini_Max.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA Then
        ThisState = "813bfdce-3db3-4883-bd4a-dd891fe49cc7"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) And ((0 = Mem_t_Ini_Delay) Or (Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay.GetLatchedValue())) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6a5e66c8-b4fa-49ea-9bbe-83d10a4872a2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "764e0d19-feb7-48f9-82e2-613f06fad06a", 0, NullString)
          Mem_t_Ini_Delay = D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS Then
        ThisState = "2d391355-f891-46bf-a56d-93a0361b8288"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_CHECKING_UP_TO_DATENESS()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "05f7e693-f5a3-4eb3-8ae8-af059395fddb", 0, NullString)
          T21_Data_Update_Finished.SetValue(True)
          Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
          'Simulation support : Notification function call for entering final state/* #REF1553# */
          RtsNotify(Me, SENTER, "ddeb1d69-2891-4582-a28a-9e4addbedbd4", 0, NullString)
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS Then
        ThisState = "2d391355-f891-46bf-a56d-93a0361b8288"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          Me.RtsExit_CHECKING_UP_TO_DATENESS()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "121edbaf-2966-46d7-a275-36cc9f601f3a", 0, NullString)
          T20_Ready_For_Update_Of_Data.SetValue(True)
          Me.RtsDefault_DATA_TRANSMISSION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA Then
        ThisState = "e5a5c9fe-4326-4b40-9e4a-372d37180ea7"
        If SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_INSTALLING_DATA()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "a3ec39b5-3a39-4287-bf67-0b55fe51aa29", 0, NullString)
          T16_Data_Installation_Complete.SetValue(True)
          Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
          'Simulation support : Notification function call for entering final state/* #REF1553# */
          RtsNotify(Me, SENTER, "5db9752c-cc79-4a22-afff-b4e1251f5092", 0, NullString)
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE And Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE Then
        ThisState = "c4f7e728-9cca-41a7-8750-fba8ff7a93bb"
        Me.RtsExit_DATA_UPDATE()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "c92fa080-2671-48da-a44b-7f8238fdb082", 0, NullString)
        Me.RtsEnter_IDLE()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE Then
        ThisState = "c4f7e728-9cca-41a7-8750-fba8ff7a93bb"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "89d1bd39-c3d3-464a-a293-e12f8cebecc0", 0, NullString)
          Me.RtsEnter_IDLE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        ThisState = "87160484-66d7-40df-87e3-8dc777d3c84d"
        If SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_IDLE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "4be447c0-ab5a-494c-8163-8b1572873158", 0, NullString)
          Mem_t_Ini_Delay = 0
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        ThisState = "87160484-66d7-40df-87e3-8dc777d3c84d"
        If SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) Then
          Me.RtsExit_IDLE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "bb05ccab-1669-4a78-b0a3-fdaace5f12eb", 0, NullString)
          Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        ThisState = "87160484-66d7-40df-87e3-8dc777d3c84d"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) And ((D2_Con_t_Ini_Step.GetLatchedValue() <= Mem_t_Ini_Delay) And (Mem_t_Ini_Delay < D3_Con_t_Ini_Max.GetLatchedValue())) Then
          Me.RtsExit_IDLE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b89cc6c4-638f-41a3-968b-7a41fd3dfadf", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "066c24e4-3d9c-4dc6-869d-6a209d6807b7", 0, NullString)
          Mem_t_Ini_Delay = Mem_t_Ini_Delay + D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        ThisState = "87160484-66d7-40df-87e3-8dc777d3c84d"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) And (Mem_t_Ini_Delay >= D3_Con_t_Ini_Max.GetLatchedValue()) Then
          Me.RtsExit_IDLE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b89cc6c4-638f-41a3-968b-7a41fd3dfadf", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6c40d2b2-de44-4469-b51d-5f14d1c345e5", 0, NullString)
          Mem_t_Ini_Delay = D3_Con_t_Ini_Max.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        ThisState = "87160484-66d7-40df-87e3-8dc777d3c84d"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) And ((0 = Mem_t_Ini_Delay) Or (Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay.GetLatchedValue())) Then
          Me.RtsExit_IDLE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b89cc6c4-638f-41a3-968b-7a41fd3dfadf", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "764e0d19-feb7-48f9-82e2-613f06fad06a", 0, NullString)
          Mem_t_Ini_Delay = D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_NotIn_F_SMI_EfeS_SR Then
        ThisState = "5cb51e72-a568-4255-a0a1-6449aa2a9e3b"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "5cb51e72-a568-4255-a0a1-6449aa2a9e3b", 0, NullString)
        RtsNotify(Me, SEXIT, "5cb51e72-a568-4255-a0a1-6449aa2a9e3b", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "b543082b-36c3-43af-8564-b101f7d28275", 0, NullString)
        cOp1_init()
        Me.RtsEnter_IDLE()
        RetValue = True
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "c85bd739-1eb9-4db7-984f-2211f2c8d44e", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttCHECKING_UP_TO_DATENESS_Timer1);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttDELAY_TIME_EXPIRING_Timer1);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttDATA_TRANSMISSION_Timer1);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_F_SMI_EfeS_SR := RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_NotIn_F_SMI_EfeS_SR;/* #REF1566# */
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE;/* #REF1566# */
    ' This.RtsCurrent_DATA_TRANSMISSION := RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_NotIn_DATA_TRANSMISSION;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "c85bd739-1eb9-4db7-984f-2211f2c8d44e", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttDELAY_TIME_EXPIRING_Timer1)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttDATA_TRANSMISSION_Timer1)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_NotIn_F_SMI_EfeS_SR
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
      Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_NotIn_DATA_TRANSMISSION
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_UPDATE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("c4f7e728-9cca-41a7-8750-fba8ff7a93bb|") then
    '   OperatedStates := OperatedStates + "c4f7e728-9cca-41a7-8750-fba8ff7a93bb|";
    ' end if
    ' // Simulation support : Notification function call for entering state : DATA_UPDATE ///* #REF520# */
    ' RtsNotify(This,SENTER,"c4f7e728-9cca-41a7-8750-fba8ff7a93bb",0,NullString);
    ' 
    ' SimCore.EnterState("c4f7e728-9cca-41a7-8750-fba8ff7a93bb","DATA_UPDATE");
    ' 
    ' This.RtsCurrent_F_SMI_EfeS_SR := RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE;/* #REF521# */
    ' 
    Private Sub RtsEnter_DATA_UPDATE()
      If not OperatedStates.Contains("c4f7e728-9cca-41a7-8750-fba8ff7a93bb|") Then
        OperatedStates = OperatedStates + "c4f7e728-9cca-41a7-8750-fba8ff7a93bb|"
      End If
      'Simulation support : Notification function call for entering state : DATA_UPDATE ///* #REF520# */
      RtsNotify(Me, SENTER, "c4f7e728-9cca-41a7-8750-fba8ff7a93bb", 0, NullString)
      SimCore.EnterState("c4f7e728-9cca-41a7-8750-fba8ff7a93bb", "DATA_UPDATE")
      Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE
    End Sub
    
    ' \ART_SMG :: Created for state : IDLE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("87160484-66d7-40df-87e3-8dc777d3c84d|") then
    '   OperatedStates := OperatedStates + "87160484-66d7-40df-87e3-8dc777d3c84d|";
    ' end if
    ' // Simulation support : Notification function call for entering state : IDLE ///* #REF520# */
    ' RtsNotify(This,SENTER,"87160484-66d7-40df-87e3-8dc777d3c84d",0,NullString);
    ' 
    ' SimCore.EnterState("87160484-66d7-40df-87e3-8dc777d3c84d","IDLE");
    ' 
    ' This.RtsCurrent_F_SMI_EfeS_SR := RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE;/* #REF521# */
    ' 
    Private Sub RtsEnter_IDLE()
      If not OperatedStates.Contains("87160484-66d7-40df-87e3-8dc777d3c84d|") Then
        OperatedStates = OperatedStates + "87160484-66d7-40df-87e3-8dc777d3c84d|"
      End If
      'Simulation support : Notification function call for entering state : IDLE ///* #REF520# */
      RtsNotify(Me, SENTER, "87160484-66d7-40df-87e3-8dc777d3c84d", 0, NullString)
      SimCore.EnterState("87160484-66d7-40df-87e3-8dc777d3c84d", "IDLE")
      Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("2d391355-f891-46bf-a56d-93a0361b8288|") then
    '   OperatedStates := OperatedStates + "2d391355-f891-46bf-a56d-93a0361b8288|";
    ' end if
    ' // Simulation support : Notification function call for entering state : CHECKING_UP_TO_DATENESS ///* #REF520# */
    ' RtsNotify(This,SENTER,"2d391355-f891-46bf-a56d-93a0361b8288",0,NullString);
    ' 
    ' SimCore.EnterState("2d391355-f891-46bf-a56d-93a0361b8288","DATA_UPDATE::CHECKING_UP_TO_DATENESS");
    ' 
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS;/* #REF521# */
    ' /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttCHECKING_UP_TO_DATENESS_Timer1, /*##STRT 4086309a-90a9-470e-ad55-31a55928c9c9 */ D4_Con_tmax_Response_MDM/*##END 4086309a-90a9-470e-ad55-31a55928c9c9 */ , CurrentTime);
    Private Sub RtsEnter_CHECKING_UP_TO_DATENESS()
      If not OperatedStates.Contains("2d391355-f891-46bf-a56d-93a0361b8288|") Then
        OperatedStates = OperatedStates + "2d391355-f891-46bf-a56d-93a0361b8288|"
      End If
      'Simulation support : Notification function call for entering state : CHECKING_UP_TO_DATENESS ///* #REF520# */
      RtsNotify(Me, SENTER, "2d391355-f891-46bf-a56d-93a0361b8288", 0, NullString)
      SimCore.EnterState("2d391355-f891-46bf-a56d-93a0361b8288", "DATA_UPDATE::CHECKING_UP_TO_DATENESS")
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1, D4_Con_tmax_Response_MDM.GetLatchedValue(), CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : INSTALLING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("e5a5c9fe-4326-4b40-9e4a-372d37180ea7|") then
    '   OperatedStates := OperatedStates + "e5a5c9fe-4326-4b40-9e4a-372d37180ea7|";
    ' end if
    ' // Simulation support : Notification function call for entering state : INSTALLING_DATA ///* #REF520# */
    ' RtsNotify(This,SENTER,"e5a5c9fe-4326-4b40-9e4a-372d37180ea7",0,NullString);
    ' 
    ' SimCore.EnterState("e5a5c9fe-4326-4b40-9e4a-372d37180ea7","DATA_UPDATE::INSTALLING_DATA");
    ' 
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA;/* #REF521# */
    ' 
    Private Sub RtsEnter_INSTALLING_DATA()
      If not OperatedStates.Contains("e5a5c9fe-4326-4b40-9e4a-372d37180ea7|") Then
        OperatedStates = OperatedStates + "e5a5c9fe-4326-4b40-9e4a-372d37180ea7|"
      End If
      'Simulation support : Notification function call for entering state : INSTALLING_DATA ///* #REF520# */
      RtsNotify(Me, SENTER, "e5a5c9fe-4326-4b40-9e4a-372d37180ea7", 0, NullString)
      SimCore.EnterState("e5a5c9fe-4326-4b40-9e4a-372d37180ea7", "DATA_UPDATE::INSTALLING_DATA")
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA
    End Sub
    
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("de3995eb-00b4-4558-9c41-6b19e0b0cece|") then
    '   OperatedStates := OperatedStates + "de3995eb-00b4-4558-9c41-6b19e0b0cece|";
    ' end if
    ' // Simulation support : Notification function call for entering state : DELAY_TIME_EXPIRING ///* #REF520# */
    ' RtsNotify(This,SENTER,"de3995eb-00b4-4558-9c41-6b19e0b0cece",0,NullString);
    ' 
    ' SimCore.EnterState("de3995eb-00b4-4558-9c41-6b19e0b0cece","DATA_UPDATE::DELAY_TIME_EXPIRING");
    ' 
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING;/* #REF521# */
    ' /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttDELAY_TIME_EXPIRING_Timer1, /*##STRT b11f8ad6-9bee-4223-bb9b-570efdbccccf */ Mem_t_Ini_Delay/*##END b11f8ad6-9bee-4223-bb9b-570efdbccccf */ , CurrentTime);
    Private Sub RtsEnter_DELAY_TIME_EXPIRING()
      If not OperatedStates.Contains("de3995eb-00b4-4558-9c41-6b19e0b0cece|") Then
        OperatedStates = OperatedStates + "de3995eb-00b4-4558-9c41-6b19e0b0cece|"
      End If
      'Simulation support : Notification function call for entering state : DELAY_TIME_EXPIRING ///* #REF520# */
      RtsNotify(Me, SENTER, "de3995eb-00b4-4558-9c41-6b19e0b0cece", 0, NullString)
      SimCore.EnterState("de3995eb-00b4-4558-9c41-6b19e0b0cece", "DATA_UPDATE::DELAY_TIME_EXPIRING")
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttDELAY_TIME_EXPIRING_Timer1, Mem_t_Ini_Delay, CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("d31ecea0-d545-4b72-92dc-9382d98c5234|") then
    '   OperatedStates := OperatedStates + "d31ecea0-d545-4b72-92dc-9382d98c5234|";
    ' end if
    ' // Simulation support : Notification function call for entering state : DATA_TRANSMISSION ///* #REF520# */
    ' RtsNotify(This,SENTER,"d31ecea0-d545-4b72-92dc-9382d98c5234",0,NullString);
    ' 
    ' SimCore.EnterState("d31ecea0-d545-4b72-92dc-9382d98c5234","DATA_UPDATE::DATA_TRANSMISSION");
    ' 
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION;/* #REF521# */
    ' /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttDATA_TRANSMISSION_Timer1, /*##STRT 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */ D5_Con_tmax_DataTransmission/*##END 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */ , CurrentTime);
    Private Sub RtsEnter_DATA_TRANSMISSION()
      If not OperatedStates.Contains("d31ecea0-d545-4b72-92dc-9382d98c5234|") Then
        OperatedStates = OperatedStates + "d31ecea0-d545-4b72-92dc-9382d98c5234|"
      End If
      'Simulation support : Notification function call for entering state : DATA_TRANSMISSION ///* #REF520# */
      RtsNotify(Me, SENTER, "d31ecea0-d545-4b72-92dc-9382d98c5234", 0, NullString)
      SimCore.EnterState("d31ecea0-d545-4b72-92dc-9382d98c5234", "DATA_UPDATE::DATA_TRANSMISSION")
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttDATA_TRANSMISSION_Timer1, D5_Con_tmax_DataTransmission.GetLatchedValue(), CurrentTime)
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("c59ea63a-29d5-489c-808a-2a9c8fa73e40|") then
    '   OperatedStates := OperatedStates + "c59ea63a-29d5-489c-808a-2a9c8fa73e40|";
    ' end if
    ' // Simulation support : Notification function call for entering state : WAITING_FOR_DATA ///* #REF520# */
    ' RtsNotify(This,SENTER,"c59ea63a-29d5-489c-808a-2a9c8fa73e40",0,NullString);
    ' 
    ' SimCore.EnterState("c59ea63a-29d5-489c-808a-2a9c8fa73e40","DATA_UPDATE::DATA_TRANSMISSION::WAITING_FOR_DATA");
    ' 
    ' This.RtsCurrent_DATA_TRANSMISSION := RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA;/* #REF521# */
    ' 
    Private Sub RtsEnter_WAITING_FOR_DATA()
      If not OperatedStates.Contains("c59ea63a-29d5-489c-808a-2a9c8fa73e40|") Then
        OperatedStates = OperatedStates + "c59ea63a-29d5-489c-808a-2a9c8fa73e40|"
      End If
      'Simulation support : Notification function call for entering state : WAITING_FOR_DATA ///* #REF520# */
      RtsNotify(Me, SENTER, "c59ea63a-29d5-489c-808a-2a9c8fa73e40", 0, NullString)
      SimCore.EnterState("c59ea63a-29d5-489c-808a-2a9c8fa73e40", "DATA_UPDATE::DATA_TRANSMISSION::WAITING_FOR_DATA")
      Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("08f0de2c-1e86-4997-be9c-c226bc320f61|") then
    '   OperatedStates := OperatedStates + "08f0de2c-1e86-4997-be9c-c226bc320f61|";
    ' end if
    ' // Simulation support : Notification function call for entering state : RECEIVING_DATA ///* #REF520# */
    ' RtsNotify(This,SENTER,"08f0de2c-1e86-4997-be9c-c226bc320f61",0,NullString);
    ' 
    ' SimCore.EnterState("08f0de2c-1e86-4997-be9c-c226bc320f61","DATA_UPDATE::DATA_TRANSMISSION::RECEIVING_DATA");
    ' 
    ' This.RtsCurrent_DATA_TRANSMISSION := RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA;/* #REF521# */
    ' 
    Private Sub RtsEnter_RECEIVING_DATA()
      If not OperatedStates.Contains("08f0de2c-1e86-4997-be9c-c226bc320f61|") Then
        OperatedStates = OperatedStates + "08f0de2c-1e86-4997-be9c-c226bc320f61|"
      End If
      'Simulation support : Notification function call for entering state : RECEIVING_DATA ///* #REF520# */
      RtsNotify(Me, SENTER, "08f0de2c-1e86-4997-be9c-c226bc320f61", 0, NullString)
      SimCore.EnterState("08f0de2c-1e86-4997-be9c-c226bc320f61", "DATA_UPDATE::DATA_TRANSMISSION::RECEIVING_DATA")
      Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("813bfdce-3db3-4883-bd4a-dd891fe49cc7|") then
    '   OperatedStates := OperatedStates + "813bfdce-3db3-4883-bd4a-dd891fe49cc7|";
    ' end if
    ' // Simulation support : Notification function call for entering state : CHECKING_DATA ///* #REF520# */
    ' RtsNotify(This,SENTER,"813bfdce-3db3-4883-bd4a-dd891fe49cc7",0,NullString);
    ' 
    ' SimCore.EnterState("813bfdce-3db3-4883-bd4a-dd891fe49cc7","DATA_UPDATE::DATA_TRANSMISSION::CHECKING_DATA");
    ' 
    ' This.RtsCurrent_DATA_TRANSMISSION := RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA;/* #REF521# */
    ' 
    Private Sub RtsEnter_CHECKING_DATA()
      If not OperatedStates.Contains("813bfdce-3db3-4883-bd4a-dd891fe49cc7|") Then
        OperatedStates = OperatedStates + "813bfdce-3db3-4883-bd4a-dd891fe49cc7|"
      End If
      'Simulation support : Notification function call for entering state : CHECKING_DATA ///* #REF520# */
      RtsNotify(Me, SENTER, "813bfdce-3db3-4883-bd4a-dd891fe49cc7", 0, NullString)
      SimCore.EnterState("813bfdce-3db3-4883-bd4a-dd891fe49cc7", "DATA_UPDATE::DATA_TRANSMISSION::CHECKING_DATA")
      Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_UPDATE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : DATA_UPDATE
    ' 	RtsNotify(This,SEXIT,"c4f7e728-9cca-41a7-8750-fba8ff7a93bb",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_DATA_UPDATE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_DATA_UPDATE()
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE Then
        'Simulation support : Notification function call for exiting state : DATA_UPDATE
        RtsNotify(Me, SEXIT, "c4f7e728-9cca-41a7-8750-fba8ff7a93bb", 0, NullString)
        RtsExitSSOf_DATA_UPDATE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : IDLE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_IDLE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : IDLE
    ' 	RtsNotify(This,SEXIT,"87160484-66d7-40df-87e3-8dc777d3c84d",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_IDLE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_IDLE()
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_IDLE Then
        'Simulation support : Notification function call for exiting state : IDLE
        RtsNotify(Me, SEXIT, "87160484-66d7-40df-87e3-8dc777d3c84d", 0, NullString)
        RtsExitSSOf_IDLE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : CHECKING_UP_TO_DATENESS
    ' 	RtsNotify(This,SEXIT,"2d391355-f891-46bf-a56d-93a0361b8288",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_CHECKING_UP_TO_DATENESS ();
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttCHECKING_UP_TO_DATENESS_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_CHECKING_UP_TO_DATENESS()
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS Then
        'Simulation support : Notification function call for exiting state : CHECKING_UP_TO_DATENESS
        RtsNotify(Me, SEXIT, "2d391355-f891-46bf-a56d-93a0361b8288", 0, NullString)
        RtsExitSSOf_CHECKING_UP_TO_DATENESS()
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : INSTALLING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : INSTALLING_DATA
    ' 	RtsNotify(This,SEXIT,"e5a5c9fe-4326-4b40-9e4a-372d37180ea7",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_INSTALLING_DATA ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_INSTALLING_DATA()
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA Then
        'Simulation support : Notification function call for exiting state : INSTALLING_DATA
        RtsNotify(Me, SEXIT, "e5a5c9fe-4326-4b40-9e4a-372d37180ea7", 0, NullString)
        RtsExitSSOf_INSTALLING_DATA()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : DELAY_TIME_EXPIRING
    ' 	RtsNotify(This,SEXIT,"de3995eb-00b4-4558-9c41-6b19e0b0cece",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_DELAY_TIME_EXPIRING ();
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttDELAY_TIME_EXPIRING_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_DELAY_TIME_EXPIRING()
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING Then
        'Simulation support : Notification function call for exiting state : DELAY_TIME_EXPIRING
        RtsNotify(Me, SEXIT, "de3995eb-00b4-4558-9c41-6b19e0b0cece", 0, NullString)
        RtsExitSSOf_DELAY_TIME_EXPIRING()
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttDELAY_TIME_EXPIRING_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : DATA_TRANSMISSION
    ' 	RtsNotify(This,SEXIT,"d31ecea0-d545-4b72-92dc-9382d98c5234",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_DATA_TRANSMISSION ();
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttDATA_TRANSMISSION_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_DATA_TRANSMISSION()
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION Then
        'Simulation support : Notification function call for exiting state : DATA_TRANSMISSION
        RtsNotify(Me, SEXIT, "d31ecea0-d545-4b72-92dc-9382d98c5234", 0, NullString)
        RtsExitSSOf_DATA_TRANSMISSION()
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttDATA_TRANSMISSION_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : WAITING_FOR_DATA
    ' 	RtsNotify(This,SEXIT,"c59ea63a-29d5-489c-808a-2a9c8fa73e40",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_WAITING_FOR_DATA ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_WAITING_FOR_DATA()
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA Then
        'Simulation support : Notification function call for exiting state : WAITING_FOR_DATA
        RtsNotify(Me, SEXIT, "c59ea63a-29d5-489c-808a-2a9c8fa73e40", 0, NullString)
        RtsExitSSOf_WAITING_FOR_DATA()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : RECEIVING_DATA
    ' 	RtsNotify(This,SEXIT,"08f0de2c-1e86-4997-be9c-c226bc320f61",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_RECEIVING_DATA ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_RECEIVING_DATA()
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA Then
        'Simulation support : Notification function call for exiting state : RECEIVING_DATA
        RtsNotify(Me, SEXIT, "08f0de2c-1e86-4997-be9c-c226bc320f61", 0, NullString)
        RtsExitSSOf_RECEIVING_DATA()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if This.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : CHECKING_DATA
    ' 	RtsNotify(This,SEXIT,"813bfdce-3db3-4883-bd4a-dd891fe49cc7",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_CHECKING_DATA ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_CHECKING_DATA()
      If Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA Then
        'Simulation support : Notification function call for exiting state : CHECKING_DATA
        RtsNotify(Me, SEXIT, "813bfdce-3db3-4883-bd4a-dd891fe49cc7", 0, NullString)
        RtsExitSSOf_CHECKING_DATA()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_UPDATE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"1b0b23bc-0ecb-41f8-9606-2dee42817468",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"1b0b23bc-0ecb-41f8-9606-2dee42817468",0,NullString);/* #REF1576# */
    ' This.RtsEnter_DATA_UPDATE();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"c38051b2-d20d-4c76-aa4b-f90acb318da2",0,NullString);/* #REF1585# */
    ' /*##STRT 363d7102-7f9d-40f1-908e-f8a5328f5f0b */  nullstat;/*##END 363d7102-7f9d-40f1-908e-f8a5328f5f0b */ /* #REF1546# */
    ' This.RtsEnter_DELAY_TIME_EXPIRING();/* #REF1590# */
    ' 
    Private Sub RtsDefault_DATA_UPDATE()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "1b0b23bc-0ecb-41f8-9606-2dee42817468", 0, NullString)
      RtsNotify(Me, SEXIT, "1b0b23bc-0ecb-41f8-9606-2dee42817468", 0, NullString)
      Me.RtsEnter_DATA_UPDATE()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "c38051b2-d20d-4c76-aa4b-f90acb318da2", 0, NullString)
      Me.RtsEnter_DELAY_TIME_EXPIRING()
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"8be354ff-7f3f-4f21-93bd-541801da9c89",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"8be354ff-7f3f-4f21-93bd-541801da9c89",0,NullString);/* #REF1576# */
    ' This.RtsEnter_DATA_TRANSMISSION();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"2aeee266-9d80-4489-89ee-cb251de9e204",0,NullString);/* #REF1585# */
    ' /*##STRT 6e17d5eb-a68a-48b6-b57b-e647fd3b3c4c */  nullstat;/*##END 6e17d5eb-a68a-48b6-b57b-e647fd3b3c4c */ /* #REF1546# */
    ' This.RtsEnter_WAITING_FOR_DATA();/* #REF1590# */
    ' 
    Private Sub RtsDefault_DATA_TRANSMISSION()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "8be354ff-7f3f-4f21-93bd-541801da9c89", 0, NullString)
      RtsNotify(Me, SEXIT, "8be354ff-7f3f-4f21-93bd-541801da9c89", 0, NullString)
      Me.RtsEnter_DATA_TRANSMISSION()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "2aeee266-9d80-4489-89ee-cb251de9e204", 0, NullString)
      Me.RtsEnter_WAITING_FOR_DATA()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As F_SMI_EfeS_SR)
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SMI_EfeS_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SMI_EfeS_SR, "RtsF_SMI_EfeS_SR_States");
    ' end if
    ' if Name = "RtsCurrent_DATA_UPDATE" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_UPDATE, "RtsF_SMI_EfeS_SRDATA_UPDATE_States");
    ' end if
    ' if Name = "RtsCurrent_DATA_TRANSMISSION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_TRANSMISSION, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_F_SMI_EfeS_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SMI_EfeS_SR, "RtsF_SMI_EfeS_SR_States");
    ' end if
    ' if Name = "RtsCurrent_DATA_UPDATE" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_UPDATE, "RtsF_SMI_EfeS_SRDATA_UPDATE_States");
    ' end if
    ' if Name = "RtsCurrent_DATA_TRANSMISSION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_TRANSMISSION, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "c85bd739-1eb9-4db7-984f-2211f2c8d44e";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "8";
    '   Value := Value + "|RtsCurrent_F_SMI_EfeS_SR";
    '   Value := Value + "|RtsCurrent_DATA_UPDATE";
    '   Value := Value + "|RtsCurrent_DATA_TRANSMISSION";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_F_SMI_EfeS_SR";
    '   Value := Value + "|RtsCurrent_DATA_UPDATE";
    '   Value := Value + "|RtsCurrent_DATA_TRANSMISSION";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As F_SMI_EfeS_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SMI_EfeS_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SMI_EfeS_SR, "RtsF_SMI_EfeS_SR_States")
      End If
      If Name = "RtsCurrent_DATA_UPDATE" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_UPDATE, "RtsF_SMI_EfeS_SRDATA_UPDATE_States")
      End If
      If Name = "RtsCurrent_DATA_TRANSMISSION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_TRANSMISSION, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_F_SMI_EfeS_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_F_SMI_EfeS_SR, "RtsF_SMI_EfeS_SR_States")
      End If
      If Name = "RtsCurrent_DATA_UPDATE" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_UPDATE, "RtsF_SMI_EfeS_SRDATA_UPDATE_States")
      End If
      If Name = "RtsCurrent_DATA_TRANSMISSION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_DATA_TRANSMISSION, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "c85bd739-1eb9-4db7-984f-2211f2c8d44e"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "8"
        Value = Value + "|RtsCurrent_F_SMI_EfeS_SR"
        Value = Value + "|RtsCurrent_DATA_UPDATE"
        Value = Value + "|RtsCurrent_DATA_TRANSMISSION"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_F_SMI_EfeS_SR"
        Value = Value + "|RtsCurrent_DATA_UPDATE"
        Value = Value + "|RtsCurrent_DATA_TRANSMISSION"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_F_SMI_EfeS_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SMI_EfeS_SR, Value, "RtsF_SMI_EfeS_SR_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SR_States));
    ' end if
    ' if Name = "RtsCurrent_DATA_UPDATE" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_DATA_UPDATE, Value, "RtsF_SMI_EfeS_SRDATA_UPDATE_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_UPDATE_States));
    ' end if
    ' if Name = "RtsCurrent_DATA_TRANSMISSION" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_DATA_TRANSMISSION, Value, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As F_SMI_EfeS_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_F_SMI_EfeS_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_F_SMI_EfeS_SR, Value, "RtsF_SMI_EfeS_SR_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SR_States))
      End If
      If Name = "RtsCurrent_DATA_UPDATE" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_DATA_UPDATE, Value, "RtsF_SMI_EfeS_SRDATA_UPDATE_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_UPDATE_States))
      End If
      If Name = "RtsCurrent_DATA_TRANSMISSION" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_DATA_TRANSMISSION, Value, "RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States", GetType(F_SMI_EfeS_SR.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttCHECKING_UP_TO_DATENESS_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsCHECKING_UP_TO_DATENESS_Timer1_In_F_SMI_EfeS_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsCHECKING_UP_TO_DATENESS_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsCHECKING_UP_TO_DATENESS_Timer1_In_F_SMI_EfeS_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttDELAY_TIME_EXPIRING_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsDELAY_TIME_EXPIRING_Timer1_In_F_SMI_EfeS_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsDELAY_TIME_EXPIRING_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttDELAY_TIME_EXPIRING_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsDELAY_TIME_EXPIRING_Timer1_In_F_SMI_EfeS_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttDATA_TRANSMISSION_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsDATA_TRANSMISSION_Timer1_In_F_SMI_EfeS_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsDATA_TRANSMISSION_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttDATA_TRANSMISSION_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsDATA_TRANSMISSION_Timer1_In_F_SMI_EfeS_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 DATA_UPDATE
    ' // H1 DATA_UPDATE - call into substate
    ' if This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsCHECKING_UP_TO_DATENESS_Timer1_In_DATA_UPDATE(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsCHECKING_UP_TO_DATENESS_Timer1_In_F_SMI_EfeS_SR(ByRef RetValue As Boolean)
      'H1 DATA_UPDATE
      'H1 DATA_UPDATE - call into substate
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE Then
        RtsCHECKING_UP_TO_DATENESS_Timer1_In_DATA_UPDATE(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 CHECKING_UP_TO_DATENESS
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS then/* #REF5# */
    ' /* #REF6# */
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_CHECKING_UP_TO_DATENESS */
    ' 	/* standard */
    ' 	This.RtsExit_CHECKING_UP_TO_DATENESS();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"ad4ce844-207f-4967-8bed-e9f40b2d7333",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 4086309a-90a9-470e-ad55-31a55928c9c9 */ 
    '  T21_Data_Update_Finished := TRUE; nullstat;/*##END 4086309a-90a9-470e-ad55-31a55928c9c9 */ /* #REF1546# */
    ' 	This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE;/* #REF1552# */
    ' 	// Simulation support : Notification function call for entering final state/* #REF1553# */
    ' 	RtsNotify(This,SENTER,"ddeb1d69-2891-4582-a28a-9e4addbedbd4",0,NullString);/* #REF13# */
    ' 	RetValue := true;
    ' 	return;
    ' 	/* #REF15# */
    ' end if
    ' // H1 DATA_TRANSMISSION
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsCHECKING_UP_TO_DATENESS_Timer1_In_DATA_UPDATE(ByRef RetValue As Boolean)
      'H1 CHECKING_UP_TO_DATENESS
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS Then
        Me.RtsExit_CHECKING_UP_TO_DATENESS()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "ad4ce844-207f-4967-8bed-e9f40b2d7333", 0, NullString)
        T21_Data_Update_Finished.SetValue(True)
        Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
        'Simulation support : Notification function call for entering final state/* #REF1553# */
        RtsNotify(Me, SENTER, "ddeb1d69-2891-4582-a28a-9e4addbedbd4", 0, NullString)
        RetValue = True
        Return
      End If
      'H1 DATA_TRANSMISSION
      RetValue = False
      Return
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 DATA_UPDATE
    ' // H1 DATA_UPDATE - call into substate
    ' if This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsDELAY_TIME_EXPIRING_Timer1_In_DATA_UPDATE(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsDELAY_TIME_EXPIRING_Timer1_In_F_SMI_EfeS_SR(ByRef RetValue As Boolean)
      'H1 DATA_UPDATE
      'H1 DATA_UPDATE - call into substate
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE Then
        RtsDELAY_TIME_EXPIRING_Timer1_In_DATA_UPDATE(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 DELAY_TIME_EXPIRING
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING then/* #REF5# */
    ' /* #REF6# */
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_DELAY_TIME_EXPIRING */
    ' 	/* standard */
    ' 	This.RtsExit_DELAY_TIME_EXPIRING();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"394dc9f3-2fce-48f8-be11-bb2f0ebc1b47",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT b11f8ad6-9bee-4223-bb9b-570efdbccccf */ 
    '  T19_Validate_Data := TRUE; nullstat;/*##END b11f8ad6-9bee-4223-bb9b-570efdbccccf */ /* #REF1546# */
    ' 	This.RtsEnter_CHECKING_UP_TO_DATENESS();/* #REF1590# */
    ' 	/* #REF13# */
    ' 	RetValue := true;
    ' 	return;
    ' 	/* #REF15# */
    ' end if
    ' // H1 DATA_TRANSMISSION
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsDELAY_TIME_EXPIRING_Timer1_In_DATA_UPDATE(ByRef RetValue As Boolean)
      'H1 DELAY_TIME_EXPIRING
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING Then
        Me.RtsExit_DELAY_TIME_EXPIRING()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "394dc9f3-2fce-48f8-be11-bb2f0ebc1b47", 0, NullString)
        T19_Validate_Data.SetValue(True)
        Me.RtsEnter_CHECKING_UP_TO_DATENESS()
        RetValue = True
        Return
      End If
      'H1 DATA_TRANSMISSION
      RetValue = False
      Return
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 DATA_UPDATE
    ' // H1 DATA_UPDATE - call into substate
    ' if This.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States{enum_datatype}.RtsF_SMI_EfeS_SR_States_DATA_UPDATE then/* #REF5# */
    ' /* #REF6# */
    ' 	RtsDATA_TRANSMISSION_Timer1_In_DATA_UPDATE(RetValue);/* #REF7# */
    ' 	if RetValue then/* #REF8# */
    ' 	/* #REF9# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF10# */
    ' 	end if
    ' /* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsDATA_TRANSMISSION_Timer1_In_F_SMI_EfeS_SR(ByRef RetValue As Boolean)
      'H1 DATA_UPDATE
      'H1 DATA_UPDATE - call into substate
      If Me.RtsCurrent_F_SMI_EfeS_SR = RtsF_SMI_EfeS_SR_States.RtsF_SMI_EfeS_SR_States_DATA_UPDATE Then
        RtsDATA_TRANSMISSION_Timer1_In_DATA_UPDATE(RetValue)
        If RetValue Then
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' // H1 DATA_TRANSMISSION
    ' if This.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION then/* #REF5# */
    ' /* #REF6# */
    ' 	if /* #REF2000# *//*##STRT 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */ (( D2_Con_t_Ini_Step <= Mem_t_Ini_Delay ) AND 
    ' ( Mem_t_Ini_Delay < D3_Con_t_Ini_Max ))/*##END 0a8f60ac-e4d3-44d1-8c6c-abcc357d3bca */  then/* #REF11# */
    ' 	/* #REF12# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ae9a6b47-05bc-4d08-982b-cd5890080373",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"066c24e4-3d9c-4dc6-869d-6a209d6807b7",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */  nullstat;/*##END 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */ /* #REF1544# */
    ' 	/*##STRT 928c670f-11e8-420d-a611-2b01cc96ecda */ 
    '  Mem_t_Ini_Delay := Mem_t_Ini_Delay + D2_Con_t_Ini_Step ; nullstat;/*##END 928c670f-11e8-420d-a611-2b01cc96ecda */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		/* #REF13# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF14# */
    ' 	end if
    ' 	if /* #REF2000# *//*##STRT c74150c6-b437-4139-977a-0b0e47be0c41 */ ( Mem_t_Ini_Delay >= D3_Con_t_Ini_Max )/*##END c74150c6-b437-4139-977a-0b0e47be0c41 */  then/* #REF11# */
    ' 	/* #REF12# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ae9a6b47-05bc-4d08-982b-cd5890080373",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6c40d2b2-de44-4469-b51d-5f14d1c345e5",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */  nullstat;/*##END 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */ /* #REF1544# */
    ' 	/*##STRT aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ 
    '  Mem_t_Ini_Delay := D3_Con_t_Ini_Max ; nullstat;/*##END aca79869-11b5-4a7f-b24c-fc28f9f709c9 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		/* #REF13# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF14# */
    ' 	end if
    ' 	if /* #REF2000# *//*##STRT c567a5e1-1efa-4add-8114-72a15b3575ac */ ((0 = Mem_t_Ini_Delay ) OR
    ' ( Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay ))/*##END c567a5e1-1efa-4add-8114-72a15b3575ac */  then/* #REF11# */
    ' 	/* #REF12# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_DATA_UPDATE */
    ' 		/* standard */
    ' 		This.RtsExit_DATA_UPDATE();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ae9a6b47-05bc-4d08-982b-cd5890080373",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"764e0d19-feb7-48f9-82e2-613f06fad06a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */  nullstat;/*##END 7bb5f132-72ec-4ce6-b7d3-7adad5799c1a */ /* #REF1544# */
    ' 	/*##STRT 6325d39a-3f11-4f24-9933-917545e2a991 */ 
    '  Mem_t_Ini_Delay := D2_Con_t_Ini_Step ; nullstat;/*##END 6325d39a-3f11-4f24-9933-917545e2a991 */ /* #REF1546# */
    ' 		This.RtsDefault_DATA_UPDATE();/* #REF1587# */
    ' 		/* #REF13# */
    ' 		RetValue := true;
    ' 		return;
    ' 		/* #REF14# */
    ' 	end if
    ' 	/* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsDATA_TRANSMISSION_Timer1_In_DATA_UPDATE(ByRef RetValue As Boolean)
      'H1 DATA_TRANSMISSION
      If Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION Then
        If ((D2_Con_t_Ini_Step.GetLatchedValue() <= Mem_t_Ini_Delay) And (Mem_t_Ini_Delay < D3_Con_t_Ini_Max.GetLatchedValue())) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ae9a6b47-05bc-4d08-982b-cd5890080373", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "066c24e4-3d9c-4dc6-869d-6a209d6807b7", 0, NullString)
          Mem_t_Ini_Delay = Mem_t_Ini_Delay + D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
        If (Mem_t_Ini_Delay >= D3_Con_t_Ini_Max.GetLatchedValue()) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ae9a6b47-05bc-4d08-982b-cd5890080373", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6c40d2b2-de44-4469-b51d-5f14d1c345e5", 0, NullString)
          Mem_t_Ini_Delay = D3_Con_t_Ini_Max.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
        If ((0 = Mem_t_Ini_Delay) Or (Mem_t_Ini_Delay = D1_Con_t_Ini_Def_Delay.GetLatchedValue())) Then
          Me.RtsExit_DATA_UPDATE()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ae9a6b47-05bc-4d08-982b-cd5890080373", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "764e0d19-feb7-48f9-82e2-613f06fad06a", 0, NullString)
          Mem_t_Ini_Delay = D2_Con_t_Ini_Step.GetLatchedValue()
          Me.RtsDefault_DATA_UPDATE()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_UPDATE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("c4f7e728-9cca-41a7-8750-fba8ff7a93bb|") then
    '   OperatedStates := OperatedStates + "c4f7e728-9cca-41a7-8750-fba8ff7a93bb|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_DATA_UPDATE
    ' /* #REF738# */
    ' 	case RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_CHECKING_UP_TO_DATENESS();/* #REF742# */
    ' 	case RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_INSTALLING_DATA();/* #REF742# */
    ' 	case RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_DELAY_TIME_EXPIRING();/* #REF742# */
    ' 	case RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_DATA_TRANSMISSION();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_DATA_UPDATE := RtsF_SMI_EfeS_SRDATA_UPDATE_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_DATA_UPDATE()
      If not OperatedStates.Contains("c4f7e728-9cca-41a7-8750-fba8ff7a93bb|") Then
        OperatedStates = OperatedStates + "c4f7e728-9cca-41a7-8750-fba8ff7a93bb|"
      End If
      Select Case Me.RtsCurrent_DATA_UPDATE
        Case RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_CHECKING_UP_TO_DATENESS
          Me.RtsExit_CHECKING_UP_TO_DATENESS()
        Case RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_INSTALLING_DATA
          Me.RtsExit_INSTALLING_DATA()
        Case RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DELAY_TIME_EXPIRING
          Me.RtsExit_DELAY_TIME_EXPIRING()
        Case RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_DATA_TRANSMISSION
          Me.RtsExit_DATA_TRANSMISSION()
      End Select
      Me.RtsCurrent_DATA_UPDATE = RtsF_SMI_EfeS_SRDATA_UPDATE_States.RtsF_SMI_EfeS_SRDATA_UPDATE_States_NotIn_DATA_UPDATE
    End Sub
    
    ' \ART_SMG :: Created for state : IDLE
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("87160484-66d7-40df-87e3-8dc777d3c84d|") then
    '   OperatedStates := OperatedStates + "87160484-66d7-40df-87e3-8dc777d3c84d|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_IDLE()
      If not OperatedStates.Contains("87160484-66d7-40df-87e3-8dc777d3c84d|") Then
        OperatedStates = OperatedStates + "87160484-66d7-40df-87e3-8dc777d3c84d|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_UP_TO_DATENESS
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("2d391355-f891-46bf-a56d-93a0361b8288|") then
    '   OperatedStates := OperatedStates + "2d391355-f891-46bf-a56d-93a0361b8288|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_CHECKING_UP_TO_DATENESS()
      If not OperatedStates.Contains("2d391355-f891-46bf-a56d-93a0361b8288|") Then
        OperatedStates = OperatedStates + "2d391355-f891-46bf-a56d-93a0361b8288|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : INSTALLING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("e5a5c9fe-4326-4b40-9e4a-372d37180ea7|") then
    '   OperatedStates := OperatedStates + "e5a5c9fe-4326-4b40-9e4a-372d37180ea7|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_INSTALLING_DATA()
      If not OperatedStates.Contains("e5a5c9fe-4326-4b40-9e4a-372d37180ea7|") Then
        OperatedStates = OperatedStates + "e5a5c9fe-4326-4b40-9e4a-372d37180ea7|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DELAY_TIME_EXPIRING
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("de3995eb-00b4-4558-9c41-6b19e0b0cece|") then
    '   OperatedStates := OperatedStates + "de3995eb-00b4-4558-9c41-6b19e0b0cece|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_DELAY_TIME_EXPIRING()
      If not OperatedStates.Contains("de3995eb-00b4-4558-9c41-6b19e0b0cece|") Then
        OperatedStates = OperatedStates + "de3995eb-00b4-4558-9c41-6b19e0b0cece|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : DATA_TRANSMISSION
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("d31ecea0-d545-4b72-92dc-9382d98c5234|") then
    '   OperatedStates := OperatedStates + "d31ecea0-d545-4b72-92dc-9382d98c5234|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_DATA_TRANSMISSION
    ' /* #REF738# */
    ' 	case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_WAITING_FOR_DATA();/* #REF742# */
    ' 	case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_RECEIVING_DATA();/* #REF742# */
    ' 	case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_CHECKING_DATA();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_DATA_TRANSMISSION := RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States{enum_datatype}.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_NotIn_DATA_TRANSMISSION;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_DATA_TRANSMISSION()
      If not OperatedStates.Contains("d31ecea0-d545-4b72-92dc-9382d98c5234|") Then
        OperatedStates = OperatedStates + "d31ecea0-d545-4b72-92dc-9382d98c5234|"
      End If
      Select Case Me.RtsCurrent_DATA_TRANSMISSION
        Case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_WAITING_FOR_DATA
          Me.RtsExit_WAITING_FOR_DATA()
        Case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_RECEIVING_DATA
          Me.RtsExit_RECEIVING_DATA()
        Case RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_CHECKING_DATA
          Me.RtsExit_CHECKING_DATA()
      End Select
      Me.RtsCurrent_DATA_TRANSMISSION = RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States.RtsF_SMI_EfeS_SRDATA_TRANSMISSION_States_NotIn_DATA_TRANSMISSION
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("c59ea63a-29d5-489c-808a-2a9c8fa73e40|") then
    '   OperatedStates := OperatedStates + "c59ea63a-29d5-489c-808a-2a9c8fa73e40|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_WAITING_FOR_DATA()
      If not OperatedStates.Contains("c59ea63a-29d5-489c-808a-2a9c8fa73e40|") Then
        OperatedStates = OperatedStates + "c59ea63a-29d5-489c-808a-2a9c8fa73e40|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("08f0de2c-1e86-4997-be9c-c226bc320f61|") then
    '   OperatedStates := OperatedStates + "08f0de2c-1e86-4997-be9c-c226bc320f61|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_RECEIVING_DATA()
      If not OperatedStates.Contains("08f0de2c-1e86-4997-be9c-c226bc320f61|") Then
        OperatedStates = OperatedStates + "08f0de2c-1e86-4997-be9c-c226bc320f61|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : CHECKING_DATA
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' if not OperatedStates.Contains ("813bfdce-3db3-4883-bd4a-dd891fe49cc7|") then
    '   OperatedStates := OperatedStates + "813bfdce-3db3-4883-bd4a-dd891fe49cc7|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_CHECKING_DATA()
      If not OperatedStates.Contains("813bfdce-3db3-4883-bd4a-dd891fe49cc7|") Then
        OperatedStates = OperatedStates + "813bfdce-3db3-4883-bd4a-dd891fe49cc7|"
      End If
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' This.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TStep(CurrentTime);
    ' This.RtsAttDELAY_TIME_EXPIRING_Timer1.TStep(CurrentTime);
    ' This.RtsAttDATA_TRANSMISSION_Timer1.TStep(CurrentTime);
    ' if This.RtsAttCHECKING_UP_TO_DATENESS_Timer1.HasElapsed() then
    '   This.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TStop();
    '   RtsCHECKING_UP_TO_DATENESS_Timer1_CallBack(This);
    ' end if
    ' if This.RtsAttDELAY_TIME_EXPIRING_Timer1.HasElapsed() then
    '   This.RtsAttDELAY_TIME_EXPIRING_Timer1.TStop();
    '   RtsDELAY_TIME_EXPIRING_Timer1_CallBack(This);
    ' end if
    ' if This.RtsAttDATA_TRANSMISSION_Timer1.HasElapsed() then
    '   This.RtsAttDATA_TRANSMISSION_Timer1.TStop();
    '   RtsDATA_TRANSMISSION_Timer1_CallBack(This);
    ' end if
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TimeToLive());
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttDELAY_TIME_EXPIRING_Timer1.TimeToLive());
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttDATA_TRANSMISSION_Timer1.TimeToLive());
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TStep(CurrentTime)
      Me.RtsAttDELAY_TIME_EXPIRING_Timer1.TStep(CurrentTime)
      Me.RtsAttDATA_TRANSMISSION_Timer1.TStep(CurrentTime)
      If Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1.HasElapsed() Then
        Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TStop()
        RtsCHECKING_UP_TO_DATENESS_Timer1_CallBack(Me)
      End If
      If Me.RtsAttDELAY_TIME_EXPIRING_Timer1.HasElapsed() Then
        Me.RtsAttDELAY_TIME_EXPIRING_Timer1.TStop()
        RtsDELAY_TIME_EXPIRING_Timer1_CallBack(Me)
      End If
      If Me.RtsAttDATA_TRANSMISSION_Timer1.HasElapsed() Then
        Me.RtsAttDATA_TRANSMISSION_Timer1.TStop()
        RtsDATA_TRANSMISSION_Timer1_CallBack(Me)
      End If
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttCHECKING_UP_TO_DATENESS_Timer1.TimeToLive())
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttDELAY_TIME_EXPIRING_Timer1.TimeToLive())
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttDATA_TRANSMISSION_Timer1.TimeToLive())
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D1_Con_t_Ini_Def_Delay: a SySimInputPort;
    ' assume D2_Con_t_Ini_Step: a SySimInputPort;
    ' assume D3_Con_t_Ini_Max: a SySimInputPort;
    ' assume D4_Con_tmax_Response_MDM: a SySimInputPort;
    ' assume D5_Con_tmax_DataTransmission: a SySimInputPort;
    ' assume T10_Data_Valid: a SySimInputPort;
    ' assume T11_Data_Invalid: a SySimInputPort;
    ' assume T12_Data_Installation_Successfully: a SySimInputPort;
    ' assume T13_Data_Update_After_Booting: a SySimInputPort;
    ' assume T14_Data_Update_After_Operational: a SySimInputPort;
    ' assume T15_Data_Update_In_Initialising: a SySimInputPort;
    ' assume T16_Data_Installation_Complete: a SySimOutputPort;
    ' assume T19_Validate_Data: a SySimOutputPort;
    ' assume T20_Ready_For_Update_Of_Data: a SySimOutputPort;
    ' assume T21_Data_Update_Finished: a SySimOutputPort;
    ' assume T22_Data_Update_Stop: a SySimInputPort;
    ' assume T6_Data_Up_To_Date: a SySimInputPort;
    ' assume T7_Data_Not_Up_To_Date: a SySimInputPort;
    ' assume T8_Data: a SySimInputPort;
    ' assume T9_Transmission_Complete: a SySimInputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg2Tmp := (/*##STRT 16bb6875-984e-4780-bc94-520702f932a8 */ ( T6_Data_Up_To_Date )/*##END 16bb6875-984e-4780-bc94-520702f932a8 */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' declare ChgFlg1Tmp := (/*##STRT c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ( T22_Data_Update_Stop )/*##END c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg9Tmp := (/*##STRT f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ( T13_Data_Update_After_Booting )/*##END f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg3Tmp := (/*##STRT c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ( T7_Data_Not_Up_To_Date )/*##END c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg10Tmp := (/*##STRT e053751c-5549-4b48-891b-e1641a568cc8 */ ( T14_Data_Update_After_Operational )/*##END e053751c-5549-4b48-891b-e1641a568cc8 */ ) : Boolean;
    ' ChgFlg10 := EvalTrigger(ChgFlg10Tmp , ChgFlgLast10);
    ' declare ChgFlg8Tmp := (/*##STRT 80f21671-b80f-4c19-b021-4287dc141810 */ ( T11_Data_Invalid )/*##END 80f21671-b80f-4c19-b021-4287dc141810 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg11Tmp := (/*##STRT 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ( T15_Data_Update_In_Initialising )/*##END 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ) : Boolean;
    ' ChgFlg11 := EvalTrigger(ChgFlg11Tmp , ChgFlgLast11);
    ' declare ChgFlg4Tmp := (/*##STRT 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ( T12_Data_Installation_Successfully )/*##END 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg6Tmp := (/*##STRT d39bc274-3c21-49bf-99a4-9f8877feb20a */ ( T9_Transmission_Complete )/*##END d39bc274-3c21-49bf-99a4-9f8877feb20a */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg5Tmp := (/*##STRT cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ( T8_Data )/*##END cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg7Tmp := (/*##STRT 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ( T10_Data_Valid )/*##END 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast10 := ChgFlg10Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast11 := ChgFlg11Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg2 := (/*##STRT 16bb6875-984e-4780-bc94-520702f932a8 */ ( T6_Data_Up_To_Date )/*##END 16bb6875-984e-4780-bc94-520702f932a8 */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ( T22_Data_Update_Stop )/*##END c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ) : Boolean;
    '   declare MaskedChgFlg9 := (/*##STRT f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ( T13_Data_Update_After_Booting )/*##END f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ( T7_Data_Not_Up_To_Date )/*##END c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ) : Boolean;
    '   declare MaskedChgFlg10 := (/*##STRT e053751c-5549-4b48-891b-e1641a568cc8 */ ( T14_Data_Update_After_Operational )/*##END e053751c-5549-4b48-891b-e1641a568cc8 */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT 80f21671-b80f-4c19-b021-4287dc141810 */ ( T11_Data_Invalid )/*##END 80f21671-b80f-4c19-b021-4287dc141810 */ ) : Boolean;
    '   declare MaskedChgFlg11 := (/*##STRT 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ( T15_Data_Update_In_Initialising )/*##END 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ( T12_Data_Installation_Successfully )/*##END 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT d39bc274-3c21-49bf-99a4-9f8877feb20a */ ( T9_Transmission_Complete )/*##END d39bc274-3c21-49bf-99a4-9f8877feb20a */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ( T8_Data )/*##END cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ( T10_Data_Valid )/*##END 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg2 := (/*##STRT 16bb6875-984e-4780-bc94-520702f932a8 */ ( T6_Data_Up_To_Date )/*##END 16bb6875-984e-4780-bc94-520702f932a8 */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ( T22_Data_Update_Stop )/*##END c8688af7-0cb2-4f9f-b1d9-350ae4374e91 */ ) : Boolean;
    '   declare UnMaskedChgFlg9 := (/*##STRT f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ( T13_Data_Update_After_Booting )/*##END f183c78f-8d57-4ea6-beb5-8f6e009f1dae */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ( T7_Data_Not_Up_To_Date )/*##END c0fa9b6f-80e0-4414-84ba-60ecd5922fe1 */ ) : Boolean;
    '   declare UnMaskedChgFlg10 := (/*##STRT e053751c-5549-4b48-891b-e1641a568cc8 */ ( T14_Data_Update_After_Operational )/*##END e053751c-5549-4b48-891b-e1641a568cc8 */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT 80f21671-b80f-4c19-b021-4287dc141810 */ ( T11_Data_Invalid )/*##END 80f21671-b80f-4c19-b021-4287dc141810 */ ) : Boolean;
    '   declare UnMaskedChgFlg11 := (/*##STRT 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ( T15_Data_Update_In_Initialising )/*##END 81a87612-13c2-4f96-934a-8cbbde4f7b3d */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ( T12_Data_Installation_Successfully )/*##END 93ecd883-6a34-497a-bc2e-9f72a5f8c0b5 */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT d39bc274-3c21-49bf-99a4-9f8877feb20a */ ( T9_Transmission_Complete )/*##END d39bc274-3c21-49bf-99a4-9f8877feb20a */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ( T8_Data )/*##END cb62742e-4cd4-47cc-80b9-45eee7c3b2cf */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ( T10_Data_Valid )/*##END 33e5e0f1-933b-43b7-a94d-7690ba75c578 */ ) : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg10 := ChgFlg10 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg11 := ChgFlg11 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := True;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := True;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := True;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := True;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := True;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := True;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := True;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := True;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := True;
    '   ChgFlg5 := False;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := True;
    '   ChgFlg7 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg2 := False;
    '   ChgFlg1 := False;
    '   ChgFlg9 := False;
    '   ChgFlg3 := False;
    '   ChgFlg10 := False;
    '   ChgFlg8 := False;
    '   ChgFlg11 := False;
    '   ChgFlg4 := False;
    '   ChgFlg6 := False;
    '   ChgFlg5 := False;
    '   ChgFlg7 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg2 := false;
    ' ChgFlg1 := false;
    ' ChgFlg9 := false;
    ' ChgFlg3 := false;
    ' ChgFlg10 := false;
    ' ChgFlg8 := false;
    ' ChgFlg11 := false;
    ' ChgFlg4 := false;
    ' ChgFlg6 := false;
    ' ChgFlg5 := false;
    ' ChgFlg7 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg2Tmp As Boolean = ((T6_Data_Up_To_Date.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      Dim ChgFlg1Tmp As Boolean = ((T22_Data_Update_Stop.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg9Tmp As Boolean = ((T13_Data_Update_After_Booting.GetLatchedValue()))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg3Tmp As Boolean = ((T7_Data_Not_Up_To_Date.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg10Tmp As Boolean = ((T14_Data_Update_After_Operational.GetLatchedValue()))
      ChgFlg10 = EvalTrigger(ChgFlg10Tmp, ChgFlgLast10)
      Dim ChgFlg8Tmp As Boolean = ((T11_Data_Invalid.GetLatchedValue()))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg11Tmp As Boolean = ((T15_Data_Update_In_Initialising.GetLatchedValue()))
      ChgFlg11 = EvalTrigger(ChgFlg11Tmp, ChgFlgLast11)
      Dim ChgFlg4Tmp As Boolean = ((T12_Data_Installation_Successfully.GetLatchedValue()))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg6Tmp As Boolean = ((T9_Transmission_Complete.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg5Tmp As Boolean = ((T8_Data.GetLatchedValue()))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg7Tmp As Boolean = ((T10_Data_Valid.GetLatchedValue()))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast2 = ChgFlg2Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast10 = ChgFlg10Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast11 = ChgFlg11Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg2 As Boolean = ((T6_Data_Up_To_Date.GetLatchedValue()))
        Dim MaskedChgFlg1 As Boolean = ((T22_Data_Update_Stop.GetLatchedValue()))
        Dim MaskedChgFlg9 As Boolean = ((T13_Data_Update_After_Booting.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T7_Data_Not_Up_To_Date.GetLatchedValue()))
        Dim MaskedChgFlg10 As Boolean = ((T14_Data_Update_After_Operational.GetLatchedValue()))
        Dim MaskedChgFlg8 As Boolean = ((T11_Data_Invalid.GetLatchedValue()))
        Dim MaskedChgFlg11 As Boolean = ((T15_Data_Update_In_Initialising.GetLatchedValue()))
        Dim MaskedChgFlg4 As Boolean = ((T12_Data_Installation_Successfully.GetLatchedValue()))
        Dim MaskedChgFlg6 As Boolean = ((T9_Transmission_Complete.GetLatchedValue()))
        Dim MaskedChgFlg5 As Boolean = ((T8_Data.GetLatchedValue()))
        Dim MaskedChgFlg7 As Boolean = ((T10_Data_Valid.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg2 As Boolean = ((T6_Data_Up_To_Date.GetLatchedValue()))
        Dim UnMaskedChgFlg1 As Boolean = ((T22_Data_Update_Stop.GetLatchedValue()))
        Dim UnMaskedChgFlg9 As Boolean = ((T13_Data_Update_After_Booting.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T7_Data_Not_Up_To_Date.GetLatchedValue()))
        Dim UnMaskedChgFlg10 As Boolean = ((T14_Data_Update_After_Operational.GetLatchedValue()))
        Dim UnMaskedChgFlg8 As Boolean = ((T11_Data_Invalid.GetLatchedValue()))
        Dim UnMaskedChgFlg11 As Boolean = ((T15_Data_Update_In_Initialising.GetLatchedValue()))
        Dim UnMaskedChgFlg4 As Boolean = ((T12_Data_Installation_Successfully.GetLatchedValue()))
        Dim UnMaskedChgFlg6 As Boolean = ((T9_Transmission_Complete.GetLatchedValue()))
        Dim UnMaskedChgFlg5 As Boolean = ((T8_Data.GetLatchedValue()))
        Dim UnMaskedChgFlg7 As Boolean = ((T10_Data_Valid.GetLatchedValue()))
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg10 As Boolean = ChgFlg10
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg11 As Boolean = ChgFlg11
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = True
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = True
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = True
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = True
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = True
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = True
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = True
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = True
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = True
          ChgFlg5 = False
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = True
          ChgFlg7 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg2 = False
          ChgFlg1 = False
          ChgFlg9 = False
          ChgFlg3 = False
          ChgFlg10 = False
          ChgFlg8 = False
          ChgFlg11 = False
          ChgFlg4 = False
          ChgFlg6 = False
          ChgFlg5 = False
          ChgFlg7 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg2 = False
      ChgFlg1 = False
      ChgFlg9 = False
      ChgFlg3 = False
      ChgFlg10 = False
      ChgFlg8 = False
      ChgFlg11 = False
      ChgFlg4 = False
      ChgFlg6 = False
      ChgFlg5 = False
      ChgFlg7 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D1_Con_t_Ini_Def_Delay.Decrement())
      Ret = (Ret Or D2_Con_t_Ini_Step.Decrement())
      Ret = (Ret Or D3_Con_t_Ini_Max.Decrement())
      Ret = (Ret Or D4_Con_tmax_Response_MDM.Decrement())
      Ret = (Ret Or D5_Con_tmax_DataTransmission.Decrement())
      Ret = (Ret Or T10_Data_Valid.Decrement())
      Ret = (Ret Or T11_Data_Invalid.Decrement())
      Ret = (Ret Or T12_Data_Installation_Successfully.Decrement())
      Ret = (Ret Or T13_Data_Update_After_Booting.Decrement())
      Ret = (Ret Or T14_Data_Update_After_Operational.Decrement())
      Ret = (Ret Or T15_Data_Update_In_Initialising.Decrement())
      Ret = (Ret Or T22_Data_Update_Stop.Decrement())
      Ret = (Ret Or T6_Data_Up_To_Date.Decrement())
      Ret = (Ret Or T7_Data_Not_Up_To_Date.Decrement())
      Ret = (Ret Or T8_Data.Decrement())
      Ret = (Ret Or T9_Transmission_Complete.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D1_Con_t_Ini_Def_Delay.Mask(What)
      D2_Con_t_Ini_Step.Mask(What)
      D3_Con_t_Ini_Max.Mask(What)
      D4_Con_tmax_Response_MDM.Mask(What)
      D5_Con_tmax_DataTransmission.Mask(What)
      T10_Data_Valid.Mask(What)
      T11_Data_Invalid.Mask(What)
      T12_Data_Installation_Successfully.Mask(What)
      T13_Data_Update_After_Booting.Mask(What)
      T14_Data_Update_After_Operational.Mask(What)
      T15_Data_Update_In_Initialising.Mask(What)
      T22_Data_Update_Stop.Mask(What)
      T6_Data_Up_To_Date.Mask(What)
      T7_Data_Not_Up_To_Date.Mask(What)
      T8_Data.Mask(What)
      T9_Transmission_Complete.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class S_SCI_EfeS_Prim_SR : Implements SMSupport.SMQueued 
    Protected Class S_SCI_EfeS_Prim_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As S_SCI_EfeS_Prim_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
      End Sub

    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsS_SCI_EfeS_Prim_SR_States
      RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION
      RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL
      RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED
      RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED
      RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_IMPERMISSIBLE
      RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT
      RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR
      RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR
      RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL
      RtsS_SCI_EfeS_Prim_SR_States_NotIn_S_SCI_EfeS_Prim_SR
    End Enum
    Public Enum RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States
      RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK
      RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION
      RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS
      RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Enum
    ' \ART_SMG :: Created for state : S_SCI_EfeS_Prim_SR
    Private RtsCurrent_S_SCI_EfeS_Prim_SR As S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SR_States
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    Private RtsAttESTABLISHING_PDI_CONNECTION_Timer1 As SMSupport.RtsTimer
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    Private RtsCurrent_ESTABLISHING_PDI_CONNECTION As S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast9 As Boolean
    Private ChgFlg9 As Boolean
    Private ChgFlgLast14 As Boolean
    Private ChgFlg14 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast10 As Boolean
    Private ChgFlg10 As Boolean
    Private ChgFlgLast11 As Boolean
    Private ChgFlg11 As Boolean
    Private ChgFlgLast17 As Boolean
    Private ChgFlg17 As Boolean
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast12 As Boolean
    Private ChgFlg12 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast13 As Boolean
    Private ChgFlg13 As Boolean
    Private ChgFlgLast16 As Boolean
    Private ChgFlg16 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast15 As Boolean
    Private ChgFlg15 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As S_SCI_EfeS_Prim_SRSMQueue = New S_SCI_EfeS_Prim_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    ' The FlowPort T5_SCP_Connection_Established represents the event of the established SCP connection.
    Protected T5_SCP_Connection_Established As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T10_SCP_Connection_Terminated represents the event of the terminated SCP connection.
    Protected T10_SCP_Connection_Terminated As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T14_Msg_Start_Initialisation refines the FlowProperty Msg_Start_Initialisation.
    Protected T14_Msg_Start_Initialisation As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T15_Msg_Initialisation_Completed refines the FlowProperty Msg_Initialisation_Completed.
    Protected T15_Msg_Initialisation_Completed As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T12_Terminate_SCP_Connection represents the event to terminate the SCP connection.
    Protected T12_Terminate_SCP_Connection As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T8_Cd_Initialisation_Request refines the FlowProperty Cd_Initialisation_Request.
    Protected T8_Cd_Initialisation_Request As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort T13_Msg_PDI_Version_Check refines the FlowProperty Msg_PDI_Version_Check.
    Protected T13_Msg_PDI_Version_Check As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T7_Cd_PDI_Version_Check refines the FlowProperty Cd_PDI_Version_Check.
    Protected T7_Cd_PDI_Version_Check As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort D4_Con_Checksum_Data provides the configured CSS.
    Protected D4_Con_Checksum_Data As OInputPort(Of String)
    ' The FlowPort DT7_PDI_Version belongs to T7_Cd_PDI_Version_Check.
    Protected DT7_PDI_Version As OOutputPort(Of String)
    ' The FlowPort D50_PDI_Connection_State provides the status of the PDI connection.
    Protected D50_PDI_Connection_State As OOutputPort(Of String)
    ' The FlowPort T6_Establish_SCP_Connection represents the event for the SCP to establish the SCP connection.
    Protected T6_Establish_SCP_Connection As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    ' The FlowPort DT13_Result belongs to T13_Msg_PDI_Version_Check.
    Protected DT13_Result As OInputPort(Of String)
    ' The FlowPort DT13_Checksum_Data belongs to T13_Msg_PDI_Version_Check.
    Protected DT13_Checksum_Data As OInputPort(Of String)
    ' The FlowPort T22_Content_Telegram_Error represents the event of a content telegram error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - improper value
    ' - locally improper value
    ' - improper combination of values
    Protected T22_Content_Telegram_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T20_Protocol_Error represents the event of a protocol error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - incomplete activation
    ' - improper message sequence
    ' - message at improper instant case
    Protected T20_Protocol_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort T21_Formal_Telegram_Error represents the event of a formal telegram error. The following events are possible as defined in [Eu.Doc.16].
    ' 
    ' - deviating message type
    ' - deviating protocol type
    ' - message length
    Protected T21_Formal_Telegram_Error As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    ' The FlowPort D2_Con_tmax_PDI_Connection provides the time value Con_tmax_PDI_Connection.
    Protected D2_Con_tmax_PDI_Connection As OInputPort(Of Integer)
    ' The FlowPort D3_Con_PDI_Version provides the configured PDIVer.
    Protected D3_Con_PDI_Version As OInputPort(Of String)
    ' The FlowPort D23_Con_Checksum_Data_Used provides configuration values whether the CSS is used and checked during initialisation.
    ' 
    ' The following values are permitted:
    ' - True: CSS is used
    ' - False: CSS is not used
    Protected D23_Con_Checksum_Data_Used As OInputPort(Of Boolean)
    ' The operation cOp1_init initialises all output ports and block properties.
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' D50_PDI_Connection_State := "";
    ' T12_Terminate_SCP_Connection := FALSE;
    ' T7_Cd_PDI_Version_Check := FALSE;
    ' DT7_PDI_Version := "";
    ' T8_Cd_Initialisation_Request := FALSE;
    ' T6_Establish_SCP_Connection := FALSE;
    Public Sub cOp1_init()
      D50_PDI_Connection_State.SetValue("")
      T12_Terminate_SCP_Connection.SetValue(False)
      T7_Cd_PDI_Version_Check.SetValue(False)
      DT7_PDI_Version.SetValue("")
      T8_Cd_Initialisation_Request.SetValue(False)
      T6_Establish_SCP_Connection.SetValue(False)
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' pInstance.RtsESTABLISHING_PDI_CONNECTION_Timer1();
    Private Shared Sub RtsESTABLISHING_PDI_CONNECTION_Timer1_CallBack(ByRef pInstance As S_SCI_EfeS_Prim_SR)
      pInstance.RtsESTABLISHING_PDI_CONNECTION_Timer1()
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' assume RtsCurrent_S_SCI_EfeS_Prim_SR: on object;
    ' assume RtsCurrent_ESTABLISHING_PDI_CONNECTION: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 9a914b97-6ed7-4a6d-8a4d-610d8bb245d0 WAITING_FOR_VERSION_CHECK */
    '   ThisState := "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT ab8332e9-f219-4caa-b038-5bbc8b036487 */ ( DT13_Result = "match")/*##END ab8332e9-f219-4caa-b038-5bbc8b036487 */  and /* #REF2000# *//*##STRT 57107609-2974-473c-8fb9-ee5733dd01d8 */ ( D23_Con_Checksum_Data_Used )/*##END 57107609-2974-473c-8fb9-ee5733dd01d8 */  and /* #REF2000# *//*##STRT 989687da-ec80-4c55-ae3b-d0dcf47acf09 */ (NOT ( DT13_Checksum_Data = D4_Con_Checksum_Data ))/*##END 989687da-ec80-4c55-ae3b-d0dcf47acf09 */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"23f1ee4a-8367-4543-8c79-c89a99f63600",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e897e3fb-308c-4e1d-be8b-8577c3703bc2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"0def6374-cead-4fcd-9af7-8dec86349915",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e88bc0eb-629b-49e4-8c2a-5500dbb38f7c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */  nullstat;/*##END f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */ /* #REF1544# */
    ' 	/*##STRT 89ccb815-b947-4bde-bd37-fe50bedb2a05 */  nullstat;/*##END 89ccb815-b947-4bde-bd37-fe50bedb2a05 */ /* #REF1544# */
    ' 	/*##STRT c7f4a052-e216-4051-b482-29b1a8607a79 */  nullstat;/*##END c7f4a052-e216-4051-b482-29b1a8607a79 */ /* #REF1544# */
    ' 	/*##STRT 0586d7cb-ad31-4d65-9e5a-0995ffbc28f6 */  nullstat;/*##END 0586d7cb-ad31-4d65-9e5a-0995ffbc28f6 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CHECKSUM_UNEQUAL();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 9a914b97-6ed7-4a6d-8a4d-610d8bb245d0 WAITING_FOR_VERSION_CHECK */
    '   ThisState := "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT ab8332e9-f219-4caa-b038-5bbc8b036487 */ ( DT13_Result = "match")/*##END ab8332e9-f219-4caa-b038-5bbc8b036487 */  and /* #REF2000# *//*##STRT 57107609-2974-473c-8fb9-ee5733dd01d8 */ ( D23_Con_Checksum_Data_Used )/*##END 57107609-2974-473c-8fb9-ee5733dd01d8 */  and /* #REF2000# *//*##STRT 9bc4662b-5494-4e29-9700-dbfc1dd1435e */ ( DT13_Checksum_Data = D4_Con_Checksum_Data )/*##END 9bc4662b-5494-4e29-9700-dbfc1dd1435e */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_VERSION_CHECK */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_VERSION_CHECK();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"23f1ee4a-8367-4543-8c79-c89a99f63600",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e897e3fb-308c-4e1d-be8b-8577c3703bc2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"0def6374-cead-4fcd-9af7-8dec86349915",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b7716bb4-3f67-49c4-aabb-341f3c16d56c",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */  nullstat;/*##END f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */ /* #REF1544# */
    ' 	/*##STRT 89ccb815-b947-4bde-bd37-fe50bedb2a05 */  nullstat;/*##END 89ccb815-b947-4bde-bd37-fe50bedb2a05 */ /* #REF1544# */
    ' 	/*##STRT c7f4a052-e216-4051-b482-29b1a8607a79 */  nullstat;/*##END c7f4a052-e216-4051-b482-29b1a8607a79 */ /* #REF1544# */
    ' 	/*##STRT 821ef706-0492-4796-9a0b-fb85c15df10b */ 
    '  T8_Cd_Initialisation_Request := TRUE; nullstat;/*##END 821ef706-0492-4796-9a0b-fb85c15df10b */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISATION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 9a914b97-6ed7-4a6d-8a4d-610d8bb245d0 WAITING_FOR_VERSION_CHECK */
    '   ThisState := "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT ab8332e9-f219-4caa-b038-5bbc8b036487 */ ( DT13_Result = "match")/*##END ab8332e9-f219-4caa-b038-5bbc8b036487 */  and /* #REF2000# *//*##STRT 64581f2e-209d-4644-943f-d9421207049c */ (NOT D23_Con_Checksum_Data_Used )/*##END 64581f2e-209d-4644-943f-d9421207049c */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_VERSION_CHECK */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_VERSION_CHECK();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"23f1ee4a-8367-4543-8c79-c89a99f63600",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e897e3fb-308c-4e1d-be8b-8577c3703bc2",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6a36e462-1263-42fb-9d37-4d8cbb80dfa9",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */  nullstat;/*##END f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */ /* #REF1544# */
    ' 	/*##STRT 89ccb815-b947-4bde-bd37-fe50bedb2a05 */  nullstat;/*##END 89ccb815-b947-4bde-bd37-fe50bedb2a05 */ /* #REF1544# */
    ' 	/*##STRT ece8b186-d03a-489f-8e74-38323ee87e02 */ 
    '  T8_Cd_Initialisation_Request := TRUE; nullstat;/*##END ece8b186-d03a-489f-8e74-38323ee87e02 */ /* #REF1546# */
    ' 		This.RtsEnter_WAITING_FOR_INITIALISATION();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK then
    ' /* #REF123# */
    ' 	/* 9a914b97-6ed7-4a6d-8a4d-610d8bb245d0 WAITING_FOR_VERSION_CHECK */
    '   ThisState := "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) and /* #REF2000# *//*##STRT ae7f150d-c775-4527-9227-e8e6fb082dee */ ( DT13_Result = "not match")/*##END ae7f150d-c775-4527-9227-e8e6fb082dee */  then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"23f1ee4a-8367-4543-8c79-c89a99f63600",0,NullString);/* #REF1599# */
    ' 		
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"33a62db1-a1a6-4b0a-9cf0-909022050e22",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */  nullstat;/*##END f72e3cbf-b9f9-4283-b0de-3fab270f5f74 */ /* #REF1544# */
    ' 	/*##STRT e019ad4c-ba1a-483c-a8ac-b3bd1a450711 */  nullstat;/*##END e019ad4c-ba1a-483c-a8ac-b3bd1a450711 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_VERSION_UNEQUAL();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION then
    ' /* #REF123# */
    ' 	/* ef441dfe-7565-4ca3-97e8-94ecc3b3b025 WAITING_FOR_INITIALISATION */
    '   ThisState := "ef441dfe-7565-4ca3-97e8-94ecc3b3b025";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_WAITING_FOR_INITIALISATION */
    ' 		/* standard */
    ' 		This.RtsExit_WAITING_FOR_INITIALISATION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7106ff56-4b00-4639-a933-efc94e663fd6",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 762cc909-6a72-402b-8a4d-595d87798e3e */  nullstat;/*##END 762cc909-6a72-402b-8a4d-595d87798e3e */ /* #REF1546# */
    ' 		This.RtsEnter_RECEIVING_STATUS();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS then
    ' /* #REF123# */
    ' 	/* f9fbd6fa-9c83-489f-8748-0aa539878f54 RECEIVING_STATUS */
    '   ThisState := "f9fbd6fa-9c83-489f-8748-0aa539878f54";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"3c7998cc-0e79-4e0c-89a2-fb9eb2e1b443",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 31a2a0d4-20b3-4b30-a0be-4da6fa7e0c20 */  nullstat;/*##END 31a2a0d4-20b3-4b30-a0be-4da6fa7e0c20 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* bdcc7435-7f33-4928-ae06-59dfc65451ee ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "bdcc7435-7f33-4928-ae06-59dfc65451ee";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"adc1752a-ba4f-4a6e-b0cd-2310f65326a3",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 3e552ce0-a03a-47c7-b552-189963913659 */  nullstat;/*##END 3e552ce0-a03a-47c7-b552-189963913659 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* bdcc7435-7f33-4928-ae06-59dfc65451ee ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "bdcc7435-7f33-4928-ae06-59dfc65451ee";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ee468b1a-795b-4ff7-b1ac-af276a94fc84",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f895c46c-09ac-4594-827f-8aa82dc35d59 */  nullstat;/*##END f895c46c-09ac-4594-827f-8aa82dc35d59 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_PROTOCOL_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* bdcc7435-7f33-4928-ae06-59dfc65451ee ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "bdcc7435-7f33-4928-ae06-59dfc65451ee";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"71081929-9c4f-4d0b-abb0-9486ac16259a",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2ef7761d-145b-4fd6-a6a0-b72a3433ab68 */  nullstat;/*##END 2ef7761d-145b-4fd6-a6a0-b72a3433ab68 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then
    ' /* #REF123# */
    ' 	/* bdcc7435-7f33-4928-ae06-59dfc65451ee ESTABLISHING_PDI_CONNECTION */
    '   ThisState := "bdcc7435-7f33-4928-ae06-59dfc65451ee";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 		/* standard */
    ' 		This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8eac55f2-d1cb-48ce-a52e-dc92e84f2516",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT bdd343eb-0fa3-4ead-90b3-75092b5684d2 */  nullstat;/*##END bdd343eb-0fa3-4ead-90b3-75092b5684d2 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR =  /* #REF121d# */ RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_NotIn_S_SCI_EfeS_Prim_SR then
    ' /* #REF123# */
    ' 	/* 25a121d1-a36d-4cc8-afe9-d2cf634e7b8f Initial0 */
    '   ThisState := "25a121d1-a36d-4cc8-afe9-d2cf634e7b8f";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"25a121d1-a36d-4cc8-afe9-d2cf634e7b8f",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"25a121d1-a36d-4cc8-afe9-d2cf634e7b8f",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"813630cc-a126-4adb-8011-6ae755533327",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT e56e9209-eed8-4e92-b886-2efdeeabc44c */  cOp1_init (); nullstat;/*##END e56e9209-eed8-4e92-b886-2efdeeabc44c */ /* #REF1546# */
    ' 	This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL then
    ' /* #REF123# */
    ' 	/* 08d17299-aa85-4b73-b62f-4747a62ec517 PDI_CHECKSUM_UNEQUAL */
    '   ThisState := "08d17299-aa85-4b73-b62f-4747a62ec517";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CHECKSUM_UNEQUAL */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CHECKSUM_UNEQUAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"4e8ebfa0-6d4e-4413-b0e8-e583597b8c20",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 1c8310e6-f092-4748-84d8-c82ca4fa9622 */  nullstat;/*##END 1c8310e6-f092-4748-84d8-c82ca4fa9622 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED then
    ' /* #REF123# */
    ' 	/* a598dff8-2813-4044-91cf-7925354bb8c6 PDI_CONNECTION_CLOSED */
    '   ThisState := "a598dff8-2813-4044-91cf-7925354bb8c6";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_CLOSED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_CLOSED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5a624c8a-62bd-4ccc-b059-7bdcf9f000ce",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 06a0821c-610f-4022-b999-d8490cad9db9 */  nullstat;/*##END 06a0821c-610f-4022-b999-d8490cad9db9 */ /* #REF1546# */
    ' 		This.RtsDefault_ESTABLISHING_PDI_CONNECTION();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* b9b274ca-51f6-4d04-b575-d606028484e7 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "b9b274ca-51f6-4d04-b575-d606028484e7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"7779f9fe-28b2-4d95-8bc0-da8b29672814",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 4771a69c-2685-44ba-b9f3-da7e1bac738e */  nullstat;/*##END 4771a69c-2685-44ba-b9f3-da7e1bac738e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* b9b274ca-51f6-4d04-b575-d606028484e7 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "b9b274ca-51f6-4d04-b575-d606028484e7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"0e201da2-da5c-43d2-9a50-b75d87791244",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 4a60dfc5-492c-4278-b6f0-0df3e27818c0 */  nullstat;/*##END 4a60dfc5-492c-4278-b6f0-0df3e27818c0 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_PROTOCOL_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* b9b274ca-51f6-4d04-b575-d606028484e7 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "b9b274ca-51f6-4d04-b575-d606028484e7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"4aa85268-8987-45bb-aef7-711cfa4ec6e0",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 95d2f0c8-ddf8-4ff3-9cc5-b79b4af7107e */  nullstat;/*##END 95d2f0c8-ddf8-4ff3-9cc5-b79b4af7107e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* b9b274ca-51f6-4d04-b575-d606028484e7 PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "b9b274ca-51f6-4d04-b575-d606028484e7";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"3b883b0d-525a-45e2-b81f-4a267a01a165",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f39b65e0-7dc4-4006-b33c-ea45818c9d86 */  nullstat;/*##END f39b65e0-7dc4-4006-b33c-ea45818c9d86 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_TELEGRAM_ERROR();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT then
    ' /* #REF123# */
    ' 	/* 02dab697-cfb1-4216-a08a-d400f1acb5ac PDI_INIT_TIMEOUT */
    '   ThisState := "02dab697-cfb1-4216-a08a-d400f1acb5ac";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_INIT_TIMEOUT */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_INIT_TIMEOUT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"ebf11713-f57a-4f34-b1b1-68a9ea479095",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 07263172-6853-4f8b-a97c-7926d9da3393 */  nullstat;/*##END 07263172-6853-4f8b-a97c-7926d9da3393 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR then
    ' /* #REF123# */
    ' 	/* e7d99859-8866-4d95-a105-66009d324e06 PDI_PROTOCOL_ERROR */
    '   ThisState := "e7d99859-8866-4d95-a105-66009d324e06";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_PROTOCOL_ERROR */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_PROTOCOL_ERROR();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"9f83ae8b-8121-4da4-9033-b1e58fd4f057",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f7a03557-a431-47e0-ab97-653fb0f9eb34 */  nullstat;/*##END f7a03557-a431-47e0-ab97-653fb0f9eb34 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR then
    ' /* #REF123# */
    ' 	/* 20aac7fe-5728-4bfc-8287-5b55af6b26eb PDI_TELEGRAM_ERROR */
    '   ThisState := "20aac7fe-5728-4bfc-8287-5b55af6b26eb";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_TELEGRAM_ERROR */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_TELEGRAM_ERROR();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"25dc863c-db32-49e3-b12f-513f49d2d62d",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT f6cea945-a799-4566-838c-9949d88a3ac5 */  nullstat;/*##END f6cea945-a799-4566-838c-9949d88a3ac5 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_IMPERMISSIBLE();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL then
    ' /* #REF123# */
    ' 	/* 75ee8219-b1db-4b1f-aae6-88174c818382 PDI_VERSION_UNEQUAL */
    '   ThisState := "75ee8219-b1db-4b1f-aae6-88174c818382";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_VERSION_UNEQUAL */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_VERSION_UNEQUAL();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"c6a05783-8244-4eac-8c13-35538e2f1397",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 52eb0272-06a2-4c7f-aa46-c43bd324d9c8 */  nullstat;/*##END 52eb0272-06a2-4c7f-aa46-c43bd324d9c8 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_CLOSED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK Then
        ThisState = "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) And (DT13_Result.GetLatchedValue() = "match") And (D23_Con_Checksum_Data_Used.GetLatchedValue()) And (NOT (DT13_Checksum_Data.GetLatchedValue() = D4_Con_Checksum_Data.GetLatchedValue())) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "23f1ee4a-8367-4543-8c79-c89a99f63600", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e897e3fb-308c-4e1d-be8b-8577c3703bc2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "0def6374-cead-4fcd-9af7-8dec86349915", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e88bc0eb-629b-49e4-8c2a-5500dbb38f7c", 0, NullString)
          Me.RtsEnter_PDI_CHECKSUM_UNEQUAL()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK Then
        ThisState = "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) And (DT13_Result.GetLatchedValue() = "match") And (D23_Con_Checksum_Data_Used.GetLatchedValue()) And (DT13_Checksum_Data.GetLatchedValue() = D4_Con_Checksum_Data.GetLatchedValue()) Then
          Me.RtsExit_WAITING_FOR_VERSION_CHECK()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "23f1ee4a-8367-4543-8c79-c89a99f63600", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e897e3fb-308c-4e1d-be8b-8577c3703bc2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "0def6374-cead-4fcd-9af7-8dec86349915", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b7716bb4-3f67-49c4-aabb-341f3c16d56c", 0, NullString)
          T8_Cd_Initialisation_Request.SetValue(True)
          Me.RtsEnter_WAITING_FOR_INITIALISATION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK Then
        ThisState = "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) And (DT13_Result.GetLatchedValue() = "match") And (NOT D23_Con_Checksum_Data_Used.GetLatchedValue()) Then
          Me.RtsExit_WAITING_FOR_VERSION_CHECK()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "23f1ee4a-8367-4543-8c79-c89a99f63600", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e897e3fb-308c-4e1d-be8b-8577c3703bc2", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6a36e462-1263-42fb-9d37-4d8cbb80dfa9", 0, NullString)
          T8_Cd_Initialisation_Request.SetValue(True)
          Me.RtsEnter_WAITING_FOR_INITIALISATION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK Then
        ThisState = "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) And (DT13_Result.GetLatchedValue() = "not match") Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "23f1ee4a-8367-4543-8c79-c89a99f63600", 0, NullString)
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "33a62db1-a1a6-4b0a-9cf0-909022050e22", 0, NullString)
          Me.RtsEnter_PDI_VERSION_UNEQUAL()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION Then
        ThisState = "ef441dfe-7565-4ca3-97e8-94ecc3b3b025"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          Me.RtsExit_WAITING_FOR_INITIALISATION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7106ff56-4b00-4639-a933-efc94e663fd6", 0, NullString)
          Me.RtsEnter_RECEIVING_STATUS()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS Then
        ThisState = "f9fbd6fa-9c83-489f-8748-0aa539878f54"
        If SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "3c7998cc-0e79-4e0c-89a2-fb9eb2e1b443", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "bdcc7435-7f33-4928-ae06-59dfc65451ee"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "adc1752a-ba4f-4a6e-b0cd-2310f65326a3", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "bdcc7435-7f33-4928-ae06-59dfc65451ee"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ee468b1a-795b-4ff7-b1ac-af276a94fc84", 0, NullString)
          Me.RtsEnter_PDI_PROTOCOL_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "bdcc7435-7f33-4928-ae06-59dfc65451ee"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "71081929-9c4f-4d0b-abb0-9486ac16259a", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        ThisState = "bdcc7435-7f33-4928-ae06-59dfc65451ee"
        If SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8eac55f2-d1cb-48ce-a52e-dc92e84f2516", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_NotIn_S_SCI_EfeS_Prim_SR Then
        ThisState = "25a121d1-a36d-4cc8-afe9-d2cf634e7b8f"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "25a121d1-a36d-4cc8-afe9-d2cf634e7b8f", 0, NullString)
        RtsNotify(Me, SEXIT, "25a121d1-a36d-4cc8-afe9-d2cf634e7b8f", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "813630cc-a126-4adb-8011-6ae755533327", 0, NullString)
        cOp1_init()
        Me.RtsEnter_PDI_CONNECTION_CLOSED()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL Then
        ThisState = "08d17299-aa85-4b73-b62f-4747a62ec517"
        If SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CHECKSUM_UNEQUAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "4e8ebfa0-6d4e-4413-b0e8-e583597b8c20", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED Then
        ThisState = "a598dff8-2813-4044-91cf-7925354bb8c6"
        If SenseTrigger(ChgFlg9, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_CLOSED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5a624c8a-62bd-4ccc-b059-7bdcf9f000ce", 0, NullString)
          Me.RtsDefault_ESTABLISHING_PDI_CONNECTION()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "b9b274ca-51f6-4d04-b575-d606028484e7"
        If SenseTrigger(ChgFlg10, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "7779f9fe-28b2-4d95-8bc0-da8b29672814", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "b9b274ca-51f6-4d04-b575-d606028484e7"
        If SenseTrigger(ChgFlg11, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "0e201da2-da5c-43d2-9a50-b75d87791244", 0, NullString)
          Me.RtsEnter_PDI_PROTOCOL_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "b9b274ca-51f6-4d04-b575-d606028484e7"
        If SenseTrigger(ChgFlg12, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "4aa85268-8987-45bb-aef7-711cfa4ec6e0", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "b9b274ca-51f6-4d04-b575-d606028484e7"
        If SenseTrigger(ChgFlg13, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "3b883b0d-525a-45e2-b81f-4a267a01a165", 0, NullString)
          Me.RtsEnter_PDI_TELEGRAM_ERROR()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT Then
        ThisState = "02dab697-cfb1-4216-a08a-d400f1acb5ac"
        If SenseTrigger(ChgFlg14, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_INIT_TIMEOUT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "ebf11713-f57a-4f34-b1b1-68a9ea479095", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR Then
        ThisState = "e7d99859-8866-4d95-a105-66009d324e06"
        If SenseTrigger(ChgFlg15, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_PROTOCOL_ERROR()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "9f83ae8b-8121-4da4-9033-b1e58fd4f057", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR Then
        ThisState = "20aac7fe-5728-4bfc-8287-5b55af6b26eb"
        If SenseTrigger(ChgFlg16, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_TELEGRAM_ERROR()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "25dc863c-db32-49e3-b12f-513f49d2d62d", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_IMPERMISSIBLE()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL Then
        ThisState = "75ee8219-b1db-4b1f-aae6-88174c818382"
        If SenseTrigger(ChgFlg17, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_VERSION_UNEQUAL()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "c6a05783-8244-4eac-8c13-35538e2f1397", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_CLOSED()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "12a3fc7b-e1a9-4000-a330-e34983cb84c8", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);/* #REF1564# */
    ' SMSupport.RtsBase.RtsCreateTimer(This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_NotIn_S_SCI_EfeS_Prim_SR;/* #REF1566# */
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "12a3fc7b-e1a9-4000-a330-e34983cb84c8", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      SMSupport.RtsBase.RtsCreateTimer(Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_NotIn_S_SCI_EfeS_Prim_SR
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub

    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("bdcc7435-7f33-4928-ae06-59dfc65451ee|") then
    '   OperatedStates := OperatedStates + "bdcc7435-7f33-4928-ae06-59dfc65451ee|";
    ' end if
    ' // Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
    ' RtsNotify(This,SENTER,"bdcc7435-7f33-4928-ae06-59dfc65451ee",0,NullString);
    ' 
    ' SimCore.EnterState("bdcc7435-7f33-4928-ae06-59dfc65451ee","ESTABLISHING_PDI_CONNECTION");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION;/* #REF521# */
    ' /* #REF523# */
    ' // Start Timers/* #REF525# */
    ' SMSupport.RtsBase.RtsStartTimer(This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1, /*##STRT 7b8c2f80-2263-4508-8b76-391d5da5b8f8 */ D2_Con_tmax_PDI_Connection/*##END 7b8c2f80-2263-4508-8b76-391d5da5b8f8 */ , CurrentTime);
    Private Sub RtsEnter_ESTABLISHING_PDI_CONNECTION()
      If Not OperatedStates.Contains("bdcc7435-7f33-4928-ae06-59dfc65451ee|") Then
        OperatedStates = OperatedStates + "bdcc7435-7f33-4928-ae06-59dfc65451ee|"
      End If
      'Simulation support : Notification function call for entering state : ESTABLISHING_PDI_CONNECTION ///* #REF520# */
      RtsNotify(Me, SENTER, "bdcc7435-7f33-4928-ae06-59dfc65451ee", 0, NullString)
      SimCore.EnterState("bdcc7435-7f33-4928-ae06-59dfc65451ee", "ESTABLISHING_PDI_CONNECTION")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION
      'Start Timers/* #REF525# */
      SMSupport.RtsBase.RtsStartTimer(Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1, D2_Con_tmax_PDI_Connection.GetLatchedValue(), CurrentTime)
    End Sub

    ' \ART_SMG :: Created for state : PDI_CHECKSUM_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("08d17299-aa85-4b73-b62f-4747a62ec517|") then
    '   OperatedStates := OperatedStates + "08d17299-aa85-4b73-b62f-4747a62ec517|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CHECKSUM_UNEQUAL ///* #REF520# */
    ' RtsNotify(This,SENTER,"08d17299-aa85-4b73-b62f-4747a62ec517",0,NullString);
    ' 
    ' SimCore.EnterState("08d17299-aa85-4b73-b62f-4747a62ec517","PDI_CHECKSUM_UNEQUAL");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 2f4f119d-6bf7-4299-8536-c5409b00ea31 */  D50_PDI_Connection_State := "CHECKSUM_UNEQUAL";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END 2f4f119d-6bf7-4299-8536-c5409b00ea31 */ 
    Private Sub RtsEnter_PDI_CHECKSUM_UNEQUAL()
      If not OperatedStates.Contains("08d17299-aa85-4b73-b62f-4747a62ec517|") Then
        OperatedStates = OperatedStates + "08d17299-aa85-4b73-b62f-4747a62ec517|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CHECKSUM_UNEQUAL ///* #REF520# */
      RtsNotify(Me, SENTER, "08d17299-aa85-4b73-b62f-4747a62ec517", 0, NullString)
      SimCore.EnterState("08d17299-aa85-4b73-b62f-4747a62ec517", "PDI_CHECKSUM_UNEQUAL")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL
      'Entry Actions
      D50_PDI_Connection_State.SetValue("CHECKSUM_UNEQUAL")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("a598dff8-2813-4044-91cf-7925354bb8c6|") then
    '   OperatedStates := OperatedStates + "a598dff8-2813-4044-91cf-7925354bb8c6|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_CLOSED ///* #REF520# */
    ' RtsNotify(This,SENTER,"a598dff8-2813-4044-91cf-7925354bb8c6",0,NullString);
    ' 
    ' SimCore.EnterState("a598dff8-2813-4044-91cf-7925354bb8c6","PDI_CONNECTION_CLOSED");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT b208239d-125a-4be8-8d3a-576c0b5816d4 */  D50_PDI_Connection_State := "CLOSED_REQUESTED";
    '  T6_Establish_SCP_Connection := TRUE; nullstat;/*##END b208239d-125a-4be8-8d3a-576c0b5816d4 */ 
    Private Sub RtsEnter_PDI_CONNECTION_CLOSED()
      If not OperatedStates.Contains("a598dff8-2813-4044-91cf-7925354bb8c6|") Then
        OperatedStates = OperatedStates + "a598dff8-2813-4044-91cf-7925354bb8c6|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_CLOSED ///* #REF520# */
      RtsNotify(Me, SENTER, "a598dff8-2813-4044-91cf-7925354bb8c6", 0, NullString)
      SimCore.EnterState("a598dff8-2813-4044-91cf-7925354bb8c6", "PDI_CONNECTION_CLOSED")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED
      'Entry Actions
      D50_PDI_Connection_State.SetValue("CLOSED_REQUESTED")
      T6_Establish_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b9b274ca-51f6-4d04-b575-d606028484e7|") then
    '   OperatedStates := OperatedStates + "b9b274ca-51f6-4d04-b575-d606028484e7|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
    ' RtsNotify(This,SENTER,"b9b274ca-51f6-4d04-b575-d606028484e7",0,NullString);
    ' 
    ' SimCore.EnterState("b9b274ca-51f6-4d04-b575-d606028484e7","PDI_CONNECTION_ESTABLISHED");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 9c164c42-ca30-4bb9-b7fe-4810a44a7ffd */  D50_PDI_Connection_State := "ESTABLISHED"; nullstat;/*##END 9c164c42-ca30-4bb9-b7fe-4810a44a7ffd */ 
    Private Sub RtsEnter_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("b9b274ca-51f6-4d04-b575-d606028484e7|") Then
        OperatedStates = OperatedStates + "b9b274ca-51f6-4d04-b575-d606028484e7|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
      RtsNotify(Me, SENTER, "b9b274ca-51f6-4d04-b575-d606028484e7", 0, NullString)
      SimCore.EnterState("b9b274ca-51f6-4d04-b575-d606028484e7", "PDI_CONNECTION_ESTABLISHED")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED
      'Entry Actions
      D50_PDI_Connection_State.SetValue("ESTABLISHED")
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b8180ee0-f815-4867-bb62-832cd4094618|") then
    '   OperatedStates := OperatedStates + "b8180ee0-f815-4867-bb62-832cd4094618|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_IMPERMISSIBLE ///* #REF520# */
    ' RtsNotify(This,SENTER,"b8180ee0-f815-4867-bb62-832cd4094618",0,NullString);
    ' 
    ' SimCore.EnterState("b8180ee0-f815-4867-bb62-832cd4094618","PDI_CONNECTION_IMPERMISSIBLE");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_IMPERMISSIBLE;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT a14b9338-adb7-4896-9efb-08c7e266e68d */  D50_PDI_Connection_State := "IMPERMISSIBLE"; nullstat;/*##END a14b9338-adb7-4896-9efb-08c7e266e68d */ 
    Private Sub RtsEnter_PDI_CONNECTION_IMPERMISSIBLE()
      If not OperatedStates.Contains("b8180ee0-f815-4867-bb62-832cd4094618|") Then
        OperatedStates = OperatedStates + "b8180ee0-f815-4867-bb62-832cd4094618|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_IMPERMISSIBLE ///* #REF520# */
      RtsNotify(Me, SENTER, "b8180ee0-f815-4867-bb62-832cd4094618", 0, NullString)
      SimCore.EnterState("b8180ee0-f815-4867-bb62-832cd4094618", "PDI_CONNECTION_IMPERMISSIBLE")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_IMPERMISSIBLE
      'Entry Actions
      D50_PDI_Connection_State.SetValue("IMPERMISSIBLE")
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_INIT_TIMEOUT
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("02dab697-cfb1-4216-a08a-d400f1acb5ac|") then
    '   OperatedStates := OperatedStates + "02dab697-cfb1-4216-a08a-d400f1acb5ac|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_INIT_TIMEOUT ///* #REF520# */
    ' RtsNotify(This,SENTER,"02dab697-cfb1-4216-a08a-d400f1acb5ac",0,NullString);
    ' 
    ' SimCore.EnterState("02dab697-cfb1-4216-a08a-d400f1acb5ac","PDI_INIT_TIMEOUT");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 60ebe417-b13b-45fd-a98c-4b62d7dee455 */  D50_PDI_Connection_State := "INIT_TIMEOUT";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END 60ebe417-b13b-45fd-a98c-4b62d7dee455 */ 
    Private Sub RtsEnter_PDI_INIT_TIMEOUT()
      If not OperatedStates.Contains("02dab697-cfb1-4216-a08a-d400f1acb5ac|") Then
        OperatedStates = OperatedStates + "02dab697-cfb1-4216-a08a-d400f1acb5ac|"
      End If
      'Simulation support : Notification function call for entering state : PDI_INIT_TIMEOUT ///* #REF520# */
      RtsNotify(Me, SENTER, "02dab697-cfb1-4216-a08a-d400f1acb5ac", 0, NullString)
      SimCore.EnterState("02dab697-cfb1-4216-a08a-d400f1acb5ac", "PDI_INIT_TIMEOUT")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT
      'Entry Actions
      D50_PDI_Connection_State.SetValue("INIT_TIMEOUT")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("e7d99859-8866-4d95-a105-66009d324e06|") then
    '   OperatedStates := OperatedStates + "e7d99859-8866-4d95-a105-66009d324e06|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_PROTOCOL_ERROR ///* #REF520# */
    ' RtsNotify(This,SENTER,"e7d99859-8866-4d95-a105-66009d324e06",0,NullString);
    ' 
    ' SimCore.EnterState("e7d99859-8866-4d95-a105-66009d324e06","PDI_PROTOCOL_ERROR");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 9356cec9-c859-4fae-ac1f-8eb10924fa79 */  D50_PDI_Connection_State := "PROTOCOL_ERROR";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END 9356cec9-c859-4fae-ac1f-8eb10924fa79 */ 
    Private Sub RtsEnter_PDI_PROTOCOL_ERROR()
      If not OperatedStates.Contains("e7d99859-8866-4d95-a105-66009d324e06|") Then
        OperatedStates = OperatedStates + "e7d99859-8866-4d95-a105-66009d324e06|"
      End If
      'Simulation support : Notification function call for entering state : PDI_PROTOCOL_ERROR ///* #REF520# */
      RtsNotify(Me, SENTER, "e7d99859-8866-4d95-a105-66009d324e06", 0, NullString)
      SimCore.EnterState("e7d99859-8866-4d95-a105-66009d324e06", "PDI_PROTOCOL_ERROR")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR
      'Entry Actions
      D50_PDI_Connection_State.SetValue("PROTOCOL_ERROR")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("20aac7fe-5728-4bfc-8287-5b55af6b26eb|") then
    '   OperatedStates := OperatedStates + "20aac7fe-5728-4bfc-8287-5b55af6b26eb|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_TELEGRAM_ERROR ///* #REF520# */
    ' RtsNotify(This,SENTER,"20aac7fe-5728-4bfc-8287-5b55af6b26eb",0,NullString);
    ' 
    ' SimCore.EnterState("20aac7fe-5728-4bfc-8287-5b55af6b26eb","PDI_TELEGRAM_ERROR");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT ccf3a547-d3dd-4d8e-b891-23c492f24d38 */  D50_PDI_Connection_State := "TELEGRAM_ERROR";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END ccf3a547-d3dd-4d8e-b891-23c492f24d38 */ 
    Private Sub RtsEnter_PDI_TELEGRAM_ERROR()
      If not OperatedStates.Contains("20aac7fe-5728-4bfc-8287-5b55af6b26eb|") Then
        OperatedStates = OperatedStates + "20aac7fe-5728-4bfc-8287-5b55af6b26eb|"
      End If
      'Simulation support : Notification function call for entering state : PDI_TELEGRAM_ERROR ///* #REF520# */
      RtsNotify(Me, SENTER, "20aac7fe-5728-4bfc-8287-5b55af6b26eb", 0, NullString)
      SimCore.EnterState("20aac7fe-5728-4bfc-8287-5b55af6b26eb", "PDI_TELEGRAM_ERROR")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR
      'Entry Actions
      D50_PDI_Connection_State.SetValue("TELEGRAM_ERROR")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("75ee8219-b1db-4b1f-aae6-88174c818382|") then
    '   OperatedStates := OperatedStates + "75ee8219-b1db-4b1f-aae6-88174c818382|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_VERSION_UNEQUAL ///* #REF520# */
    ' RtsNotify(This,SENTER,"75ee8219-b1db-4b1f-aae6-88174c818382",0,NullString);
    ' 
    ' SimCore.EnterState("75ee8219-b1db-4b1f-aae6-88174c818382","PDI_VERSION_UNEQUAL");
    ' 
    ' This.RtsCurrent_S_SCI_EfeS_Prim_SR := RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT ed89ef7a-023e-4134-ac22-8ac3e2754fe4 */  D50_PDI_Connection_State := "VERSION_UNEQUAL";
    '  T12_Terminate_SCP_Connection := TRUE; nullstat;/*##END ed89ef7a-023e-4134-ac22-8ac3e2754fe4 */ 
    Private Sub RtsEnter_PDI_VERSION_UNEQUAL()
      If not OperatedStates.Contains("75ee8219-b1db-4b1f-aae6-88174c818382|") Then
        OperatedStates = OperatedStates + "75ee8219-b1db-4b1f-aae6-88174c818382|"
      End If
      'Simulation support : Notification function call for entering state : PDI_VERSION_UNEQUAL ///* #REF520# */
      RtsNotify(Me, SENTER, "75ee8219-b1db-4b1f-aae6-88174c818382", 0, NullString)
      SimCore.EnterState("75ee8219-b1db-4b1f-aae6-88174c818382", "PDI_VERSION_UNEQUAL")
      Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL
      'Entry Actions
      D50_PDI_Connection_State.SetValue("VERSION_UNEQUAL")
      T12_Terminate_SCP_Connection.SetValue(True)
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|") then
    '   OperatedStates := OperatedStates + "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|";
    ' end if
    ' // Simulation support : Notification function call for entering state : WAITING_FOR_VERSION_CHECK ///* #REF520# */
    ' RtsNotify(This,SENTER,"9a914b97-6ed7-4a6d-8a4d-610d8bb245d0",0,NullString);
    ' 
    ' SimCore.EnterState("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0","ESTABLISHING_PDI_CONNECTION::WAITING_FOR_VERSION_CHECK");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT bce65948-5459-49ba-b49d-08d51b2211dd */  D50_PDI_Connection_State := "WAITING_FOR_VERSION_CHECK"; nullstat;/*##END bce65948-5459-49ba-b49d-08d51b2211dd */ 
    Private Sub RtsEnter_WAITING_FOR_VERSION_CHECK()
      If not OperatedStates.Contains("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|") Then
        OperatedStates = OperatedStates + "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|"
      End If
      'Simulation support : Notification function call for entering state : WAITING_FOR_VERSION_CHECK ///* #REF520# */
      RtsNotify(Me, SENTER, "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0", 0, NullString)
      SimCore.EnterState("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0", "ESTABLISHING_PDI_CONNECTION::WAITING_FOR_VERSION_CHECK")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK
      'Entry Actions
      D50_PDI_Connection_State.SetValue("WAITING_FOR_VERSION_CHECK")
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("ef441dfe-7565-4ca3-97e8-94ecc3b3b025|") then
    '   OperatedStates := OperatedStates + "ef441dfe-7565-4ca3-97e8-94ecc3b3b025|";
    ' end if
    ' // Simulation support : Notification function call for entering state : WAITING_FOR_INITIALISATION ///* #REF520# */
    ' RtsNotify(This,SENTER,"ef441dfe-7565-4ca3-97e8-94ecc3b3b025",0,NullString);
    ' 
    ' SimCore.EnterState("ef441dfe-7565-4ca3-97e8-94ecc3b3b025","ESTABLISHING_PDI_CONNECTION::WAITING_FOR_INITIALISATION");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 4c07e2f1-0382-42b4-a6f8-435de826d15b */  D50_PDI_Connection_State := "WAITING_FOR_INITIALISATION"; nullstat;/*##END 4c07e2f1-0382-42b4-a6f8-435de826d15b */ 
    Private Sub RtsEnter_WAITING_FOR_INITIALISATION()
      If not OperatedStates.Contains("ef441dfe-7565-4ca3-97e8-94ecc3b3b025|") Then
        OperatedStates = OperatedStates + "ef441dfe-7565-4ca3-97e8-94ecc3b3b025|"
      End If
      'Simulation support : Notification function call for entering state : WAITING_FOR_INITIALISATION ///* #REF520# */
      RtsNotify(Me, SENTER, "ef441dfe-7565-4ca3-97e8-94ecc3b3b025", 0, NullString)
      SimCore.EnterState("ef441dfe-7565-4ca3-97e8-94ecc3b3b025", "ESTABLISHING_PDI_CONNECTION::WAITING_FOR_INITIALISATION")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION
      'Entry Actions
      D50_PDI_Connection_State.SetValue("WAITING_FOR_INITIALISATION")
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("f9fbd6fa-9c83-489f-8748-0aa539878f54|") then
    '   OperatedStates := OperatedStates + "f9fbd6fa-9c83-489f-8748-0aa539878f54|";
    ' end if
    ' // Simulation support : Notification function call for entering state : RECEIVING_STATUS ///* #REF520# */
    ' RtsNotify(This,SENTER,"f9fbd6fa-9c83-489f-8748-0aa539878f54",0,NullString);
    ' 
    ' SimCore.EnterState("f9fbd6fa-9c83-489f-8748-0aa539878f54","ESTABLISHING_PDI_CONNECTION::RECEIVING_STATUS");
    ' 
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS;/* #REF521# */
    ' /* #REF522# */
    ' // Entry Actions
    ' /*##STRT 7ec1447f-1572-4673-a4f1-541804ac157a */  D50_PDI_Connection_State := "RECEIVING_STATUS"; nullstat;/*##END 7ec1447f-1572-4673-a4f1-541804ac157a */ 
    Private Sub RtsEnter_RECEIVING_STATUS()
      If not OperatedStates.Contains("f9fbd6fa-9c83-489f-8748-0aa539878f54|") Then
        OperatedStates = OperatedStates + "f9fbd6fa-9c83-489f-8748-0aa539878f54|"
      End If
      'Simulation support : Notification function call for entering state : RECEIVING_STATUS ///* #REF520# */
      RtsNotify(Me, SENTER, "f9fbd6fa-9c83-489f-8748-0aa539878f54", 0, NullString)
      SimCore.EnterState("f9fbd6fa-9c83-489f-8748-0aa539878f54", "ESTABLISHING_PDI_CONNECTION::RECEIVING_STATUS")
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS
      'Entry Actions
      D50_PDI_Connection_State.SetValue("RECEIVING_STATUS")
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
    ' 	RtsNotify(This,SEXIT,"bdcc7435-7f33-4928-ae06-59dfc65451ee",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_ESTABLISHING_PDI_CONNECTION ();
    ' 	/* #REF750# */
    ' 	// Stop Timers/* #REF751# */
    ' 	SMSupport.RtsBase.RtsStopTimer(This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1);
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_ESTABLISHING_PDI_CONNECTION()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        'Simulation support : Notification function call for exiting state : ESTABLISHING_PDI_CONNECTION
        RtsNotify(Me, SEXIT, "bdcc7435-7f33-4928-ae06-59dfc65451ee", 0, NullString)
        RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
        'Stop Timers/* #REF751# */
        SMSupport.RtsBase.RtsStopTimer(Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1)
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CHECKSUM_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CHECKSUM_UNEQUAL
    ' 	RtsNotify(This,SEXIT,"08d17299-aa85-4b73-b62f-4747a62ec517",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CHECKSUM_UNEQUAL ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CHECKSUM_UNEQUAL()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CHECKSUM_UNEQUAL Then
        'Simulation support : Notification function call for exiting state : PDI_CHECKSUM_UNEQUAL
        RtsNotify(Me, SEXIT, "08d17299-aa85-4b73-b62f-4747a62ec517", 0, NullString)
        RtsExitSSOf_PDI_CHECKSUM_UNEQUAL()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_CLOSED
    ' 	RtsNotify(This,SEXIT,"a598dff8-2813-4044-91cf-7925354bb8c6",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_CLOSED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_CLOSED()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_CLOSED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_CLOSED
        RtsNotify(Me, SEXIT, "a598dff8-2813-4044-91cf-7925354bb8c6", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_CLOSED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
    ' 	RtsNotify(This,SEXIT,"b9b274ca-51f6-4d04-b575-d606028484e7",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_ESTABLISHED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_ESTABLISHED()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_ESTABLISHED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
        RtsNotify(Me, SEXIT, "b9b274ca-51f6-4d04-b575-d606028484e7", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_IMPERMISSIBLE then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_IMPERMISSIBLE
    ' 	RtsNotify(This,SEXIT,"b8180ee0-f815-4867-bb62-832cd4094618",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_IMPERMISSIBLE()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_CONNECTION_IMPERMISSIBLE Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_IMPERMISSIBLE
        RtsNotify(Me, SEXIT, "b8180ee0-f815-4867-bb62-832cd4094618", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_INIT_TIMEOUT
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_INIT_TIMEOUT
    ' 	RtsNotify(This,SEXIT,"02dab697-cfb1-4216-a08a-d400f1acb5ac",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_INIT_TIMEOUT ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_INIT_TIMEOUT()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_INIT_TIMEOUT Then
        'Simulation support : Notification function call for exiting state : PDI_INIT_TIMEOUT
        RtsNotify(Me, SEXIT, "02dab697-cfb1-4216-a08a-d400f1acb5ac", 0, NullString)
        RtsExitSSOf_PDI_INIT_TIMEOUT()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_PROTOCOL_ERROR
    ' 	RtsNotify(This,SEXIT,"e7d99859-8866-4d95-a105-66009d324e06",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_PROTOCOL_ERROR ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_PROTOCOL_ERROR()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_PROTOCOL_ERROR Then
        'Simulation support : Notification function call for exiting state : PDI_PROTOCOL_ERROR
        RtsNotify(Me, SEXIT, "e7d99859-8866-4d95-a105-66009d324e06", 0, NullString)
        RtsExitSSOf_PDI_PROTOCOL_ERROR()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_TELEGRAM_ERROR
    ' 	RtsNotify(This,SEXIT,"20aac7fe-5728-4bfc-8287-5b55af6b26eb",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_TELEGRAM_ERROR ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_TELEGRAM_ERROR()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_TELEGRAM_ERROR Then
        'Simulation support : Notification function call for exiting state : PDI_TELEGRAM_ERROR
        RtsNotify(Me, SEXIT, "20aac7fe-5728-4bfc-8287-5b55af6b26eb", 0, NullString)
        RtsExitSSOf_PDI_TELEGRAM_ERROR()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_VERSION_UNEQUAL
    ' 	RtsNotify(This,SEXIT,"75ee8219-b1db-4b1f-aae6-88174c818382",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_VERSION_UNEQUAL ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_VERSION_UNEQUAL()
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_PDI_VERSION_UNEQUAL Then
        'Simulation support : Notification function call for exiting state : PDI_VERSION_UNEQUAL
        RtsNotify(Me, SEXIT, "75ee8219-b1db-4b1f-aae6-88174c818382", 0, NullString)
        RtsExitSSOf_PDI_VERSION_UNEQUAL()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : WAITING_FOR_VERSION_CHECK
    ' 	RtsNotify(This,SEXIT,"9a914b97-6ed7-4a6d-8a4d-610d8bb245d0",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_WAITING_FOR_VERSION_CHECK ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_WAITING_FOR_VERSION_CHECK()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK Then
        'Simulation support : Notification function call for exiting state : WAITING_FOR_VERSION_CHECK
        RtsNotify(Me, SEXIT, "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0", 0, NullString)
        RtsExitSSOf_WAITING_FOR_VERSION_CHECK()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : WAITING_FOR_INITIALISATION
    ' 	RtsNotify(This,SEXIT,"ef441dfe-7565-4ca3-97e8-94ecc3b3b025",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_WAITING_FOR_INITIALISATION ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_WAITING_FOR_INITIALISATION()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION Then
        'Simulation support : Notification function call for exiting state : WAITING_FOR_INITIALISATION
        RtsNotify(Me, SEXIT, "ef441dfe-7565-4ca3-97e8-94ecc3b3b025", 0, NullString)
        RtsExitSSOf_WAITING_FOR_INITIALISATION()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if This.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : RECEIVING_STATUS
    ' 	RtsNotify(This,SEXIT,"f9fbd6fa-9c83-489f-8748-0aa539878f54",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_RECEIVING_STATUS ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_RECEIVING_STATUS()
      If Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS Then
        'Simulation support : Notification function call for exiting state : RECEIVING_STATUS
        RtsNotify(Me, SEXIT, "f9fbd6fa-9c83-489f-8748-0aa539878f54", 0, NullString)
        RtsExitSSOf_RECEIVING_STATUS()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"c9551e30-1655-4f5b-965e-7615f08937ba",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"c9551e30-1655-4f5b-965e-7615f08937ba",0,NullString);/* #REF1576# */
    ' This.RtsEnter_ESTABLISHING_PDI_CONNECTION();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"aae77615-89f3-41c3-8a73-9a17e4435ddf",0,NullString);/* #REF1585# */
    ' /*##STRT 3ec38848-39a1-40d5-9328-e0071784bb18 */  DT7_PDI_Version := D3_Con_PDI_Version ;
    '  T7_Cd_PDI_Version_Check := TRUE; nullstat;/*##END 3ec38848-39a1-40d5-9328-e0071784bb18 */ /* #REF1546# */
    ' This.RtsEnter_WAITING_FOR_VERSION_CHECK();/* #REF1590# */
    ' 
    Private Sub RtsDefault_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "c9551e30-1655-4f5b-965e-7615f08937ba", 0, NullString)
      RtsNotify(Me, SEXIT, "c9551e30-1655-4f5b-965e-7615f08937ba", 0, NullString)
      Me.RtsEnter_ESTABLISHING_PDI_CONNECTION()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "aae77615-89f3-41c3-8a73-9a17e4435ddf", 0, NullString)
      DT7_PDI_Version.SetValue(D3_Con_PDI_Version.GetLatchedValue())
      T7_Cd_PDI_Version_Check.SetValue(True)
      Me.RtsEnter_WAITING_FOR_VERSION_CHECK()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As S_SCI_EfeS_Prim_SR)
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, "RtsS_SCI_EfeS_Prim_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, "RtsS_SCI_EfeS_Prim_SR_States");
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "12a3fc7b-e1a9-4000-a330-e34983cb84c8";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "6";
    '   Value := Value + "|RtsCurrent_S_SCI_EfeS_Prim_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_S_SCI_EfeS_Prim_SR";
    '   Value := Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As S_SCI_EfeS_Prim_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, "RtsS_SCI_EfeS_Prim_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, "RtsS_SCI_EfeS_Prim_SR_States")
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "12a3fc7b-e1a9-4000-a330-e34983cb84c8"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "6"
        Value = Value + "|RtsCurrent_S_SCI_EfeS_Prim_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_S_SCI_EfeS_Prim_SR"
        Value = Value + "|RtsCurrent_ESTABLISHING_PDI_CONNECTION"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, Value, "RtsS_SCI_EfeS_Prim_SR_States", GetType(S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SR_States));
    ' end if
    ' if Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States", GetType(S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As S_SCI_EfeS_Prim_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_S_SCI_EfeS_Prim_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_S_SCI_EfeS_Prim_SR, Value, "RtsS_SCI_EfeS_Prim_SR_States", GetType(S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SR_States))
      End If
      If Name = "RtsCurrent_ESTABLISHING_PDI_CONNECTION" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_ESTABLISHING_PDI_CONNECTION, Value, "RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States", GetType(S_SCI_EfeS_Prim_SR.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' SMSupport.RtsBase.RtsStopTimer(This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1);
    ' declare RetValue := false : boolean;
    '   SMSupport.RtsBase.RtsLock(This.RtsBusy);
    '   This.RtsESTABLISHING_PDI_CONNECTION_Timer1_In_S_SCI_EfeS_Prim_SR(RetValue);
    '   RetValue := true;
    '   while RetValue do
    '     This.RtsRunToCompletion(RetValue);
    '   end while
    '   SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Private Sub RtsESTABLISHING_PDI_CONNECTION_Timer1()
      SMSupport.RtsBase.RtsStopTimer(Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1)
      Dim RetValue As boolean = False
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      Me.RtsESTABLISHING_PDI_CONNECTION_Timer1_In_S_SCI_EfeS_Prim_SR(RetValue)
      RetValue = True
      While RetValue
        Me.RtsRunToCompletion(RetValue)
      End While
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' // H1 ESTABLISHING_PDI_CONNECTION
    ' if This.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION then/* #REF5# */
    ' /* #REF6# */
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_ESTABLISHING_PDI_CONNECTION */
    ' 	/* standard */
    ' 	This.RtsExit_ESTABLISHING_PDI_CONNECTION();/* #REF1596# */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"bf045ca0-8df5-4382-b69a-26d902b052c5",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 7b8c2f80-2263-4508-8b76-391d5da5b8f8 */  nullstat;/*##END 7b8c2f80-2263-4508-8b76-391d5da5b8f8 */ /* #REF1546# */
    ' 	This.RtsEnter_PDI_INIT_TIMEOUT();/* #REF1590# */
    ' 	/* #REF13# */
    ' 	RetValue := true;
    ' 	return;
    ' 	/* #REF15# */
    ' end if
    ' RetValue := false;/* #REF4# */
    ' return;
    Private Sub RtsESTABLISHING_PDI_CONNECTION_Timer1_In_S_SCI_EfeS_Prim_SR(ByRef RetValue As Boolean)
      'H1 ESTABLISHING_PDI_CONNECTION
      If Me.RtsCurrent_S_SCI_EfeS_Prim_SR = RtsS_SCI_EfeS_Prim_SR_States.RtsS_SCI_EfeS_Prim_SR_States_ESTABLISHING_PDI_CONNECTION Then
        Me.RtsExit_ESTABLISHING_PDI_CONNECTION()
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "bf045ca0-8df5-4382-b69a-26d902b052c5", 0, NullString)
        Me.RtsEnter_PDI_INIT_TIMEOUT()
        RetValue = True
        Return
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Created for state : ESTABLISHING_PDI_CONNECTION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("bdcc7435-7f33-4928-ae06-59dfc65451ee|") then
    '   OperatedStates := OperatedStates + "bdcc7435-7f33-4928-ae06-59dfc65451ee|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_ESTABLISHING_PDI_CONNECTION
    ' /* #REF738# */
    ' 	case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_WAITING_FOR_VERSION_CHECK();/* #REF742# */
    ' 	case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_WAITING_FOR_INITIALISATION();/* #REF742# */
    ' 	case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_RECEIVING_STATUS();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_ESTABLISHING_PDI_CONNECTION := RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States{enum_datatype}.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_ESTABLISHING_PDI_CONNECTION()
      If not OperatedStates.Contains("bdcc7435-7f33-4928-ae06-59dfc65451ee|") Then
        OperatedStates = OperatedStates + "bdcc7435-7f33-4928-ae06-59dfc65451ee|"
      End If
      Select Case Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION
        Case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_VERSION_CHECK
          Me.RtsExit_WAITING_FOR_VERSION_CHECK()
        Case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_WAITING_FOR_INITIALISATION
          Me.RtsExit_WAITING_FOR_INITIALISATION()
        Case RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_RECEIVING_STATUS
          Me.RtsExit_RECEIVING_STATUS()
      End Select
      Me.RtsCurrent_ESTABLISHING_PDI_CONNECTION = RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States.RtsS_SCI_EfeS_Prim_SRESTABLISHING_PDI_CONNECTION_States_NotIn_ESTABLISHING_PDI_CONNECTION
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CHECKSUM_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("08d17299-aa85-4b73-b62f-4747a62ec517|") then
    '   OperatedStates := OperatedStates + "08d17299-aa85-4b73-b62f-4747a62ec517|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CHECKSUM_UNEQUAL()
      If not OperatedStates.Contains("08d17299-aa85-4b73-b62f-4747a62ec517|") Then
        OperatedStates = OperatedStates + "08d17299-aa85-4b73-b62f-4747a62ec517|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_CLOSED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("a598dff8-2813-4044-91cf-7925354bb8c6|") then
    '   OperatedStates := OperatedStates + "a598dff8-2813-4044-91cf-7925354bb8c6|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_CLOSED()
      If not OperatedStates.Contains("a598dff8-2813-4044-91cf-7925354bb8c6|") Then
        OperatedStates = OperatedStates + "a598dff8-2813-4044-91cf-7925354bb8c6|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b9b274ca-51f6-4d04-b575-d606028484e7|") then
    '   OperatedStates := OperatedStates + "b9b274ca-51f6-4d04-b575-d606028484e7|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("b9b274ca-51f6-4d04-b575-d606028484e7|") Then
        OperatedStates = OperatedStates + "b9b274ca-51f6-4d04-b575-d606028484e7|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_IMPERMISSIBLE
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("b8180ee0-f815-4867-bb62-832cd4094618|") then
    '   OperatedStates := OperatedStates + "b8180ee0-f815-4867-bb62-832cd4094618|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_IMPERMISSIBLE()
      If not OperatedStates.Contains("b8180ee0-f815-4867-bb62-832cd4094618|") Then
        OperatedStates = OperatedStates + "b8180ee0-f815-4867-bb62-832cd4094618|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_INIT_TIMEOUT
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("02dab697-cfb1-4216-a08a-d400f1acb5ac|") then
    '   OperatedStates := OperatedStates + "02dab697-cfb1-4216-a08a-d400f1acb5ac|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_INIT_TIMEOUT()
      If not OperatedStates.Contains("02dab697-cfb1-4216-a08a-d400f1acb5ac|") Then
        OperatedStates = OperatedStates + "02dab697-cfb1-4216-a08a-d400f1acb5ac|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_PROTOCOL_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("e7d99859-8866-4d95-a105-66009d324e06|") then
    '   OperatedStates := OperatedStates + "e7d99859-8866-4d95-a105-66009d324e06|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_PROTOCOL_ERROR()
      If not OperatedStates.Contains("e7d99859-8866-4d95-a105-66009d324e06|") Then
        OperatedStates = OperatedStates + "e7d99859-8866-4d95-a105-66009d324e06|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_TELEGRAM_ERROR
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("20aac7fe-5728-4bfc-8287-5b55af6b26eb|") then
    '   OperatedStates := OperatedStates + "20aac7fe-5728-4bfc-8287-5b55af6b26eb|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_TELEGRAM_ERROR()
      If not OperatedStates.Contains("20aac7fe-5728-4bfc-8287-5b55af6b26eb|") Then
        OperatedStates = OperatedStates + "20aac7fe-5728-4bfc-8287-5b55af6b26eb|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_VERSION_UNEQUAL
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("75ee8219-b1db-4b1f-aae6-88174c818382|") then
    '   OperatedStates := OperatedStates + "75ee8219-b1db-4b1f-aae6-88174c818382|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_VERSION_UNEQUAL()
      If not OperatedStates.Contains("75ee8219-b1db-4b1f-aae6-88174c818382|") Then
        OperatedStates = OperatedStates + "75ee8219-b1db-4b1f-aae6-88174c818382|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_VERSION_CHECK
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|") then
    '   OperatedStates := OperatedStates + "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_WAITING_FOR_VERSION_CHECK()
      If not OperatedStates.Contains("9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|") Then
        OperatedStates = OperatedStates + "9a914b97-6ed7-4a6d-8a4d-610d8bb245d0|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : WAITING_FOR_INITIALISATION
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("ef441dfe-7565-4ca3-97e8-94ecc3b3b025|") then
    '   OperatedStates := OperatedStates + "ef441dfe-7565-4ca3-97e8-94ecc3b3b025|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_WAITING_FOR_INITIALISATION()
      If not OperatedStates.Contains("ef441dfe-7565-4ca3-97e8-94ecc3b3b025|") Then
        OperatedStates = OperatedStates + "ef441dfe-7565-4ca3-97e8-94ecc3b3b025|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' if not OperatedStates.Contains ("f9fbd6fa-9c83-489f-8748-0aa539878f54|") then
    '   OperatedStates := OperatedStates + "f9fbd6fa-9c83-489f-8748-0aa539878f54|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_RECEIVING_STATUS()
      If not OperatedStates.Contains("f9fbd6fa-9c83-489f-8748-0aa539878f54|") Then
        OperatedStates = OperatedStates + "f9fbd6fa-9c83-489f-8748-0aa539878f54|"
      End If
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TStep(CurrentTime);
    ' if This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.HasElapsed() then
    '   This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TStop();
    '   RtsESTABLISHING_PDI_CONNECTION_Timer1_CallBack(This);
    ' end if
    ' Ret := SMSupport.Duration.MinOf(Ret, This.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TimeToLive());
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TStep(CurrentTime)
      If Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.HasElapsed() Then
        Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TStop()
        RtsESTABLISHING_PDI_CONNECTION_Timer1_CallBack(Me)
      End If
      Ret = SMSupport.Duration.MinOf(Ret, Me.RtsAttESTABLISHING_PDI_CONNECTION_Timer1.TimeToLive())
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D23_Con_Checksum_Data_Used: a SySimInputPort;
    ' assume D2_Con_tmax_PDI_Connection: a SySimInputPort;
    ' assume D3_Con_PDI_Version: a SySimInputPort;
    ' assume D4_Con_Checksum_Data: a SySimInputPort;
    ' assume D50_PDI_Connection_State: a SySimOutputPort;
    ' assume DT13_Checksum_Data: a SySimInputPort;
    ' assume DT13_Result: a SySimInputPort;
    ' assume DT7_PDI_Version: a SySimOutputPort;
    ' assume T10_SCP_Connection_Terminated: a SySimInputPort;
    ' assume T12_Terminate_SCP_Connection: a SySimOutputPort;
    ' assume T13_Msg_PDI_Version_Check: a SySimInputPort;
    ' assume T14_Msg_Start_Initialisation: a SySimInputPort;
    ' assume T15_Msg_Initialisation_Completed: a SySimInputPort;
    ' assume T20_Protocol_Error: a SySimInputPort;
    ' assume T21_Formal_Telegram_Error: a SySimInputPort;
    ' assume T22_Content_Telegram_Error: a SySimInputPort;
    ' assume T5_SCP_Connection_Established: a SySimInputPort;
    ' assume T6_Establish_SCP_Connection: a SySimOutputPort;
    ' assume T7_Cd_PDI_Version_Check: a SySimOutputPort;
    ' assume T8_Cd_Initialisation_Request: a SySimOutputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg9Tmp := (/*##STRT ca96e462-8d46-46d3-96d9-24c433ae53be */ ( T5_SCP_Connection_Established )/*##END ca96e462-8d46-46d3-96d9-24c433ae53be */ ) : Boolean;
    ' ChgFlg9 := EvalTrigger(ChgFlg9Tmp , ChgFlgLast9);
    ' declare ChgFlg14Tmp := (/*##STRT e978b143-001b-4e30-90fc-17901bdf39ea */ ( T10_SCP_Connection_Terminated )/*##END e978b143-001b-4e30-90fc-17901bdf39ea */ ) : Boolean;
    ' ChgFlg14 := EvalTrigger(ChgFlg14Tmp , ChgFlgLast14);
    ' declare ChgFlg8Tmp := (/*##STRT 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ( T10_SCP_Connection_Terminated )/*##END 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg3Tmp := (/*##STRT 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ( T21_Formal_Telegram_Error )/*##END 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg7Tmp := (/*##STRT 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ( T15_Msg_Initialisation_Completed )/*##END 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg1Tmp := (/*##STRT b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ( T10_SCP_Connection_Terminated )/*##END b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg10Tmp := (/*##STRT 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ( T10_SCP_Connection_Terminated )/*##END 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ) : Boolean;
    ' ChgFlg10 := EvalTrigger(ChgFlg10Tmp , ChgFlgLast10);
    ' declare ChgFlg11Tmp := (/*##STRT fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ( T20_Protocol_Error )/*##END fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ) : Boolean;
    ' ChgFlg11 := EvalTrigger(ChgFlg11Tmp , ChgFlgLast11);
    ' declare ChgFlg17Tmp := (/*##STRT 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ( T10_SCP_Connection_Terminated )/*##END 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ) : Boolean;
    ' ChgFlg17 := EvalTrigger(ChgFlg17Tmp , ChgFlgLast17);
    ' declare ChgFlg6Tmp := (/*##STRT 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ( T14_Msg_Start_Initialisation )/*##END 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg12Tmp := (/*##STRT dbe4f45c-407c-43fe-aa21-278494194b28 */ ( T21_Formal_Telegram_Error )/*##END dbe4f45c-407c-43fe-aa21-278494194b28 */ ) : Boolean;
    ' ChgFlg12 := EvalTrigger(ChgFlg12Tmp , ChgFlgLast12);
    ' declare ChgFlg4Tmp := (/*##STRT d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ( T22_Content_Telegram_Error )/*##END d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg13Tmp := (/*##STRT 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ( T22_Content_Telegram_Error )/*##END 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ) : Boolean;
    ' ChgFlg13 := EvalTrigger(ChgFlg13Tmp , ChgFlgLast13);
    ' declare ChgFlg16Tmp := (/*##STRT 5f266780-9097-4ed3-b252-f212bcb21af2 */ ( T10_SCP_Connection_Terminated )/*##END 5f266780-9097-4ed3-b252-f212bcb21af2 */ ) : Boolean;
    ' ChgFlg16 := EvalTrigger(ChgFlg16Tmp , ChgFlgLast16);
    ' declare ChgFlg5Tmp := (/*##STRT 87d54294-f204-4917-b527-85aed8908720 */ ( T13_Msg_PDI_Version_Check )/*##END 87d54294-f204-4917-b527-85aed8908720 */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg15Tmp := (/*##STRT 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ( T10_SCP_Connection_Terminated )/*##END 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ) : Boolean;
    ' ChgFlg15 := EvalTrigger(ChgFlg15Tmp , ChgFlgLast15);
    ' declare ChgFlg2Tmp := (/*##STRT 672713c8-6f81-496f-9aff-5665b61e577d */ ( T20_Protocol_Error )/*##END 672713c8-6f81-496f-9aff-5665b61e577d */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast9 := ChgFlg9Tmp;
    ' ChgFlgLast14 := ChgFlg14Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast10 := ChgFlg10Tmp;
    ' ChgFlgLast11 := ChgFlg11Tmp;
    ' ChgFlgLast17 := ChgFlg17Tmp;
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast12 := ChgFlg12Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast13 := ChgFlg13Tmp;
    ' ChgFlgLast16 := ChgFlg16Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast15 := ChgFlg15Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg9 := (/*##STRT ca96e462-8d46-46d3-96d9-24c433ae53be */ ( T5_SCP_Connection_Established )/*##END ca96e462-8d46-46d3-96d9-24c433ae53be */ ) : Boolean;
    '   declare MaskedChgFlg14 := (/*##STRT e978b143-001b-4e30-90fc-17901bdf39ea */ ( T10_SCP_Connection_Terminated )/*##END e978b143-001b-4e30-90fc-17901bdf39ea */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ( T10_SCP_Connection_Terminated )/*##END 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ( T21_Formal_Telegram_Error )/*##END 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ( T15_Msg_Initialisation_Completed )/*##END 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ( T10_SCP_Connection_Terminated )/*##END b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ) : Boolean;
    '   declare MaskedChgFlg10 := (/*##STRT 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ( T10_SCP_Connection_Terminated )/*##END 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ) : Boolean;
    '   declare MaskedChgFlg11 := (/*##STRT fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ( T20_Protocol_Error )/*##END fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ) : Boolean;
    '   declare MaskedChgFlg17 := (/*##STRT 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ( T10_SCP_Connection_Terminated )/*##END 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ) : Boolean;
    '   declare MaskedChgFlg6 := (/*##STRT 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ( T14_Msg_Start_Initialisation )/*##END 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ) : Boolean;
    '   declare MaskedChgFlg12 := (/*##STRT dbe4f45c-407c-43fe-aa21-278494194b28 */ ( T21_Formal_Telegram_Error )/*##END dbe4f45c-407c-43fe-aa21-278494194b28 */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ( T22_Content_Telegram_Error )/*##END d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ) : Boolean;
    '   declare MaskedChgFlg13 := (/*##STRT 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ( T22_Content_Telegram_Error )/*##END 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ) : Boolean;
    '   declare MaskedChgFlg16 := (/*##STRT 5f266780-9097-4ed3-b252-f212bcb21af2 */ ( T10_SCP_Connection_Terminated )/*##END 5f266780-9097-4ed3-b252-f212bcb21af2 */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT 87d54294-f204-4917-b527-85aed8908720 */ ( T13_Msg_PDI_Version_Check )/*##END 87d54294-f204-4917-b527-85aed8908720 */ ) : Boolean;
    '   declare MaskedChgFlg15 := (/*##STRT 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ( T10_SCP_Connection_Terminated )/*##END 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT 672713c8-6f81-496f-9aff-5665b61e577d */ ( T20_Protocol_Error )/*##END 672713c8-6f81-496f-9aff-5665b61e577d */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg9 := (/*##STRT ca96e462-8d46-46d3-96d9-24c433ae53be */ ( T5_SCP_Connection_Established )/*##END ca96e462-8d46-46d3-96d9-24c433ae53be */ ) : Boolean;
    '   declare UnMaskedChgFlg14 := (/*##STRT e978b143-001b-4e30-90fc-17901bdf39ea */ ( T10_SCP_Connection_Terminated )/*##END e978b143-001b-4e30-90fc-17901bdf39ea */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ( T10_SCP_Connection_Terminated )/*##END 178a09b2-132b-43e7-b9ef-edcd0effe0ed */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ( T21_Formal_Telegram_Error )/*##END 5baed757-a410-4afb-8d7f-4ffe3d34977b */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ( T15_Msg_Initialisation_Completed )/*##END 8b146e83-8184-4964-9ff5-8c9b3b9f609c */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ( T10_SCP_Connection_Terminated )/*##END b83bb344-a81f-4e34-85cd-6c5f8afa58b9 */ ) : Boolean;
    '   declare UnMaskedChgFlg10 := (/*##STRT 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ( T10_SCP_Connection_Terminated )/*##END 23b0af0a-854a-40e0-9f6c-f2a9c972049b */ ) : Boolean;
    '   declare UnMaskedChgFlg11 := (/*##STRT fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ( T20_Protocol_Error )/*##END fd51d7cd-64c8-4916-a8ce-27aa99099b63 */ ) : Boolean;
    '   declare UnMaskedChgFlg17 := (/*##STRT 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ( T10_SCP_Connection_Terminated )/*##END 903e54d1-1898-4583-835a-b2ff85e7e8ce */ ) : Boolean;
    '   declare UnMaskedChgFlg6 := (/*##STRT 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ( T14_Msg_Start_Initialisation )/*##END 5a051e4d-9e85-4363-9957-06e6b7da76b2 */ ) : Boolean;
    '   declare UnMaskedChgFlg12 := (/*##STRT dbe4f45c-407c-43fe-aa21-278494194b28 */ ( T21_Formal_Telegram_Error )/*##END dbe4f45c-407c-43fe-aa21-278494194b28 */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ( T22_Content_Telegram_Error )/*##END d8f786a3-b42a-4473-8227-8ebe8afe82cf */ ) : Boolean;
    '   declare UnMaskedChgFlg13 := (/*##STRT 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ( T22_Content_Telegram_Error )/*##END 0d34c75c-ebea-47ab-bb69-590b26b59f82 */ ) : Boolean;
    '   declare UnMaskedChgFlg16 := (/*##STRT 5f266780-9097-4ed3-b252-f212bcb21af2 */ ( T10_SCP_Connection_Terminated )/*##END 5f266780-9097-4ed3-b252-f212bcb21af2 */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT 87d54294-f204-4917-b527-85aed8908720 */ ( T13_Msg_PDI_Version_Check )/*##END 87d54294-f204-4917-b527-85aed8908720 */ ) : Boolean;
    '   declare UnMaskedChgFlg15 := (/*##STRT 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ( T10_SCP_Connection_Terminated )/*##END 37f1b1ef-4366-46ee-b34d-b5a0b7ab0d9f */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT 672713c8-6f81-496f-9aff-5665b61e577d */ ( T20_Protocol_Error )/*##END 672713c8-6f81-496f-9aff-5665b61e577d */ ) : Boolean;
    '   declare PreviousChgFlg9 := ChgFlg9 : Boolean;
    '   declare PreviousChgFlg14 := ChgFlg14 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg10 := ChgFlg10 : Boolean;
    '   declare PreviousChgFlg11 := ChgFlg11 : Boolean;
    '   declare PreviousChgFlg17 := ChgFlg17 : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg12 := ChgFlg12 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg13 := ChgFlg13 : Boolean;
    '   declare PreviousChgFlg16 := ChgFlg16 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg15 := ChgFlg15 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := True;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := True;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := True;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := True;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := True;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := True;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := True;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := True;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := True;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := True;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := True;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := True;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := True;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := True;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := True;
    '   ChgFlg15 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := True;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg9 := False;
    '   ChgFlg14 := False;
    '   ChgFlg8 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg1 := False;
    '   ChgFlg10 := False;
    '   ChgFlg11 := False;
    '   ChgFlg17 := False;
    '   ChgFlg6 := False;
    '   ChgFlg12 := False;
    '   ChgFlg4 := False;
    '   ChgFlg13 := False;
    '   ChgFlg16 := False;
    '   ChgFlg5 := False;
    '   ChgFlg15 := False;
    '   ChgFlg2 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg9 := false;
    ' ChgFlg14 := false;
    ' ChgFlg8 := false;
    ' ChgFlg3 := false;
    ' ChgFlg7 := false;
    ' ChgFlg1 := false;
    ' ChgFlg10 := false;
    ' ChgFlg11 := false;
    ' ChgFlg17 := false;
    ' ChgFlg6 := false;
    ' ChgFlg12 := false;
    ' ChgFlg4 := false;
    ' ChgFlg13 := false;
    ' ChgFlg16 := false;
    ' ChgFlg5 := false;
    ' ChgFlg15 := false;
    ' ChgFlg2 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg9Tmp As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
      ChgFlg9 = EvalTrigger(ChgFlg9Tmp, ChgFlgLast9)
      Dim ChgFlg14Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg14 = EvalTrigger(ChgFlg14Tmp, ChgFlgLast14)
      Dim ChgFlg8Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg3Tmp As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg7Tmp As Boolean = ((T15_Msg_Initialisation_Completed.GetLatchedValue()))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg1Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg10Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg10 = EvalTrigger(ChgFlg10Tmp, ChgFlgLast10)
      Dim ChgFlg11Tmp As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
      ChgFlg11 = EvalTrigger(ChgFlg11Tmp, ChgFlgLast11)
      Dim ChgFlg17Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg17 = EvalTrigger(ChgFlg17Tmp, ChgFlgLast17)
      Dim ChgFlg6Tmp As Boolean = ((T14_Msg_Start_Initialisation.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg12Tmp As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
      ChgFlg12 = EvalTrigger(ChgFlg12Tmp, ChgFlgLast12)
      Dim ChgFlg4Tmp As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg13Tmp As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
      ChgFlg13 = EvalTrigger(ChgFlg13Tmp, ChgFlgLast13)
      Dim ChgFlg16Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg16 = EvalTrigger(ChgFlg16Tmp, ChgFlgLast16)
      Dim ChgFlg5Tmp As Boolean = ((T13_Msg_PDI_Version_Check.GetLatchedValue()))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg15Tmp As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
      ChgFlg15 = EvalTrigger(ChgFlg15Tmp, ChgFlgLast15)
      Dim ChgFlg2Tmp As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast9 = ChgFlg9Tmp
      ChgFlgLast14 = ChgFlg14Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast10 = ChgFlg10Tmp
      ChgFlgLast11 = ChgFlg11Tmp
      ChgFlgLast17 = ChgFlg17Tmp
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast12 = ChgFlg12Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast13 = ChgFlg13Tmp
      ChgFlgLast16 = ChgFlg16Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast15 = ChgFlg15Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg9 As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
        Dim MaskedChgFlg14 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg8 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg7 As Boolean = ((T15_Msg_Initialisation_Completed.GetLatchedValue()))
        Dim MaskedChgFlg1 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg10 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg11 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim MaskedChgFlg17 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg6 As Boolean = ((T14_Msg_Start_Initialisation.GetLatchedValue()))
        Dim MaskedChgFlg12 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg4 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg13 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim MaskedChgFlg16 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg5 As Boolean = ((T13_Msg_PDI_Version_Check.GetLatchedValue()))
        Dim MaskedChgFlg15 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim MaskedChgFlg2 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg9 As Boolean = ((T5_SCP_Connection_Established.GetLatchedValue()))
        Dim UnMaskedChgFlg14 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg8 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg7 As Boolean = ((T15_Msg_Initialisation_Completed.GetLatchedValue()))
        Dim UnMaskedChgFlg1 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg10 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg11 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg17 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg6 As Boolean = ((T14_Msg_Start_Initialisation.GetLatchedValue()))
        Dim UnMaskedChgFlg12 As Boolean = ((T21_Formal_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg4 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg13 As Boolean = ((T22_Content_Telegram_Error.GetLatchedValue()))
        Dim UnMaskedChgFlg16 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg5 As Boolean = ((T13_Msg_PDI_Version_Check.GetLatchedValue()))
        Dim UnMaskedChgFlg15 As Boolean = ((T10_SCP_Connection_Terminated.GetLatchedValue()))
        Dim UnMaskedChgFlg2 As Boolean = ((T20_Protocol_Error.GetLatchedValue()))
        Dim PreviousChgFlg9 As Boolean = ChgFlg9
        Dim PreviousChgFlg14 As Boolean = ChgFlg14
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg10 As Boolean = ChgFlg10
        Dim PreviousChgFlg11 As Boolean = ChgFlg11
        Dim PreviousChgFlg17 As Boolean = ChgFlg17
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg12 As Boolean = ChgFlg12
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg13 As Boolean = ChgFlg13
        Dim PreviousChgFlg16 As Boolean = ChgFlg16
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg15 As Boolean = ChgFlg15
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg9 And UnMaskedChgFlg9 And Not MaskedChgFlg9 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = True
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg14 And UnMaskedChgFlg14 And Not MaskedChgFlg14 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = True
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = True
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = True
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = True
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = True
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg10 And UnMaskedChgFlg10 And Not MaskedChgFlg10 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = True
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg11 And UnMaskedChgFlg11 And Not MaskedChgFlg11 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = True
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg17 And UnMaskedChgFlg17 And Not MaskedChgFlg17 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = True
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = True
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg12 And UnMaskedChgFlg12 And Not MaskedChgFlg12 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = True
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = True
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg13 And UnMaskedChgFlg13 And Not MaskedChgFlg13 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = True
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg16 And UnMaskedChgFlg16 And Not MaskedChgFlg16 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = True
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = True
          ChgFlg15 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg15 And UnMaskedChgFlg15 And Not MaskedChgFlg15 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = True
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg9 = False
          ChgFlg14 = False
          ChgFlg8 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg1 = False
          ChgFlg10 = False
          ChgFlg11 = False
          ChgFlg17 = False
          ChgFlg6 = False
          ChgFlg12 = False
          ChgFlg4 = False
          ChgFlg13 = False
          ChgFlg16 = False
          ChgFlg5 = False
          ChgFlg15 = False
          ChgFlg2 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg9 = False
      ChgFlg14 = False
      ChgFlg8 = False
      ChgFlg3 = False
      ChgFlg7 = False
      ChgFlg1 = False
      ChgFlg10 = False
      ChgFlg11 = False
      ChgFlg17 = False
      ChgFlg6 = False
      ChgFlg12 = False
      ChgFlg4 = False
      ChgFlg13 = False
      ChgFlg16 = False
      ChgFlg5 = False
      ChgFlg15 = False
      ChgFlg2 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D23_Con_Checksum_Data_Used.Decrement())
      Ret = (Ret Or D2_Con_tmax_PDI_Connection.Decrement())
      Ret = (Ret Or D3_Con_PDI_Version.Decrement())
      Ret = (Ret Or D4_Con_Checksum_Data.Decrement())
      Ret = (Ret Or DT13_Checksum_Data.Decrement())
      Ret = (Ret Or DT13_Result.Decrement())
      Ret = (Ret Or T10_SCP_Connection_Terminated.Decrement())
      Ret = (Ret Or T13_Msg_PDI_Version_Check.Decrement())
      Ret = (Ret Or T14_Msg_Start_Initialisation.Decrement())
      Ret = (Ret Or T15_Msg_Initialisation_Completed.Decrement())
      Ret = (Ret Or T20_Protocol_Error.Decrement())
      Ret = (Ret Or T21_Formal_Telegram_Error.Decrement())
      Ret = (Ret Or T22_Content_Telegram_Error.Decrement())
      Ret = (Ret Or T5_SCP_Connection_Established.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D23_Con_Checksum_Data_Used.Mask(What)
      D2_Con_tmax_PDI_Connection.Mask(What)
      D3_Con_PDI_Version.Mask(What)
      D4_Con_Checksum_Data.Mask(What)
      DT13_Checksum_Data.Mask(What)
      DT13_Result.Mask(What)
      T10_SCP_Connection_Terminated.Mask(What)
      T13_Msg_PDI_Version_Check.Mask(What)
      T14_Msg_Start_Initialisation.Mask(What)
      T15_Msg_Initialisation_Completed.Mask(What)
      T20_Protocol_Error.Mask(What)
      T21_Formal_Telegram_Error.Mask(What)
      T22_Content_Telegram_Error.Mask(What)
      T5_SCP_Connection_Established.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
  <System.ComponentModel.ToolboxItem(False)> _
  Public Class S_SCI_P_SR : Implements SMSupport.SMQueued 
    Protected Class S_SCI_P_SRSMQueue : Inherits SMSupport.SMQueue
      Public Overrides Sub DispatchOne(ByVal Target As SMSupport.SMQueued, ByVal Msg As SMSupport.SMMessage)
        Dim TheTarget As S_SCI_P_SR = Target
        TheTarget.Sender = Msg.GetSender()
        Select Case Msg.GetId()
        End Select
        
      End Sub
      
    End Class
    Public Shadows Class TypeConverter : Inherits SMSupport.TypeConverterBase
    End Class
    Public Enum RtsS_SCI_P_SR_States
      RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED
      RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT
      RtsS_SCI_P_SR_States_NotIn_S_SCI_P_SR
    End Enum
    Public Enum RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States
      RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS
      RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED
      RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_NotIn_RECEIVING_STATUS_REPORT
    End Enum
    ' \ART_SMG :: Created for state : S_SCI_P_SR
    Private RtsCurrent_S_SCI_P_SR As S_SCI_P_SR.RtsS_SCI_P_SR_States
    ' \ART_SMG :: Created for state : RECEIVING_STATUS_REPORT
    Private RtsCurrent_RECEIVING_STATUS_REPORT As S_SCI_P_SR.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States
    ' \ART_SMG :: Always Created
    Private RtsBusy As SMSupport.RtsSemaphore
    Private ChgFlgLast6 As Boolean
    Private ChgFlg6 As Boolean
    Private ChgFlgLast8 As Boolean
    Private ChgFlg8 As Boolean
    Private ChgFlgLast4 As Boolean
    Private ChgFlg4 As Boolean
    Private ChgFlgLast1 As Boolean
    Private ChgFlg1 As Boolean
    Private ChgFlgLast3 As Boolean
    Private ChgFlg3 As Boolean
    Private ChgFlgLast7 As Boolean
    Private ChgFlg7 As Boolean
    Private ChgFlgLast5 As Boolean
    Private ChgFlg5 As Boolean
    Private ChgFlgLast2 As Boolean
    Private ChgFlg2 As Boolean
    Private Const TickDivider As Single = 0.050
    Private CurrentTime As SMSupport.Time
    Private OperatedStates As String = ""
    Private SMStarted As Boolean
    Protected Shadows Sender As Object
    Private TheQueue As S_SCI_P_SRSMQueue = New S_SCI_P_SRSMQueue
    Private Shadows WithEvents SimCore As OSimDeviceCore
    Private Mem_Move_Point As String
    Protected T1_Cd_Move_Point As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected DT1_Move_Point_Target As OOutputPort(Of String)
    Protected T2_Msg_Point_Position As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected DT2_Point_Position As OInputPort(Of String)
    Protected T3_Msg_Timeout As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected T10_Move_Point As OInputPort(Of EULYNX_Profile.Data_Types.PulsedIn)
    Protected DT10_Move_Point As OInputPort(Of String)
    Protected T30_Timeout As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected T20_Point_Position As OOutputPort(Of EULYNX_Profile.Data_Types.PulsedOut)
    Protected DT20_Point_Position As OOutputPort(Of String)
    Private Mem_Point_Position As String
    Protected D21_S_SCI_EfeS_Gen_SR_State As OInputPort(Of String)
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' T1_Cd_Move_Point := FALSE;
    ' DT1_Move_Point_Target := "";
    ' T20_Point_Position := FALSE;
    ' DT20_Point_Position := "";
    ' T30_Timeout := FALSE;
    ' Mem_Move_Point := "";
    ' Mem_Point_Position := "";
    Public Sub cOp1_Init()
      T1_Cd_Move_Point.SetValue(False)
      DT1_Move_Point_Target.SetValue("")
      T20_Point_Position.SetValue(False)
      DT20_Point_Position.SetValue("")
      T30_Timeout.SetValue(False)
      Mem_Move_Point = ""
      Mem_Point_Position = ""
    End Sub
    
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' assume RtsCurrent_S_SCI_P_SR: on object;
    ' assume RtsCurrent_RECEIVING_STATUS_REPORT: on object;
    ' declare ThisState : String;
    ' /* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS then
    ' /* #REF123# */
    ' 	/* 9a5490fd-3032-4324-8a79-b0295d0205e8 REPORT_STATUS */
    '   ThisState := "9a5490fd-3032-4324-8a79-b0295d0205e8";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_REPORT_STATUS */
    ' 		/* standard */
    ' 		This.RtsExit_REPORT_STATUS();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8d50cf45-0560-40e8-9c01-1a860f0d795b",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 03bad4b5-fa9c-4221-be13-760b89622d0b */ 
    '  DT20_Point_Position := DT2_Point_Position ;
    '  T20_Point_Position := TRUE;
    '  Mem_Point_Position := DT2_Point_Position ; nullstat;/*##END 03bad4b5-fa9c-4221-be13-760b89622d0b */ /* #REF1546# */
    ' 		This.RtsEnter_STATUS_REPORTED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED then
    ' /* #REF123# */
    ' 	/* f7833d8f-ff58-489b-b4d0-e7c1bc52af64 STATUS_REPORTED */
    '   ThisState := "f7833d8f-ff58-489b-b4d0-e7c1bc52af64";
    ' 	if /* #REF2000# *//*##STRT 32d252d8-bb4b-469e-8a50-60206854566c */ (
    '  Mem_Point_Position = DT2_Point_Position )/*##END 32d252d8-bb4b-469e-8a50-60206854566c */  and /* #REF2001# */ SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_RECEIVING_STATUS_REPORT */
    ' 		/* standard */
    ' 		This.RtsExit_RECEIVING_STATUS_REPORT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"66839a28-a199-45a1-823b-977787f0d78d",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 7388a70f-189a-434d-a36a-807784a75ea7 */  nullstat;/*##END 7388a70f-189a-434d-a36a-807784a75ea7 */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED then
    ' /* #REF123# */
    ' 	/* f7833d8f-ff58-489b-b4d0-e7c1bc52af64 STATUS_REPORTED */
    '   ThisState := "f7833d8f-ff58-489b-b4d0-e7c1bc52af64";
    ' 	if /* #REF2000# *//*##STRT 66e745bc-4bd4-445c-a871-b897e16571f7 */ (
    '  Mem_Point_Position <> DT2_Point_Position )/*##END 66e745bc-4bd4-445c-a871-b897e16571f7 */  and /* #REF2001# */ SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_RECEIVING_STATUS_REPORT */
    ' 		/* standard */
    ' 		This.RtsExit_RECEIVING_STATUS_REPORT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"b4467878-6991-40cd-9527-a3ad6d3b9ada",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 2d73386a-be20-4331-91da-b9d0398a675e */ 
    '  Mem_Point_Position := DT2_Point_Position ;
    '  DT20_Point_Position := DT2_Point_Position ;
    '  T20_Point_Position := TRUE; nullstat;/*##END 2d73386a-be20-4331-91da-b9d0398a675e */ /* #REF1546# */
    ' 		This.RtsEnter_PDI_CONNECTION_ESTABLISHED();/* #REF1590# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 80064005-195d-432e-b201-d98f89ede29e PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "80064005-195d-432e-b201-d98f89ede29e";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"64be0111-a027-4bdc-a7c1-67a8be80c0ea",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 64be0111-a027-4bdc-a7c1-67a8be80c0ea */  T30_Timeout := TRUE; nullstat;/*##END 64be0111-a027-4bdc-a7c1-67a8be80c0ea */ /* #REF1546# */
    ' 		ChgFlg3 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 80064005-195d-432e-b201-d98f89ede29e PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "80064005-195d-432e-b201-d98f89ede29e";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"e03b6a94-e21f-400d-aaf9-7f9f6ecef23f",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT e03b6a94-e21f-400d-aaf9-7f9f6ecef23f */  DT20_Point_Position := DT2_Point_Position ;
    '  T20_Point_Position := TRUE; nullstat;/*##END e03b6a94-e21f-400d-aaf9-7f9f6ecef23f */ /* #REF1546# */
    ' 		ChgFlg2 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 80064005-195d-432e-b201-d98f89ede29e PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "80064005-195d-432e-b201-d98f89ede29e";
    ' 	if /* #REF2003# */ SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"5099f360-56d8-47f8-aaf3-d2f0b6f56771",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 5099f360-56d8-47f8-aaf3-d2f0b6f56771 */ 
    '  DT1_Move_Point_Target := DT10_Move_Point ;
    '  T1_Cd_Move_Point := TRUE; nullstat;/*##END 5099f360-56d8-47f8-aaf3-d2f0b6f56771 */ /* #REF1546# */
    ' 		ChgFlg1 := False;
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR =  /* #REF121d# */ RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_NotIn_S_SCI_P_SR then
    ' /* #REF123# */
    ' 	/* 70bc9908-84e7-4b6a-99e6-8be900c7b60e Initial0 */
    '   ThisState := "70bc9908-84e7-4b6a-99e6-8be900c7b60e";
    ' 	// Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
    ' 	RtsNotify(This,SENTER,"70bc9908-84e7-4b6a-99e6-8be900c7b60e",0,NullString);/* #REF127# */
    ' 	RtsNotify(This,SEXIT,"70bc9908-84e7-4b6a-99e6-8be900c7b60e",0,NullString);/* #REF128# */
    ' 	
    ' 	/* #REF7004# */
    ' 	/* #REF7001# */
    ' 	/* #REF7002# */
    ' 	/* #REF7002B#  RtsExit_Initial0 */
    ' 	/* standard */
    ' 	// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 	RtsNotify(This,TRANSITION,"4bd2bd56-53a5-438a-bfb5-84945ad0d869",0,NullString);/* #REF1599# */
    ' 	
    ' 	/*##STRT 318c9016-4a16-4102-8abf-2d4b246550b2 */  cOp1_init (); nullstat;/*##END 318c9016-4a16-4102-8abf-2d4b246550b2 */ /* #REF1546# */
    ' 	This.RtsDefault_RECEIVING_STATUS_REPORT();/* #REF1587# */
    ' 	RetValue := true; /* #REF129# */
    ' 	return;/* #REF130# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then
    ' /* #REF123# */
    ' 	/* 80064005-195d-432e-b201-d98f89ede29e PDI_CONNECTION_ESTABLISHED */
    '   ThisState := "80064005-195d-432e-b201-d98f89ede29e";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_PDI_CONNECTION_ESTABLISHED */
    ' 		/* standard */
    ' 		This.RtsExit_PDI_CONNECTION_ESTABLISHED();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"8f2f8b22-5d6a-4e9c-aa0b-b49fe36a5c94",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 3be23364-3ca5-490c-bbe1-6bd8fd55084c */  nullstat;/*##END 3be23364-3ca5-490c-bbe1-6bd8fd55084c */ /* #REF1546# */
    ' 		This.RtsDefault_RECEIVING_STATUS_REPORT();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF121# */
    ' if /* #REF121c# */ This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT then
    ' /* #REF123# */
    ' 	/* 81f1f53f-a655-4d11-9f74-af7746e43adb RECEIVING_STATUS_REPORT */
    '   ThisState := "81f1f53f-a655-4d11-9f74-af7746e43adb";
    ' 	if /* #REF2001# */ SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) then/* #REF124# */
    ' 	/* #REF125# */
    ' 		/* #REF7004# */
    ' 		/* #REF7001# */
    ' 		/* #REF7002# */
    ' 		/* #REF7002B#  RtsExit_RECEIVING_STATUS_REPORT */
    ' 		/* standard */
    ' 		This.RtsExit_RECEIVING_STATUS_REPORT();/* #REF1596# */
    ' 		// Simulation support : Notification function calls for transition/* #REF1598# */
    ' 		RtsNotify(This,TRANSITION,"6280ba1b-c62c-4d6b-98e7-fb085506f179",0,NullString);/* #REF1599# */
    ' 		
    ' 		/*##STRT 92eefd4f-d9f8-4038-b43c-e96aa3e58a84 */  nullstat;/*##END 92eefd4f-d9f8-4038-b43c-e96aa3e58a84 */ /* #REF1546# */
    ' 		This.RtsDefault_RECEIVING_STATUS_REPORT();/* #REF1587# */
    ' 		RetValue := true; /* #REF129# */
    ' 		return;/* #REF130# */
    ' 	End If/* #REF131# */
    ' End If/* #REF122# */
    ' RetValue := false;
    ' return;
    Private Sub RtsRunToCompletion(ByRef RetValue As Boolean, Optional ByVal ChangeEventsActive As Boolean = False)
      Dim ThisState As String = Nothing
      If Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS Then
        ThisState = "9a5490fd-3032-4324-8a79-b0295d0205e8"
        If SenseTrigger(ChgFlg6, ChangeEventsActive, ThisState) Then
          Me.RtsExit_REPORT_STATUS()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8d50cf45-0560-40e8-9c01-1a860f0d795b", 0, NullString)
          DT20_Point_Position.SetValue(DT2_Point_Position.GetLatchedValue())
          T20_Point_Position.SetValue(True)
          Mem_Point_Position = DT2_Point_Position.GetLatchedValue()
          Me.RtsEnter_STATUS_REPORTED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED Then
        ThisState = "f7833d8f-ff58-489b-b4d0-e7c1bc52af64"
        If (Mem_Point_Position = DT2_Point_Position.GetLatchedValue()) And SenseTrigger(ChgFlg7, ChangeEventsActive, ThisState) Then
          Me.RtsExit_RECEIVING_STATUS_REPORT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "66839a28-a199-45a1-823b-977787f0d78d", 0, NullString)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED Then
        ThisState = "f7833d8f-ff58-489b-b4d0-e7c1bc52af64"
        If (Mem_Point_Position <> DT2_Point_Position.GetLatchedValue()) And SenseTrigger(ChgFlg8, ChangeEventsActive, ThisState) Then
          Me.RtsExit_RECEIVING_STATUS_REPORT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "b4467878-6991-40cd-9527-a3ad6d3b9ada", 0, NullString)
          Mem_Point_Position = DT2_Point_Position.GetLatchedValue()
          DT20_Point_Position.SetValue(DT2_Point_Position.GetLatchedValue())
          T20_Point_Position.SetValue(True)
          Me.RtsEnter_PDI_CONNECTION_ESTABLISHED()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "80064005-195d-432e-b201-d98f89ede29e"
        If SenseTrigger(ChgFlg3, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "64be0111-a027-4bdc-a7c1-67a8be80c0ea", 0, NullString)
          T30_Timeout.SetValue(True)
          ChgFlg3 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "80064005-195d-432e-b201-d98f89ede29e"
        If SenseTrigger(ChgFlg2, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "e03b6a94-e21f-400d-aaf9-7f9f6ecef23f", 0, NullString)
          DT20_Point_Position.SetValue(DT2_Point_Position.GetLatchedValue())
          T20_Point_Position.SetValue(True)
          ChgFlg2 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "80064005-195d-432e-b201-d98f89ede29e"
        If SenseTrigger(ChgFlg1, ChangeEventsActive, ThisState) Then
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "5099f360-56d8-47f8-aaf3-d2f0b6f56771", 0, NullString)
          DT1_Move_Point_Target.SetValue(DT10_Move_Point.GetLatchedValue())
          T1_Cd_Move_Point.SetValue(True)
          ChgFlg1 = False
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_NotIn_S_SCI_P_SR Then
        ThisState = "70bc9908-84e7-4b6a-99e6-8be900c7b60e"
        'Simulation support : Notification function calls for Entry and Exit of Initial state/* #REF126# */
        RtsNotify(Me, SENTER, "70bc9908-84e7-4b6a-99e6-8be900c7b60e", 0, NullString)
        RtsNotify(Me, SEXIT, "70bc9908-84e7-4b6a-99e6-8be900c7b60e", 0, NullString)
        'Simulation support : Notification function calls for transition/* #REF1598# */
        RtsNotify(Me, TRANSITION, "4bd2bd56-53a5-438a-bfb5-84945ad0d869", 0, NullString)
        cOp1_init()
        Me.RtsDefault_RECEIVING_STATUS_REPORT()
        RetValue = True
        Return
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        ThisState = "80064005-195d-432e-b201-d98f89ede29e"
        If SenseTrigger(ChgFlg4, ChangeEventsActive, ThisState) Then
          Me.RtsExit_PDI_CONNECTION_ESTABLISHED()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "8f2f8b22-5d6a-4e9c-aa0b-b49fe36a5c94", 0, NullString)
          Me.RtsDefault_RECEIVING_STATUS_REPORT()
          RetValue = True
          Return
        End If
      End If
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT Then
        ThisState = "81f1f53f-a655-4d11-9f74-af7746e43adb"
        If SenseTrigger(ChgFlg5, ChangeEventsActive, ThisState) Then
          Me.RtsExit_RECEIVING_STATUS_REPORT()
          'Simulation support : Notification function calls for transition/* #REF1598# */
          RtsNotify(Me, TRANSITION, "6280ba1b-c62c-4d6b-98e7-fb085506f179", 0, NullString)
          Me.RtsDefault_RECEIVING_STATUS_REPORT()
          RetValue = True
          Return
        End If
      End If
      RetValue = False
      Return
    End Sub
    
    ' \ART_SMG :: Constructor
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85");/* #REF1559# */
    ' SimInitialize();/* #REF1560# */
    ' CurrentTime := New SMSupport.Time;/* #REF1560# */
    ' RtsNotifySynchronous(This, CREATE, "bf17ad05-d6eb-413a-ac9d-28d9064d73d7", 0, NullString, addressof(RtsInjectEvent), addressof(RtsGetAttributeValue), addressof(RtsSetAttributeValue));/* #REF1561# */
    ' SMSupport.RtsBase.RtsCreateSemaphore(This.RtsBusy);/* #REF1563# */
    ' SMSupport.RtsBase.RtsLock(This.RtsBusy);// DoState Timer Placeholder
    ' /* #REF1565# */
    ' 
    ' // Initialising State Vectors to NotIn
    ' This.RtsCurrent_S_SCI_P_SR := RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_NotIn_S_SCI_P_SR;/* #REF1566# */
    ' This.RtsCurrent_RECEIVING_STATUS_REPORT := RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_NotIn_RECEIVING_STATUS_REPORT;/* #REF1566# */
    ' SMSupport.RtsBase.RtsUnlock(This.RtsBusy);
    ' 
    Public Shadows Sub SMGInitialize(Optional ByVal SingleStep As Boolean = False)
      SimSetModelId("df7d62d6-d1cb-43e3-9dea-156304063f85")
      SimInitialize()
      CurrentTime = New SMSupport.Time
      RtsNotifySynchronous(Me, CREATE, "bf17ad05-d6eb-413a-ac9d-28d9064d73d7", 0, NullString, AddressOf RtsInjectEvent, AddressOf RtsGetAttributeValue, AddressOf RtsSetAttributeValue)
      SMSupport.RtsBase.RtsCreateSemaphore(Me.RtsBusy)
      SMSupport.RtsBase.RtsLock(Me.RtsBusy)
      'DoState Timer Placeholder
      'Initialising State Vectors to NotIn
      Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_NotIn_S_SCI_P_SR
      Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_NotIn_RECEIVING_STATUS_REPORT
      SMSupport.RtsBase.RtsUnlock(Me.RtsBusy)
    End Sub
    
    ' \ART_SMG :: Destructor
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' /* #REF1617# */
    ' RtsUnregister(This);
    Public Shadows Sub SMGTerminate()
      RtsUnregister(Me)
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("80064005-195d-432e-b201-d98f89ede29e|") then
    '   OperatedStates := OperatedStates + "80064005-195d-432e-b201-d98f89ede29e|";
    ' end if
    ' // Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
    ' RtsNotify(This,SENTER,"80064005-195d-432e-b201-d98f89ede29e",0,NullString);
    ' 
    ' SimCore.EnterState("80064005-195d-432e-b201-d98f89ede29e","PDI_CONNECTION_ESTABLISHED");
    ' 
    ' This.RtsCurrent_S_SCI_P_SR := RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED;/* #REF521# */
    ' 
    Private Sub RtsEnter_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("80064005-195d-432e-b201-d98f89ede29e|") Then
        OperatedStates = OperatedStates + "80064005-195d-432e-b201-d98f89ede29e|"
      End If
      'Simulation support : Notification function call for entering state : PDI_CONNECTION_ESTABLISHED ///* #REF520# */
      RtsNotify(Me, SENTER, "80064005-195d-432e-b201-d98f89ede29e", 0, NullString)
      SimCore.EnterState("80064005-195d-432e-b201-d98f89ede29e", "PDI_CONNECTION_ESTABLISHED")
      Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS_REPORT
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("81f1f53f-a655-4d11-9f74-af7746e43adb|") then
    '   OperatedStates := OperatedStates + "81f1f53f-a655-4d11-9f74-af7746e43adb|";
    ' end if
    ' // Simulation support : Notification function call for entering state : RECEIVING_STATUS_REPORT ///* #REF520# */
    ' RtsNotify(This,SENTER,"81f1f53f-a655-4d11-9f74-af7746e43adb",0,NullString);
    ' 
    ' SimCore.EnterState("81f1f53f-a655-4d11-9f74-af7746e43adb","RECEIVING_STATUS_REPORT");
    ' 
    ' This.RtsCurrent_S_SCI_P_SR := RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT;/* #REF521# */
    ' 
    Private Sub RtsEnter_RECEIVING_STATUS_REPORT()
      If not OperatedStates.Contains("81f1f53f-a655-4d11-9f74-af7746e43adb|") Then
        OperatedStates = OperatedStates + "81f1f53f-a655-4d11-9f74-af7746e43adb|"
      End If
      'Simulation support : Notification function call for entering state : RECEIVING_STATUS_REPORT ///* #REF520# */
      RtsNotify(Me, SENTER, "81f1f53f-a655-4d11-9f74-af7746e43adb", 0, NullString)
      SimCore.EnterState("81f1f53f-a655-4d11-9f74-af7746e43adb", "RECEIVING_STATUS_REPORT")
      Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("9a5490fd-3032-4324-8a79-b0295d0205e8|") then
    '   OperatedStates := OperatedStates + "9a5490fd-3032-4324-8a79-b0295d0205e8|";
    ' end if
    ' // Simulation support : Notification function call for entering state : REPORT_STATUS ///* #REF520# */
    ' RtsNotify(This,SENTER,"9a5490fd-3032-4324-8a79-b0295d0205e8",0,NullString);
    ' 
    ' SimCore.EnterState("9a5490fd-3032-4324-8a79-b0295d0205e8","RECEIVING_STATUS_REPORT::REPORT_STATUS");
    ' 
    ' This.RtsCurrent_RECEIVING_STATUS_REPORT := RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS;/* #REF521# */
    ' 
    Private Sub RtsEnter_REPORT_STATUS()
      If not OperatedStates.Contains("9a5490fd-3032-4324-8a79-b0295d0205e8|") Then
        OperatedStates = OperatedStates + "9a5490fd-3032-4324-8a79-b0295d0205e8|"
      End If
      'Simulation support : Notification function call for entering state : REPORT_STATUS ///* #REF520# */
      RtsNotify(Me, SENTER, "9a5490fd-3032-4324-8a79-b0295d0205e8", 0, NullString)
      SimCore.EnterState("9a5490fd-3032-4324-8a79-b0295d0205e8", "RECEIVING_STATUS_REPORT::REPORT_STATUS")
      Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("f7833d8f-ff58-489b-b4d0-e7c1bc52af64|") then
    '   OperatedStates := OperatedStates + "f7833d8f-ff58-489b-b4d0-e7c1bc52af64|";
    ' end if
    ' // Simulation support : Notification function call for entering state : STATUS_REPORTED ///* #REF520# */
    ' RtsNotify(This,SENTER,"f7833d8f-ff58-489b-b4d0-e7c1bc52af64",0,NullString);
    ' 
    ' SimCore.EnterState("f7833d8f-ff58-489b-b4d0-e7c1bc52af64","RECEIVING_STATUS_REPORT::STATUS_REPORTED");
    ' 
    ' This.RtsCurrent_RECEIVING_STATUS_REPORT := RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED;/* #REF521# */
    ' 
    Private Sub RtsEnter_STATUS_REPORTED()
      If not OperatedStates.Contains("f7833d8f-ff58-489b-b4d0-e7c1bc52af64|") Then
        OperatedStates = OperatedStates + "f7833d8f-ff58-489b-b4d0-e7c1bc52af64|"
      End If
      'Simulation support : Notification function call for entering state : STATUS_REPORTED ///* #REF520# */
      RtsNotify(Me, SENTER, "f7833d8f-ff58-489b-b4d0-e7c1bc52af64", 0, NullString)
      SimCore.EnterState("f7833d8f-ff58-489b-b4d0-e7c1bc52af64", "RECEIVING_STATUS_REPORT::STATUS_REPORTED")
      Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
    ' 	RtsNotify(This,SEXIT,"80064005-195d-432e-b201-d98f89ede29e",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_PDI_CONNECTION_ESTABLISHED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_PDI_CONNECTION_ESTABLISHED()
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_PDI_CONNECTION_ESTABLISHED Then
        'Simulation support : Notification function call for exiting state : PDI_CONNECTION_ESTABLISHED
        RtsNotify(Me, SEXIT, "80064005-195d-432e-b201-d98f89ede29e", 0, NullString)
        RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS_REPORT
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if This.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States{enum_datatype}.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : RECEIVING_STATUS_REPORT
    ' 	RtsNotify(This,SEXIT,"81f1f53f-a655-4d11-9f74-af7746e43adb",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_RECEIVING_STATUS_REPORT ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_RECEIVING_STATUS_REPORT()
      If Me.RtsCurrent_S_SCI_P_SR = RtsS_SCI_P_SR_States.RtsS_SCI_P_SR_States_RECEIVING_STATUS_REPORT Then
        'Simulation support : Notification function call for exiting state : RECEIVING_STATUS_REPORT
        RtsNotify(Me, SEXIT, "81f1f53f-a655-4d11-9f74-af7746e43adb", 0, NullString)
        RtsExitSSOf_RECEIVING_STATUS_REPORT()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if This.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : REPORT_STATUS
    ' 	RtsNotify(This,SEXIT,"9a5490fd-3032-4324-8a79-b0295d0205e8",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_REPORT_STATUS ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_REPORT_STATUS()
      If Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS Then
        'Simulation support : Notification function call for exiting state : REPORT_STATUS
        RtsNotify(Me, SEXIT, "9a5490fd-3032-4324-8a79-b0295d0205e8", 0, NullString)
        RtsExitSSOf_REPORT_STATUS()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if This.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED then/* #REF753# */
    ' /* #REF722# */
    ' 	// Simulation support : Notification function call for exiting state : STATUS_REPORTED
    ' 	RtsNotify(This,SEXIT,"f7833d8f-ff58-489b-b4d0-e7c1bc52af64",0,NullString);/* #REF723# */
    ' 	RtsExitSSOf_STATUS_REPORTED ();
    ' 	/* #REF754# */
    ' end if
    Private Sub RtsExit_STATUS_REPORTED()
      If Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED Then
        'Simulation support : Notification function call for exiting state : STATUS_REPORTED
        RtsNotify(Me, SEXIT, "f7833d8f-ff58-489b-b4d0-e7c1bc52af64", 0, NullString)
        RtsExitSSOf_STATUS_REPORTED()
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS_REPORT
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' // Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
    ' RtsNotify(This,SENTER,"c7cf9359-ab6f-4ac8-8a19-19d9e3838fcf",0,NullString);/* #REF1575# */
    ' RtsNotify(This,SEXIT,"c7cf9359-ab6f-4ac8-8a19-19d9e3838fcf",0,NullString);/* #REF1576# */
    ' This.RtsEnter_RECEIVING_STATUS_REPORT();/* #REF1577# */
    ' /* #REF1582# */
    ' // Simulation support : Notification function calls for default transition/* #REF1584# */
    ' RtsNotify(This,TRANSITION,"9cda912c-36f6-4d8c-b838-1c80bc40db77",0,NullString);/* #REF1585# */
    ' /*##STRT 258ed83d-2456-49d1-bdb7-8c0beb7ba02f */  nullstat;/*##END 258ed83d-2456-49d1-bdb7-8c0beb7ba02f */ /* #REF1546# */
    ' This.RtsEnter_REPORT_STATUS();/* #REF1590# */
    ' 
    Private Sub RtsDefault_RECEIVING_STATUS_REPORT()
      'Simulation support : Notification function calls for entry and exit of initial state/* #REF1574# */
      RtsNotify(Me, SENTER, "c7cf9359-ab6f-4ac8-8a19-19d9e3838fcf", 0, NullString)
      RtsNotify(Me, SEXIT, "c7cf9359-ab6f-4ac8-8a19-19d9e3838fcf", 0, NullString)
      Me.RtsEnter_RECEIVING_STATUS_REPORT()
      'Simulation support : Notification function calls for default transition/* #REF1584# */
      RtsNotify(Me, TRANSITION, "9cda912c-36f6-4d8c-b838-1c80bc40db77", 0, NullString)
      Me.RtsEnter_REPORT_STATUS()
    End Sub
    
    Private Shared Sub RtsInjectEvent(ByRef RetValue As Integer, ByRef TheEvent As String, ByRef Params As SimStringArray, ByRef pInstance As S_SCI_P_SR)
    End Sub
    
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_S_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_P_SR, "RtsS_SCI_P_SR_States");
    ' end if
    ' if Name = "RtsCurrent_RECEIVING_STATUS_REPORT" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "RtsCurrent_S_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_P_SR, "RtsS_SCI_P_SR_States");
    ' end if
    ' if Name = "RtsCurrent_RECEIVING_STATUS_REPORT" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States");
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore");
    ' end if
    ' if Name = "$ClassID" then
    '   // Return the Current Class ID
    '   Value := "bf17ad05-d6eb-413a-ac9d-28d9064d73d7";
    ' end if
    ' if Name = "$Model" then
    '   // Return the Current Model ID
    '   Value := "df7d62d6-d1cb-43e3-9dea-156304063f85";
    ' end if
    ' if Name = "$AttributeNames" then
    '   Value := "6";
    '   Value := Value + "|RtsCurrent_S_SCI_P_SR";
    '   Value := Value + "|RtsCurrent_RECEIVING_STATUS_REPORT";
    '   Value := Value + "|RtsBusy";
    '   Value := Value + "|RtsCurrent_S_SCI_P_SR";
    '   Value := Value + "|RtsCurrent_RECEIVING_STATUS_REPORT";
    '   Value := Value + "|RtsBusy";
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsGetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByVal buflen As Integer, ByRef pInstance As S_SCI_P_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_S_SCI_P_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_P_SR, "RtsS_SCI_P_SR_States")
      End If
      If Name = "RtsCurrent_RECEIVING_STATUS_REPORT" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "RtsCurrent_S_SCI_P_SR" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_S_SCI_P_SR, "RtsS_SCI_P_SR_States")
      End If
      If Name = "RtsCurrent_RECEIVING_STATUS_REPORT" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States")
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertToString(Value, pInstance.RtsBusy, "SMSupport.RtsSemaphore")
      End If
      If Name = "$ClassID" Then
        'Return the Current Class ID
        Value = "bf17ad05-d6eb-413a-ac9d-28d9064d73d7"
      End If
      If Name = "$Model" Then
        'Return the Current Model ID
        Value = "df7d62d6-d1cb-43e3-9dea-156304063f85"
      End If
      If Name = "$AttributeNames" Then
        Value = "6"
        Value = Value + "|RtsCurrent_S_SCI_P_SR"
        Value = Value + "|RtsCurrent_RECEIVING_STATUS_REPORT"
        Value = Value + "|RtsBusy"
        Value = Value + "|RtsCurrent_S_SCI_P_SR"
        Value = Value + "|RtsCurrent_RECEIVING_STATUS_REPORT"
        Value = Value + "|RtsBusy"
      End If
      RetValue = Ret
    End Sub
    
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' declare Ret := 0: Integer;
    ' if Name = "RtsCurrent_S_SCI_P_SR" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_S_SCI_P_SR, Value, "RtsS_SCI_P_SR_States", GetType(S_SCI_P_SR.RtsS_SCI_P_SR_States));
    ' end if
    ' if Name = "RtsCurrent_RECEIVING_STATUS_REPORT" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, Value, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States", GetType(S_SCI_P_SR.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States));
    ' end if
    ' if Name = "RtsBusy" then
    '   Ret := TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore));
    ' end if
    ' RetValue := Ret;
    ' 
    Private Shared Sub RtsSetAttributeValue(ByRef RetValue As Integer, ByRef Name As String, ByRef Value As String, ByRef pInstance As S_SCI_P_SR)
      Dim Ret As Integer = 0
      If Name = "RtsCurrent_S_SCI_P_SR" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_S_SCI_P_SR, Value, "RtsS_SCI_P_SR_States", GetType(S_SCI_P_SR.RtsS_SCI_P_SR_States))
      End If
      If Name = "RtsCurrent_RECEIVING_STATUS_REPORT" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsCurrent_RECEIVING_STATUS_REPORT, Value, "RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States", GetType(S_SCI_P_SR.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States))
      End If
      If Name = "RtsBusy" Then
        Ret = TypeConverter.ConvertFromString(pInstance.RtsBusy, Value, "SMSupport.RtsSemaphore", GetType(SMSupport.RtsSemaphore))
      End If
      RetValue = Ret
    End Sub
    
    ' \ART_SMG :: Created for state : PDI_CONNECTION_ESTABLISHED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("80064005-195d-432e-b201-d98f89ede29e|") then
    '   OperatedStates := OperatedStates + "80064005-195d-432e-b201-d98f89ede29e|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_PDI_CONNECTION_ESTABLISHED()
      If not OperatedStates.Contains("80064005-195d-432e-b201-d98f89ede29e|") Then
        OperatedStates = OperatedStates + "80064005-195d-432e-b201-d98f89ede29e|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : RECEIVING_STATUS_REPORT
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("81f1f53f-a655-4d11-9f74-af7746e43adb|") then
    '   OperatedStates := OperatedStates + "81f1f53f-a655-4d11-9f74-af7746e43adb|";
    ' end if
    ' /* #REF737# */
    ' select case This.RtsCurrent_RECEIVING_STATUS_REPORT
    ' /* #REF738# */
    ' 	case RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_REPORT_STATUS();/* #REF742# */
    ' 	case RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED:/* #REF740# */
    ' 	/* #REF741# */
    ' 		This.RtsExit_STATUS_REPORTED();/* #REF742# */
    ' 	case else:/* #REF743# */
    ' 		/* #REF744# */
    ' end select
    ' This.RtsCurrent_RECEIVING_STATUS_REPORT := RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States{enum_datatype}.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_NotIn_RECEIVING_STATUS_REPORT;/* #REF748# */
    ' 
    Private Sub RtsExitSSOf_RECEIVING_STATUS_REPORT()
      If not OperatedStates.Contains("81f1f53f-a655-4d11-9f74-af7746e43adb|") Then
        OperatedStates = OperatedStates + "81f1f53f-a655-4d11-9f74-af7746e43adb|"
      End If
      Select Case Me.RtsCurrent_RECEIVING_STATUS_REPORT
        Case RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_REPORT_STATUS
          Me.RtsExit_REPORT_STATUS()
        Case RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_STATUS_REPORTED
          Me.RtsExit_STATUS_REPORTED()
      End Select
      Me.RtsCurrent_RECEIVING_STATUS_REPORT = RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States.RtsS_SCI_P_SRRECEIVING_STATUS_REPORT_States_NotIn_RECEIVING_STATUS_REPORT
    End Sub
    
    ' \ART_SMG :: Created for state : REPORT_STATUS
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("9a5490fd-3032-4324-8a79-b0295d0205e8|") then
    '   OperatedStates := OperatedStates + "9a5490fd-3032-4324-8a79-b0295d0205e8|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_REPORT_STATUS()
      If not OperatedStates.Contains("9a5490fd-3032-4324-8a79-b0295d0205e8|") Then
        OperatedStates = OperatedStates + "9a5490fd-3032-4324-8a79-b0295d0205e8|"
      End If
    End Sub
    
    ' \ART_SMG :: Created for state : STATUS_REPORTED
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' if not OperatedStates.Contains ("f7833d8f-ff58-489b-b4d0-e7c1bc52af64|") then
    '   OperatedStates := OperatedStates + "f7833d8f-ff58-489b-b4d0-e7c1bc52af64|";
    ' end if
    ' 
    Private Sub RtsExitSSOf_STATUS_REPORTED()
      If not OperatedStates.Contains("f7833d8f-ff58-489b-b4d0-e7c1bc52af64|") Then
        OperatedStates = OperatedStates + "f7833d8f-ff58-489b-b4d0-e7c1bc52af64|"
      End If
    End Sub
    
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    '   declare Ret := SMSupport.RtsTimer.MaxDuration: SMSupport.Duration;
    '   CurrentTime := NewCurrentTime;
    ' TTL := Ret;
    Public Shadows Sub SMStep(ByVal NewCurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      Dim Ret As SMSupport.Duration = SMSupport.RtsTimer.MaxDuration
      CurrentTime = NewCurrentTime
      TTL = Ret
    End Sub
    
    Public Shadows Sub SMQueueStep(ByVal CurrentTime As SMSupport.Time, ByRef TTL As SMSupport.Duration)
      If Not SMStarted Then
        Dim RunAgain As Boolean = True
        While RunAgain
          RtsRunToCompletion(RunAgain)
        End While
        SMStarted = True
      End If
      GetQueue().DispatchAllExisting(Me)
      SMStep(CurrentTime, TTL)
      RunChangeEvents()
    End Sub
    
    ' assume D21_S_SCI_EfeS_Gen_SR_State: a SySimInputPort;
    ' assume DT10_Move_Point: a SySimInputPort;
    ' assume DT1_Move_Point_Target: a SySimOutputPort;
    ' assume DT20_Point_Position: a SySimOutputPort;
    ' assume DT2_Point_Position: a SySimInputPort;
    ' assume T10_Move_Point: a SySimInputPort;
    ' assume T1_Cd_Move_Point: a SySimOutputPort;
    ' assume T20_Point_Position: a SySimOutputPort;
    ' assume T2_Msg_Point_Position: a SySimInputPort;
    ' assume T30_Timeout: a SySimOutputPort;
    ' assume T3_Msg_Timeout: a SySimInputPort;
    ' Declare RetValue := False : Boolean;
    ' declare ChgFlg6Tmp := (/*##STRT 84a53bb8-c342-448f-a923-95ed7bef0790 */ ( T2_Msg_Point_Position )/*##END 84a53bb8-c342-448f-a923-95ed7bef0790 */ ) : Boolean;
    ' ChgFlg6 := EvalTrigger(ChgFlg6Tmp , ChgFlgLast6);
    ' declare ChgFlg8Tmp := (/*##STRT eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ) : Boolean;
    ' ChgFlg8 := EvalTrigger(ChgFlg8Tmp , ChgFlgLast8);
    ' declare ChgFlg4Tmp := (/*##STRT 4e25a490-fef7-4e1e-b628-b714937ace90 */ ( D21_S_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 4e25a490-fef7-4e1e-b628-b714937ace90 */ ) : Boolean;
    ' ChgFlg4 := EvalTrigger(ChgFlg4Tmp , ChgFlgLast4);
    ' declare ChgFlg1Tmp := (/*##STRT 80a0e439-f382-482f-9e51-766bfc562ae6 */ ( T10_Move_Point )/*##END 80a0e439-f382-482f-9e51-766bfc562ae6 */ ) : Boolean;
    ' ChgFlg1 := EvalTrigger(ChgFlg1Tmp , ChgFlgLast1);
    ' declare ChgFlg3Tmp := (/*##STRT 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ( T3_Msg_Timeout )/*##END 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ) : Boolean;
    ' ChgFlg3 := EvalTrigger(ChgFlg3Tmp , ChgFlgLast3);
    ' declare ChgFlg7Tmp := (/*##STRT b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ) : Boolean;
    ' ChgFlg7 := EvalTrigger(ChgFlg7Tmp , ChgFlgLast7);
    ' declare ChgFlg5Tmp := (/*##STRT 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ( D21_S_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ) : Boolean;
    ' ChgFlg5 := EvalTrigger(ChgFlg5Tmp , ChgFlgLast5);
    ' declare ChgFlg2Tmp := (/*##STRT f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ( T2_Msg_Point_Position )/*##END f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ) : Boolean;
    ' ChgFlg2 := EvalTrigger(ChgFlg2Tmp , ChgFlgLast2);
    ' OperatedStates := "";
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' RtsRunToCompletion(RetValue, True);
    ' ChgFlgLast6 := ChgFlg6Tmp;
    ' ChgFlgLast8 := ChgFlg8Tmp;
    ' ChgFlgLast4 := ChgFlg4Tmp;
    ' ChgFlgLast1 := ChgFlg1Tmp;
    ' ChgFlgLast3 := ChgFlg3Tmp;
    ' ChgFlgLast7 := ChgFlg7Tmp;
    ' ChgFlgLast5 := ChgFlg5Tmp;
    ' ChgFlgLast2 := ChgFlg2Tmp;
    ' While DecrementInPorts() Do
    '   MaskInPorts(True);
    '   declare MaskedChgFlg6 := (/*##STRT 84a53bb8-c342-448f-a923-95ed7bef0790 */ ( T2_Msg_Point_Position )/*##END 84a53bb8-c342-448f-a923-95ed7bef0790 */ ) : Boolean;
    '   declare MaskedChgFlg8 := (/*##STRT eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ) : Boolean;
    '   declare MaskedChgFlg4 := (/*##STRT 4e25a490-fef7-4e1e-b628-b714937ace90 */ ( D21_S_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 4e25a490-fef7-4e1e-b628-b714937ace90 */ ) : Boolean;
    '   declare MaskedChgFlg1 := (/*##STRT 80a0e439-f382-482f-9e51-766bfc562ae6 */ ( T10_Move_Point )/*##END 80a0e439-f382-482f-9e51-766bfc562ae6 */ ) : Boolean;
    '   declare MaskedChgFlg3 := (/*##STRT 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ( T3_Msg_Timeout )/*##END 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ) : Boolean;
    '   declare MaskedChgFlg7 := (/*##STRT b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ) : Boolean;
    '   declare MaskedChgFlg5 := (/*##STRT 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ( D21_S_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ) : Boolean;
    '   declare MaskedChgFlg2 := (/*##STRT f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ( T2_Msg_Point_Position )/*##END f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ) : Boolean;
    '   MaskInPorts(False);
    '   declare UnMaskedChgFlg6 := (/*##STRT 84a53bb8-c342-448f-a923-95ed7bef0790 */ ( T2_Msg_Point_Position )/*##END 84a53bb8-c342-448f-a923-95ed7bef0790 */ ) : Boolean;
    '   declare UnMaskedChgFlg8 := (/*##STRT eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END eb3f8c0a-1f3c-427c-8ed0-a56921561dc3 */ ) : Boolean;
    '   declare UnMaskedChgFlg4 := (/*##STRT 4e25a490-fef7-4e1e-b628-b714937ace90 */ ( D21_S_SCI_EfeS_Gen_SR_State <> "ESTABLISHED")/*##END 4e25a490-fef7-4e1e-b628-b714937ace90 */ ) : Boolean;
    '   declare UnMaskedChgFlg1 := (/*##STRT 80a0e439-f382-482f-9e51-766bfc562ae6 */ ( T10_Move_Point )/*##END 80a0e439-f382-482f-9e51-766bfc562ae6 */ ) : Boolean;
    '   declare UnMaskedChgFlg3 := (/*##STRT 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ( T3_Msg_Timeout )/*##END 5167a527-aaf1-46c3-88e9-5534f2d6792f */ ) : Boolean;
    '   declare UnMaskedChgFlg7 := (/*##STRT b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ( D21_S_SCI_EfeS_Gen_SR_State = "ESTABLISHED")/*##END b48b5e5d-6df8-48ac-9b30-1c0e0147505e */ ) : Boolean;
    '   declare UnMaskedChgFlg5 := (/*##STRT 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ( D21_S_SCI_EfeS_Gen_SR_State = "CLOSED")/*##END 68bca0a6-3501-422f-ae5b-76ec07ed3404 */ ) : Boolean;
    '   declare UnMaskedChgFlg2 := (/*##STRT f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ( T2_Msg_Point_Position )/*##END f6e921f6-617d-4969-a92a-51c0ae1214e2 */ ) : Boolean;
    '   declare PreviousChgFlg6 := ChgFlg6 : Boolean;
    '   declare PreviousChgFlg8 := ChgFlg8 : Boolean;
    '   declare PreviousChgFlg4 := ChgFlg4 : Boolean;
    '   declare PreviousChgFlg1 := ChgFlg1 : Boolean;
    '   declare PreviousChgFlg3 := ChgFlg3 : Boolean;
    '   declare PreviousChgFlg7 := ChgFlg7 : Boolean;
    '   declare PreviousChgFlg5 := ChgFlg5 : Boolean;
    '   declare PreviousChgFlg2 := ChgFlg2 : Boolean;
    '   // A condition is 'sensitive to ports' whenever:
    '   // (1) was true so far in this execution, and
    '   // (2) is still true at this port decrement state, and
    '   // (3) would be false if we mask the ports
    '   If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := True;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := True;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := True;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := True;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := True;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := True;
    '   ChgFlg5 := False;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := True;
    '   ChgFlg2 := False;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    '   If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
    '     // This is sensitive to ports - run it again
    '   ChgFlg6 := False;
    '   ChgFlg8 := False;
    '   ChgFlg4 := False;
    '   ChgFlg1 := False;
    '   ChgFlg3 := False;
    '   ChgFlg7 := False;
    '   ChgFlg5 := False;
    '   ChgFlg2 := True;
    '     OperatedStates := "";
    '     RtsRunToCompletion(RetValue, True);
    '   End If
    ' End While
    ' ChgFlg6 := false;
    ' ChgFlg8 := false;
    ' ChgFlg4 := false;
    ' ChgFlg1 := false;
    ' ChgFlg3 := false;
    ' ChgFlg7 := false;
    ' ChgFlg5 := false;
    ' ChgFlg2 := false;
    ' 
    Public Shadows Sub RunChangeEvents()
      Dim RetValue As Boolean = False
      Dim ChgFlg6Tmp As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
      ChgFlg6 = EvalTrigger(ChgFlg6Tmp, ChgFlgLast6)
      Dim ChgFlg8Tmp As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
      ChgFlg8 = EvalTrigger(ChgFlg8Tmp, ChgFlgLast8)
      Dim ChgFlg4Tmp As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
      ChgFlg4 = EvalTrigger(ChgFlg4Tmp, ChgFlgLast4)
      Dim ChgFlg1Tmp As Boolean = ((T10_Move_Point.GetLatchedValue()))
      ChgFlg1 = EvalTrigger(ChgFlg1Tmp, ChgFlgLast1)
      Dim ChgFlg3Tmp As Boolean = ((T3_Msg_Timeout.GetLatchedValue()))
      ChgFlg3 = EvalTrigger(ChgFlg3Tmp, ChgFlgLast3)
      Dim ChgFlg7Tmp As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
      ChgFlg7 = EvalTrigger(ChgFlg7Tmp, ChgFlgLast7)
      Dim ChgFlg5Tmp As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
      ChgFlg5 = EvalTrigger(ChgFlg5Tmp, ChgFlgLast5)
      Dim ChgFlg2Tmp As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
      ChgFlg2 = EvalTrigger(ChgFlg2Tmp, ChgFlgLast2)
      OperatedStates = ""
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      RtsRunToCompletion(RetValue, True)
      ChgFlgLast6 = ChgFlg6Tmp
      ChgFlgLast8 = ChgFlg8Tmp
      ChgFlgLast4 = ChgFlg4Tmp
      ChgFlgLast1 = ChgFlg1Tmp
      ChgFlgLast3 = ChgFlg3Tmp
      ChgFlgLast7 = ChgFlg7Tmp
      ChgFlgLast5 = ChgFlg5Tmp
      ChgFlgLast2 = ChgFlg2Tmp
      While DecrementInPorts()
        MaskInPorts(True)
        Dim MaskedChgFlg6 As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
        Dim MaskedChgFlg8 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim MaskedChgFlg4 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
        Dim MaskedChgFlg1 As Boolean = ((T10_Move_Point.GetLatchedValue()))
        Dim MaskedChgFlg3 As Boolean = ((T3_Msg_Timeout.GetLatchedValue()))
        Dim MaskedChgFlg7 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim MaskedChgFlg5 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
        Dim MaskedChgFlg2 As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
        MaskInPorts(False)
        Dim UnMaskedChgFlg6 As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
        Dim UnMaskedChgFlg8 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim UnMaskedChgFlg4 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() <> "ESTABLISHED"))
        Dim UnMaskedChgFlg1 As Boolean = ((T10_Move_Point.GetLatchedValue()))
        Dim UnMaskedChgFlg3 As Boolean = ((T3_Msg_Timeout.GetLatchedValue()))
        Dim UnMaskedChgFlg7 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "ESTABLISHED"))
        Dim UnMaskedChgFlg5 As Boolean = ((D21_S_SCI_EfeS_Gen_SR_State.GetLatchedValue() = "CLOSED"))
        Dim UnMaskedChgFlg2 As Boolean = ((T2_Msg_Point_Position.GetLatchedValue()))
        Dim PreviousChgFlg6 As Boolean = ChgFlg6
        Dim PreviousChgFlg8 As Boolean = ChgFlg8
        Dim PreviousChgFlg4 As Boolean = ChgFlg4
        Dim PreviousChgFlg1 As Boolean = ChgFlg1
        Dim PreviousChgFlg3 As Boolean = ChgFlg3
        Dim PreviousChgFlg7 As Boolean = ChgFlg7
        Dim PreviousChgFlg5 As Boolean = ChgFlg5
        Dim PreviousChgFlg2 As Boolean = ChgFlg2
        'A condition is 'sensitive to ports' whenever:
        '(1) was true so far in this execution, and
        '(2) is still true at this port decrement state, and
        '(3) would be false if we mask the ports
        If PreviousChgFlg6 And UnMaskedChgFlg6 And Not MaskedChgFlg6 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = True
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg8 And UnMaskedChgFlg8 And Not MaskedChgFlg8 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = True
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg4 And UnMaskedChgFlg4 And Not MaskedChgFlg4 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = True
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg1 And UnMaskedChgFlg1 And Not MaskedChgFlg1 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = True
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg3 And UnMaskedChgFlg3 And Not MaskedChgFlg3 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = True
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg7 And UnMaskedChgFlg7 And Not MaskedChgFlg7 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = True
          ChgFlg5 = False
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg5 And UnMaskedChgFlg5 And Not MaskedChgFlg5 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = True
          ChgFlg2 = False
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
        If PreviousChgFlg2 And UnMaskedChgFlg2 And Not MaskedChgFlg2 Then
          'This is sensitive to ports - run it again
          ChgFlg6 = False
          ChgFlg8 = False
          ChgFlg4 = False
          ChgFlg1 = False
          ChgFlg3 = False
          ChgFlg7 = False
          ChgFlg5 = False
          ChgFlg2 = True
          OperatedStates = ""
          RtsRunToCompletion(RetValue, True)
        End If
      End While
      ChgFlg6 = False
      ChgFlg8 = False
      ChgFlg4 = False
      ChgFlg1 = False
      ChgFlg3 = False
      ChgFlg7 = False
      ChgFlg5 = False
      ChgFlg2 = False
    End Sub
    
    Private Function SenseTrigger(ByVal ExprValue As Boolean, ByVal ChangeEventActive As Boolean, ByVal ThisState As String) As Boolean
      Dim Ret As Boolean = False
      If ChangeEventActive Then
        If Not OperatedStates.Contains(ThisState + "|") Then
          If ExprValue Then
            Ret = True
          End If
        End If
      End If
      Return Ret
    End Function
    
    Public Shadows Function EvalTrigger(ByVal ExprValue As Boolean, ByVal LastExprValue As Boolean) As Boolean
      Dim Ret As Boolean = False
      If ExprValue And Not LastExprValue Then
        Ret = True
      End If
      Return Ret
    End Function
    
    Public Shadows Function DecrementInPorts() As Boolean
      Dim Ret As Boolean = False
      Ret = (Ret Or D21_S_SCI_EfeS_Gen_SR_State.Decrement())
      Ret = (Ret Or DT10_Move_Point.Decrement())
      Ret = (Ret Or DT2_Point_Position.Decrement())
      Ret = (Ret Or T10_Move_Point.Decrement())
      Ret = (Ret Or T2_Msg_Point_Position.Decrement())
      Ret = (Ret Or T3_Msg_Timeout.Decrement())
      Return Ret
    End Function
    
    Public Shadows Sub MaskInPorts(ByVal What As Boolean)
      D21_S_SCI_EfeS_Gen_SR_State.Mask(What)
      DT10_Move_Point.Mask(What)
      DT2_Point_Position.Mask(What)
      T10_Move_Point.Mask(What)
      T2_Msg_Point_Position.Mask(What)
      T3_Msg_Timeout.Mask(What)
      
    End Sub
    
    Public Overridable Function GetQueue() As SMSupport.SMQueue Implements SMSupport.SMQueued.GetQueue
      Return TheQueue
    End Function
    
  End Class
End Namespace
